<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use File;
use App\Library\CommonController;
use JWTAuth;
use Illuminate\Support\Facades\Crypt;

class BillCheckAuthority extends Controller
{
    // get Module setting data 
    public function getModuleSetting($type = null)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;

        if ($type != null) {
            $result = DB::table('tai_module_setting as m')
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'm.created_by')
                ->leftJoin('tai_employee_master as eu', 'eu.id', '=', 'm.updated_by')
                ->select('m.*', DB::raw('CONCAT(e.first_name, " ", e.last_name) as created_by_name'), DB::raw('CONCAT(eu.first_name, " ", eu.last_name) as updated_by_name'))
                ->where('m.tenant_id', $tenantId)
                ->where('m.is_active', 1)
                ->where('m.module_name', 'Bill_Checking')
                ->get();
            // dd($result);
        } else {
            $result = DB::table('tai_module_setting as m')
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'm.created_by')
                ->leftJoin('tai_employee_master as eu', 'eu.id', '=', 'm.updated_by')
                ->select('m.*', DB::raw('CONCAT(e.first_name, " ", e.last_name) as created_by_name'), DB::raw('CONCAT(eu.first_name, " ", eu.last_name) as updated_by_name'))
                ->where('m.tenant_id', $tenantId)
                ->where('m.module_name', 'Bill_Checking')->get();
        }

        return response()->json(['status' => 1, 'message' =>  "Found Data !!!", 'data' => $result]);
    }

    public function getModuleSettingById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;

        // if($type !== null)
        $result = DB::table('tai_module_setting as m')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'm.created_by')
            ->leftJoin('tai_employee_master as eu', 'eu.id', '=', 'm.updated_by')
            ->select('m.*', DB::raw('CONCAT(e.first_name, " ", e.last_name) as created_by_name'), DB::raw('CONCAT(eu.first_name, " ", eu.last_name) as updated_by_name'))
            ->where('m.is_active', 1)
            ->where('m.module_name', 'Bill_Checking')
            ->where('m.id', $id)->first();
        // $result->details = null;
        if ($result) {
            $result->details = DB::table('tai_module_setting_details')->where('tenant_id', $tenantId)->where('is_active', 1)->where('setting_id', $result->id)->where('is_active', 1)->get();
        }

        return response()->json(['status' => 1, 'message' =>  "Found Data !!!", 'data' => $result]);
    }

    // master setting
    public function createModuleAuthority(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;


        // $data = $request->toArray();
        $data['tenant_id'] = $tenantId;
        $data['module_name'] = "Bill_Checking";
        $data['setting_type'] = 'U';
        $data['submodule_name'] = $request->submodule_name;
        $data['setting_name'] = $request->setting_name;
        $data['remark'] = $request->remark;

        if ($request->id) {
            // dd($request->id);
            $check = DB::table('tai_module_setting')->where('setting_name', $request->setting_name)->where('module_name', 'Bill_Checking')->where('id', '!=', $request->id)->first();
            if ($check) {
                return response()->json(['status' => 0, 'message' =>  "Setting name already exist !!!", 'data' => null]);
            }
            $data['updated_by'] = $token_data->id;
            $data['updated_at'] = now();
            $data['is_active'] = $request->is_active;

            $query = DB::table('tai_module_setting')->where('id', $request->id)->update($data);
            // dd($query);
            if ($query) {
                return response()->json(['status' => 1, 'message' =>  "Data updated !!!", 'data' => $data]);
            } else {
                return response()->json(['status' => 0, 'message' =>  "Failed to update !!!", 'data' => null]);
            }
        } else {
            $check = DB::table('tai_module_setting')->where('setting_name', $request->setting_name)->where('module_name', 'Bill_Checking')->first();
            if ($check) {
                return response()->json(['status' => 0, 'message' =>  "Setting name already exist !!!", 'data' => null]);
            }

            $data['created_by'] = $token_data->id;
            $data['created_at'] = now();
            $data['is_active'] = 1;
            $data['field_type'] = 'input';
            $data['field_datatype'] = 'char';
            $data['field_value'] = 'Y';

            $query = DB::table('tai_module_setting')->insertGetId($data);
            if ($query) {
                if ($request->user_id && count($request->user_id) > 0) {
                    foreach ($request->user_id as $u) {
                        DB::table('tai_module_setting_details')->insert([
                            'setting_level' => 'U', 'setting_id' => $query,
                            'tenant_id' => $tenantId, 'user_id' => $u, 'is_active' => 1,
                            'created_at' => now(), 'created_by' => $token_data->id
                        ]);
                    }
                }
                return response()->json(['status' => 1, 'message' =>  "Data inserted !!!", 'data' => $data]);
            } else {
                return response()->json(['status' => 0, 'message' =>  "Failed to add !!!", 'data' => null]);
            }
        }
    }

    // create / update setting details of user with from and end date
    public function createModuleAuthorityUserSetting(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;

        $data['tenant_id'] = $tenantId;
        $data['setting_level'] = 'U';
        $data['user_id'] = $request->user_id;
        $data['setting_id'] = $request->setting_id;
        $data['setting_value'] = $request->setting_value;
        $data['from_date'] = $request->from_date;
        $data['to_date'] = $request->to_date;
        $data['is_active'] = 1;

        if ($request->id) {
            $check = DB::table('tai_module_setting_details')->where('setting_level', 'U')->where('tenant_id', $tenantId)->where('id', '!=', $request->id)->where('setting_id', '=', $request->setting_id)->where('user_id', '=', $request->user_id)->first();
            if ($check) {
                return response()->json(['status' => 0, 'message' =>  "Details already exist !!!", 'data' => null]);
            }
            $data['updated_by'] = $token_data->id;
            $data['updated_at'] = now();

            $query = DB::table('tai_module_setting_details')->where('id', $request->id)->update($data);
            if ($query) {
                return response()->json(['status' => 1, 'message' =>  "Update data !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' =>  "Failed to update !!!", 'data' => null]);
            }
        } else {
            // $check = DB::table('tai_module_setting_details')->where('setting_level', 'U')->where('tenant_id', $tenantId)->where('user_id', $request->user_id)->where('setting_id', $request->setting_id)->first();
            // if ($check) {
            //     return response()->json(['status' => 0, 'message' =>  "Details already exist !!!", 'data' => null]);
            // }

            // $data['created_by'] = $token_data->id;
            // $data['created_at'] = now();

            // // dd($data);
            // $query = DB::table('tai_module_setting_details')->insertGetId($data);
            // if ($query) {
            //     return response()->json(['status' => 1, 'message' =>  "Insert data !!!", 'data' => null]);
            // } else {
            //     return response()->json(['status' => 0, 'message' =>  "Failed to insert !!!", 'data' => null]);
            // }

            // dd($request->all());

            $setting_id = $request->setting_id;
            $setting_value = $request->setting_value;
            if (count($request->user_details) > 0) {
                foreach ($request->user_details as $row) {

                    foreach ($row['user_id'] as $u) {
                        DB::table('tai_module_setting_details')
                            ->where('setting_level', 'U')
                            ->where('tenant_id', $tenantId)
                            // ->where('user_id', $u)
                            // ->where('setting_id', $request->setting_id)
                            ->insert([
                                'setting_level' => 'U', 'setting_id' => $setting_id,
                                'tenant_id' => $tenantId, 'user_id' => $u,
                                "from_date" => $row['from_date'], "to_date" => $row['to_date'],
                                'setting_value' => $setting_value, 'is_active' => 1,
                                'created_at' => now(), 'created_by' => $token_data->id
                            ]);
                    }
                }
                return response()->json(['status' => 1, 'message' =>  "Insert data successfully !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' =>  "User Details Required !!!", 'data' => null]);
            }
        }
    }

    public function getModuleAuthorityUserSetting($setting_id)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;

        $query = DB::table('tai_module_setting_details as d')
            ->leftJoin('tai_module_setting as m', 'm.id', 'd.setting_id')
            ->leftJoin('tai_employee_master as e', 'e.id', 'd.user_id')
            ->where('d.setting_id', $setting_id)
            ->select('d.*', 'm.module_name', 'm.submodule_name', 'm.setting_name', DB::raw('CONCAT(e.first_name, " ",e.last_name) As employee '))
            ->get();
        if ($query) {
            return response()->json(['status' => 1, 'message' =>  "Data found !!!", 'data' => $query]);
        } else {
            return response()->json(['status' => 0, 'message' =>  "Data not found !!!", 'data' => NULL]);
        }
    }

    public function getSubMenuName($id)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;

        $query = DB::table('tai_menu_master')->select('id', 'name', 'parent_id')->where('parent_id', $id)->where('tenant_id', $tenantId)->where('is_active', 1)->get();

        if ($query) {
            return response()->json(['status' => 1, 'message' =>  "Data found !!!", 'data' => $query]);
        } else {
            return response()->json(['status' => 0, 'message' =>  "Data not found !!!", 'data' => NULL]);
        }
    }
}
