<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use File;
use App\Library\CommonController;
use datetime;
use ZipArchive;
use Redirect;
use Validator;
use PDF;
use Route;
use URL;
use ZanySoft\Zip\ZipManager;
use Zip;
use \Illuminate\Support\Facades\Storage;
use Maatwebsite\Excel\Facades\Excel;
use Illuminate\Support\Str;
use Exception;
use JWTAuth;

class BillPayment extends Controller
{
    public function isCancelBill($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;
        
        $data = DB::table('tai_bc_bill_checking_transactions')->where('id', $id)->update(['is_active'=> 0]);
        if($data){
            return response()->json(['status' => 1, 'message' =>'Cancel Bill ', 'data' => $id]);
        }else{
            return response()->json(['status' =>0, 'message' =>"Bill Not Cancelled", 'data'=>null]);
        }
    }
    // bill paymnet details
    public function getBillPayment(Request $request, $user_id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;

        $bill_type = $request->bill_type;
        $date = $request->date;

        $check_user = DB::table('tai_employee_master')->where('id', $user_id)->first();
        
        // print_r($request->toArray());exit;
        // return $request->toArray();
        // download payment text file
        // if ($request->requestFor == 'download' || $request->requestFor == 'downloadButton') 
        // {
        //     // dd('download');

        //     // date 04-12-2018 harry change code
        //     // generate uniqye key 
        //     $payment_status = DB::table('tai_bc_status_conventions')->where('used_for', 'Payment_status')->where('convention_name', 'Release')->first();
        //     if (!$payment_status) {
        //         return response()->json(['status' => 0, 'message' => 'Something went wrong', 'data' => null]);
        //     }

        //     $data = DB::table('tai_bc_payment_details as p')
        //                 ->leftJoin('tai_bc_vendor_master as vm', 'p.vendor_id', '=', 'vm.id')
        //                 ->leftJoin('tai_bc_bill_checking_transactions as bc', 'p.tai_bc_bill_checking_transactions_id', '=', 'bc.id')
        //                 ->leftJoin('tai_bc_bill_type_master as bt', 'p.bill_type_id', '=', 'bt.id')
        //                 ->distinct()
        //                 ->where('vm.is_active', '=', 1)
        //                 ->whereIn('p.bill_type_id', $request->bill_type)
        //                 ->where('p.payment_date', '<=', date('Y-m-d', strtotime($request->date)))
        //                 ->orderBy('vm.vendor_name')
        //                 ->groupBy('p.vendor_id')
        //                 ->where('p.payment_status', $payment_status->id)
        //                 ->select(
        //                     'p.payment_date', DB::raw('GROUP_CONCAT(distinct(bc.bc_id)) as bc_id'),
        //                     DB::raw('SUM(p.amount_to_be_paid) as total_payment'),
        //                     'vm.id as vendor_id',
        //                     'vm.address',
        //                     'vm.vendor_name',
        //                     'vm.bank_name',
        //                     'vm.bank_branch_name',
        //                     'vm.account_no',
        //                     'vm.ifsc_code',
        //                     'vm.acme_account_name',
        //                     'vm.beneficiary_name',
        //                     DB::raw('GROUP_CONCAT(distinct(bc.vendor_bill_no)) as bill_no'),
        //                     'p.remark',
        //                     DB::raw('GROUP_CONCAT(distinct(p.id)) as id'),
        //                     DB::raw('GROUP_CONCAT(distinct(p.tai_bc_bill_checking_transactions_id)) as transaction_id', 'bc.debit_advance'),
        //                     'bt.bill_type',
        //                     'vm.remark'
        //                 )
        //                 ->get();

        //         if(count($data) <=0 )
        //         {
        //             return response()->json(['status' => 0, 'message' => 'Data Not Found', 'data' => null]);
        //         }
                
        //             // dd($data);    
        //         if(count($data) ){
        //             $ids = [];
        //             foreach($data as $data){
        //                // $ids = $data->id;
        //                 array_push($ids, $data->id);
        //             }
        //         }            
            

        //     // $input = $request->all();
        //     $d = json_encode($data, true);
        //     $ids = json_encode($ids);
        //     $data = json_decode($d, true);
            
        //     //total_payment
        //     $data = $this->array_sort($data, 'total_payment', SORT_ASC);
        //     $data = array($data);

        //     // update key for bill payments
        //     $returnData = $this->callUpdateKeyPaymentList($ids, $data);

        //     // // generate text files and download zip
        //     $filePath=$this->generateZipFile($data, $returnData['keys'], $returnData['id']);

        //     return response()->json(['status'=>1,'message'=>"File Generated","data"=>str_replace('/var/www/html','',$filePath)]);
        // }

        // dd($check_user);
        if ($check_user) {
            if ($bill_type && count($bill_type) >= 0 && $date) {
                $payment_status = DB::table('tai_bc_status_conventions')->where('used_for', 'Payment_status')->where('convention_name', 'Release')->first();
                if (!$payment_status) {
                    return response()->json(['status' => 0, 'message' => 'Something went wrong', 'data' => null]);
                }

                $getdata = DB::table('tai_bc_payment_details as p')
                    ->leftJoin('tai_bc_vendor_master as vm', 'p.vendor_id', '=', 'vm.id')
                    ->leftJoin('tai_bc_bill_checking_transactions as bc', 'p.tai_bc_bill_checking_transactions_id', '=', 'bc.id')
                    ->leftJoin('tai_bc_bill_type_master as bt', 'p.bill_type_id', '=', 'bt.id')
                    ->distinct()
                    ->where('vm.is_active', '=', 1)
                    ->whereIn('p.bill_type_id', $bill_type)
                    ->where('p.payment_date', '<=', date('Y-m-d', strtotime($date)))
                    ->orderBy('vm.vendor_name')
                    ->groupBy('p.vendor_id')
                    ->where('p.payment_status', $payment_status->id)
                    ->select(
                        'p.payment_date', DB::raw('GROUP_CONCAT(distinct(bc.bc_id)) as bc_id'),
                        DB::raw('SUM(p.amount_to_be_paid) as total_payment'),
                        'vm.id as vendor_id',
                        'vm.address',
                        'vm.vendor_name',
                        'vm.bank_name',
                        'vm.bank_branch_name',
                        'vm.account_no',
                        'vm.ifsc_code',
                        'vm.acme_account_name',
                        'vm.beneficiary_name',
                        DB::raw('GROUP_CONCAT(distinct(bc.vendor_bill_no)) as bill_no'),
                        'p.remark',
                        DB::raw('GROUP_CONCAT(distinct(p.id)) as id'),
                        DB::raw('GROUP_CONCAT(distinct(p.tai_bc_bill_checking_transactions_id)) as transaction_id', 'bc.debit_advance'),
                        'bt.bill_type',
                        'vm.remark', 'vm.narration', 'vm.reference_number', 'vm.card_number'
                    )
                    ->get();
                    // dd($getdata);

                if (count($getdata) != 0) 
                {
                    if($getdata[0]->transaction_id) {
                        // dd('hi');
                        $str = "";
                        foreach ($getdata as $key => $row) {
                            $str .= "'" . str_replace("'", '', strtoupper($row->acme_account_name)) . "',";
                        }

                        $str = rtrim($str, ",");
                        // dd(json_encode($str));
                        $service_url = 'http://114.29.232.154/connectus/api/billcheck/getAccountBalance';
                        $ch = curl_init();
                        curl_setopt($ch, CURLOPT_URL, $service_url);
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt(
                            $ch,
                            CURLOPT_HTTPHEADER,
                            array(
                                'Authorization:jdO4jCFnTnOPA5VnQHOmgLhnTnONZeZcRnO3.jdO4EB9mgsWIg6WqNotcQHOmhMGIg6WqNotcQHOog65bV63pEXN0RXbniCSqhpSaELZnToNbSIpxNrcaE4SaELZnToJ8RXbnD7AdhrAziKOagLAIg6WqNotcRIlcQHO4hrKOEHN0NnNxNrEuhr5LfB9EEBKdXBVnToO3.Xqq4QdYazL4J5XH7QHI46CLFZCbb3K5GJe5UFE-s4xPnWpoGn2ymHlbBCBL52JqW8nD0YMOMRRYQZEzB9tE5sl',
                                'Content-Type:application/json;charset=UTF-8',
                                'X-key:zVhY2RjNGFormBoWI4LWE3YmYtZmY2MzVh',
                            )
                        );
                        curl_setopt($ch, CURLOPT_POST, 1);
                        $json_input_fields = json_encode($str);
                        curl_setopt($ch, CURLOPT_POSTFIELDS, $json_input_fields);

                        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
                        $json_response = curl_exec($ch);
                        // Close request to clear up some resources
                        curl_close($ch);
                        // dd(json_decode($json_response, true));

                        $str = json_decode($json_response, true);

                        foreach ($getdata as $key => $row) {
                            $d = [];
                            $row->acme_name = '';
                            $row->acc_code = '';
                            $row->balance = 0;
                            // dd($str);
                            if ($row->acme_account_name) {
                                if ($str != null) {
                                    $padm_row_data = $this->searchAcmeName($str, $row->acme_account_name);
                                    $row->acme_name = $padm_row_data->nm ? $padm_row_data->nm : NULL;
                                    $row->acc_code = $padm_row_data->acc_code ? $padm_row_data->acc_code : NULL;
                                    // $row->balance 	= $padm_row_data->balance;
                                    $row->balance = $padm_row_data->balance ? $padm_row_data->balance : 0;
                                    if ($row->balance > 0) {
                                        $row->balance = abs($row->balance);
                                        //$row->balance .= ' Dr'; 
                                    } elseif ($row->balance < 0) {
                                        $row->balance = abs($row->balance);
                                        //$row->balance .= ' Cr'; 
                                    }
                                } else {
                                    $row->acme_name = '';
                                    $row->acc_code = '';
                                    $row->balance = 0;
                                }


                            }
                            $d[] = $row;

                        }
                        // dd($getdata);
                        $data['getdata'] = $d;
                    }
                }

                
                $access['Bill_Payment'] = $this->checkAuthorityAccess($user_id, 'Bill_Checking', 'Bill_Payment');

                // $access = $access;
                // dd($getdata);
                return response()->json(['status' => 1, 'message' => 'Found Dta', 'data' => $getdata, 'access' => $access]);

            } else {
                return response()->json(['status' => 0, 'message' => 'All Fields are required', 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => 'User Not Found', 'data' => null]);
        }
    }

    public function searchAcmeName($access, $value)
    {
        if ($access) {
            foreach ($access as $key => $row) {
                if ($row->nm === $value) {
                    return $row;
                }
            }
            return false;
        }
        return false;
    }

    // Authoruity for update Bill Checking transaction_data
    public function checkAuthorityAccess($user_id, $module_name, $auth_name)
    {
        $query = DB::table('tai_module_setting')->where('setting_name', $auth_name)
                                                ->where('field_value', 'Y')
                                                ->where('setting_type', 'U')
                                                ->where('module_name', $module_name)
                                                ->where('is_active', '1')->first();

        if ($query) {
            $check = DB::table('tai_module_setting_details')->where('setting_id', $query->id)
                                                            ->where('user_id', $user_id)
                                                            ->where('is_active', '1')
                                                            ->where('setting_value', 'Y')->first();

            if ($check) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
        return false;
    }

    public function getExport(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;
        
        $id = explode(',', $request->id);
        $till_date = date('Y-m-d', strtotime($request->till_date));
        $time = date('Y-m-d H:i:s');


        $payment_status = DB::table('tai_bc_status_conventions')->where('used_for', 'Payment_status')->where('convention_name', 'Release')->first();
        if (!$payment_status) {
            return response()->json(['status' => 0, 'message' => 'Something went wrong', 'data' => null]);
        }

        $result = DB::table('tai_bc_payment_details AS d')
            ->join('tai_bc_vendor_master AS v', 'd.vendor_id', '=', 'v.id')
            ->join('tai_bc_bill_checking_transactions AS tr', 'd.tai_bc_bill_checking_transactions_id', '=', 'tr.id')
            ->select(
                'd.payment_date', DB::raw('SUM(d.amount_to_be_paid) as total_payment'),
                'v.vendor_name as vendor_name',
                'v.bank_name',
                'v.beneficiary_name',
                'v.bank_branch_name',
                'v.account_no',
                'v.ifsc_code',
                'tr.vendor_bill_no',
                // 		                    // 'tr.acme_doc_no', 
                'd.remark', DB::raw('GROUP_CONCAT(distinct(d.id)) as id'),
                DB::raw(
                    'GROUP_CONCAT(distinct(d.tai_bc_bill_checking_transactions_id)) as transaction_id',
                    'tr.debit_advance',
                    'v.card_number',
                    'v.reference_number',
                    'v.narration'
                )
            )
            ->distinct()
            ->where('d.payment_status', $payment_status->id)
            ->where('d.is_active', 1)
            ->where('d.payment_date', '<=', date('Y-m-d', strtotime($till_date)))
            ->groupBy('d.vendor_id')
            ->get();

        // DB::select("SELECT `d`.*, v.*, tr.*
        // FROM `tai_bc_payment_details` AS `d`  
        // JOIN `tai_bc_vendor_master` AS `v` ON `d`.`vendor_id` = `v`.`id` 
        // JOIN `tai_bc_bill_checking_transactions` AS `tr` ON `d`.`tai_bc_bill_checking_transactions_id` = `tr`.`id`
        // WHERE `d`.`payment_status` = 17 
        // AND `d`.`is_active` = 1 
        // AND `d`.`payment_date` <= '2023-01-01' 
        // GROUP BY `d`.`vendor_id`");

        $fields = array(
            'id',
            'vendor_name',
            'bank_name',
            'beneficiary_name',
            'bank_branch_name',
            'account_no',
            'ifsc_code',
            'total_payment',

        );
        $delimiter = ",";
        $filename = "Bill Payment Report" . date('Y-m-d') . ".csv";
        $f = fopen('php://memory', 'w');
        fputcsv($f, $fields, $delimiter);

        foreach ($result as $key => $value) {

            $arrayName = array(
                ++$key,
                strtoupper($value->vendor_name),
                strtoupper($value->bank_name),
                strtoupper($value->beneficiary_name),
                strtoupper($value->bank_branch_name),
                $value->account_no,
                strtoupper($value->ifsc_code),
                $value->total_payment,

            );
            fputcsv($f, $arrayName, $delimiter);
        }

        fseek($f, 0);
        header('Content-Type: text/csv');
        header('Content-Disposition: attachment; filename="' . $filename . '";');
        fpassthru($f);

        foreach ($id as $value) {
            // 44 as release status
            // 50 as Confirmation pending
            $payment_confirm = DB::table('tai_bc_status_conventions')->where('used_for', 'Billchecking_Payment_template')->where('convention_name', 'Confirmation Pending')->first();
            if (!$payment_confirm) {
                return response()->json(['status' => 0, 'message' => 'Something went wrong', 'data' => null]);
            }
            DB::table('tai_bc_payment_details')
                ->where('id', $value)
                ->where('payment_status', $payment_status->id)
                ->update(['key' => strtotime($time), 'payment_status' => $payment_confirm->id]);
        }

    }

    // download text file
    public function postDownloadFile(\Illuminate\Http\Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;
        

        // result and id of result (input data)
        // downoad the text file 
        $unique_key = strtotime(date('Y-m-d H:i:s'));

        if ($request->input('excel') == 'Excel') 
        {
            $data = json_decode($request->data);
            $ids = json_decode($request->ids);

            $fields = array(
                'VendorName',
                'Acme Name',
                'Account Balance',
                'Transaction Id',
                'BC ID',
                'Bill Nos',
                'Acme Nos',
                'Total Payment',
                'Remark',
                'Beneficiary Name',
                'BankName',
                'BankBranchName',
                'AccountNo',
                'IFSC Code',
                'Export Date',
                'Card Number',
                'Ref Number',
                'Narration'
            );

            $delimiter = ",";
            $filename = "Bill Payment Report " . $unique_key . ' ' . date('Y-m-d H:i:s') . ".csv";
            $f = fopen('php://memory', 'w');
            fputcsv($f, $fields, $delimiter);


            foreach ($data as $key => $value) {

                $transaction_count = explode(',', $value->transaction_id);
                $bc_id_count = explode(',', $value->bc_id);

                $arrayName = array(
                    strtoupper($value->vendor_id),
                    strtoupper($value->acme_account_name),
                    $value->balance,
                    count($transaction_count) == 1 ? $value->transaction_id : "'" . $value->transaction_id,
                    count($bc_id_count) == 1 ? $value->bc_id : "'" . $value->bc_id,
                    $value->bill_no,
                    // $value->acme_doc_no,
                    $value->total_payment,
                    $value->remark,
                    strtoupper($value->beneficiary_name),
                    strtoupper($value->bank_name),
                    strtoupper($value->bank_branch_name),
                    $value->account_no,
                    strtoupper($value->ifsc_code),
                    date('Y-m-d H:i:s'),
                    $value->card_number,
                    $value->reference_number,
                    $value->narration
                );
                //       // fputcsv($file,$arrayName);
                fputcsv($f, $arrayName, $delimiter);
                // dd($arrayName);/
            }
            fseek($f, 0);
            //set headers to download file rather than displayed
            header('Content-Type: text/csv');
            header('Content-Disposition: attachment; filename="' . $filename . '";');

            //output all remaining data on a file pointer
            fpassthru($f);

        }

        if ($request->requestFor == 'download' || $request->requestFor == 'downloadButton') 
        {

            // date 04-12-2018 harry change code
            // generate uniqye key 
            $payment_status = DB::table('tai_bc_status_conventions')->where('used_for', 'Payment_status')->where('convention_name', 'Release')->first();
            if (!$payment_status) {
                return response()->json(['status' => 0, 'message' => 'Something went wrong', 'data' => null]);
            }

            $data = DB::table('tai_bc_payment_details as p')
                        ->leftJoin('tai_bc_vendor_master as vm', 'p.vendor_id', '=', 'vm.id')
                        ->leftJoin('tai_bc_bill_checking_transactions as bc', 'p.tai_bc_bill_checking_transactions_id', '=', 'bc.id')
                        ->leftJoin('tai_bc_bill_type_master as bt', 'p.bill_type_id', '=', 'bt.id')
                        ->distinct()
                        ->where('vm.is_active', '=', 1)
                        ->whereIn('p.bill_type_id', $request->bill_type)
                        ->where('p.payment_date', '<=', date('Y-m-d', strtotime($request->date)))
                        ->orderBy('vm.vendor_name')
                        ->groupBy('p.vendor_id')
                        ->where('p.payment_status', $payment_status->id) // release status
                        ->select(
                            'p.payment_date', DB::raw('GROUP_CONCAT(distinct(bc.bc_id)) as bc_id'),
                            DB::raw('SUM(p.amount_to_be_paid) as total_payment'),
                            'vm.id as vendor_id',
                            'vm.address',
                            'vm.vendor_name',
                            'vm.bank_name',
                            'vm.bank_branch_name',
                            'vm.account_no',
                            'vm.ifsc_code',
                            'vm.acme_account_name',
                            'vm.beneficiary_name',
                            DB::raw('GROUP_CONCAT(distinct(bc.vendor_bill_no)) as bill_no'),
                            'p.remark',
                            DB::raw('GROUP_CONCAT(distinct(p.id)) as id'),
                            DB::raw('GROUP_CONCAT(distinct(p.tai_bc_bill_checking_transactions_id)) as transaction_id', 'bc.debit_advance'),
                            'bt.bill_type',
                            'vm.remark'
                        )
                        ->get();

                if(count($data) <=0 )
                {
                    return response()->json(['status' => 0, 'message' => 'Data Not Found', 'data' => null]);
                }
                
                    // dd($data);    
                if(count($data) ){
                    $ids = [];
                    foreach($data as $data){
                        array_push($ids, $data->id);
                    }
                }

            // $input = $request->all();
            $d = json_encode($data, true);
            $ids = json_encode($ids);
            $data = json_decode($d, true);
            
            //total_payment
            $data = $this->array_sort($data, 'total_payment', SORT_ASC);
            $data = array($data);

            // update key for bill payments
            $returnData = $this->callUpdateKeyPaymentList($ids, $data);

            // // generate text files and download zip
            $filePath=$this->generateZipFile($data, $returnData['keys'], $returnData['id']);

            return response()->json(['status'=>1,'message'=>"File Generated","data"=>str_replace('/var/www/html','',$filePath)]);
        }
    }

    public function array_sort($array, $on, $order = SORT_ASC)
    {

        $new_array = array();
        $sortable_array = array();

        if (count($array) > 0) {
            foreach ($array as $k => $v) {
                if (is_array($v)) {
                    foreach ($v as $k2 => $v2) {
                        if ($k2 == $on) {
                            $sortable_array[$k] = $v2;
                        }
                    }
                } else {
                    $sortable_array[$k] = $v;
                }
            }

            switch ($order) {
                case SORT_ASC:
                    asort($sortable_array);
                    break;
                case SORT_DESC:
                    arsort($sortable_array);
                    break;
            }

            foreach ($sortable_array as $k => $v) {
                $new_array[$k] = $array[$k];
            }
        }

        return $new_array;
    }

    public function callUpdateKeyPaymentList($ids, $data)
    {
        $i = 0;
        $unique_key = time() . $i;
        $slab = 9900000; //DB::table('cms_settings')->where('id', 20)->first()->content;
        $total = 0;
        $keys = array();
        // dd($data);
        foreach ($data as $key => $row) {
            // dd($row);
            $total += $row['total_payment'];

            if ($total >= $slab) {
                $i++;
                $unique_key = time() . $i;
                if ($row['total_payment'] <= $slab) {
                    $total = $row['total_payment'];
                } else {
                    $total = 0;
                }
            }

            if ($row['total_payment'] <= $slab) {

                $this->updatePaymentlist($row['id'], $unique_key);
            } else {

                $return_data = $this->updatePaymentGreaterThanSlab($row['id'], $i, $slab);
                // dd('bye', $return_data, $i, $slab);
                $i = $return_data['i'];
                // key store
                for ($j = 0; $j < count($return_data['keys']); $j++) {
                    array_push($keys, $return_data['keys'][$j]);
                }
            }
            array_push($keys, $unique_key);
        }
        $keys = array_unique($keys);
        // dd($keys);

        return ['id' => $ids, 'keys' => $keys];
    }

    public function updatePaymentlist($ids, $unique_key)
    {

        $ids = explode(',', $ids);
        foreach ($ids as $value) {

            $payment_confirm = DB::table('tai_bc_status_conventions')->where('used_for', 'Billchecking_Payment_template')
                ->where('convention_name', 'Confirmation Pending')
                ->first();

            $payment_status = DB::table('tai_bc_status_conventions')->where('used_for', 'Payment_Status')
                ->where('convention_name', 'Release')
                ->first();

            $is_update = DB::table('tai_bc_payment_details')
                            ->where('id', $value)
                            ->where('payment_status', $payment_status->id)
                            ->update([
                                'key' => $unique_key,
                                'payment_status' => $payment_confirm->id,  //Confirmation Pending
                                'updated_at' => now(),
                                'updated_by' => 1
                            ]);
            CommonController::generateHistory("DOWNLOAD TEST FILE", 'tai_bc_payment_details', $value);

        }
    }

    public function updatePaymentGreaterThanSlab($ids, $i, $slab)
    {
        $unique_key = time() . $i;
        $data['keys'][] = $unique_key;
        $whereIn = explode(',', $ids);
        $result = DB::table('tai_bc_payment_details')
            ->select('id', 'key', 'payment_status', 'amount_to_be_paid')
            ->whereIn('id', $whereIn)
            ->where('is_active', 1)
            ->get();

        $total = 0;
        $data = array();
        $data['keys'] = [];
        foreach ($result as $key => $row) {
            $total += $row->amount_to_be_paid;

            if ($total >= $slab) {
                $i++;
                $unique_key = time() . $i;
                if ($row->amount_to_be_paid <= $slab) {
                    $total = $row->amount_to_be_paid;
                } else {
                    $total = 0;
                }
            }
            if ($row->amount_to_be_paid <= $slab) {
                $this->updatePaymentlist($row->id, $unique_key);
            }
            array_push($data['keys'], $unique_key);
        }
        $data['i'] = $i;
        return $data;
    }

    public function generateZipFile($data, $payment_keys, $ids = NULL)
    {
        // check exist directory
        $destinationPath = storage_path() . "/app/Attachment/BillChecking/payments/";
        if (!is_dir($destinationPath)) {
            mkdir($destinationPath, 0777, true);
        }
        $file_names = array();

        // $payment_status = DB::table('tai_bc_status_conventions')->where('used_for', 'Payment_status')->where('convention_name', 'Release')->first();

        foreach ($payment_keys as $key => $unique_key) {

            $data = DB::table('tai_bc_payment_details AS d')
                ->join('tai_bc_vendor_master AS v', 'd.vendor_id', '=', 'v.id')
                ->join('tai_bc_bill_checking_transactions AS tr', 'd.tai_bc_bill_checking_transactions_id', '=', 'tr.id')
                ->join('tai_bc_bill_type_master AS bt', 'tr.bill_type', '=', 'bt.id')
                ->select(
                    'd.payment_date', DB::raw('GROUP_CONCAT(distinct(tr.bc_id)) as bc_id'),
                    DB::raw('SUM(amount_to_be_paid) as total_payment'),
                    'v.id as vendor_id',
                    'v.address',
                    'v.vendor_name',
                    'v.bank_name',
                    'v.beneficiary_name',
                    'v.bank_branch_name',
                    'v.acme_account_name',
                    'v.account_no',
                    'v.ifsc_code',
                    // DB::raw('GROUP_CONCAT(distinct(tr.bill_no)) as bill_no'), 'tr.acme_doc_no', 'd.remark', 
                    DB::raw('GROUP_CONCAT(distinct(d.id)) as id'),
                    DB::raw('GROUP_CONCAT(distinct(d.tai_bc_bill_checking_transactions_id)) as transaction_id', 'tr.debit_advance'),
                    'bt.bill_type',
                    'v.consider_in_payment',
                    'v.card_number',
                    'v.reference_number',
                    'v.narration',
                    'v.payee_list',
                    'v.mobile_no'

                )
                    //Generate seperate txt file for petty cash bill type
                    //fatch required fields for that (consider_in_payment,card_number,ref_number,narration,contact_no)
                ->distinct()
                    // ->where('d.payment_status', $payment_status->id)
                ->where('d.is_active', 1)
                ->where('d.key', $unique_key)
                    // ->orderBy('v.vendor_name', 'asc')
                    // ->groupBy('d.vendor_id')
                ->get();


            // $query="SELECT DISTINCT d.payment_date, GROUP_CONCAT(DISTINCT(tr.bc_id)) AS bc_id, SUM(amount_to_be_paid) AS total_payment, v.id AS vendor_id, v.address, 
            //         v.vendor_name, v.bank_name, v.beneficiary_name, v.bank_branch_name, v.acme_account_name, v.account_no, v.ifsc_code, 
            //         GROUP_CONCAT(DISTINCT(d.id)) AS id, GROUP_CONCAT(DISTINCT(d.tai_bc_bill_checking_transactions_id)) AS transaction_id, bt.bill_type, 
            //         v.consider_in_payment, v.card_number, v.reference_number, v.narration 
            //         FROM tai_bc_payment_details AS d 
            //         INNER JOIN tai_bc_vendor_master AS v ON d.vendor_id = v.id 
            //         INNER JOIN tai_bc_bill_checking_transactions AS tr ON d.tai_bc_bill_checking_transactions_id = tr.id 
            //         INNER JOIN tai_bc_bill_type_master AS bt ON tr.bill_type = bt.id 
            //         WHERE d.payment_status = $payment_status->id AND d.is_active = 1 AND d.key = $unique_key;";
            //         //$data=DB::select(DB::raw($query));

            // //if(!$data){
            //     echo $query;
            //     dd($ids);
            // //}
            // exit();


            $date = date('d/m/Y');
            $sbi_total_amount = 0;
            $neft_total_amount = 0;
            $rtgs_total_amount = 0;
            //28-01-2020 NikhilB TicketId:T34339
            //Generate seperate txt file for petty cash bill type
            $pettycash_total_amount = 0;

            $max_amount = 200000;
            $sbi_arr = [];
            $non_sbi_NEFT = [];
            $non_sbi_RTGS = [];
            //28-01-2020 NikhilB TicketId:T34339
            //Generate seperate txt file for petty cash bill type
            $petty_CASH = [];

            // check already exist
            $sbi_file = $unique_key . '_SBI_PAYEE.txt';
            $rtgs_file = $unique_key . '_RTGS_PAYEE.txt';
            $neft_file = $unique_key . '_NEFT_PAYEE.txt';
            $payee_file = $unique_key . '_PAYEE.txt';
            //28-01-2020 NikhilB TicketId:T34339
            //Generate seperate txt file for petty cash bill type

            $pettycash_file = $unique_key . '_PETTYCASH.txt';


            foreach ($data as $key => $row) {
            
                if (
                    $row->account_no && $row->ifsc_code && $row->bank_branch_name && $row->beneficiary_name &&
                    $row->bank_name && $row->total_payment > 0
                ) {

                    $acc_type = "";
                    //Generate seperate txt file for petty cash bill type
                    if ($row->consider_in_payment == 'PETTY_CASH') {
                        $petty_CASH[] = $row;
                        $pettycash_total_amount += $row->total_payment;
                        $acc_type = "O";
                    } else
                        if (strtoupper(trim($row->bank_name)) == 'STATE BANK OF INDIA') {
                            $sbi_arr[] = $row;

                            $sbi_total_amount += $row->total_payment;
                            $acc_type = "S";
                        } else {
                            $acc_type = "O";

                            if ($row->total_payment < $max_amount) {
                                //neft
                                $neft_total_amount += $row->total_payment;
                                $non_sbi_NEFT[] = $row;
                            } else {
                                // rtgs
                                $rtgs_total_amount += $row->total_payment;
                                $non_sbi_RTGS[] = $row;
                            }
                        }

                    $payment_detail = $acc_type . "#"; // S : SBI
                    $payment_detail .= "A" . "#";
                    $payment_detail .= $this->removeSpecailChars($row->vendor_name) . "#"; // Vendor Name
                    $payment_detail .= $row->account_no . "#"; // Account Number
                    $payment_detail .= "" . "#"; // 
                    $payment_detail .= substr($row->ifsc_code, -11) . "#"; // ifsc code
                    $payment_detail .= strtoupper(trim($row->bank_name)) . "#"; // bank name
                    $payment_detail .= trim($row->bank_branch_name) . "#"; // bank branch name
                    $payment_detail .= "\r\n";

                    if ($row->payee_list == 0) {
                        $f=File::append($destinationPath . $payee_file, $payment_detail);
                        DB::table('tai_bc_vendor_master')->where('id', $row->vendor_id)->update(['payee_list' => 1]);
                    }
                }
            }

            array_push($file_names, $payee_file);
            ///////////////////////////////
            //Generate seperate txt file for petty cash bill type
            // add data in txt file

            if ($pettycash_total_amount) {

                $bank_detail = $this->getOwnBankDetailPetty($pettycash_total_amount, $unique_key, $date, "");

                File::append($destinationPath . $pettycash_file, $bank_detail);
                foreach ($petty_CASH as $key => $row) {
                    if ($row->card_number && $row->ref_number && $row->narration && $row->mobile_no) {

                        $str = $row->card_number . "|"; //card number
                        $str .= $row->ref_number . "|"; // reference number
                        $str .= "|";
                        $str .= $row->total_payment . "|"; // amount
                        $str .= $row->bank_branch_name . "|"; // bank_branch_name 
                        $str .= $row->mobile_no; // mobile number
                        $str .= ""; // payment identifire                         
                        $str .= "\r\n"; // new line
                        // $str = nl2br(e($str));
                        File::append($destinationPath . $pettycash_file, $str);
                    }
                }

                array_push($file_names, $pettycash_file);
            }
            if ($sbi_total_amount) {

                $bank_detail = $this->getOwnBankDetail($sbi_total_amount, $unique_key, $date, "");
                File::append($destinationPath . $sbi_file, $bank_detail);
                foreach ($sbi_arr as $key => $row) {
                    if ($row->account_no && $row->ifsc_code && $row->bank_branch_name && $row->beneficiary_name && $row->bank_name) {

                        $ifsc_code = substr($row->ifsc_code, -5); // ifsc code
                        $str = $row->account_no . "#";
                        $str .= strtoupper($ifsc_code) . "#"; // ifsc code
                        $str .= $date . "#";
                        $str .= "#";
                        $str .= $row->total_payment . "#";
                        $str .= $unique_key . "-" . $row->vendor_id . "#";
                        $str .= 'SBI_' . $unique_key . "#";
                        $str .= ""; // payment identifire                         
                        $str .= "\r\n"; // new line
                        // $str = nl2br(e($str));
                        File::append($destinationPath . $sbi_file, $str);
                    }
                }
                array_push($file_names, $sbi_file);
            }


            if ($rtgs_total_amount) {

                $bank_detail = $this->getOwnBankDetail($rtgs_total_amount, $unique_key, $date, "RTGS");
                File::append($destinationPath . $rtgs_file, $bank_detail);

                foreach ($non_sbi_RTGS as $key => $row) {
                    if ($row->account_no && $row->ifsc_code && $row->bank_branch_name && $row->beneficiary_name && $row->bank_name) {
                        $ifsc_code = substr($row->ifsc_code, -11); // ifsc code
                        $str = $row->account_no . "#";
                        $str .= strtoupper($ifsc_code) . "#"; // ifsc code
                        $str .= $date . "#";
                        $str .= "#";
                        $str .= $row->total_payment . "#";
                        $str .= $unique_key . "-" . $row->vendor_id . "#";
                        $str .= 'NON SBI RTGS_' . $unique_key . "#";
                        $str .= "RTGS"; // payment identifire

                        $str .= "\r\n"; // new line
                        // $str = nl2br(e($str));
                        File::append($destinationPath . $rtgs_file, $str);
                    }
                }
                array_push($file_names, $rtgs_file);
            }

            if ($neft_total_amount) {

                $bank_detail = $this->getOwnBankDetail($neft_total_amount, $unique_key, $date, "NEFT");
                File::append($destinationPath . $neft_file, $bank_detail);

                foreach ($non_sbi_NEFT as $key => $row) {
                    if ($row->account_no && $row->ifsc_code && $row->bank_branch_name && $row->beneficiary_name && $row->bank_name) {

                        $ifsc_code = substr($row->ifsc_code, -11); // ifsc code
                        $str = $row->account_no . "#";
                        $str .= strtoupper($ifsc_code) . "#"; // ifsc code
                        $str .= $date . "#";
                        $str .= "#";
                        $str .= $row->total_payment . "#";
                        $str .= $unique_key . "-" . $row->vendor_id . "#";
                        $str .= 'NON SBI NEFT_' . $unique_key . "#";
                        $str .= "NEFT"; // payment identifire

                        $str .= "\r\n"; // new line
                        // $str = nl2br(e($str));
                        File::append($destinationPath . $neft_file, $str);
                    }
                }

                array_push($file_names, $neft_file);
            }
        }

        // return response()->download($destinationPath.$sbi_file);
        // $file_names=array($payee_file,$sbi_file, $rtgs_file, $neft_file);
        $archive_file_name = date("Y-m-d_H:i:s") . '_payment.zip';
        //$file_path = public_path() . "/upload/payments/";
        $file_path = $destinationPath;
        return $this->zipFilesAndDownload($file_names, $archive_file_name, $file_path);
    }

    public function removeSpecailChars($string)
    {
        // $string = str_replace(' ', '-', $string); // Replaces all spaces with hyphens.

        return preg_replace('/[^A-Za-z0-9\-]/', ' ', $string); // Removes special chars.
    }

    public function getOwnBankDetail($total_amount, $unique_key, $date, $identifire = '')
    {

        // $result = DB::table('cms_settings')
        //     ->select('id', 'content')
        //     ->where('name', 'sbi_account')
        //     ->orwhere('name', 'sbi_ifsc_code')
        //     ->orderBy('id')
        //     ->get();

        // $result = array();
        // $result[0]['id'] = 17;
        // $result[0]['content'] = '00000033534353557';
        // $result[1]['id'] = '18';
        // $result[1]['content'] = 'SBIN0000454';

        // $str = $result[0]->content . "#"; // account number
        // $str .= substr($result[1]->content, -5) . "#"; // ifsc code
        // $str .= $date . "#"; // date
        // $str .= $total_amount . "#";
        // $str .= "#";
        // $str .= $unique_key . '-' . $identifire . "#";
        // $str .= 'SBI_' . $unique_key . "#";
        // $str .= $identifire; // payment identifire
        // $str .= "\r\n"; // new line
        // // $str = nl2br(e($str));
        // return $str;

        $result = DB::table('tai_bc_settings')
            ->select('id', 'content')
            ->where('name', 'sbi_account')
            ->orwhere('name', 'sbi_ifsc_code')
            ->orderBy('id')
            ->get();


        $str = $result[0]->content . "#"; // account number
        $str .= substr($result[1]->content, -5) . "#"; // ifsc code
        $str .= $date . "#"; // date
        $str .= $total_amount . "#";
        $str .= "#";
        $str .= $unique_key . '-' . $identifire . "#";
        $str .= 'SBI_' . $unique_key . "#";
        $str .= $identifire; // payment identifire
        $str .= "\r\n"; // new line
        // $str = nl2br(e($str));
        return $str;

    }


    public function zipFilesAndDownload($file_names, $archive_file_name, $file_path)
    {
        //create the object
        // $public_dir = public_path() . "/upload/payments/";


        $public_dir = storage_path() . "/app/Attachment/BillChecking/payments/zip";
        if (!is_dir($public_dir)) {
            mkdir($public_dir, 0777, true);
        }


        $zip = new ZipArchive();
        // dd($zip);
        //create the file and throw the error if unsuccessful
    
        if ($zip->open($public_dir . '/' . $archive_file_name, ZIPARCHIVE::CREATE) !== TRUE) {
            echo "cannot open <$archive_file_name>\n";
        }

        //add each files of $file_name array to archive
        if(count($file_names))
        {
            foreach ($file_names as $files) {
                // echo storage_path() . "/app/Attachment/BillChecking/payments/$files"; 
                if (Storage::disk('attachment')->exists("/BillChecking/payments/$files")) {
                    // echo "FOUND =".storage_path() . "/app/Attachment/BillChecking/payments/$files";
                        $zip->addFile(storage_path() . "/app/Attachment/BillChecking/payments/$files",$files);
                }else{
                    // echo "Not Found =".storage_path() . "/app/Attachment/BillChecking/payments/$files";
                }
            }
            $zip->close();
        }
        

        ////      then send the headers to foce download the zip file
        // header("Content-type: application/zip");
        // header("Content-Disposition: attachment; filename=$archive_file_name");
        // header("Pragma: no-cache");
        // header("Expires: 0");
        $archive_file_name = $public_dir . '/' . $archive_file_name;
        
        return $archive_file_name;
        // readfile("$archive_file_name");
        exit;
    }


    // auto update payments through excel file
    public function postPaymentUpdate(\Illuminate\Http\Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 30-05-2023
        $tenantId = $token_data->tenant_id;
        

        // file uploading function only accept XML file.
        $request->validate([
                'file' => 'required|file|max:10240',
        ]);

        $file = $request->file('file');
    
        $Extension = $file->getClientOriginalExtension();
        // check extenstion
        if($Extension=='xls' || $Extension=='csv'){
            
            $path = $request->file('file')->getRealPath();
            $uploadData = \Excel::toArray($path, $request->file('file'));
        
            if(count($uploadData) <=0){
                return response()->json([ 'success' => false,'message' => 'No data to process']);
            }
            $data = $uploadData[0];
            $header = $data[0];
            unset($data[0]);
            // dd($data);

            if(count($data) <= 0){
                return response()->json([ 'success' => false,'message' => 'No data to process']);
            }
            $mainData = array();
            foreach ($data as $d) {
                // dd(strtolower($header));
                $mainData[] = array_combine(str_replace(' ', '_', array_map('strtolower', $header)), $d);
            }
            // dd($mainData);

            if(count($mainData)){

                $destinationPath = storage_path(). '/app/Attachment/BillChecking/bank_files';
                $file->move($destinationPath,$file->getClientOriginalName());
                $arr = array();
                $not_update_excel = array();

                foreach ($mainData as $key => $value) {
                    
                    // Paymnet status id for => Paid
                    $payment_status_id  = DB::table('tai_bc_status_conventions')->where('used_for','Payment_Status')
                                                        ->where('convention_name','Paid')
                                                        ->where('is_active',1)
                                                        ->first()->id;

                    $ptype = str_replace("'", "", $value['payment_type']);
                    $payment_status = $payment_status_id;
                    $ref_no  = '';
                    $transaction_date_time = '';

                    // Payment Type NEFT
                    $actual_payment_date = $this->change_date_format(str_replace("'", "", $value['transaction_date']));
                    $actual_payment_time = str_replace("'", "", $value['transaction_time']);
                    
                    $explode = explode('-', $value['corporate_reference_number']);
                    $key        = $explode[0];
                    $vendor_id  = $explode[1];
                    // dd($key, $vendor_id);
                    $arr['transaction_date_time']  = $actual_payment_date.' '.$actual_payment_time; 
                    //sayali nikam T27460 RTGS UTR  
                    $arr['actual_payment_date']  = $actual_payment_date;  

                    // dd(count($explode) == 2 && $vendor_id <> "NEFT");
                    if(count($explode) == 2 && $vendor_id != "NEFT"){  

                        if($value['transaction_status'] != "'Success"){

                            // payment status not success then change to release
                            // as discuss with gaurav sir
                            // $payment_status         = 42;      // paid      
                            // $payment_status         = 44;   // Release

                            //Update payment status relase(44) to bank reject(83)
                            //as per discussion with gaurav sir.  
                            $payment_status_reject  = DB::table('tai_bc_status_conventions')->where('used_for','payment_template')
                                                                                        ->where('convention_name','Reject')
                                                                                        ->where('is_active',1)->first()->id;       
                            $payment_status         = $payment_status_reject;     //reject       
                        }

                        // NEFT              
                        if($ptype=="NEFT"){
                            $arr['payment_reference_number']    = str_replace("'", "", $value['utr_number']);           
                        }else{
                            $arr['payment_reference_number']    = str_replace("'", "", $value['utr_number']);           
                        }
                        $arr['payment_status'] = $payment_status;

                        // auto entry issue, call auto entry function before update payment status in database (bc_bill_payment_detail)
                        // as discuss with gaurav sir
                        //Added Vendor condition as per discuss with Gaurav Sir code updated by Aishwarya Lanke Date :24-01-2020
                        
                        //auto entry with uniqueId

                        // dd($arr);
                        if ($payment_status == $payment_status_id) { // paid
                            // dd($key,$vendor_id,$arr['payment_reference_number']);
                            $this->getbankpaymentDoc($key,$vendor_id,$arr['payment_reference_number']);
                        }

                        $payment_status_confirm  = DB::table('tai_bc_status_conventions')->where('used_for','Billchecking_Payment_template')
                                                                                        ->where('convention_name','Confirmation Pending')
                                                                                        ->where('is_active',1)->first()->id;
                        DB::table('tai_bc_payment_details')
                                        ->where('key', $key)
                                        ->where('vendor_id', $vendor_id)
                                        ->where('payment_status', $payment_status_confirm) // confirmation pending
                                        ->update($arr);
                        
                        // send mail and sms  26-12-2018
                        $bill_no = DB::table('tai_bc_payment_details as p')
                                            ->join('tai_bc_bill_checking_transactions as t', 'p.tai_bc_bill_checking_transactions_id','t.id')
                                            ->select(DB::raw('GROUP_CONCAT(t.vendor_bill_no) as bill_no, SUM(t.tds_amount) AS tds_amount'))
                                            ->where('p.vendor_id', $vendor_id)
                                            ->where('p.key', $key)
                                            ->groupBy('p.vendor_id')
                                            ->first();
                        // dd($bill_no);
                        $credit_amount = str_ireplace("'", "", $value['credit_amount']);

                        $flag = 1 ; //DB::table('cms_settings')->where('id', 22)->first()->content;
                        // dd(1);
                        if($flag==1) {
                            //send sms and email to vendor after payment done with detail
                            // dd($vendor_id, $arr['payment_reference_number'], $bill_no->bill_no, $credit_amount,$bill_no->tds_amount);
                            // $this->sendVendorMailSms($vendor_id, $arr['payment_reference_number'], $bill_no->bill_no, $credit_amount,$bill_no->tds_amount);
                        }
                    }else{
                        
                        return response()->json(['status'=> 0, 'message'=>'Data Not Found', 'data'=>null]);
                    }
                    
                } 
                //comment file moving code and added to after file read code
                // as per discuss with gaurav sir.

            }
            return response()->json(['status'=>1, 'message'=>'Successfully Update Payment', 'data'=>$mainData]);
        }else{
            return response()->json(['status'=>0, 'message'=>'Something Went Wrong', 'data'=>null]);
        }
    }

    public function change_date_format($date)
    {
        $date = strtr($date, '/', '-');
        $date = date("Y-m-d", strtotime($date));
        return $date;
    }

    //auto entry with uniqueId
    public function getBankPaymentDoc($key, $vendor_id = 1, $payment_reference_number)
    {

        //Update new sprogram key, for auto entry, as per discuss with sanmati and gaurav sir.
        $url = 'http://182.76.32.122:8080/acme-document-web/doc/autoGenerateDoc?sProgramKey=1';

        $payment_status_confirm  = DB::table('tai_bc_status_conventions')->where('used_for','Billchecking_Payment_template')
                                                                                        ->where('convention_name','Confirmation Pending')
                                                                                        ->where('is_active',1)->first()->id;

        // dd(DB::select("SELECT `pd`.`payment_reference_number`, `pd`.`key`, `pd`.`bill_type_id`, `v`.`acme_account_name`, `tr`.`tds_amount`, 
        // `pd`.`vendor_id`, SUM(amount_to_be_paid) AS amount, GROUP_CONCAT(DISTINCT(tr.bc_id)) AS bc_id, 
        //  GROUP_CONCAT(DISTINCT(tr.id)) AS transaction_id, GROUP_CONCAT(DISTINCT(pd.id)) AS payment_detail_id 
        //  FROM `tai_bc_payment_details` AS `pd` 
        //  JOIN `tai_bc_vendor_master` AS `v` ON `pd`.`vendor_id` = `v`.`id` 
        //  JOIN `tai_bc_bill_checking_transactions` AS `tr` ON `pd`.`tai_bc_bill_checking_transactions_id` = `tr`.`id` 
        //  LEFT JOIN `tai_bc_bill_type_master` AS `bt` ON `pd`.`bill_type_id` = `bt`.`id` 
        //  WHERE `pd`.`key` = 16694412690 
        //  AND `pd`.`vendor_id` = 1 AND `pd`.`payment_status` = 26 GROUP BY `pd`.`tai_bc_bill_checking_transactions_id` "));

        $result = DB::table('tai_bc_payment_details as pd')
                        ->join('tai_bc_vendor_master as v', 'pd.vendor_id', '=', 'v.id')
                        ->join('tai_bc_bill_checking_transactions AS tr', 'pd.tai_bc_bill_checking_transactions_id', '=', 'tr.id')
                        ->leftjoin('tai_bc_bill_type_master as bt', 'pd.bill_type_id', '=', 'bt.id')
                        ->select('pd.payment_reference_number','pd.key','pd.bill_type_id', 'v.acme_account_name', 'tr.tds_amount',
                        // 'tr.is_padm_entry',
                        'pd.vendor_id',DB::raw('SUM(amount_to_be_paid) as amount'),DB::raw('GROUP_CONCAT(distinct(tr.bc_id)) as bc_id, 
                                        GROUP_CONCAT(distinct(tr.id)) as transaction_id, GROUP_CONCAT(distinct(pd.id)) as payment_detail_id'))
                        ->where('pd.key',$key)
                        //Added Vendor condition as per discuss with Gaurav Sir code updated by Aishwarya Lanke Date :24-01-2020
                        ->where('pd.vendor_id',$vendor_id)

                        // get records of Confirmation Pending(50) status insted of Paid(42)
                        // as discuss with gaurav sir
                        ->where('pd.payment_status',$payment_status_confirm)
                        //->where('is_padm_entry', 0)
                        // ->where('payment_doc_response', '-')
                        // ->groupBy('bill_type')
                        ->groupBy('pd.tai_bc_bill_checking_transactions_id')
                        ->get();
        if (count($result) == 0) {
            return response()->json(['status' => 0, 'message' => "Already generated sereis !!!", 'data' => null]);
        }

        
        $date = date("d-m-Y", strtotime(substr_replace($key, "", -1)));
        $data = array();
        $sub_arr = array();
        $payment_detail_arr = array();
        $payment_detail_advance_arr = array();
        $narration4 = '';
        $total = 0;

        // dd($result);
        foreach ($result as $key => $row) {

            $payment_detail = explode(',', $row->payment_detail_id);
            foreach ($payment_detail as $key => $pd_id) {
                $payment_detail_arr[] = $pd_id;
            }

            // if ($row->bill_type == 'Advance Given') {

            //     $explode_data = explode(',', $row->transaction_id);


            //     $d = DB::table('tai_bc_bill_checking_transactions as tr')
            //                 ->join('tai_bc_payment_details as pd', 'tr.id', '=', 'pd.tai_bc_bill_checking_transactions_id')
            //                 ->leftjoin('tai_bc_bill_type_master as bt', 'pd.bill_type', '=', 'bt.id')
            //                 ->join('tai_bc_vendor_master as v', 'pd.vendor_id', '=', 'v.id')
            //                 // ->leftjoin('tai_bc_section_master as sm', 'tr.tds_section', '=', 'sm.id')
            //                 // ->leftjoin('tai_bc_section_constitution_mapping as scm', 'tr.tds_constitution', '=', 'scm.id')
            //                 ->select('tr.id as transaction_id', 'pd.key', 'bt.bill_type', 'v.acme_acc_name', 'tr.tds', 'tr.bc_id', 
            //                 DB::raw('pd.amt_to_be_paid as amount, tr.tds_amount')) //sm.id as section_id, sm.section_name, scm.constitution_name,
            //                 ->whereIn('tr.id', $explode_data)
            //                 //23-08-2022 NikhilB TicketId:TT3605
            //                 //only get confirmation pending entries for auto entry
            //                 ->where('pd.payment_status', 50)
            //                 ->get();

            //     // echo '<pre>'; 
            //     // print_r($d); 
            //     // print_r($explode_data);
            //     // echo '</pre>';
            //     // die();

            //     foreach ($d as $k => $advance_grive_row) {
            //     // $total += $row->amount;  

            //     //$total += $advance_grive_row->amount;
            //     //  $total = $advance_grive_row->amount+ $advance_grive_row->tds_amount;
            //     // for roundup madhuri L 20190926
            //     // $total = $advance_grive_row->amount+ ceil($advance_grive_row->tds_amount);
            //     $total += $advance_grive_row->amount + ceil($advance_grive_row->tds_amount);
            //     //print_r($total);
            //     //die();




            //     $sub_arr[] = array(
            //         "type"        => "Dr",
            //         "account"     => $advance_grive_row->acme_acc_name,
            //         // "amount"      =>round($advance_grive_row->amount,2),
            //         // "amount"=>round(($advance_grive_row->amount+ $advance_grive_row->tds_amount),2),
            //         "amount" => round(($advance_grive_row->amount + ceil($advance_grive_row->tds_amount)), 2),
            //         "narration"   => $advance_grive_row->bc_id,
            //         "tDSStatus"   => $advance_grive_row->tds > 0 ? true : false,
            //         "tDSSection"      => $advance_grive_row->section_name,
            //         "tDSConstitution" => $advance_grive_row->constitution_name,
            //         // "tDSAmount"   =>round($advance_grive_row->tds_amount,2),
            //         "tDSAmount"   => round(ceil($advance_grive_row->tds_amount), 2),
            //         "tDSSurcharge" => 0,
            //         "tDSCessAmount" => 0,
            //         "hSNCode" => 0,
            //         "sGST" => "",
            //         "cGST" => "",
            //         "iGST" => "",
            //         "cESS" => "",
            //         "gSTType" => "",
            //         "location" => "Corporate Office (HO)"
            //     );
            //     }
            // } else {

                // print_r($row->acme_account_name);
                // die();
                // $total = $row->amount; 
                $total += $row->amount;
                $sub_arr[] = array(
                "type"        => "Dr",
                "account"     => $row->acme_account_name,
                "amount"      => round($row->amount, 2),
                "narration"   => $row->bc_id,
                "tDSStatus"   => false,
                "tDSSection"      => "",
                "tDSConstitution" => "",
                "tDSAmount"   => 0,
                "tDSSurcharge" => 0,
                "tDSCessAmount" => 0,
                "hSNCode" => 0,
                "sGST" => "",
                "cGST" => "",
                "iGST" => "",
                "cESS" => "",
                "gSTType" => "",
                "location" => "Corporate Office (HO)"
                );
            // }

        }
        // dd('endfor');.
        $data = array(
            //auto entry with uniqueId
            "autoDocUniqueId" => 'BC-' . $row->key . '-' . $row->vendor_id . '-' . $payment_reference_number,
            "voucherType"   => "BankPayment",
            // "docMasterName" =>"Bank Payment",
            "docMasterName" => "Bank Payment Ho",
            "date" => date('d/m/Y'),
            "location" => "CENTRALISE OTHER",
            "department" => "ACCOUNTS & FINANCE",
            "bankAccName" => "STATE BANK OF INDIA (RTGS) 3557",
            "instrumentType" => "other",
            "narration" => "Auto Doc",
            "amount" => round($total, 2),
            "narration1" => "Being Amt paid against cspl id:",
            "narration2" => date('d/m/Y'),
            "narration3" => "UTR NO-" . $row->payment_reference_number,
            "narration4" => "narr4",
            "narration5" => "narr5",
            "chequeNo" => "123456789",
            "chequeDdDate" => date('d/m/Y'),
            "ddNo" => "",
            "ourGstnNo" => "27AADCC0012C1ZL",
            "docLineItemFields" => $sub_arr
        );

        unset($sub_arr);

        // convet json format
        $data = json_encode($data);

        // dd($data);
       
        # a pass-thru script to call my Play server-side code.
        # currently needed in my dev environment because Apache and Play run on
        # different ports. (i need to do something like a reverse-proxy from
        # Apache to Play.)

        # the POST data we receive from Sencha (which is not JSON)

        $data_string = $data;

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch,CURLOPT_HTTPHEADER,
        array(
            'Content-Type: application/json',
            'Authorization:jdO4jCFnTnOPA5VnQHOmgLhnTnONZeZcRnO3.jdO4EB9mgsWIg6WqNotcQHOmhMGIg6WqNotcQHOog65bV63pEXN0RXbniCSqhpSaELZnToNbSIpxNrcaE4SaELZnToJdQHOoiCOdEB94Zr3xEZSaELZnToJbTIJxNsWdDZqpNotnNnbnErqdgZEugqqqDCOOEHN0Rs4.4u2aD8g6bgtaSFEVc3m7zLqcoJIlhaD4os2o_qUFERh23JRtgYk_X-2Tdw2j289ZUZrPLC9pIewm_gC1EAgT3l',
            'X-key:zVhY2RjNGFormBoWI4LWE3YmYtZmY2MzVh',
            'Content-Length:'.strlen($data_string)
        )
        );
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        $result = curl_exec($ch);
        // dd($result, 'hi');
        if (!curl_errno($ch)) {
            $info = curl_getinfo($ch);
            // echo 'Took ' . $info['total_time'] . ' seconds to send a request to ' . $info['url'];
        } else {
            $result =  curl_error($ch);
            // echo 'Curl error: ' . curl_error($ch);
        }
        // dd($result,$data_string);

        // $result = '{"data":{"series":"IB1P","docCode":16551631,"docDate":"26/11/2022","docNo":1726,"resultList":[{"series":"IB1P","docNo":1726,"docCode":16551631}],"totalDocument":1}}';
        // if (!curl_errno($ch)) {
        //     $info = curl_getinfo($ch);
        //     echo 'Took ' . $info['total_time'] . ' seconds to send a request to ' . $info['url'];
        // } else {
        //     $result =  curl_error($ch);
        //     echo 'Curl error: ' . curl_error($ch);
        // }
        //auto entry with uniqueId
        //sleep(1); // Wait 1 second before retrying
        //close connection
        // curl_close($ch);
        $result = json_decode($result);
        // dd($result);
        
        if ($result) {
            if ($result->data->totalDocument) {

                foreach ($payment_detail_arr as $key => $sr) {
                # code...
                DB::table('tai_bc_payment_details')
                    ->where('id', $sr)
                    ->where('payment_doc_response', '-')
                    ->update(['payment_doc_response' => json_encode($result)]);
                }

                $arrayName = array(
                    'series' => $result->data->series,
                    'doc_code' => $result->data->docCode,
                    'doc_date' => $this->change_date_format($result->data->docDate),
                    'doc_no' => $result->data->docNo,
                    'total_document' => $result->data->totalDocument,
                    'created_by'  => 40,
                    'created_at'  => now()
                );
                // dd($arrayName);
                $insertGetId = DB::table('tai_bc_doc_series')->insertGetId($arrayName);
                $list = array();
                foreach ($result->data->resultList as $key => $row) {
                    $list[] = array(
                        'series' => $row->series,
                        'doc_no' => $row->docNo,
                        'doc_code' => $row->docCode,
                        'tai_bc_doc_series_id' => $insertGetId,
                        'created_at' => now()
                    );
                }
                // dd($list);
                if (count($list)) {
                    DB::table('tai_bc_doc_series_list')->insert($list);
                }
                $file = time() . '_file.json';
                $destinationPath = storage_path() . "/app/Attachment/BillChecking/uploads/json/";
                if (!is_dir($destinationPath)) {
                    mkdir($destinationPath, 0777, true);
                }
                File::put($destinationPath . $file, $data);
                // return response()->download($destinationPath.$file);

                $msg = json_encode($result);
                // dd('success');   / 
                // CRUDBooster::redirect(CRUDBooster::mainpath('payment-update'), $msg, 'success');
            }
            // dd('end if');
        } else {
            // dd('error');
        // CRUDBooster::redirect(CRUDBooster::mainpath('payment-update'), 'Padm not getting response.', 'danger');
        }

        // }  
        return false;
    }

    //send sms and email to vendor after payment done with detail
    public function sendVendorMailSms($vendor_id = '', $utr_number = '', $bill_no = '', $credit_amount = '', $tds_amount = '')
    {
        // dd($vendor_id, $utr_number, $bill_no, $credit_amount,$tds_amount);

        $vendor_data = DB::table('tai_bc_vendor_master')
                            ->select('id', 'vendor_name', 'email', 'mobile_no')
                            ->where('id', 1)//$vendor_id)
                            ->first();


        // dd($vendor_data);

        $data = array();
        $data['id']         = $vendor_data->id;
        $data['name']       = $vendor_data->vendor_name;
        $data['email']   = $vendor_data->email;
        $data['mobile_no'] = $vendor_data->mobile_no;
        $data['email']   = 'punam.shinde@techneai.com';
        $vendor_data->mobile_no = '8329717539';

        $data['utr_no'] = $utr_number;
        $data['bill_no'] = $bill_no;
        $data['amount'] = $credit_amount;

        if ($vendor_data->mobile_no != 'NA' || $vendor_data->mobile_no != '' || strlen($vendor_data->mobile_no) >= 10) {
            //send sms
            if ($tds_amount > 0) {
                // $body = 'Payment of Rs. '.$credit_amount.' against bill no '.$bill_no.' done vide UTR No '.$utr_number.'. TDS amount Rs. '.$tds_amount.' Chndukaka Saraf & Sons Pvt Ltd';
                $body = 'Payment of Rs. '.$credit_amount.' against bill no '.$bill_no.' done vide UTR No '.
                        $utr_number.'. TDS amount Rs. '.$tds_amount.' deducted against this bill Chandukaka Saraf & Sons Pvt Ltd';
            } else {
                $body = 'Payment of Rs. '.$credit_amount.' against bill no '.$bill_no.' done vide UTR No '.$utr_number.' .';
            }

            // $response = SMSLibrary::sms($vendor_data->mobile_no, $body);
            // dd($response);
            $arrayName = array();
            $arrayName['receiver']  = $vendor_data->mobile_no;
            $arrayName['scheduled_datetime'] = now();
            $arrayName['sender_name']        = 'CSPL-HO';
            $arrayName['sender']             = 'CSPL-HO';
            $arrayName['created_by']         = 40;
            $arrayName['type']               = 'sms';
            $arrayName['source']            = 'Auto Payment';
            $arrayName['created_at']            = date("Y-m-d H:i:s");

            // if ($response['status'] == 1) {
            //     $arrayName['is_sent']            = 'S';
            //     $arrayName['response']         = $response['response'];
            //     $arrayName['sent_at']            = now();
            //     $arrayName['delivery_datetime']            = now();
            // } else {
            //     $arrayName['is_sent']            = 'F';
            //     $arrayName['sent_at']            = now();
            // }
            // dd($arrayName);
            // DB::table('cms_cspl_communication_detail')->insert($arrayName);
        }

        // $to_name = $data['name'];
        // $to_email = $data['email_id'];
        // $to_email = filter_var($to_email, FILTER_SANITIZE_EMAIL);

        // Validate email
        // if (filter_var($to_email, FILTER_VALIDATE_EMAIL)) {
        //     \Mail::send('email.bill-checking-email', $data, function ($message) use ($to_name, $to_email) {
        //         $message->to($to_email, $to_name)
        //         ->subject('Regarding Payment');
        //         $message->from('noreply@csjewellers.com', $report);
        //     });
        // }
    }

}