<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use App\Library\CommonController;
use JWTAuth;

class BillTypeMasterController extends Controller
{
    // get convention master data for dropdown

    public function getDropdowns(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate();

        //PARAM : used_for : BC_Legal_Status,

        if ($request->used_for) {
            if (!is_array($request->used_for)) {
                $keys = explode(',', $request->used_for);
            } else {
                $keys = $request->used_for;
            }

            $data = [];
            foreach ($keys as $k) {
                $temp = DB::table('tai_bc_status_conventions')->where('used_for', $k)->where('is_active', 1)->orderBy('sort_order', 'ASC')->get();
                $tempData = [];
                foreach ($temp as $t) {
                    $tempData[$k][] = ['id' => $t->id, 'name' => $t->convention_name, 'is_active' => $t->is_active];
                }
                $data[] = $tempData;
            }
            return response()->json(['status' => 1, 'message' => "Data Found !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "Required Used For Filed !!!", 'data' => NULL]);
        }
    }

    // section master
    public function getSectionDropdown()
    {
        $token_data = JWTAuth::parseToken()->authenticate();

        $data = DB::table('tai_bc_section_master')->where('is_active', 1)->get();
        return response()->json(['status' => 1, 'message' => "Data Found !!!", 'data' => $data]);
    }

    public function getSectionMappingDropdown(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();

        // dd($request->id);
        $data = DB::table('tai_bc_section_constitution_mapping')->where('bc_section_master_id', $id)->where('is_active', 1)->get();
        return response()->json(['status' => 1, 'message' => "Data Found !!!", 'data' => $data]);
    }


    // payment status dropdown
    public function getPaymentStatusDropdown()
    {
        $token_data = JWTAuth::parseToken()->authenticate();

        $data = DB::table('tai_bc_status_conventions')->select('id', 'convention_name')->where('used_for', 'Payment_Status')->where('is_active', 1)->get();
        return response()->json(['status' => 1, 'message' => "Data Found !!!", 'data' => $data]);
    }

    // API for get bill type employee mapping
    public function getBillTypeMappedEmp(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();

        $data = DB::table('tai_bc_employee_bill_type_mapping as m')
            ->leftJoin('tai_employee_master as e', 'm.employee_id', 'e.id')
            ->where('m.bill_type_id', $id)
            ->where('m.is_active', 1)
            ->where('e.is_active', 1)
            ->select('e.id', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS employee_name"))
            ->get();
        return response()->json(['status' => 1, 'message' => "Data Found !!!", 'data' => $data]);
    }

    // public function getConventionDropdown()
    // {
    //     $result = DB::table('tai_bc_status_conventions')->where('used_for','BC_Legal_Status')->where('is_active',1)->get();
    //     if(count($result)>0){
    //         return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
    //     }else{
    //         return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
    //     } 
    // }

    // // get bill type master for dropdown
    // public function getBillTypeDropdown($tenantId)
    // {
    //     $result = DB::table('tai_bc_bill_type_master')->where('is_active',1)->where('tenant_id',$tenantId)->get();
    //     if(count($result)>0){
    //         return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
    //     }else{
    //         return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
    //     }
    // }

    // get data for admin side
    public function getBillTypeData(Request $request, $type = null)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        // dd($tenantId, $type);
        if ($request->user_id) {
            $result = DB::table('tai_bc_bill_type_master as bt')
                ->select('bt.*', DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'bt.updated_by')
                ->leftJoin('tai_employee_master as em', 'em.id', '=', 'bt.created_by')
                ->leftJoin('tai_bc_employee_bill_type_mapping as map', 'map.bill_type_id', '=', 'bt.id')
                ->where('map.employee_id', $request->user_id)
                ->where('bt.tenant_id', $tenantId)
                ->orderBy('id', 'Desc')
                ->get();

            $data = [];
            foreach ($result as $row) {

                $res['id'] = $row->id;
                $res['tenant_id'] = $row->tenant_id;
                // $res['employee_id'] = $row->employee_id;
                $res['bill_type'] = $row->bill_type;
                $res['is_active'] = $row->is_active;
                $res['remark'] = $row->remark;
                $res['created_at'] = $row->created_at;
                $res['created_by'] = $row->created_by;
                $res['updated_at'] = $row->updated_at;
                $res['updated_by'] = $row->updated_by;

                $res['employee'] = DB::table('tai_bc_employee_bill_type_mapping as m')
                    ->leftJoin('tai_employee_master as e', 'e.id', '=', 'm.employee_id')
                    ->where('m.bill_type_id', $row->id)
                    ->where('m.is_active', 1)
                    ->select('m.employee_id', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS employee"))
                    ->get();
                $data[] = $res;
                // dd($que);
            }
            $result = $data;
        } else {
            $result = DB::table('tai_bc_bill_type_master as bt')
                ->select('bt.*', DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'bt.updated_by')
                ->leftJoin('tai_employee_master as em', 'em.id', '=', 'bt.created_by')
                ->where('bt.tenant_id', $tenantId)
                ->orderBy('id', 'Desc');
            if ($type != null) {
                $result = $result->where('bt.is_active', 1)->get();
            } else {
                $result = $result->get();
            }

            $data = [];
            foreach ($result as $row) {

                $res['id'] = $row->id;
                $res['tenant_id'] = $row->tenant_id;
                // $res['employee_id'] = $row->employee_id;
                $res['bill_type'] = $row->bill_type;
                $res['is_active'] = $row->is_active;
                $res['remark'] = $row->remark;
                $res['created_at'] = $row->created_at;
                $res['created_by'] = $row->created_by;
                $res['updated_at'] = $row->updated_at;
                $res['updated_by'] = $row->updated_by;



                $res['employee'] = DB::table('tai_bc_employee_bill_type_mapping as m')
                    ->leftJoin('tai_employee_master as e', 'e.id', '=', 'm.employee_id')
                    ->where('m.bill_type_id', $row->id)
                    ->where('m.is_active', 1)
                    ->select('m.employee_id', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS employee"))
                    ->get();
                $data[] = $res;
                // dd($que);
            }
            $result = $data;
            // return $result;             
        }

        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    // get By Id 
    public function getBillTypeDataById(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        if ($id) {
            $data = $request->toArray();
            // dd();
            $result = DB::table('tai_bc_bill_type_master')->where('id', $id)->first();

            $bill_type_authority = DB::table('tai_bc_bill_multi_approval_authority as mt')
                ->select(
                    'mt.employee_id as employee_id',
                    'mt.amount as amount',
                    'mt.is_required_number as is_required_number',
                    'mt.bil_approval_level as bil_approval_level'
                )
                ->join('tai_bc_bill_type_master as bt', 'bt.id', '=', 'mt.bil_type_id')
                ->join('tai_employee_master as em', 'em.id', '=', 'mt.employee_id')
                ->where('mt.is_active', 1)
                ->where('mt.bil_type_id', $id)->groupby('bil_approval_level')
                ->get();
            // dd($bill_type_authority);

            foreach ($bill_type_authority as $d) {
                $employee_ids = DB::table('tai_bc_bill_multi_approval_authority as mt')
                    ->select(DB::raw('group_concat(employee_id SEPARATOR ",") as employee_id'))
                    ->where('bil_type_id', $id)
                    ->where('bil_approval_level', $d->bil_approval_level)
                    //->where('mt.is_active', 1)
                    ->first();
                $employee_ids = DB::table('tai_employee_master')->select('id as id')->whereIn('id', explode(",", $employee_ids->employee_id))->get();

                $requiredEmp = DB::table('tai_bc_bill_multi_approval_authority as mt')
                    ->select(DB::raw('group_concat(employee_id SEPARATOR ",") as employee_id'))
                    ->where('bil_type_id', $id)
                    ->where('bil_approval_level', $d->bil_approval_level)
                    ->where('is_required', 1)
                    // ->where('mt.is_active', 1)
                    ->first();
                $requiredEmp = DB::table('tai_employee_master')->select('id as id')->whereIn('id', explode(",", $requiredEmp->employee_id))->get();

                $d->employee_id = (object)$employee_ids;
                $d->required_users = (object)$requiredEmp;
                // $d->is_editable = 0;
            }
            // dd($bill_type_authority);
            // $bill_type_authority = $is_required;
            //dd($is_required);

            $approval_data =  DB::table('tai_bc_bill_multi_approval_authority as mt')
                ->select('bt.bill_type as bill_type', 'bt.tenant_id as tenant_id', 'bt.remark as remark', 'mt.levels_of_approver as levels_of_approver', 'bt.is_active as is_active')
                ->join('tai_bc_bill_type_master as bt', 'bt.id', '=', 'mt.bil_type_id')
                //->where('mt.is_active', 1)
                ->where('bil_type_id', $id)->first();

            $is_required = DB::table('tai_bc_bill_multi_approval_authority')
                ->select('employee_id', 'bil_approval_level')
                ->where('is_required', 1)
                //->where('mt.is_active', 1)
                ->where('bil_type_id', $id)->get();

            // dd($is_required);
            if ($result) {
                $result->employee = DB::table('tai_bc_employee_bill_type_mapping as e')
                    ->leftJoin('tai_employee_master as emp', 'e.employee_id', '=', 'emp.id')
                    ->where('e.bill_type_id', $id)
                    ->select('emp.id')
                    ->get()->pluck('id');
            } else {
                $result['employee'] = [];
            }

            $approval_data->approver = $bill_type_authority;
            $approval_data->assign_users = $result->employee;
            $approval_data->approver->is_required = $is_required;
            $data = $approval_data;

            // dd($data);
            //$data = $bill_type_authority;

            if ($result) {
                return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $data]);
            } else {
                return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "ID Not found !!!", 'data' => null]);
        }
    }

    // create new data
    public function createBillType(Request $request, $id = '')
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        if ($id) {
            $data = $request->toArray();
            //  dd($data);
            // if (!$request->bill_type && !$request->remark && !$request->is_active) {
            //     return response()->json(['status' => 0, 'message' => "Required Bill Type !!!", 'data' => null]);
            // }

            $result = array(
                'tenant_id'    => $request->tenant_id ? $request->tenant_id : 1,
                'bill_type'    => $request->bill_type,
                'remark'       => $request->remark,
                'is_active'    => $request->is_active,
                'updated_at' => $request->updated_at,
                'updated_by' => $request->updated_by
            );


            $check = DB::table('tai_bc_bill_type_master')
                ->where('id', '!=', $id)
                ->where('bill_type', $request->bill_type)
                ->first();

            $decode = json_decode($data['approverData']);
            foreach ($decode as $d) {
                foreach ($d as $value) {
                    if ($value->amount == null && $value->required_numbers != null) {
                        return response()->json(['status' => 0, 'message' => "Amount is required !!!", 'data' => null]);
                    }
                }
            }

            $result = DB::table('tai_bc_bill_type_master')->where('id', $id)->update($result);
            // dd($result);
            DB::table('tai_bc_employee_bill_type_mapping')->where('bill_type_id', $id)->delete();
            DB::table('tai_bc_bill_multi_approval_authority')->where('bil_type_id', $id)->delete();
            // DB::table('tai_bc_bill_multi_approval_authority')->where('bil_type_id', $id)->update(['is_active' => 0]);



            // if ($key !== false) {
            //     return response()->json(['status' => 0, 'message' => "Amount is required !!!", 'data' => null]);
            // }

            foreach ($decode as $d) {
                // return ($d);
                foreach ($d as $value) {
                    // return ($value->employee_id);
                    // dd(is_array($value), is_object($value));
                    if ($value->employee_id && count(($value->employee_id))) {
                        foreach ($value->employee_id as $e) {
                            //  dd($value['employee_id']);
                            $is_required = in_array($e, $value->required_users) ? 1 : 0;

                            $table_insert = DB::table('tai_bc_bill_multi_approval_authority')->insertGetId([
                                'bil_type_id' => $id,
                                'employee_id' => $e ? $e : 1,
                                'amount' =>  $value->amount,
                                'is_required' => $is_required,
                                'is_required_number' => $value->required_numbers,
                                'bil_approval_level' => $value->bill_approval_level,
                                'created_at' => date('Y-m-d H:i:s'),
                                'created_by' => $request->user_id,
                                'levels_of_approver' => $request->levels_of_approver,
                            ]);
                        }
                    }
                }
            }



            // dd($request->employee_id);
            if (count($request->assign_employee_id)) {
                // dd('hi');
                foreach ($request->assign_employee_id as $emp) {
                    $emp_res = array(
                        'tenant_id'    => $request->tenant_id ? $request->tenant_id : 1,
                        'bill_type_id'    => $id,
                        'employee_id' => $emp,
                        'remark'       => $request->remark,
                        'is_active'    => 1,
                        'updated_at' => $request->updated_at,
                        'updated_by' => $request->updated_by
                    );
                    $data = DB::table('tai_bc_employee_bill_type_mapping')->insert($emp_res);
                }
            }
            // dd('bye');


            // if($request->employee_id >= 0)
            // {
            //     foreach($request->employee_id as $emp_res)
            //     {
            //         foreach($emp as $e)
            //         {
            //             // dd($emp_res,$emp, $e);
            //                 if($emp_res == $e->id)
            //                 {
            //                     // dd($request->employee_id,1);
            //                     $emp_result = array(
            //                         'tenant_id'    => $request->tenant_id,
            //                         'bill_type_id'    => $id,
            //                         'employee_id' => $e->id,
            //                         'remark'       => $request->remark,
            //                         'is_active'    => 1,
            //                         'updated_at' => $request->updated_at,
            //                         'updated_by' => $request->updated_by
            //                     );
            //                     $data = DB::table('tai_bc_employee_bill_type_mapping')->where('id',$id)->update($emp_result);

            //                 }else{
            //                     // dd($request->employee_id,2);
            //                     $emp_result = array(
            //                         'tenant_id'    => $request->tenant_id,
            //                         'bill_type_id'    => $id,
            //                         'employee_id' => $emp_res,
            //                         'remark'       => $request->remark,
            //                         'is_active'    => 1,
            //                         'updated_at' => $request->updated_at,
            //                         'updated_by' => $request->updated_by
            //                     );
            //                     $data = DB::table('tai_bc_employee_bill_type_mapping')->insert($emp_result);
            //                 }

            //         }


            //     }

            // }
            // else{
            //     dd($request->employee_id);
            //     foreach($request->employee_id as $emp)
            //     {
            //         $emp_res = array(
            //             'tenant_id'    => $request->tenant_id,
            //             'bill_type_id'    => $id,
            //             'employee_id' => $emp,
            //             'remark'       => $request->remark,
            //             'is_active'    => 1,
            //             'updated_at' => $request->updated_at,
            //             'updated_by' => $request->updated_by
            //         );
            //         $data = DB::table('tai_bc_employee_bill_type_mapping')->insert($emp_res);
            //     }
            // }

            // $data = DB::table('tai_bc_employee_bill_type_mapping')->insert($emp_data);
            // if($result){
            // $table = 'tai_bc_bill_type_master';
            // $result = (array) DB::table('tai_bc_bill_type_master')->where('id', $id)->first();
            // CommonController::generateHistory("UPDATE", $table,$id);

            return response()->json(['status' => 1, 'message' => "Bill Type Updated !!!", 'data' => $id]);
            // }else{
            //     return response()->json(['status'=> 0, 'message'=> "Bill Type Not Updated !!!",'data' => null]);
            // }

        } else {
            // if (!$request->bill_type && !$request->remark && !$request->is_active ) {
            //     return response()->json(['status' => 0, 'message' => "Required Bill Type !!!", 'data' => null]);
            // }
            // dd($request->all());
            $data = $request->toArray();
            //dd($data);
            // dd($request->all());
            //  dd($data);
            // $check = DB::table('tai_bc_bill_type_master')
            //     ->where('bill_type', $request->bil_type_id)
            //     ->first();
            if (!$request->bill_type) {
                return response()->json(['status' => 0, 'message' => "Bill Type Not Found !!!", 'data' => null]);
            } else {

                $already = DB::table('tai_bc_bill_type_master')
                    ->where('bill_type', $request->bill_type)
                    ->first();

                if ($already) {
                    return response()->json(['status' => 0, 'message' => "Bill Type Already Exists !!!", 'data' => null]);
                }


                $result = array(
                    'tenant_id' => $request->tenant_id ? $request->tenant_id : 1,
                    'bill_type'    => $request->bill_type,
                    'remark'       => $request->remark,
                    'is_active'    => $request->is_active,
                    'created_at' => $request->created_at,
                    'created_by' => $request->created_by
                );
                // dd($result);  
                $id = DB::table('tai_bc_bill_type_master')->insertGetId($result);

                // dd($data['approverData']);
                $decode = json_decode($data['approverData']);

                foreach ($decode as $d) {
                    foreach ($d as $value) {
                        if ($value->amount == null && $value->required_numbers != null) {
                            return response()->json(['status' => 0, 'message' => "Amount is required !!!", 'data' => null]);
                        }
                    }
                }

                foreach ($decode as $d) {
                    // dd($d);
                    foreach ($d as $value) {
                        //dd($value->employee_id);
                        // dd(is_array($value), is_object($value));
                        if ($value->employee_id && count(($value->employee_id))) {
                            foreach ($value->employee_id as $e) {
                                //  dd($value['employee_id']);
                                $is_required = in_array($e, $value->required_users) ? 1 : 0;

                                $table_insert = DB::table('tai_bc_bill_multi_approval_authority')->insertGetId([
                                    // dd('hello'),
                                    'bil_type_id' => $id,
                                    'employee_id' => $e ? $e : 1,
                                    'amount' =>  $value->amount,
                                    'is_required' => $is_required,
                                    'is_required_number' => $value->required_numbers,
                                    'bil_approval_level' => $value->bill_approval_level,
                                    'created_at' => date('Y-m-d H:i:s'),
                                    'created_by' => $request->user_id,
                                    'levels_of_approver' => $request->levels_of_approver,
                                ]);
                            }
                        }
                    }
                }

                if (count($request->assign_employee_id) > 0) {
                    foreach ($request->assign_employee_id as $emp) {
                        $emp_res = array(
                            'tenant_id'    => $request->tenant_id ? $request->tenant_id : 1,
                            'bill_type_id'    => $id,
                            'employee_id' => $emp,
                            'remark'       => $request->remark,
                            'is_active'    => 1,
                            'created_at' => $request->created_at,
                            'created_by' => $request->created_by
                        );
                        $data = DB::table('tai_bc_employee_bill_type_mapping')->insert($emp_res);
                    }
                }

                if ($table_insert) {
                    // $table = 'tai_bc_bill_type_master';
                    // $result = (array) DB::table('tai_bc_bill_type_master')->where('id', $id)->first();
                    // CommonController::generateHistory("INSERT", $table, $id);

                    return response()->json(['status' => 1, 'message' => "Bill Type Inserted !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Bill Type Not Inserted !!!", 'data' => null]);
                }
            }
        }
    }

    // public function updateBillType(Request $request, $id)
    // {
    //     if(!$request->bill_type && !$request->sort_order && !$request->remark && !$request->is_active)
    //     {
    //         return response()->json([ 'status'=> 0, 'message'=> "Required Bill Type and Sort Order !!!", 'data' => null]);
    //     }

    //     $data=$request->toArray();

    //     $check = DB::table('tai_bc_bill_type_master')
    //                 ->where('id','!=',$id)  
    //                 ->where('bill_type', $data['bill_type'])
    //                 ->orwhere('sort_order', $data['sort_order'])      
    //                 ->first();

    //     if($check)
    //     {
    //         return response()->json([ 'status'=> 0,'message'=> "Bill Type Already Exists !!!", 'data' => null]);
    //     }
    //     else{

    //         $result = DB::table('tai_bc_bill_type_master')->where('id',$id)->update($data);
    //         if($result){
    //             return response()->json(['status'=> 1, 'message'=> "Bill Type Updated !!!", 'data' => $result]);
    //         }else{
    //             return response()->json(['status'=> 0, 'message'=> "Bill Type Not Updated !!!",'data' => null]);
    //         }
    //     } 
    // }


    // get bill type history by Id
    public function getBillTypeHistoryById(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = DB::table('tai_bc_bill_type_master_history as bt')
            ->select('bt.*', DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'bt.updated_by')
            ->leftJoin('tai_employee_master as em', 'em.id', '=', 'bt.created_by')
            ->where('bt.id', $id)->get();

        return response()->json(['status' => 1, 'message' => "Found Data", 'data' => $data]);
    }

    // get bill type history
    public function getBillTypeHistory(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = DB::table('tai_bc_bill_type_master_history as bt')
            ->select('bt.*', DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'bt.updated_by')
            ->leftJoin('tai_employee_master as em', 'em.id', '=', 'bt.created_by')
            ->get();
        return response()->json(['status' => 1, 'message' => "Found Data", 'data' => $data]);
    }


    // create bill type mapping
    public function updateBillTypeMapping(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        if ($request->id && $request->employee_id && $request->bill_type_id && $request->is_active) {
            $result = $request->all();
            $data = DB::table('tai_bc_employee_bill_type_mapping')->where('id', $id)->update($result);
            if ($data) {
                return response()->json(['status' => 1, 'message' => "Data Updated Successfully !!!", 'data' => $data]);
            } else {
                return response()->json(['status' => 0, 'message' => "Data Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Required All Data !!!", 'data' => $data]);
        }
    }

    // get all data
    public function getBillTypeMapping($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = DB::table('tai_bc_employee_bill_type_mapping')->where('bill_type_id', $id)->get();
        return response()->json(['status' => 0, 'message' => "Data Not Inserted !!!", 'data' => $data]);
    }
}
