<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use JWTAuth;

class ConnectorController extends Controller
{
    public function postVendor(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();

        $insert = DB::table('tai_connector_master')->insert($data);
        if($insert){
            return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!",'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "Not Inserted !!!",'data' => null]);
        } 
    }

    public function getVendor(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $result=[];

        $getType = DB::table('tai_connector_master')->where('is_active', 1)->groupBy('type')->get('type');

        $data = DB::table('tai_connector_master')->where('is_active', 1)->get();

        foreach ($getType as $val){
            foreach ($data as $key => $value) {
                
                $get = DB::table('tai_connector_tenant')->where('tenant_id', $tenantId)->where('connector_id', $value->id)->where('is_active',1)->first();
                if($get){                    
                    $isD = ['isDefault'=>1];
                    if($val->type == $value->type){ $result[$val->type][] = $value = array_merge(json_decode(json_encode($value), true), $isD); }
                }else{
                    if($val->type == $value->type){ $result[$val->type][] = $value; }
                }
            } 
        }

        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        } 
    }

    public function postConnector(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();

        unset($data['user_id']);
        unset($data['status']);
        unset($data['type']);

        $getTenant = DB::table('tai_employee_master')->where('id', $request->user_id)->first();

        $deactiveOtherVendors = DB::table('tai_connector_tenant as ct')->join('tai_connector_master as cm', 'cm.id', '=', 'ct.connector_id')->where('cm.type', $request->type)->where('ct.tenant_id', $getTenant->tenant_id)->update(['ct.is_active'=>0]);

        $data = array_merge($data, ['tenant_id'=>'1']);
        if($request->status == 'Active'){
            $insert = DB::table('tai_connector_tenant')->insert([$data]);
        }        

        $getType = DB::table('tai_connector_master')->where('is_active', 1)->groupBy('type')->get('type');

        $data = DB::table('tai_connector_master')->where('is_active', 1)->get();

        foreach ($getType as $val){
            foreach ($data as $key => $value) {
                
                $get = DB::table('tai_connector_tenant')->where('tenant_id', $tenantId)->where('connector_id', $value->id)->where('is_active',1)->first();
                if($get){                    
                    $isD = ['isDefault'=>1];
                    if($val->type == $value->type){ $result[$val->type][] = $value = array_merge(json_decode(json_encode($value), true), $isD); }
                }else{
                    if($val->type == $value->type){ $result[$val->type][] = $value; }
                }
            } 
        }

        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        } 
    }

    public function getConnector($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        
        $result = DB::table('tai_connector_tenant')->where('tenant_id', $id)->get();
        if($result){
            return $result;
        }else{
            return 'Not Found';
        }
    }
   
}
