<?php
// live
namespace App\Http\Controllers;

use App\Models\Tenant;
use Illuminate\Http\Request;
use DB;
use JWTAuth;

class CustomerController extends Controller
{
    public function getAllCustomer(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_customer_master as t')
            ->leftJoin('tai_customer_type_master as ty', 'ty.id', '=', 't.customer_type_id')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 't.updated_by')
            ->leftJoin('tai_employee_master as ec', 'ec.id', '=', 't.created_by')
            ->leftjoin('tai_country_master as tcm', 't.country_id', 'tcm.id')
            ->leftjoin('tai_city_master as tc', 't.city_id', 'tc.id')
            ->leftjoin('tai_state_master as ts', 't.state_id', 'ts.id')
            ->where('t.tenant_id', $tenantId)
            ->select('t.*', 'tcm.country', 'tc.city', 'ts.state', 'ty.type_name', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"))
            ->orderBy('t.is_active', 'DESC')
            ->orderBy('t.id', 'DESC')
            ->get();

        // if ($token_data->customer_id) {
        //     $result = $result->where('t.id', $customerId);
        // }
        // $result = $result->select('t.*', 'tcm.country', 'tc.city', 'ts.state', 'ty.type_name', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"))
        //     ->orderBy('t.is_active', 'DESC')
        //     ->orderBy('t.id', 'DESC')
        //     ->get();

        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function createCustomer(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = $request->toArray();

        $check = DB::table('tai_customer_master')
            ->where('email_id', $request->email_id)
            ->first();

        $data['is_active'] = 1;
        $already = DB::table('tai_customer_master')
            ->where('name', $request->name)
            ->where('customer_type_id', $request->customer_type_id)
            ->first();
        if ($already) {
            return response()->json(['status' => 0, 'message' => "Customer Name (Duplicate) Alreday Exist !!!", 'data' => null]);
        }

        if ($check) {
            return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
        } else {
            $result = DB::table('tai_customer_master')->insert($data);
            if ($result > 0) {
                return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
            }
        }
    }

    public function updateCustomer(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        // $customerId = $token_data->customer_id;

        $check = DB::table('tai_customer_master')
            ->where('id', '!=', $id)
            ->where('tenant_id', $tenantId)
            ->where('email_id', $request->email_id)
            ->get();

        $already = DB::table('tai_customer_master')
            ->where('name', $request->name)
            ->where('tenant_id', $tenantId)
            ->where('customer_type_id', $request->customer_type_id)
            ->where('id', '!=', $id)
            ->first();
        if ($already) {
            return response()->json(['status' => 0, 'message' => "Customer Name (Duplicate) Alreday Exist !!!", 'data' => null]);
        }

        if (count($check) == 0) {

            $result = DB::table('tai_customer_master')->where('id', $id)->update($request->toArray());
            if ($result) {
                return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Email Id Alreday Exist !!!", 'data' => null]);
        }
    }

    public function deleteCustomer($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;

        $result = DB::table('tai_customer_master')
            ->where('tenant_id', $tenantId)
            ->where('id', $id)
            ->delete();

        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Deleted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Deleted !!!", 'data' => null]);
        }
    }

    public function getCustomerById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        
        $result = DB::table('tai_customer_master as t')
            ->leftJoin('tai_customer_type_master as ty', 'ty.id', '=', 't.customer_type_id')
            ->where('t.id', $id)
            ->where('t.tenant_id', $tenantId)
            ->select('t.*', 'ty.type_name')
            ->first();

        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }
}
