<?php
// live
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use JWTAuth;

class CustomerTypeController extends Controller
{
    public function getAllCustomerType(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_customer_type_master as t')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 't.updated_by')
            ->leftJoin('tai_employee_master as ec', 'ec.id', '=', 't.created_by')
            ->where('t.tenant_id', $tenantId)
            ->select('t.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"),DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"))
            ->orderBy('t.is_active', 'DESC')
            ->orderBy('t.id', 'DESC')
            ->get();

        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function createCustomerType(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;

        // return $data['type_name'];
        if (array_key_exists('type_name', $data) && $data['type_name']) {
            $check = DB::table('tai_customer_type_master')->where('type_name', $data['type_name'])->first();
            if ($check) {
                return response()->json(['status' => 0, 'message' => "Customer Type Already Exists !!!", 'data' => null]);
            } else {
                $result = DB::table('tai_customer_type_master')->insert($data);
                if ($result > 0) {
                    return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
                }
            }
        }
    }

    public function updateCustomerType(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = $request->toArray();
        if (!$id) {
            return response()->json(['status' => 0, 'message' => "Required Customer Type !!!", 'data' => null]);
        }
        $check = DB::table('tai_customer_type_master')->where('tenant_id', $tenantId)->where('type_name', $data['type_name'])->where('id', '!=', $id)->where('is_active', 1)->first();
        if (!$check) {
            $result = DB::table('tai_customer_type_master')->where('tenant_id', $tenantId)->where('id', $id)->update($data);
            if ($result) {
                return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Customer Type Already Exists !!!", 'data' => null]);
        }
    }


    public function deleteCustomerType($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_customer_type_master')->where('tenant_id', $tenantId)->where('id', $id)->update(['is_active' => 0]);
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Deleted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Deleted !!!", 'data' => null]);
        }
    }

    public function getCustomerTypeById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_customer_type_master')->where('tenant_id', $tenantId)->where('id', $id)->first();
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }
}
