<?php
// live
namespace App\Http\Controllers;

use App\Models\Department;
use Illuminate\Http\Request;
use DB;
use JWTAuth;

class DepartmentController extends Controller
{
    public function getAllDepartment(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;

        $query = DB::table('tai_department_master as d')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'd.updated_by')
            ->leftJoin('tai_employee_master as ec', 'ec.id', '=', 'd.created_by');
        // ->where('d.is_active', 1);

        if ($request->header('X-Type')) {
            $query->select('d.id', 'd.tenant_id', 'd.department');
        } else {
            // Date: 05-06-2023 Punam shinde
            // if($customerId){
            //     $employeeDept = DB::table('tai_employee_master')->where('account_for', 'CUSTOMER')->where('customer_id', $customerId)->where('is_active', 1)->pluck('department_id')->toArray();
            //     if(count($employeeDept) > 0){
            //         $query->where('d.tenant_id', $tenantId)->whereIn('d.id', $employeeDept)->select('d.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"));
            //     }
            // }else{
                $query->where('d.tenant_id', $tenantId)->select('d.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"));
            // }
            // $query->where('d.tenant_id', $tenantId);
            // $query->select('d.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"));
        }
        $result = $query
            ->orderBy('d.id', 'DESC')
            ->orderBy('d.is_active', 'DESC')
            ->get();

        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function createDepartment(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        if (!$request->department) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } elseif (preg_match('/^[a-zA-Z\s]+$/', $request->department)) {
            $data = $request->toArray();
            $data['tenant_id'] = $tenantId;

            $check = DB::table('tai_department_master')
                ->where('department', $request->department)
                ->get();
            if (count($check) == 0) {
                $result = DB::table('tai_department_master')->insert($data);
                if ($result > 0) {
                    return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Please input alphabet characters only !!!", 'data' => null]);
        }
    }

    public function updateDepartment(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        if (!$request->department) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } elseif (preg_match('/^[a-zA-Z\s]+$/', $request->department)) {

            $data = $request->toArray();

            $check = DB::table('tai_department_master')
                ->where('id', '<>', $id)
                ->where('tenant_id', $tenantId)
                ->where('department', $request->department)
                ->get();

            if (count($check) == 0) {
                $result = DB::table('tai_department_master')->where('id', $id)->update($data);
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Please input alphabet characters only !!!", 'data' => null]);
        }
    }

    public function deleteDepartment($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_department_master')->where('id', $id)->update(['is_active' => 0]);
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Deleted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Deleted !!!", 'data' => null]);
        }
    }

    public function getDepartmentById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_department_master')->where('id', $id)->first();
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }
}
