<?php
// live
namespace App\Http\Controllers;

use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use JWTAuth;

class DynamicFormController extends Controller
{
    public function getAllDynamicForm(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023
        $tenantId = $token_data->tenant_id;
        // $customerId = $token_data->customer_id;

        $result = DB::table('tai_dynamic_form as d')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'd.updated_by')
            ->leftJoin('tai_employee_master as em', 'em.id', '=', 'd.created_by')
            ->where('d.tenant_id', $tenantId)
            ->select('d.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"))
                        ->orderBy('d.is_active', 'ASC')
                        ->orderBy('d.id', 'DESC')
                        ->get();

        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }        
    }
    
    public function createDynamicForm(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023
        $tenantId = $token_data->tenant_id;
        // $customerId = $token_data->customer_id;

        $check = DB::table('tai_dynamic_form')->where('tenant_id', $tenantId)->where('template_name', $request->template_name)->first();
        if ($check) {
            return response()->json(['status' => 0, 'message' => "Form Name  already present !!!", 'data' => null]);
        }

        // dd(json_encode($request->data));
        // return response()->json(['status'=> 0, 'message'=> "Form Name  already present !!!", 'data' => $request->toArray()]);

        // dd($request->all());
        $result = DB::table('tai_dynamic_form')->insert([
            "tenant_id" => $tenantId,
            // "customer_id" => $customerId,
            "template_name" => $request->template_name,
            // "data" => json_encode($request->dynamicForm),
            "data" => $request->data, //punam shinde Date:02-06-2023
            "created_by" => $request->created_by,
            "created_at" => NOW(),
                                                        ]);  
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
        } 
    }

    public function updateDynamicForm(Request $request, $id)
    {   
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023
        $tenantId = $token_data->tenant_id;

        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;

        $check = DB::table('tai_dynamic_form')->where('tenant_id', $tenantId)->where('template_name', $request->template_name)->first();
        if ($check && $check->id != $id) {
            return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
        }
        if($request->data == NULL){
            return response()->json(['status' => 0, 'message' => "Please enter dynamic form !!!", 'data' => null]);

        }   

        // $result = DB::table('tai_dynamic_form')->where('id', $id)->update($data);   
        $result = DB::table('tai_dynamic_form')->where('tenant_id', $tenantId)->where('id', $id)->update([
            "template_name" => $request->template_name,
            // "data" => json_encode($request->dynamicForm),
            "data" => $request->data, //punam shinde Date:02-06-2023
            "updated_at" => now()
                                                                            ]);  
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
        }   
    }

    public function deleteDynamicForm($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_dynamic_form')->where('tenant_id', $token_data->tenant_id)->where('id', $id)->update(['is_active' => 1]);
        if ($result) {
            return response()->json(['message' => "Record Deleted", 'status' => 1, 'data' => null]);
        } else {
            return response()->json(['message' => "Record Not Deleted", 'status' => 0, 'data' => null]);
        }        
    }

    public function getDynamicFormById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_dynamic_form')->where('tenant_id', $token_data->tenant_id)->where('id', $id)->first();
        if ($result) {
            $result->data = json_decode($result->data);
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }
}
