<?php
namespace App\Http\Controllers;

use App\Models\Department;
use Illuminate\Http\Request;
use DB;
use JWTAuth;

class MenuController extends Controller
{

    public function getAllMenu(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $menus=DB::table('tai_menu_master')
                        ->where('is_active',1)
                        ->where('tenant_id',$tenantId)
                        ->get();
        $data=array();            
        if(count($menus)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $menus]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found!!!",'data' => null]);
        }
        
    }

    public function getRole(Request $request,$roleId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $roleAccess=DB::table('tai_menu_access')
                        ->where('role_id',$roleId)
                        ->where('tenant_id',$tenantId)
                        ->get();
        if(count($roleAccess)>0){
            return response()->json(['status'=> 1, 'message'=> "Record found !!!",'data' => $roleAccess]);
        }else{
            return response()->json(['status'=> 0, 'message'=> "No Record found !!! Please Create Access",'data' => null]);
        }
        
    }

    public function getMenuByRoleId(Request $request,$roleId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $menu=array();
        $menuIds=DB::table('tai_menu_access')->where('is_active',1)
                                            ->where('tenant_id',$tenantId)
                                            ->where('role_id',$roleId)
                                            ->where(['can_read'=>1])
                                            ->pluck('menu_id')
                                            ->toArray();
        
        $menus=DB::table('tai_menu_master')->whereNull('parent_id')->get();                                    
        
        foreach($menus as $m){

            if(in_array($m->id,$menuIds))
            {
                $m->routerLink=explode(',',$m->routerLink);    
                $childrens=DB::table('tai_menu_master')->where('is_active',1)
                                                        ->where('tenant_id',$tenantId)
                                                        ->where('parent_id',$m->id)
                                                        ->whereIn('id',$menuIds)
                                                        ->get()
                                                        ->toArray();
                    if(count($childrens))
                    {       
                        $childTemp=array();     
                        foreach($childrens as $c){
                            $c->routerLink=explode(',',$c->routerLink);
                            $childTemp[]=(array)$c;
                        }    
                        $m->children=$childTemp;                                       
                    }else{
                        $m->children=array();                                       
                    }


                   $access= DB::table('tai_menu_access')->where('tenant_id',$tenantId)
                                                ->where('role_id',$roleId)
                                                ->where('menu_id',$m->id)
                                                ->where('is_active',1)
                                                ->first();

                    $tempAccess['read']=$access ? $access->can_read : 0;
                    $tempAccess['create']=$access ? $access->can_create : 0;
                    $tempAccess['update']=$access ? $access->can_update : 0;
                    $tempAccess['delete']=$access ? $access->can_delete : 0;
                    $m->access=$tempAccess;

                    $temp[]=(array)$m;
                    $menu["menu"]=$temp;
                }
            }
        if($menu){
            return response()->json([ 'status'=> 1, 'message'=> "Record Updated !!!", 'data' => $menu]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "Menu Not Assigned !!!", 'data' => null]);
        }   
        
    }

   

    public function createAccess(Request $request)
    {   
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        
        // return $getData;
        $data = [];
        // return  $request->toArray();

        if($tenantId && $request->role_id)
        {

            if($request->role_id)

            DB::table('tai_menu_access')->where('role_id',$request->role_id)->delete();

            for ($i=0; $i < count($request->menu); $i++) { 
                $data['tenant_id'] = $tenantId;
                $data['role_id'] = $request->role_id;
                $data['menu_id'] = $request->menu[$i]['id'];
                $data['can_read'] = $request->menu[$i]['can_read'];
                $data['can_create'] = $request->menu[$i]['can_create'];
                $data['can_update'] = $request->menu[$i]['can_update'];
                // $data['can_delete'] = $request->menu[$i]['can_delete'];
                $data['is_active'] = '1';
                $data['created_by'] = $request->created_by;
                $data['created_at'] = $request->created_at;

                DB::table('tai_menu_access')->insert($data);
            }
            return response()->json(['status'=> 1, 'message'=> "Record Inserted !!!", 'data' => null]);
        }else{
            return response()->json(['status'=> 0, 'message'=> "Role or Tenant not found !!!", 'data' => null]);
        }
    }

    

}
