<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use JWTAuth;

class ModuleController extends Controller
{
    public function getAllModule(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_project_modules as m')
                    ->leftJoin('tai_project_master as p','p.id','=','m.project_id')
                    ->leftJoin('tai_employee_master as e','e.id','=','m.updated_by')
                    ->select('m.*','p.project_name',DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                    ->where('m.tenant_id','=',$tenantId)
                    ->orderBy('m.is_active','DESC')
                    ->orderBy('m.id','DESC')                    
                    ->get();

        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        }        
    }
    
    public function createModule(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if(!$request->module_name || !$request->project_id){   
             return response()->json([ 'status'=> 0, 'message'=> "Invalid Data !!!", 'data' => null]);
        }

        $check = DB::table('tai_project_modules')
                    ->where('module_name',$request->module_name)
                    ->where('project_id',$request->project_id)
                    ->get();

        if(count($check) == 0)
        {
            $data=$request->toArray();
            $result=DB::table('tai_project_modules')->insert($data);

            if($result > 0){
                return response()->json(['status'=> 1, 'message'=> "Record Inserted !!!", 'data' => null]);
            }else{
                return response()->json(['status'=> 0, 'message'=> "Record Not Inserted !!!",'data' => null]);
            }    
        }else{
            return response()->json([ 'status'=> 0,'message'=> "Record Already Exists !!!", 'data' => null]);
        }
    }

    public function updateModule(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data=$request->toArray();
        // dd($request->toArray());
        $check = DB::table('tai_project_modules')->where('id',$id)->first();
        
        $result = DB::table('tai_project_modules')->where('id',$id)->update($data);
        if($result){
            return response()->json(['status'=> 1, 'message'=> "Record Updated !!!", 'data' => null]);
        }else{
            return response()->json(['status'=> 0, 'message'=> "Record Not Updated !!!", 'data' => null]);
        } 
    }

    
    public function deleteModule($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_project_modules')->where('id', $id)->update(['is_active'=>0]);
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Deleted !!!", 'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "Record Not Deleted !!!", 'data' => null]);
        }        
    }

    public function getModuleById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        
        $result = DB::table('tai_project_modules')->where('id', $id)->first();
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Found !!!", 'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Fund !!!", 'data' => null]);
        }
    }
}