<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use DB;
use JWTAuth;

class ModuleSettingController extends Controller
{
    public function getSetting(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if($request->module_name && $request->submodule_name){
            $query = DB::table('tai_module_setting as ms')
                    ->join('tai_module_setting_details as md','md.setting_id','=','ms.id')
                    ->where('ms.module_name', $request->module_name)
                    ->where('ms.submodule_name', $request->submodule_name)
                    ->select('ms.setting_name','md.setting_value');
                    // if($request->setting_name)
                    // {
                    //     $query->where('ms.setting_name', $request->setting_name);
                    //     $query->select('md.setting_value');
                    // }
            $data=$query->get()->toArray();    
                    
                    
            if($data){
                return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $data]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
            }

        }else{
            return response()->json([ 'status'=> 0, 'message'=> "All fields are required !!!",'data' => null]);
        } 
    }

    public function addModules(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $request->tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();

        $data2 = [ 
                    "is_active"=>$request->is_active,
                    "remark"=>$request->remark,
                    "created_by"=>$request->created_by,
                    "created_at"=>$request->created_at,
                    "updated_by"=>$request->updated_by,
                    "updated_at"=>$request->updated_at,
                    "tenant_id"=>$request->tenant_id,
                    "setting_value"=>$request->setting_value
                ];

        unset($data['tenant_id']);
        unset($data['setting_value']);

        $msId = DB::table('tai_module_setting')->insertGetId($data);

        $allMD = array_merge($data2, ['setting_id'=>$msId]);

        DB::table('tai_module_setting_details')->insert($allMD);
    }


    public function getSettingByName(Request $request,$module_name,$submodule_name){
        
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        
        $settings=DB::table('tai_module_setting as ms')
                            ->where('module_name',$module_name)
                            ->where('submodule_name',$submodule_name)
                            ->get();
            $data=array();

            if(count($settings)){    
                foreach($settings as $s){
                    $setting=DB::table('tai_module_setting_details')
                                            ->where('tenant_id',$tenantId)
                                            ->where('setting_id',$s->id)
                                            ->first();
                    if($setting){                        
                        $data[$s->setting_name]=$setting->setting_value;
                    }
                }
            }

            if(count($data)){
                return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $data]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
            }
        
    }


    public function getModuleSetting(Request $request,$module_name,$submodule_name){
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if($module_name && $submodule_name)
        {
            $data=DB::table('tai_module_setting')->where('module_name',$module_name)
                                                  ->where('submodule_name',$submodule_name)
                                                  ->get();
            if($data){
                return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $data]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
            }
        }
    }


    public function getAllModuleSetting(Request $request){
       
       $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenant_id = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
       
        if($tenant_id){
            $module=DB::table('tai_module_setting')->pluck('module_name')->toArray();
            $module=array_unique($module);

            $data = array();

                foreach($module as $m){
                    $submodule=DB::table('tai_module_setting')->where('module_name',$m)
                                        ->pluck('submodule_name')
                                        ->toArray();
                    $submodule=array_values(array_unique($submodule));
                    

                    $data[]=['module_name'=>$m,'submodule_name'=>$submodule];
                }

                if($data){
                    return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $data]);
                }else{
                    return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
                }
    
        }
    }


    public function updateAllModuleSetting(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenant_id = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // $tenant_id = $request->tenant_id;
        $updated_by = $request->updated_by;
        
        for($i=0;$i<count($request->setting_id);$i++)
        {
            $check = DB::table('tai_module_setting_details')->where('setting_id', $request->setting_id[$i])
                                                            ->where('tenant_id', $tenant_id)
                                                            ->first();
            

            if($check){
                DB::table('tai_module_setting_details')->where('id', $check->id)
                                                            ->update([
                                                                        'setting_value' => $request->setting_value[$i],
                                                                        'updated_at'=> $request->created_at,
                                                                        'updated_by' => $request->created_by
                                                                    ]);
                }else{
                    DB::table('tai_module_setting_details')->insert([
                                                                        'tenant_id'=>$request->tenant_id,
                                                                        'setting_id' => $request->setting_id[$i],
                                                                        'setting_value' => $request->setting_value[$i],
                                                                        'created_at'=> $request->created_at,
                                                                        'created_by' => $request->created_by
                                                                    ]);
                }
        }
        return response()->json(['status' => 1, 'message' => "Module Setting Updated !!!"]);
    }

}
