<?php
// live
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use DB;
use JWTAuth;

class NotificationController extends Controller
{
    public function getNotification($userId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_notification as n')
                        ->leftJoin('tai_employee_master as e','e.id','=','n.from_user_id')
                        ->where('n.is_read', 0)
                        ->where('n.tenant_id',$tenantId)    
                        ->where('n.to_user_id',$userId)
                        ->select('n.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS from_user"))
                        ->orderBy('n.id','DESC')
                        ->get();
                        
        if(count($result) > 0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        }        
    }

    public function markedReadNotification(Request $request,$id){

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        DB::table('tai_notification')->where('id',$id)->update(['is_read'=>1]);
        return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => null]);
    }
    
    public function getAllNotification(Request $request,$userId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data=DB::table('tai_notification')
                    ->where('tenant_id',$tenantId)        
                    ->where('to_user_id',$userId)
                    ->where('is_read',0)
                    ->orderBy('id','Desc')
                    // ->limit(20)
                    ->get();
        return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $data]);
    }

    public function markAllAsReadNotification(Request $request,$userId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        DB::table('tai_notification')->where('to_user_id',$userId)
                ->where('is_read', 0)->update(['is_read'=>1]);
        return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => null]);
    }
}
