<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use App\Library\CommonController;
use JWTAuth;


class PaymentTemplateController extends Controller
{

    public $week = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday", "Saturday"];

    // get all data for admin
    public function getPaymentTemplate(Request $request, $type=null)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = [];
        $data = DB::table('tai_bc_payment_template as pt')
                    ->select('pt.*',
                            DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"),
                            DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), 
                            'con.convention_name as payment_type_name', 
                            'btm.convention_name as bill_type_name'
                        )
                    ->leftJoin('tai_bc_status_conventions as con','con.id','=','pt.payment_type')
                    ->leftJoin('tai_employee_master as e','e.id','=','pt.updated_by')
                    ->leftJoin('tai_employee_master as em','em.id','=','pt.created_by')
                    ->leftJoin('tai_bc_status_conventions as btm','btm.id','=','pt.bill_type')
                    ->where('pt.tenant_id',$tenantId);
                    // ->get();

        if($type != null){
            $data = $data->where('pt.is_active', 1)->get();

        }else{
            $data = $data->get();
        }
        foreach($data as $val)
        {
           
            $val->payment_weekly_name = "";

            // bill type
            // $val->bill_type = DB::table('tai_bc_status_conventions')->where('id',$val->bill_type)->first()->convention_name;

            if($val->payment_weekly){
                
                $payment_weekly_array = explode(", ", $val->payment_weekly);
               
                $size = sizeof($payment_weekly_array);
                
                $que = DB::table('tai_bc_status_conventions')->where('id',$val->payment_type)->first();
                // dd($que);
                $val->payment_type = $que->convention_name;
                if($que && $que->convention_name == 'Weekly'){
                    $weeks = [];
                    
                    for($i = 0; $i<$size; $i++) {
                        $days = $payment_weekly_array[$i];
                        

                        $days = str_replace(" ", "",  $days);
                        $week = $this->week[$days];

                        // if($i == ($size-1)) {
                        //     $weeks = $this->week[$days];
                        // } else {
                        //     $weeks = $this->week[$days] . ', ';
                        // }
                        $weeks[] = $week;
                    }
                    
                    $val->payment_weekly_name = $weeks;
                    // dd($val->payment_weekly);
                }
                else {

                    $val->payment_weekly = $val->payment_type;
                }	
            }
            $result[] = $val;
            
        }
        // dd($result);
        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        }
    }

    // get data by id 
    public function getPaymentTemplateById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenantId;

        if($id){
            $result = DB::table('tai_bc_payment_template as pt')
                            ->select('pt.*',DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"),DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                            ->leftJoin('tai_employee_master as e','e.id','=','pt.updated_by')
                            ->leftJoin('tai_employee_master as em','em.id','=','pt.created_by')
                            ->where('pt.id',$id)->first();
            if($result)
            {
                // bill type
                // $result->bill_type = DB::table('tai_bc_status_conventions')->where('id',$result->bill_type)->first()->convention_name;

                // display weeks
                // $week_name = array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');

                if($result->payment_weekly){
                    $payment_weekly_array = explode(",", $result->payment_weekly);

                    $size = sizeof($payment_weekly_array);

                    $que = DB::table('tai_bc_status_conventions')->where('id',$result->payment_type)->first()->convention_name;
                    $result->payment_type = $que;

                    if($que == 'Weekly' || $que == 'WEEKLY')
                    {
                        $weeks = '';
                        for($i = 0; $i<$size; $i++) {
                            $days = $payment_weekly_array[$i];

                            $days = str_replace(" ", "", $days);

                            if($i == ($size-1)) {
                                $weeks .= $this->week[$days];
                            } else {
                                $weeks .= $this->week[$days] . ', ';
                            }
                        }
                        $result->payment_weekly= ($weeks);
                    } else {
                        $result->payment_weekly = $result->payment_weekly;
                    }	
                }
                
            }
            else{
                return response()->json([ 'status'=> 0, 'message'=> "Id Not Found !!!",'data' => null]);
            }

            if($result){
                return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
            }
        }   
        else{
            return response()->json([ 'status'=> 0, 'message'=> "Id Not found !!!",'data' => null]);
        }
    }

    // date_consider_for_payment = payment_type
    // payment_type = bill_day
    // payment_day = Payment Weekly
    // payment_day_monthly = bill day

    public function createPaymentTemplate(Request $request, $id='')
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenantId;

        $payment_weekly = '';
        $bill_day = '';
        $min_days = $request->min_days;
    
        // check template name
        if($request->template_name){
            $check = DB::table('tai_bc_payment_template')->where('template_name',$request->template_name);
            if($id){ $check= $check->where('id','!=',$id); } 
            $check = $check->first();
            if($check){
                return response()->json([ 'status'=> 1, 'message'=> "Template Name Already Exist !!!",'data' => Null]);
            }
        }

        if($request->payment_type)
        {
            $que = DB::table('tai_bc_status_conventions')->where('used_for','Payment_Type')->where('convention_name',ucfirst($request->payment_type))->first();
            
            if($que){

                $request->payment_type=$que->id;
                // dd($request->payment_weekly);
                // dd($que->convention_name);/

                if($que->convention_name == 'Weekly' || $que->convention_name == 'WEEKLY')
                {
                    $intWeek=[];
                    if($request->payment_weekly){
                        foreach($request->payment_weekly as $w){
                            foreach($this->week as $index=>$week){
                                if($w==$week){
                                    $intWeek[]=$index;
                                }
                            }
                        }
                    
                        // $min_days = implode (",",$intWeek); // for week      
                        $payment_weekly =  implode (", ",$intWeek); 
                    }   
                    // dd($payment_weekly);
                }
                else{
                    $bill_day =  $request->input('bill_day'); // for month
                }
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "Convention Name Error !!!",'data' => Null]);
            }
        }

        if(!$min_days){
            return response()->json([ 'status'=> 0, 'message'=> "MIN DAYS Required!!!",'data' => Null]);
        }    

        if($request->bill_type){
            $bill_type_val = DB::table('tai_bc_status_conventions')->where('used_for','Bill_Type')->where('convention_name',$request->bill_type)->first()->id;
        }
        else{
            return response()->json([ 'status'=> 0, 'message'=> "MIN DAYS Required!!!",'data' => Null]);
        }
        $arrayName = array(
			'template_name'			=> $request->template_name,
            'payment_type'	=> $request->payment_type,
            'bill_type'	=> $bill_type_val,
			'min_days'		=> $min_days,
            'payment_weekly' =>$payment_weekly,
            'bill_day' => $bill_day,
			'remark'		=> $request->remark,
			'is_active'		=>  $request->is_active,
            
		);

		if($id){

            $arrayName['updated_at']		=  $request->updated_at;
            $arrayName['updated_by']		=  $request->updated_by;

			$check = DB::table('tai_bc_payment_template')->where('id', $id)->update($arrayName);

            if($check){
                $table = 'tai_bc_payment_template';
                $result = (array) DB::table('tai_bc_payment_template')->where('id', $id)->first();
                CommonController::generateHistory("UPDATE", $table,$id);

                return response()->json([ 'status'=> 1, 'message'=> "Record Updated !!!",'data' => $request->toArray()]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "Record Not Updated !!!",'data' => null]);
            }

		}else{

            $arrayName['created_at']		=  $request->created_at;
            $arrayName['created_by']		=  $request->created_by;

			$id = DB::table('tai_bc_payment_template')->insertGetId($arrayName);

            if($id){
                $table = 'tai_bc_payment_template';
                $result = (array) DB::table('tai_bc_payment_template')->where('id', $id)->first();
                CommonController::generateHistory('Insert', $table, $id);

                return response()->json([ 'status'=> 1, 'message'=> "Record Added !!!",'data' => $id]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "Record Not Added !!!",'data' => null]);
            }

		}
    }

    // // get payment template history by Id
    public function getPaymentTemaplteHistoryById(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenantId;

        if($id){
            $result = DB::table('tai_bc_payment_template_history as pt')
                            ->select('pt.*',DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"),DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                            ->leftJoin('tai_employee_master as e','e.id','=','pt.updated_by')
                            ->leftJoin('tai_employee_master as em','em.id','=','pt.created_by')
                            ->where('pt.id',$id)->first();
            if($result)
            {
                // bill type
                // $result->bill_type = DB::table('tai_bc_status_conventions')->where('id',$result->bill_type)->first()->convention_name;

                // display weeks
                // $week_name = array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');

                if($result->payment_weekly){
                    $payment_weekly_array = explode(", ", $result->payment_weekly);

                    $size = sizeof($payment_weekly_array);

                    $que = DB::table('tai_bc_status_conventions')->where('id',$result->payment_type)->first()->convention_name;
                    $result->payment_type = $que;

                    if($que == 'Weekly' || $que == 'WEEKLY')
                    {
                        $weeks = [];
                        for($i = 0; $i<$size; $i++) {
                            $days = $payment_weekly_array[$i];
                        
                            $days = str_replace(" ", "",  $days);
                            $week = $this->week[$days];
                            $weeks[] = $week;
                        }
                        $result->payment_weekly= $weeks;
                    } else {
                        $result->payment_weekly = $result->payment_weekly;
                    }	
                }
                
            }
            else{
                return response()->json([ 'status'=> 0, 'message'=> "Id Not Found !!!",'data' => null]);
            }

            if($result){
                return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
            }else{
                return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
            }
        }   
        else{
            return response()->json([ 'status'=> 0, 'message'=> "Id Not found !!!",'data' => null]);
        }
    }

    // get payment template history
    public function getPaymentTemaplteHistory(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenantId;

        $result = [];
        $data = DB::table('tai_bc_payment_template_history as pt')
                            ->select('pt.*',DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"),DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                            ->leftJoin('tai_employee_master as e','e.id','=','pt.updated_by')
                            ->leftJoin('tai_employee_master as em','em.id','=','pt.created_by')    
                            ->get();

        foreach($data as $val)
        {
            // dd($val);

            // bill type
            // $val->bill_type = DB::table('tai_bc_status_conventions')->where('id',$val->bill_type)->first()->convention_name;

            if($val->payment_weekly){
                $payment_weekly_array = explode(",", $val->payment_weekly);

                $size = sizeof($payment_weekly_array);
                
                $que = DB::table('tai_bc_status_conventions')->where('id',$val->payment_type)->first();
                // dd($que);
                $val->payment_type = $que->convention_name;
                if($que && $que->convention_name == 'Weekly' || $que == 'WEEKLY'){
                    $weeks = '';
                    for($i = 0; $i<$size; $i++) {
                        $days = $payment_weekly_array[$i];
                        
                        $days = str_replace(" ", "",  $days);

                        // if($i == ($size-1)) {
                        //     $weeks = $this->week[$days];
                        // } else {
                        //     $weeks = $this->week[$days] . ', ';
                        // }
                    }
                    $val->payment_weekly= ($weeks);
                    // dd($val->payment_weekly);
                }
                else {
                    $val->payment_weekly = $val->payment_type;
                }	
            }
            $result[] = $val;
            
        }
        // dd($result);
        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        }
    }

}