<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;

class QueryTypeController extends Controller
{
    public function getAllQueryType(Request $request, $tenantId)
    {
        $result = DB::table('tai_query_type_master as q')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'q.updated_by')
            ->select('q.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->orderBy('q.is_active', 'DESC')
            ->orderBy('q.id', 'DESC')
            ->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function getAllQueryType1(Request $request, $tenantId)
    {
        $result = DB::table('tai_query_type_master as q')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'q.updated_by')
            ->leftJoin('tai_employee_master as em', 'em.id', '=', 'q.created_by')
            ->leftJoin('tai_dynamic_form as d', 'q.form_id', '=', 'd.id')
            // ->select('q.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"))
            ->select('q.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), 'd.template_name as form_id_name')
            ->orderBy('q.is_active', 'DESC')
            ->orderBy('q.id', 'DESC')
            ->get();
        if (count($result) > 0) {
            foreach ($result as $row) {
                $row->query_group = DB::table('tai_group_query_type_mapping')
                    ->select(DB::raw("GROUP_CONCAT(query_type_group_id) AS query_group"))
                    ->where('query_type_id', $row->id)
                    ->where('is_active',1)
                    ->get();
                
                $row->query_group = explode(",", $row->query_group[0]->query_group);
                // if (!empty($row->query_group)) {
                //     $row->query_group_name = DB::table('tai_query_type_master')->select(DB::raw("GROUP_CONCAT(query_type_name) AS query_group"))->whereIn('id', $row->query_group)->get();
                //     $row->query_group_name = explode(",", $row->query_group_name[0]->query_group);

                    
                // }
                $row->query_group = array_map('intval', $row->query_group);

                // punam
                $row->query_group_data = DB::table('tai_group_query_type_mapping as map')
                ->join('tai_query_type_group_master as g','g.id','map.query_type_group_id')
                ->select('map.query_type_group_id', 'group_name')
                ->where('map.query_type_id', $row->id)
                ->where('map.is_active',1)
                ->where('g.is_active',1)
                ->where('map.tenant_id', $row->tenant_id)
                ->where('g.tenant_id', $row->tenant_id)
                ->get()->toArray();

                $group_name = array_column($row->query_group_data, 'group_name');
                $row->query_group_name = implode(",", $group_name);
            }
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function getAllQueryGroup(Request $request, $tenantId)
    {
        $result = DB::table('tai_query_type_group_master AS q')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'q.updated_by')
            ->leftJoin('tai_employee_master as em', 'em.id', '=', 'q.created_by')
            ->select('q.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"))
            ->orderBy('q.is_active', 'DESC')
            ->orderBy('q.id', 'DESC')
            ->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function getQueryTypeExternally(Request $request, $tenantId)
    {
        $result = DB::table('tai_query_type_master as q')
            ->leftJoin('tai_customer_mapping as c', 'c.query_type_id', 'q.id')
            ->select('q.id', 'q.query_type_name', 'q.is_active', 'c.priority')
            ->where('c.customer_type_id', 1)
            ->where('q.tenant_id', 1)
            ->orderBy('q.is_active', 'DESC')
            ->orderBy('q.id', 'DESC')
            ->get();

        if (count($result) > 0) {
            $data = [];
            foreach ($result as $r) {
                $data[] = [
                    'id' => $r->id,
                    'query_type_name' => $r->query_type_name,
                    'priority' => $r->priority,
                    'is_active' => $r->is_active
                ];
            }
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function createQueryType(Request $request)
    {
        if (!$request->query_type_name) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } else if (preg_match('/^[a-zA-Z]+[a-zA-Z0-9._ -]+$/', $request->query_type_name)) {
            $data = $request->toArray();
            $check = DB::table('tai_query_type_master')
                ->where('query_type_name', $request->query_type_name)
                ->get();
            if (count($check) == 0) {
                // $query_group = $data['query_group'];
                // unset($data['query_group']);
                $result = DB::table('tai_query_type_master')->insertGetId($data);
                // if ($result) {
                //     if (is_array($query_group)) {
                //         foreach ($query_group as $q) {
                //             $query_mapping = [
                //                 'query_type_group_id' => $q,
                //                 'query_type_id' => $result,
                //                 'tenant_id' => $request->tenant_id,
                //                 'remark' => $request->remark,
                //                 'created_at' => $request->created_at,
                //                 'created_by' => $request->created_by,
                //                 'updated_at' => $request->created_at,
                //                 'updated_by' => $request->created_by
                //             ];
                //             $results = DB::table('tai_group_query_type_mapping')->insertGetId($query_mapping);
                //         }
                //     }
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Query Type Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Name only accept charachters and numbers !!!", 'data' => null]);
        }
    }

    public function createQueryType1(Request $request)
    {
        if (!$request->query_type_name) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } else if (preg_match('/^[a-zA-Z]+[a-zA-Z0-9._ -]+$/', $request->query_type_name)) {
            $data = $request->toArray();
            $check = DB::table('tai_query_type_master')
                ->where('query_type_name', $request->query_type_name)
                ->get();
            if (count($check) == 0) {
                $query_group = $data['query_group'];
                unset($data['query_group']);
                $result = DB::table('tai_query_type_master')->insertGetId($data);
                if ($result) {
                    if (is_array($query_group)) {
                        foreach ($query_group as $q) {
                            $query_mapping = [
                                'query_type_group_id' => $q,
                                'query_type_id' => $result,
                                'tenant_id' => $request->tenant_id,
                                'remark' => $request->remark,
                                'created_at' => $request->created_at,
                                'created_by' => $request->created_by,
                                'updated_at' => $request->created_at,
                                'updated_by' => $request->created_by
                            ];
                            $results = DB::table('tai_group_query_type_mapping')->insertGetId($query_mapping);
                        }
                    }
                }
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Query Type Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Name only accept charachters and numbers !!!", 'data' => null]);
        }
    }

    public function createQueryGroup(Request $request)
    {
        if (!$request->group_name) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } elseif (preg_match('/^[a-zA-Z]+[a-zA-Z0-9._ -]+$/', $request->group_name)) {
            $data = $request->toArray();
            $check = DB::table('tai_query_type_group_master')
                ->where('group_name', $request->group_name)
                ->get();
            if (count($check) == 0) {
                $result = DB::table('tai_query_type_group_master')->insertGetId($data);
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Query Group Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Name only accept charachters and numbers !!!", 'data' => null]);
        }
    }

    public function updateQueryGroup(Request $request, $id)
    {
        if (!$request->group_name) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } elseif (preg_match('/^[a-zA-Z]+[a-zA-Z0-9._ -]+$/', $request->group_name)) {
            $data = $request->toArray();
            $check = DB::table('tai_query_type_group_master')
                ->where('id', '<>', $id)
                ->where('group_name', $request->group_name)
                ->get();
            if (count($check) == 0) {
                $result = DB::table('tai_query_type_group_master')->where('id', $id)->update($data);
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Query Group Updated !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Query Group Not Updated !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Query Group Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Name only accept charachters and numbers !!!", 'data' => null]);
        }
    }

    public function updateQueryType(Request $request, $id)
    {
        if (!$request->query_type_name) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } elseif (preg_match('/^[a-zA-Z]+[a-zA-Z0-9._ -]+$/', $request->query_type_name)) {
            $data = $request->toArray();
            $check = DB::table('tai_query_type_master')
                ->where('id', '<>', $id)
                ->where('query_type_name', $request->query_type_name)
                ->get();

            if (count($check) == 0) {
                // $query_group = $data['query_group'];
                // unset($data['query_group']);
                $result = DB::table('tai_query_type_master')->where('id', $id)->update($data);
                // if (is_array($query_group)) {
                //     foreach ($query_group as $q) {
                //         $query_mapping = [
                //             'query_type_group_id' => $q,
                //             'query_type_id' => $result,
                //             'tenant_id' => $request->tenant_id,
                //             'remark' => $request->remark,
                //             'created_at' => $request->created_at,
                //             'created_by' => $request->created_by,
                //             'updated_at' => $request->created_at,
                //             'updated_by' => $request->created_by
                //         ];
                //         $results = DB::table('tai_group_query_type_mapping')->insertGetId($query_mapping);
                //     }
                // }
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Name only accept charachters and numbers !!!", 'data' => null]);
        }
    }

    public function updateQueryType1(Request $request, $id)
    {
        // dd($request->all());
        if (!$request->query_type_name) {
            return response()->json(['status' => 0, 'message' => "Invalid Data !!!", 'data' => null]);
        } elseif (preg_match('/^[a-zA-Z]+[a-zA-Z0-9._ -]+$/', $request->query_type_name)) {
            $data = $request->toArray();
            $check = DB::table('tai_query_type_master')
                ->where('id', '<>', $id)
                ->where('query_type_name', $request->query_type_name)
                ->get();

            if (count($check) == 0) {
                $query_group = $data['query_group'];
                unset($data['query_group']);
                $result = DB::table('tai_query_type_master')->where('id', $id)->update($data);
                
                $deactivated = DB::table('tai_group_query_type_mapping')->where('query_type_id', $id)->update(['is_active'=>0]);
                $data_deactivated = DB::table('tai_group_query_type_mapping')->where('query_type_id', $id)->where('is_active',0)->pluck('query_type_group_id')->toArray();
                $get_data = DB::table('tai_query_type_master')->where('id', $id)->first();

                if (is_array($query_group)) {
                    foreach ($query_group as $q) {
                    
                        if(array_search($q, $data_deactivated)){
                            $query_mapping = [
                                'query_type_group_id' => $q,
                                'query_type_id' => $id,
                                'tenant_id' => $get_data->tenant_id,
                                // 'remark' => $request->remark,
                                'is_active' => 1,
                                // 'created_at' => $get_data->created_at,
                                // 'created_by' => $get_data->created_by,
                                'updated_at' => $request->updated_at,
                                'updated_by' => $request->updated_by
                            ];
                            // dd($query_mapping);
                            $results = DB::table('tai_group_query_type_mapping')->where('query_type_group_id',$q)->where('query_type_id', $id)->where('tenant_id', $get_data->tenant_id)->update($query_mapping);
                        }else{
                            $query_mapping = [
                                'query_type_group_id' => $q,
                                'query_type_id' => $id,
                                'tenant_id' => $get_data->tenant_id,
                                'remark' => $request->remark,
                                'created_at' => $request->updated_at,
                                'created_by' => $request->updated_at,
                                'updated_at' => $request->updated_at,
                                'updated_by' => $request->updated_by
                            ];
                            $results = DB::table('tai_group_query_type_mapping')->insertGetId($query_mapping);
                        }
                    }
                }
                if ($result) {
                    return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Name only accept charachters and numbers !!!", 'data' => null]);
        }
    }

    public function deleteQueryType($id)
    {
        $result = DB::table('tai_query_type_master')->where('id', $id)->update(['is_active' => 0]);
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Deleted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Deleted !!!", 'data' => null]);
        }
    }

    public function getQueryTypeById($id)
    {
        $result = DB::table('tai_query_type_master')->where('id', $id)->first();
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Deleted !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Deleted !!!", 'data' => null]);
        }
    }

    public function getQueryTypeForm(Request $request, $tenant_id, $query_type_id)
    {
        $result = DB::table('tai_query_type_master as q')
            ->leftJoin('tai_dynamic_form as d', 'd.id', '=', 'q.form_id')
            ->where('q.id', $query_type_id)
            ->where('d.is_active', 1)
            ->select('d.data')
            ->first();

        if ($result) {
            return $result->data;
        } else {
            return;
            // return response()->json([ 'status'=> 0, 'message'=> "No Record Found !!!", 'data' => null]);
        }
    }


    // add query type mapping
    public function addQueryTypeMapping(Request $request, $tenant_id)
    {

        if ($request->main_query_type_name) {
            $check = DB::table('tai_main_query_type')->where('main_query_type_name', $request->main_query_type_name)->where('is_active', 1)
                ->where('tenant_id', $tenant_id)->first();
            if ($check) {
                return response()->json(['status' => 1, 'message' => 'Main Query Type Name Already Exist', 'data' => null]);
            }
            if (count($request->query_type_id) > 0) {
                $insertGetId = DB::table('tai_main_query_type')->insertGetId([
                    'tenant_id' => $tenant_id, 'main_query_type_name' => $request->main_query_type_name,
                    'is_active' => 1, 'remark' => $request->remark, 'created_by' => $request->created_by,
                    'created_at' => $request->created_by ? $request->created_by : now()
                ]);
                if ($insertGetId) {
                    foreach ($request->query_type_id as $q) {
                        // dd($q);
                        $query_type_id = DB::table('tai_query_type_master')->where('is_active', 1)->where('tenant_id', $tenant_id)->first();
                        if ($query_type_id) {
                            DB::table('tai_main_query_type_mapping')->insertGetId([
                                'tenant_id' => $tenant_id, 'main_query_type_id' => $insertGetId,
                                'query_type_master_id' => $q,
                                'is_active' => 1, 'remark' => $request->remark, 'created_by' => $request->created_by,
                                'created_at' => $request->created_by ? $request->created_by : now()
                            ]);
                        }
                    }
                    return response()->json(['status' => 1, 'message' => 'Data Added Successfully ', 'data' => $insertGetId]);
                } else {
                    return response()->json(['status' => 1, 'message' => 'Oops! Something went wrong ', 'data' => null]);
                }
            } else {
                return response()->json(['status' => 1, 'message' => 'Query Type Name Missing', 'data' => null]);
            }
        } else {
            return response()->json(['status' => 1, 'message' => 'Main Query Type Name Missing', 'data' => null]);
        }
    }

    public function getQueryTypeMapping(Request $request, $tenant_id)
    {
        $result = DB::table('tai_main_query_type')->where('is_active', 1)->where('tenant_id', $tenant_id)->get();
        return response()->json(['status' => 1, 'message' => 'Data Found', 'data' => $result]);
    }

    public function updateQueryTypeMapping(Request $request, $tenant_id)
    {
        if ($request->parent_id) {
            if (!$request->parent_id && !$request->remark && !$request->is_active) {
                return response()->json(['status' => 0, 'message' => "All Fields Required !!!", 'data' => null]);
            }

            $check = DB::table('tai_query_type_master')
                ->where('id', '=', $request->parent_id)
                ->first();
            if (!$check) {
                return response()->json(['status' => 0, 'message' => "Main Query Type Not Exist !!!", 'data' => null]);
            }

            if ($request->parent_id) {
                $old_data =  DB::table('tai_query_type_mapping')->where('tenant_id', $tenant_id)->where('parent_id', $request->parent_id)->first();
                if ($old_data) {
                    $created_at = $old_data->created_at;
                    $created_by = $old_data->created_by;
                    if (count($request->child_id) > 0) {
                        DB::table('tai_query_type_mapping')->where('tenant_id', $tenant_id)->where('parent_id', $request->parent_id)->delete();
                        foreach ($request->child_id as $c) {
                            $query = DB::table('tai_query_type_mapping')->insert([
                                'tenant_id' => $tenant_id, 'parent_id' => $request->parent_id,
                                'child_id' => $c, 'remark' => $request->remark,
                                'is_active' => $reques, 'created_at' => $created_at ? $created_at : now(),
                                'created_by' => $created_by, 'updated_at' => $request->updated_at ? $request->updated_at : now(),
                                'updated_by' => $request->updated_by
                            ]);
                        }
                        return response()->json(['status' => 1, 'message' => 'Query Type Mapped Updated Successfully', 'data' => null]);
                    } else {
                        return response()->json(['status' => 0, 'message' => 'Chiid Data Not Found']);
                    }
                } else {
                    return response()->json(['status' => 0, 'message' => 'Parent Data Not Found']);
                }
            } else {
                return response()->json(['status' => 0, 'message' => 'Parent Data Not Found']);
            }
        } else {
        }
    }

    public function getQueryTypeMappingById(Request $request, $tenant_id, $parent_id)
    {
        if ($parent_id) {
            // dd('hi');
            $result = DB::table('tai_query_type_master')->select('query_type_name as parent_name', 'id as parent_id')
                ->where('tenant_id', $tenant_id)->where('id', $parent_id)->first();
            // dd($result);
            if ($result) {
                // dd('hi');
                $result->child_data = DB::table('tai_query_type_mapping as m')
                    ->leftJoin('tai_query_type_master as q', 'm.child_id', '=', 'q.id')
                    ->where('m.tenant_id', $tenant_id)
                    ->where('m.parent_id', $result->parent_id)
                    ->select('m.child_id', 'q.query_type_name as child_name')
                    ->get();
            } else {
                $result['child_data'] = [];
            }
            if ($result) {
                return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
            } else {
                return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "ID Not found !!!", 'data' => null]);
        }
    }

    public function getQueryTypeDropdown($tenant_id)
    {
        $result = DB::table('tai_query_type_master')->select('id', 'tenant_id', 'query_type_name', 'is_active')
            ->where('is_active', 1)->where('tenant_id', $tenant_id)->get();
        return response()->json(['status' => 1, 'message' => "Data found !!!", 'data' => $result]);
    }
}
