<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use DB;
use Illuminate\Http\Request;
use JWTAuth;

class ReportController extends Controller
{
    public function ticketReport(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id;

        // $query=DB::table('tai_ticket_master as tm')
        //                 ->leftjoin('tai_employee_master as em','em.id','=','tm.assign_to_user_id')
        //                 ->leftjoin('tai_status_master as sm','sm.id','=','tm.status_id')
        //                 ->leftjoin('tai_department_master as dm','dm.id','=','tm.assign_to_department_id')
        //                 ->leftjoin('tai_employee_master as em_c','em_c.id','=','tm.created_by')
        //                 ->where('tm.is_active', 1);
        // if($request->ticket_id){
        //     $query->whereIn('tm.ticket_id', explode(',',$request->ticket_id));
        // }
        // if($request->assign_to_user_id){
        //     $query->where('tm.assign_to_user_id', $request->assign_to_user_id);
        //         //   ->orWhere('tm.created_by',$request->assign_to_user_id);
        // }
        // if($request->type_id){
        //     $query->where('tm.type_id', $request->type_id);
        // }
        // if($request->status_id){
        //     $query->where('tm.status_id', $request->status_id);
        // }
        // if($request->assign_to_department_id){
        //     $query->where('tm.assign_to_department_id', $request->assign_to_department_id);
        // }

        // $query->select('tm.*',DB::raw("CONCAT(em.first_name,' ',em.last_name) AS assign_to_user"),'dm.department as assign_to_department','sm.status as status_name',
        // DB::raw('CONCAT(em_c.first_name," ",em_c.last_name) AS created_by'));
        // $data = $query->get();

        if ($request->ticket_id || $request->assign_to_user_id || $request->assign_to_department_id || $request->status_id) {
            $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured,
                    CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department as assign_to_department, sm.status AS status_name,
                    CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                    fd.department AS from_department_name,
                    CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name,
                    fd.department AS from_department_name, pm.project_name, pmod.module_name , psub.sub_module_name, qtm.query_type_name
                    from tai_ticket_master AS tm
                    LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id
                    LEFT JOIN tai_employee_master AS em_u ON em_u.id = tm.user_id
                    LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by
                    LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                    LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id
                    LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id
                    LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id
                    LEFT JOIN tai_project_master AS pm ON pm.id = tm.project_id
                    LEFT JOIN tai_project_modules AS pmod ON pmod.id = tm.module_id
                    LEFT JOIN tai_project_sub_modules AS psub ON psub.id = tm.submodule_id
                    LEFT JOIN tai_query_type_master AS qtm ON qtm.id = tm.query_type_id
                    -- LEFT JOIN tai_project_modules AS mod ON mod.id = tm.module_id
                    -- LEFT JOIN tai_project_sub_modules AS smod ON smod.id = tm.submodule_id
                    WHERE tm.is_active = 1 AND tm.tenant_id = '" . $tenantId . "' AND 1=1 ";


            if ($request->from_date && $request->to_date) {
                $query .= " AND tm.ticket_date between '" . $request->from_date . "' and '" . $request->to_date . "' ";
            }

            if ($request->ticket_id) {
                $ticketIds = explode(',', $request->ticket_id);
                if (count($ticketIds)) {
                    $query .= " AND tm.ticket_id IN (" . implode(', ', array_map(function ($val) {
                        return sprintf("'%s'", $val);
                    }, $ticketIds)) . ")";
                }
            }
            if ($request->user_id) {
                // $userIds=explode(',',$request->assign_to_user_id);
                $userIds = $request->user_id;
                if (count($userIds)) {
                    if ($userIds[0]) {
                        $query .= " AND ( tm.user_id IN (" . implode(",", $request->user_id) . ") OR
                    tm.created_by IN (" . implode(",", $request->user_id) . ")
                    )";
                    }
                }
            }
            if ($request->assign_to_user_id) {
                // $userIds=explode(',',$request->assign_to_user_id);
                $userIds = $request->assign_to_user_id;
                if (count($userIds)) {
                    if ($userIds[0]) {
                        $query .= " AND ( tm.assign_to_user_id IN (" . implode(",", $request->assign_to_user_id) . "))";
                        //      OR
                        // tm.created_by IN (" . implode(",", $request->assign_to_user_id) . ")
                        // )";
                    }
                }
            }

            if ($request->from_department_id) {
                // $deparmentIds=explode(',',$request->from_department_id);
                $deparmentIds = $request->from_department_id;
                if (count($deparmentIds)) {
                    if ($deparmentIds[0]) {
                        $query .= " AND (tm.from_department_id IN (" . implode(",", $request->from_department_id) . ")";
                    }
                }
            }

            if ($request->assign_to_department_id) {
                // $deparmentIds=explode(',',$request->assign_to_department_id);
                $deparmentIds = $request->assign_to_department_id;
                if (count($deparmentIds)) {
                    if ($deparmentIds[0]) {
                        $query .= " AND (tm.assign_to_department_id IN (" . implode(",", $request->assign_to_department_id) . ")) ";
                    }
                }
            }

            if ($request->status_id) {
                // $statusIds=explode(',',$request->status_id);
                $statusIds = $request->status_id;
                if (count($statusIds)) {
                    if ($statusIds[0]) {
                        $query .= " AND tm.status_id IN (" . implode(',', $request->status_id) . ")";
                    }
                }
            }
            // return $query;
            $data = DB::select(DB::raw($query));

            if (count($data) > 0) {
                return response()->json(['status' => 1, 'message' => $query, 'data' => $data]);
            } else {
                return response()->json(['status' => 0, 'message' => "No Data Found", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "No Data Found", 'data' => null]);
        }
    }

    public function userTaskReport(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;

        $query = "SELECT  SUM(TIME_TO_SEC(total_time)) as total_time_data, round(SUM(TIME_TO_SEC(total_time)) / 60) as total_time_min,  h.user_id, 
                        h.ticket_task_id,tm.ticket_id,ts.task_name,
                        ts.status,ts.updated_at,h.start_time,h.stop_time,
                  CONCAT(e.first_name, ' ', e.last_name) as employee_name
                  FROM tai_ticket_task_time_history as h
                  LEFT JOIN tai_ticket_task as ts ON h.ticket_task_id = ts.id 
                  LEFT JOIN tai_employee_master as e ON h.user_id = e.id
                  LEFT JOIN tai_ticket_master as tm ON h.ticket_id = tm.id
                  Where 1 =1 and tm.tenant_id = '".$tenantId."' AND h.is_active = 1 ";

        // $query = "SELECT SUM(h.total_time_min) as total_time_data,h.user_id,h.ticket_task_id,ts.task_name,
        //             CONCAT(e.first_name, ' ', e.last_name) as employee_name,tm.ticket_id
        //             FROM tai_ticket_task_time_history AS h
        //             LEFT JOIN tai_ticket_task ts ON h.ticket_task_id = ts.id
        //             LEFT JOIN tai_ticket_master tm ON h.ticket_id = tm.id
        //             LEFT JOIN tai_employee_master e ON h.user_id = e.id";

        if ($request->from_date) {
            $query .= " AND DATE(h.start_time) >= '" . $request->from_date . "' ";
        }
        if ($request->to_date) {
            $query .= " AND DATE(h.stop_time) <= '" . $request->to_date . "' ";
        }

        if ($request->user_id && $request->user_id[0] != "") {
            $query .= " AND h.user_id IN (" . implode(',', $request->user_id) . ") ";
        }

        if ($request->task_name) {
            $query .= " AND ts.task_name LIKE '%" . $request->task_name . "%' ";
        }

        $query .= " GROUP BY h.user_id, h.ticket_task_id ORDER BY employee_name";

        $data = DB::select(DB::raw($query));

        if (count($data)) {
            foreach ($data as $d) {
                if ($d->total_time_data > 0) {
                    $hours = floor($d->total_time_data / 3600);
                    $minutes = floor(($d->total_time_data % 3600) / 60);
                    $seconds = ($d->total_time_data % 60);
                    if ($hours < 10) {
                        $hours = "0$hours";
                    }
                    if ($minutes < 10) {
                        $minutes = "0$minutes";
                    }
                    if ($seconds < 10) {
                        $seconds = "0$seconds";
                    }
                    $d->total_worked = "$hours:$minutes:$seconds";
                } else {
                    $d->total_worked = "00:00:00";
                }
                $d->start_time = date_format(date_create($d->start_time), "Y/m/d");
                $d->stop_time = date_format(date_create($d->stop_time), "Y/m/d");

                $d->total_time_data = $d->total_time_data / 60;
            }
        }

        if (count($data) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found", 'data' => null]);
        }
    }


    public function ticketTimelineReport_for_simple_timeline(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:30-05-2023

        $result = DB::select("SELECT tm.id,tt.id,tt.task_name,(SELECT MIN(start_time) 
                                FROM tai_ticket_task_time_history WHERE ticket_task_id = tt.id AND start_time IS NOT NULL AND stop_time IS NOT NULL
                                ) AS started_at,
                                (SELECT MAX(stop_time) FROM tai_ticket_task_time_history WHERE ticket_task_id = tt.id AND start_time IS NOT NULL AND stop_time IS NOT NULL) AS ended_at 
                                FROM tai_ticket_master AS tm 
                                LEFT JOIN tai_ticket_task AS tt ON tt.ticket_id = tm.id 
                                WHERE tm.ticket_id='$tenantId'  ");
        if ($result) {
            foreach ($result as $key => $value) {
                $series = [];
                $series['x'] = $value->task_name;
                $series['y'] = [
                    (int) round(Carbon::parse($value->started_at)->format('Uu') / pow(10, 6 - 3)),
                    (int) round(Carbon::parse($value->ended_at)->format('Uu') / pow(10, 6 - 3)),
                ];
                $dd['data'][] = $series;
            }
            $data['series'][] = $dd;
            $data['options']['chart'] = ['height' => 50, 'type' => 'rangeBar'];
            $data['options']['plotOptions'] = ['bar' => ['horizontal' => true]];
            $data['options']['xaxis'] = ['type' => 'datetime'];
            // dd($data);
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => $request->toArray()]);
        }
        return $data;
    }

    public function ticketTimelineReport(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::select("SELECT tm.id,tt.id,tt.task_name
                                               FROM tai_ticket_master AS tm
                                               LEFT JOIN tai_ticket_task AS tt ON tt.ticket_id = tm.id
                                               WHERE tt.is_active=1 AND
                                               tm.ticket_id='$tenantId'
                            ");

        $final = [];
        $alltask = [];
        foreach ($result as $r) {

            $emp = DB::table('tai_ticket_task_owner as o')
                ->join('tai_employee_master as e', 'e.id', '=', 'o.task_owner_id')
                ->where('o.is_active', 1)
                ->where('o.ticket_task_id', $r->id)
                ->select('o.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS user_name"))
                ->get();

            foreach ($emp as $e) {
                $temp['name'] = $e->user_name;
                $temp['data'] = [];

                $history = DB::table('tai_ticket_task_time_history')->where('ticket_task_id', $r->id)->where('user_id', $e->task_owner_id)
                    ->select('start_time', 'stop_time')
                    ->orderBy('user_id')
                    ->get();

                foreach ($history as $h) {
                    if (!in_array($r->task_name, $alltask)) {
                        $alltask[] = $r->task_name;
                    }
                    $timeArray['x'] = $r->task_name;
                    $timeArray['y'] = [
                        (int) round(Carbon::parse($h->start_time)->format('Uu') / pow(10, 6 - 3)),
                        (int) round(Carbon::parse($h->stop_time)->format('Uu') / pow(10, 6 - 3)),
                        // $h->start_time,
                        // $h->stop_time,
                    ];
                    $temp['data'][] = $timeArray;
                }
                $final[] = $temp;
            }
        }
        $arr = $final;
        $new_arr = [];
        $new_arr1 = [];
        $new_arr2 = [];
        foreach ($arr as $k => $v) {
            $new_arr1[] = ['name' => $v['name']];
            foreach ($v['data'] as $vd) {
                $new_arr[$v['name']]['data'][] = $vd;
            }
        }
        $new_arr1 = array_values(array_map("unserialize", array_unique(array_map("serialize", $new_arr1))));
        foreach ($new_arr1 as $k => $v) {
            if (array_key_exists($v['name'], $new_arr)) {
                $new_arr2[] = ['name' => $v['name'], 'data' => $new_arr[$v['name']]['data']];
            }
        }
        // dd($final);
        $height = count($alltask) * 200 / 2;
        if ($height == 0) {
            $height = 10;
        }
        $barheight = 0.05 * $height;
        $data['series'] = $new_arr2;
        $data['options']['chart'] = ['height' => $height, 'type' => 'rangeBar'];
        $data['options']['plotOptions'] = ['bar' => ['horizontal' => true, 'barHeight' => $barheight . '%']];
        $data['options']['xaxis'] = ['type' => 'datetime'];

        $data['options']['stroke'] = ['width' => 1];
        $data['options']['fill'] = ['type' => 'solid', 'opacity' => 0.6];
        $data['options']['legend'] = ['position' => 'top', 'horizontalAlign' => 'left'];

        return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $data]);
    }

    public function resourcePlanning(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:

        // $data=$request->toArray();
        // return response()->json(['status'=> 1,'message'=> "Data Found !!!",'data' => $data]);

        $query = "SELECT p.date,p.user_id,CONCAT(e.first_name,' ',e.last_name) AS user_name,SUM(p.total_hours) AS hours
            FROM tai_task_planner AS p  
            LEFT JOIN tai_employee_master AS e ON e.id=p.user_id
            WHERE p.is_active = 1 AND p.user_id != '' ";

        if ($request->from_date) {
            $query .= " AND DATE(p.date) >= '" . $request->from_date . "'";
        } else {
            $query .= " AND DATE(p.date) >= '" . date('Y-m-01') . "'";
        }
        if ($request->to_date) {
            $query .= " AND DATE(p.date) <= '" . $request->to_date . "'";
        } else {
            $query .= " AND DATE(p.date) <= '" . date('Y-m-31') . "'";
        }

        if ($request->user_id && count($request->user_id) > 0) {
            $user = implode(',', $request->user_id);
            if ($user) {
                $query .= " AND e.id IN ($user) ";
            }
        }
        $query .= " GROUP BY p.date,p.user_id ORDER BY user_name,p.date";
        $data = DB::select(DB::raw($query));

        if (count($data) > 0) {
            foreach ($data as $d) {

                // $time=DB::table('tai_task_planner')->where('is_active',1)
                //                                 ->where('user_id',$d->user_id)
                //                                 ->select('total_hours')
                //                                 ->whereDate('date','>=',$request->from_date)
                //                                 ->whereDate('date','<=',$request->to_date)
                //                                 ->pluck('total_hours')
                //                                 ->toArray();

                $q = "SELECT SUM(total_hours_in_min) as mins FROM tai_task_planner AS p WHERE p.user_id=$d->user_id AND p.is_active=1 AND DATE(p.date) = '" . $d->date . "' GROUP BY p.date";
                $total_time = DB::select(DB::raw($q));

                $tempHr = intdiv($total_time[0]->mins, 60);
                $totalHr = $tempHr > 10 ? $tempHr : "0$tempHr";

                $tempMin = $total_time[0]->mins % 60;
                $totalMin = $tempMin > 10 ? $tempMin : "0$tempMin";

                $d->hours = $totalHr . ":" . $totalMin;

                // dd($total_time);

                $d->tasks = DB::table('tai_ticket_task as t')
                    ->leftJoin('tai_task_planner as tp', 'tp.ticket_task_id', '=', 't.id')
                    // DATE:23-05-2023 PUNAM SHINDE
                    ->leftJoin('tai_ticket_master as tm', 'tm.id', 't.ticket_id')
                    // -------------
                    ->where('tp.user_id', $d->user_id)
                    ->where('tp.date', $d->date)
                    ->where('tm.tenant_id', $tenantId)
                    ->where('tp.is_active', 1)
                    ->select('t.task_name', 'tp.total_hours', 'tm.id', 'tm.ticket_id')
                    ->get();

                // dd($d->tasks);
            }

            // return response()->json(['status' => 1, 'message' => $query, 'data' => $data]);
            return response()->json(['status' => 1, 'message' => "Data found", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Data Found !!!", 'data' => null]);
        }
    }

    public function hoursWiseTaskRecord(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:

        $result = DB::select("SELECT tm.id,tt.id,tt.task_name
                                               FROM tai_ticket_master AS tm
                                               LEFT JOIN tai_ticket_task AS tt ON tt.ticket_id = tm.id
                                               WHERE tt.is_active=1 AND
                                               tm.ticket_id='$request->ticket_id'
                                               AND tm.tenant_id='$tenantId'
                                            --    AND tm.customer_id IN ('$customerId')
                                               ");

        $final = [];
        $alltask = [];
        foreach ($result as $r) {

            $emp = DB::table('tai_ticket_task_owner as o')
                ->join('tai_employee_master as e', 'e.id', '=', 'o.task_owner_id')
                ->where('o.is_active', 1)
                ->where('o.ticket_task_id', $r->id)
                ->select('o.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS user_name"))
                ->get();

            foreach ($emp as $e) {
                $temp['name'] = $e->user_name;
                $temp['data'] = [];
                $currentDate = date('Y-m-d'); // Get the current date in 'YYYY-MM-DD' format
                // dd($currentDate);
                $history = DB::table('tai_ticket_task_time_history')
                    ->where('ticket_task_id', $r->id)
                    ->where('user_id', $e->task_owner_id)
                    ->whereDate('start_time', $currentDate)
                    ->whereDate('stop_time', $currentDate)
                    ->select('start_time', 'stop_time')
                    ->orderBy('user_id')
                    ->get();
                // If no records found for the current date, fetch records for the last 8 days
                // if ($history->isEmpty()) {
                //     $startDate = date('Y-m-d', strtotime('-8 days')); // Get the start date (8 days ago) in 'YYYY-MM-DD' format
                //     $endDate = $currentDate; // Current date is the end date

                //     $history = DB::table('tai_ticket_task_time_history')
                //         ->where('ticket_task_id', $r->id)
                //         ->where('user_id', $e->task_owner_id)
                //         ->whereBetween('start_time', [$startDate, $endDate])
                //         ->select('start_time', 'stop_time')
                //         ->orderBy('user_id')
                //         ->get();
                // }

                foreach ($history as $h) {

                    if (!in_array($r->task_name, $alltask)) {
                        $alltask[] = $r->task_name;
                    }
                    $timeArray['x'] = $r->task_name;
                    $timeArray['y'] = [
                        (int) round(Carbon::parse($h->start_time)->format('Uu') / pow(10, 6 - 3)),
                        (int) round(Carbon::parse($h->stop_time)->format('Uu') / pow(10, 6 - 3)),
                        // $h->start_time,
                        // $h->stop_time,
                    ];
                    //   $timeArray['y'] = [                    
                    //     $h->start_time,
                    //     $h->stop_time,
                    // ];
                    $temp['data'][] = $timeArray;
                }
                $final[] = $temp;
            }
        }
        $arr = $final;
        $new_arr = [];
        $new_arr1 = [];
        $new_arr2 = [];
        foreach ($arr as $k => $v) {
            $new_arr1[] = ['name' => $v['name']];
            foreach ($v['data'] as $vd) {
                $new_arr[$v['name']]['data'][] = $vd;
            }
        }
        $new_arr1 = array_values(array_map("unserialize", array_unique(array_map("serialize", $new_arr1))));
        foreach ($new_arr1 as $k => $v) {
            if (array_key_exists($v['name'], $new_arr)) {
                $new_arr2[] = ['name' => $v['name'], 'data' => $new_arr[$v['name']]['data']];
            }
        }
        // dd($final);
        $height = count($alltask) * 200 / 2;
        if ($height == 0) {
            $height = 10;
        }
        $barheight = 0.05 * $height;
        $data['series'] = $new_arr2;
        $data['options']['chart'] = ['height' => $height, 'type' => 'rangeBar'];
        $data['options']['plotOptions'] = ['bar' => ['horizontal' => true, 'barHeight' => $barheight . '%']];
        $data['options']['xaxis'] = ['type' => 'datetime'];

        $data['options']['stroke'] = ['width' => 1];
        $data['options']['fill'] = ['type' => 'solid', 'opacity' => 0.6];
        $data['options']['legend'] = ['position' => 'top', 'horizontalAlign' => 'left'];

        return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $data]);
    }
}
