<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use JWTAuth;

class SubModuleController extends Controller
{
    public function getAllSubmodule(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_project_sub_modules as s')
                        ->leftJoin('tai_project_master as p','p.id','=','s.project_id')
                        ->leftJoin('tai_project_modules as m','m.id','=','s.module_id')
                        ->leftJoin('tai_employee_master as e','e.id','=','s.updated_by')
                        ->where('s.tenant_id', '=',$tenantId)
                        ->select('s.*','m.module_name','p.project_name',DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                        ->orderBy('s.id','DESC')
                        ->orderBy('s.is_active','ASC')
                        ->get();

        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        }        
    }
    
    public function createSubmodule(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if(!$request->module_id || !$request->sub_module_name){   
             return response()->json([ 'status'=> 0, 'message'=> "Invalid Data !!!", 'data' => null]);
        }

        $check = DB::table('tai_project_sub_modules')
                    ->where('module_id',$request->module_id)
                    ->where('sub_module_name',$request->sub_module_name)
                    ->get();

        if(count($check) == 0)
        {
            $data=$request->toArray();
            $result=DB::table('tai_project_sub_modules')->insert($data);

            if($result > 0){
                return response()->json(['status'=> 1, 'message'=> "Record Inserted !!!", 'data' => null]);
            }else{
                return response()->json(['status'=> 0, 'message'=> "Record Not Inserted !!!",'data' => null]);
            }    
        }else{
            return response()->json([ 'status'=> 0,'message'=> "Record Already Exists !!!", 'data' => null]);
        }
    }

    public function updateSubmodule(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data=$request->toArray();
        // dd($request->toArray());
        $check = DB::table('tai_project_sub_modules')->where('tenant_id',$tenantId)->where('id',$id)->first();
        
        $result = DB::table('tai_project_sub_modules')->where('tenant_id',$tenantId)->where('id',$id)->update($data);
        if($result){
            return response()->json(['status'=> 1, 'message'=> "Record Updated !!!", 'data' => null]);
        }else{
            return response()->json(['status'=> 0, 'message'=> "Record Not Updated !!!", 'data' => null]);
        } 
    }

    
    public function deleteSubmodule($id)
    {
        $result = DB::table('tai_project_sub_modules')->where('tenant_id',$tenantId)->where('id', $id)->update(['is_active'=>0]);
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Deleted !!!", 'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "Record Not Deleted !!!", 'data' => null]);
        }        
    }

    public function getSubmoduleById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_project_sub_modules')->where('tenant_id',$tenantId)->where('id', $id)->first();
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Deleted !!!", 'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Deleted !!!", 'data' => null]);
        }
    }
}
