<?php

namespace App\Http\Controllers;
use App\Library\CommonController;
use App\Library\TaskSupportiveController as TaskSupportive;
use App\Library\OwnershipController as Ownership;
use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use Carbon\Carbon;

class TaskTimerController extends Controller
{
    public function postTimerDataGroupActivity(Request $request){
        return $request->toArray();
    }

    public function postTimerData(Request $request)
    {   
        $task = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();

        if(($request->status=="START" || $request->status=="Start") && !$task->start_time)
        {
            DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                            'status'=>'IN_PROGRESS',
                                                                            'start_time'=>$request->time,
                                                                            'time_status'=>"START",
                                                                        ]);
        }

        if($request->status=="START" || $request->status=="Start")
        {
        
            $this->updateTime($request->ticket_id,$request->ticket_task_id,$request->user_id,$request->time,"START");
            
            DB::table('tai_ticket_task_time_history')->insert([
                                                                'tenant_id'=>$request->tenant_id,
                                                                'ticket_id'=>$request->ticket_id,
                                                                'ticket_task_id'=>$request->ticket_task_id,
                                                                'user_id'=>$request->user_id,
                                                                'start_time'=>$request->time,
                                                                'created_at'=>now()
                                                                ]);
            

        }else{
            $time_history = DB::table('tai_ticket_task_time_history')->where([
                                                                    'ticket_id'=>$request->ticket_id,
                                                                    'ticket_task_id'=>$request->ticket_task_id,
                                                                    'user_id'=>$request->user_id
                                                                ])
                                                                ->orderBy('id','DESC')
                                                                ->first();
                                                                
            $start = new Carbon($time_history->start_time);
            $finish = new Carbon($request->time);
            
            $total_time = $start->diff($finish)->format('%H:%I:%S');  
                            
            $total_time_min = Carbon::parse($start)->diffInMinutes($finish);   

            DB::table('tai_ticket_task_time_history')
                        ->where('id',$time_history->id)
                        ->update(['stop_time'=>$request->time,
                                    'total_time'=>$total_time,
                                    'total_time_min'=>$total_time_min
                                ]);   
            
        }   

        $time=DB::table('tai_ticket_task_time_history')->where([
                                                        'ticket_id'=>$request->ticket_id,
                                                        'ticket_task_id'=>$request->ticket_task_id
                                                    ])
                                                    ->whereNotNull('start_time')
                                                    ->whereNotNull('stop_time')
                                                    ->pluck('total_time')
                                                    ->toArray();
        if($time)
        {          
            $sum = strtotime('00:00:00');
            $totaltime = 0;         
            foreach( $time as $element ) {
                $timeinsec = strtotime($element) - $sum;
                $totaltime = $totaltime + $timeinsec;
            }
            $h = intval($totaltime / 3600);
            $totaltime = $totaltime - ($h * 3600);
            $m = intval($totaltime / 60);
            $s = $totaltime - ($m * 60);
            $f=$h.":".$m.":".$s;
            
            $sum=DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history 
                                        WHERE ticket_id=$request->ticket_id 
                                        AND ticket_task_id=$request->ticket_task_id"));

            DB::table('tai_ticket_task')->where('id', $task->id)->update(['total_worked'=>$f,'total_worked_in_min'=>$sum[0]->time_in_min]);
        }   
        $status=($request->status=="Start" || $request->status=="START") ? "STOP":"START";
        return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!", 'data' => $status]);                                       
        
    }   


    public function updateTime($ticket_id,$ticket_task_id,$user_id,$time,$type){
            //1. Select all user task whose stop_time is null or technically last played task
            $userTask=DB::table('tai_ticket_task_time_history')->where([
                                                                            'user_id'=>$user_id
                                                                        ])
                                                                    ->whereNull('stop_time')
                                                                    ->get();

            foreach($userTask as $u)            //2. Loop through each task
            { 
                //3. Calculate different between start_time & stop_time
                $start = new Carbon($u->start_time);
                $finish = new Carbon($time);
                $total_time = $start->diff($finish)->format('%H:%I:%S');  
                $total_time_min = Carbon::parse($start)->diffInMinutes($finish);
                
                //4. Update time in ticket_task
                $update= DB::table('tai_ticket_task_time_history')->where('id',$u->id)
                                                                  ->update(['stop_time'=>$time,
                                                                            'total_time'=>$total_time,
                                                                            'total_time_min'=>$total_time_min
                                                                         ]);                      
               
                //5. Sum of all task history against ticket_id & task_id                                                         
                if($update)
                {                                    
                    $time=DB::table('tai_ticket_task_time_history')
                                                        ->where([
                                                            'ticket_id'=>$u->ticket_id,
                                                            'ticket_task_id'=>$u->ticket_task_id,
                                                        ])
                                                        ->whereNotNull('start_time')
                                                        ->whereNotNull('stop_time')
                                                        ->whereNotNull('total_time')
                                                        ->pluck('total_time')
                                                        ->toArray();                                            
                                                           
                    if($time)
                    {          
                        $sum = strtotime('00:00:00');
                        $totaltime = 0;         
                        foreach( $time as $element )
                        {
                            $timeinsec = strtotime($element) - $sum;
                            $totaltime = $totaltime + $timeinsec;
                        }
                        $h = intval($totaltime / 3600);
                        $totaltime = $totaltime - ($h * 3600);
                        $m = intval($totaltime / 60);
                        $s = $totaltime - ($m * 60);
                        $f=$h.":".$m.":".$s;
                        $sum=DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history 
                                                WHERE ticket_id=$u->ticket_id 
                                                AND ticket_task_id=$u->ticket_task_id"));

                        DB::table('tai_ticket_task')->where('id', $u->ticket_task_id)
                                                                ->update([
                                                                        'total_worked'=>$f,
                                                                        'total_worked_in_min'=>$sum[0]->time_in_min
                                                                        ]);                                              
                    } //time
                } // update
            }   //for 
    }

   
}
