<?php
// Live function
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use JWTAuth;

class TemplateController extends Controller
{

    public function getAllTemplate(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_template_master as tm")
            ->leftJoin("tai_employee_master as em", "em.id", "=", "tm.created_by")
            ->leftJoin("tai_employee_master as e", "e.id", "=", "tm.updated_by")
            ->where('tm.tenant_id', $tenantId)
            ->select("tm.*", "em.first_name", "em.last_name", DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->orderBy("tm.is_active", "desc")
            ->orderBy("tm.id", "desc")
            ->get();
        return response()->json([
            "status" => 1,
            "message" => "Record Found !!!",
            "data" => $result,
        ]);
    }

    public function getAllBasket(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_template_basket as tm")
            ->leftJoin("tai_employee_master as em", "em.id", "=", "tm.created_by")
            ->leftJoin("tai_employee_master as e", "e.id", "=", "tm.updated_by")
            ->where('tm.tenant_id', $tenantId)
            ->select("tm.*", "em.first_name", "em.last_name", DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->orderBy("tm.is_active", "desc")
            ->orderBy("tm.id", "desc")
            ->get();

        return response()->json([
            "status" => 1,
            "message" => "Record Found !!!",
            "data" => $result,
        ]);
    }

    public function getAllTask(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_template_basket_task as tm")
            ->leftJoin("tai_employee_master as em", "em.id", "=", "tm.created_by")
            ->leftJoin("tai_employee_master as e", "e.id", "=", "tm.updated_by")
            ->where('tm.tenant_id', $tenantId)
            ->select("tm.*", "em.first_name", "em.last_name", DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->orderBy("tm.is_active", "desc")
            ->orderBy("tm.id", "desc")
            ->get();

        return response()->json([
            "status" => 1,
            "message" => "Record Found !!!",
            "data" => $result,
        ]);
    }


    // public function createTemplate(Request $request)
    // {
    //     $token_data = JWTAuth::parseToken()->authenticate(); // Get authenticated user from JWT token
    //     $tenantId = $token_data->tenant_id; // Get the tenant ID from the user

    //     // dd($this->timeToMinutesOrHours('03:40:00', 'hours'));
    //     // dd($request->all());
    //     // Check if the required fields are present
    //     if (!$request->template_name || !$request->template_data) {
    //         return response()->json(["status" => 0, "message" => "Empty Data !!!", "data" => null]);
    //     }

    //     $templateData = $request->template_data;

    //     $checkTemplate = DB::table("tai_template_master")->where([
    //         "tenant_id" => $tenantId,
    //         "template_name" => $request->template_name,
    //     ])->first();

    //     if (empty($checkTemplate)) {
    //         // Insert the template master record
    //         $templateId = DB::table("tai_template_master")->insertGetId([
    //             "tenant_id" => $tenantId,
    //             "template_name" => $request->template_name,
    //             "created_at" => now(),
    //             "created_by" => $token_data->id,
    //             "calculate_from" => $request->calculate_from,
    //         ]);

    //         $basket = $task = "";
    //         if (count($templateData)) {
    //             foreach ($templateData as $template) {
    //                 // Check if the basket already exists
    //                 $checkBasket = DB::table("tai_template_basket")->where([
    //                     "tenant_id" => $tenantId,
    //                     "template_id" => $templateId,
    //                     "basket_name" => $template["basket_name"],
    //                 ])->first();

    //                 if (!$checkBasket) {
    //                     // Insert the template basket record
    //                     $templateBasketId = DB::table("tai_template_basket")->insertGetId([
    //                         "tenant_id" => $tenantId,
    //                         "template_id" => $templateId,
    //                         "basket_name" => $template["basket_name"],
    //                         "basket_owner" => $template["basket_owner"],
    //                         "created_at" => $request->created_at,
    //                         "created_by" => $request->created_by,
    //                     ]);

    //                     if (count($template["basket_task"])) {
    //                         foreach ($template["basket_task"] as $task) {
    //                             // Check if the basket task already exists
    //                             $checkTask = DB::table("tai_template_basket_task")->where([
    //                                 "tenant_id" => $tenantId,
    //                                 "template_basket_id" => $templateBasketId,
    //                                 "task" => $task["task_name"],
    //                             ])->first();

                                

    //                             if (!$checkTask) {
    //                                 // dd($task["total_time"]);
    //                                 $total_time = $this->convertTimeFormat($task["total_time"]);
    //                                 // dd($total_time);    
    //                                 // Insert the template basket task record
    //                                 DB::table("tai_template_basket_task")->insert([
    //                                     "tenant_id" => $tenantId,
    //                                     "template_basket_id" => $templateBasketId,
    //                                     "task" => $task["task_name"],
    //                                     "created_at" => $request->created_at,
    //                                     "created_by" => $request->created_by,
    //                                     "total_time" => $total_time, // time required to complete task
    //                                     "total_time_minute" => $this->timeToMinutesOrHours($total_time), // Minutes required to complete task
    //                                     "days" => $task["days"], // After how many days the task will start
    //                                     "total_hours" => $total_time, //$this->timeToMinutesOrHours($total_time, 'hours'), // Hours required to complete task
    //                                     "start_days" => $task["start_days"]
    //                                 ]);

    //                             } else {
    //                                 $task .= $task["task_name"] . ", ";
    //                             }
    //                         }
    //                     }
    //                 } else {
    //                     $basket .= $template["basket_name"] . ", ";
    //                 }
    //             }
    //         }

    //         if ($basket) {
    //             $basket = rtrim($basket, ", ");
    //             $task = rtrim($task, ", ");

    //             $message = ($basket != "") ? $basket . " basket " : "";
    //             $message .= ($task != "") ? $task . " task " : "";

    //             if ($basket != "" || $task != "") {
    //                 return response()->json(["status" => 0, "message" => $message . "already exist!!!", "data" => null]);
    //             }
    //         } else {
    //             return response()->json(["status" => 1, "message" => "Template created successfully!!!", "data" => null]);
    //         }
    //     } else {
    //         return response()->json(["status" => 0, "message" => $request->template_name . " template already exist!!!", "data" => null]);
    //     }
    // }


    //updated by Rushikesh Harkare -> 09/08/2023
    public function createTemplate(Request $request, $templateId = NULL)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); // Get authenticated user from JWT token
        $tenantId = $token_data->tenant_id; // Get the tenant ID from the user

        // Update Template data -> name and calculate from only
        // return [$request->all(), $templateId];
        if($templateId != NULL){
            if(!$request->template_name || !$request->calculate_from){
                return response()->json(["status" => 0, "message" => "Template name & calculate form required !!!", "data" => null]);
            }

            $template_update = DB::table("tai_template_master")
            ->where('id',$templateId)
            ->update([
                "template_name" => $request->template_name,
                "updated_at" => now(),
                "updated_by" => $token_data->id,
                "calculate_from" => $request->calculate_from,
            ]);

            if($template_update){
                return response()->json(["status" => 1, "message" => "Template name updated successfully!!!", "data" => null]);
            }else{
                return response()->json(["status" => 0, "message" => "Template name failed to update !!!", "data" => null]);
            }
        }

        // Check if the required fields are present
        if (!$request->template_name || !$request->template_data) {
            return response()->json(["status" => 0, "message" => "Empty Data !!!", "data" => null]);
        }

        $templateData = $request->template_data;

        $checkTemplate = DB::table("tai_template_master")->where([
            "tenant_id" => $tenantId,
            "template_name" => $request->template_name,
        ])->first();

        if (empty($checkTemplate)) {
            // Insert the template master record
            $templateId = DB::table("tai_template_master")->insertGetId([
                "tenant_id" => $tenantId,
                "template_name" => $request->template_name,
                "created_at" => now(),
                "created_by" => $token_data->id,
                "calculate_from" => $request->calculate_from,
            ]);

            $basket = $task = "";
            if (count($templateData)) {
                foreach ($templateData as $template) {
                    // Check if the basket already exists
                    $checkBasket = DB::table("tai_template_basket")->where([
                        "tenant_id" => $tenantId,
                        "template_id" => $templateId,
                        "basket_name" => $template["basket_name"],
                    ])->first();

                    if (!$checkBasket) {
                        // Insert the template basket record
                        $templateBasketId = DB::table("tai_template_basket")->insertGetId([
                            "tenant_id" => $tenantId,
                            "template_id" => $templateId,
                            "basket_name" => $template["basket_name"],
                            "basket_owner" => $template["basket_owner"],
                            "created_at" => now(),
                            "created_by" => $token_data->id,
                        ]);

                        if (count($template["basket_task"])) {
                            foreach ($template["basket_task"] as $task) {
                                // Check if the basket task already exists
                                $checkTask = DB::table("tai_template_basket_task")->where([
                                    "tenant_id" => $tenantId,
                                    "template_basket_id" => $templateBasketId,
                                    "task" => $task["task_name"],
                                ])->first();

                                

                                if (!$checkTask) {
                                    // dd($task["total_time"]);
                                    $total_time = $this->convertTimeFormat($task["total_time"]);
                                    // dd($total_time);    
                                    // Insert the template basket task record
                                    DB::table("tai_template_basket_task")->insert([
                                        "tenant_id" => $tenantId,
                                        "template_basket_id" => $templateBasketId,
                                        "task" => $task["task_name"],
                                        "created_at" => now(),
                                        "created_by" => $token_data->id,
                                        "total_time" => $total_time, // time required to complete task
                                        "total_time_minute" => $this->timeToMinutesOrHours($total_time), // Minutes required to complete task
                                        "days" => $task["days"], // After how many days the task will start
                                        "total_hours" => $total_time, //$this->timeToMinutesOrHours($total_time, 'hours'), // Hours required to complete task
                                        "start_days" => $task["start_days"]
                                    ]);

                                } else {
                                    $task .= $task["task_name"] . ", ";
                                }
                            }
                        }
                    } else {
                        $basket .= $template["basket_name"] . ", ";
                    }
                }
            }

            if ($basket) {
                $basket = rtrim($basket, ", ");
                $task = rtrim($task, ", ");

                $message = ($basket != "") ? $basket . " basket " : "";
                $message .= ($task != "") ? $task . " task " : "";

                if ($basket != "" || $task != "") {
                    return response()->json(["status" => 0, "message" => $message . "already exist!!!", "data" => null]);
                }
            } else {
                return response()->json(["status" => 1, "message" => "Template created successfully!!!", "data" => null]);
            }
        } else {
            return response()->json(["status" => 0, "message" => $request->template_name . " template already exist!!!", "data" => null]);
        }
    }



    function convertTimeFormat($timeStr)
    {
        // Convert time format "03.40" or "03:40" to "03:40:00"
        $timeArr = explode('.', str_replace(':', '.', $timeStr));
        $hours = str_pad($timeArr[0], 2, '0', STR_PAD_LEFT);
        $minutes = isset($timeArr[1]) ? str_pad($timeArr[1], 2, '0', STR_PAD_RIGHT) : '00';

        return $hours . ':' . $minutes;
    }

    function timeToMinutesOrHours($timeStr, $type = NULL)
    {
        // Convert time format "03:40:00" to minutes
        $timeArr = explode(':', $timeStr);
        $hours = intval($timeArr[0]);
        $minutes = intval($timeArr[1]);
        // $seconds = intval($timeArr[2]);
        if ($type == 'hours') {
            $totalHours = $hours + ($minutes / 60);
            return number_format($totalHours, 2);
            // return $totalHours;
        } else {
            $totalMinutes = $hours * 60 + $minutes / 60;
            return number_format($totalMinutes, 2);
        }
    }

    public function getTemplateById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $temp = [];

        $result = DB::table("tai_template_master as tm")->where('tenant_id', $tenantId)->where("id", $id)->where("is_active", 1)->first();
        // dd($result);/
        $final = [];
        $final["template_name"] = $result->template_name;
        $final["AB"] = $result->calculate_from;

        $templateBasket = DB::table("tai_template_basket")->where("template_id", $id)->where("is_active", 1)->get();

        foreach ($templateBasket as $b) {
            $temp["basket_id"] = $b->id;
            $temp["basket_name"] = $b->basket_name;
            $temp["basket_owner"] = $b->basket_owner;
            $temp["basket_task"] = [];

            $task = DB::table("tai_template_basket_task")->where("template_basket_id", $b->id)
                ->where('tenant_id', $tenantId)
                ->where("is_active", 1)
                ->get()
                ->toArray();

            foreach ($task as $t) {

                $temp["basket_task"][] = [
                    "task_id" => $t->id,
                    "task_name" => $t->task,
                    "task_total_time" => $t->total_time,
                    "task_days" => $t->days,
                    // "AB" => $result->calculate_from,
                    "total_hours" => $t->total_hours,
                    "total_time_minute" => $t->total_time_minute,
                    "is_active" => $t->is_active,
                    "created_by" => $t->created_by,
                    "created_at" => $t->created_at,
                    "updated_by" => $t->updated_by,
                    "updated_at" => $t->updated_at,
                    "start_days" => $t->start_days,
                ];
            }
            $final["template_data"][] = $temp;
        }

        return response()->json(["status" => 1, "message" => "Record Found !!!", "data" => $final]);
        if (count($result) > 0) {
            return response()->json(["status" => 1, "message" => "Record Found !!!", "data" => $final]);
        } else {
            return response()->json([
                "status" => 0, "message" => "No Record Found !!!", "data" => null,
            ]);
        }
    }

    public function updateTask(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;

        if (isset($data["total_time"])) {
            $data = array_merge($data, ["total_time_minute" => $data["total_time"] * 8 * 60]);
        }

        $result = DB::table("tai_template_basket_task")->where("id", $id)
            ->where('tenant_id', $tenantId)
            ->where("is_active", 1)
            ->update($data);

        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Updated !!!", "data" => null]);
        }
    }

    public function updateBasket(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // return [$request->toArray(), $id];
        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;
        //  dd($id,$data,$request->all());
        $result = DB::table("tai_template_basket")
            ->where("id", $id)
            ->where("is_active", 1)
            ->update($data);

        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Updated !!!", "data" => null]);
        }
    }

    public function deleteTask(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();

        $result = DB::table("tai_template_basket_task")->where('tenant_id', $tenantId)->where("id", $id)->update(["is_active" => 0]);
        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Updated !!!", "data" => null]);
        }
    }

    public function createBasket(Request $request, $templateId)
    {
        //Bhgyashri sonone TT9526 
        //Template master add basket and task
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $basketData = [];
        $templateId = DB::table("tai_template_master as tm")->where('tenant_id', $tenantId)->where("id", $templateId)->where("is_active", 1)->first();
        $basketData = $request->toArray();
        $basketData['tenant_id'] = $tenantId;
        $basketData['template_id'] = $templateId->id;
        $basketData['basket_owner'] = $request->basket_owner;
        $basketData['basket_name'] = $request->basket_name;
        $basketData['created_at'] = now();
        $result = DB::table("tai_template_basket")->insertGetId($basketData);
        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Created !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Created !!!", "data" => null]);
        }
    }


    public function createTask(Request $request, $templateId, $basketId)
    {
        //Bhgyashri sonone TT9526 
        //Template master add basket and task
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;
        $data['template_basket_id'] = $basketId;
        $data['task'] = $request->task;
        $data['days'] = $request->days;
        $data['total_hours'] = $request->total_hours;
        $data['created_at'] = now();
        $data['start_days'] = $request->start_days;


        $result = DB::table("tai_template_basket_task")->insertGetId($data);

        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Created !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Created !!!", "data" => null]);
        }
    }

    public function editTemplate(Request $request, $templateId)
    {     //Bhgyashri sonone TT9526 
        //Template master add basket and task
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $temp = [];
        $templateId = DB::table("tai_template_master as tm")->where('tenant_id', $tenantId)->where("id", $templateId)->where("is_active", 1)->first();
        if ($templateId) {
            $basketData = $request->toArray();
            $basketData['tenant_id'] = $tenantId;
            $basketData['template_id'] = $templateId->id;
            $basketData['basket_owner'] = $request->basket_owner;
            $basketData['basket_name'] = $request->basket_name;
            $basketData['created_at'] = now();

            $baktetId = DB::table("tai_template_basket")->insertGetId($basketData);
            if ($baktetId) {
                // Create a task against the created basket
                $taskData = [
                    'tenant_id' => $tenantId,
                    'template_basket_id' => $baktetId,
                    'task' => $request->task,
                    "created_at" => $request->created_at,
                    "created_by" => $request->created_by,
                    "total_time" => $request->total_time, //days required to complete task
                    "total_time_minute" => $request->total_time_minute * 8 * 60, //days required to complete task
                    "days" => $request->days, //after how many days task will start
                    "total_hours" => $request->total_hours * 8, //hours required to complete task
                    "created_at" => now(),
                ];
                $taskResult = DB::table("tai_template_basket_task")->insert($taskData);


                if ($taskResult) {
                    return response()->json(["status" => 1, "message" => "Task Created Successfully!", "data" => null]);
                } else {
                    return response()->json(["status" => 0, "message" => "Failed to Create Task!", "data" => null]);
                }
            } else {
                return response()->json(["status" => 0, "message" => "Failed to Create Basket!", "data" => null]);
            }
        } else {
            return response()->json(["status" => 0, "message" => "Template Not Found or Inactive!", "data" => null]);
        }
    }
}
