<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use JWTAuth;

class TemplateController_BCK25072023 extends Controller
{

    public function getAllTemplate(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_template_master as tm")
            ->leftJoin("tai_employee_master as em", "em.id", "=", "tm.created_by")
            ->leftJoin("tai_employee_master as e", "e.id", "=", "tm.updated_by")
            ->where('tm.tenant_id', $tenantId)
            ->select("tm.*", "em.first_name", "em.last_name", DB::raw("CONCAT(em.first_name,' ',em.last_name) AS created_by"), DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
            ->orderBy("tm.is_active", "desc")
            ->orderBy("tm.id", "desc")
            ->get();
        return response()->json([
            "status" => 1,
            "message" => "Record Found !!!",
            "data" => $result,
        ]);
    }


    // public function createTemplate(Request $request)
    // {
    //     if (!$request->template_name || !$request->template_data) {
    //         return response()->json([
    //             "status" => 0,
    //             "message" => "Empty Data !!!",
    //             "data" => null,
    //         ]);
    //     } else {
    //         $templateData = $request->template_data;

    //         $checkDuplicateTemplateName = DB::table("tai_template_master")
    //             ->where("template_name", $request->template_name)
    //             ->get();

    //         if (
    //             count($templateData) &&
    //             count($checkDuplicateTemplateName) == 0
    //         ) {
    //             for ($k = 0; $k < count($templateData); $k++) {
    //                 $checkDuplicateBasket = DB::table("tai_template_basket")
    //                     ->where("basket_name", $templateData[$k]["basket_name"])
    //                     ->get();

    //                 if (count($checkDuplicateBasket)>0) {
    //                     return response()->json([
    //                         "status" => 0,
    //                         "message" =>
    //                             "Basket name already exists!!!",
    //                         "data" => null,
    //                     ]);
    //                 }
    //             }
    //         } else {
    //             return response()->json([
    //                 "status" => 0,
    //                 "message" =>
    //                     "Tempalate Name not be Blank or Repetitive !!!",
    //                 "data" => null,
    //             ]);
    //         }

    //         $data = $request->toArray();

    //         $templateId = DB::table("tai_template_master")->insertGetId([
    //                                                                         "tenant_id" => $request->tenant_id,
    //                                                                         "template_name" => $request->template_name,
    //                                                                         "created_at" => $request->created_at,
    //                                                                         "created_by" => $request->created_by,
    //                                                                         "calculate_from" => $request->calculate_from,
    //                                                                     ]);

    //         if (count($templateData)) {
    //             for ($i = 0; $i < count($templateData); $i++) {
    //                 $templateBasketId = DB::table("tai_template_basket")->insertGetId([
    //                                                                         "tenant_id" => $request->tenant_id,
    //                                                                         "template_id" => $templateId,
    //                                                                         "basket_name" => $templateData[$i]["basket_name"],
    //                                                                         "basket_owner" => $templateData[$i]["basket_owner"],
    //                                                                         "created_at" => $request->created_at,
    //                                                                         "created_by" => $request->created_by,
    //                                                                     ]);

    //                 if (count($templateData[$i]["basket_task"])) {

    //                     foreach ($templateData[$i]["basket_task"] as $t) {
    //                                 DB::table("tai_template_basket_task")->insert([
    //                                     "tenant_id" => $request->tenant_id,
    //                                     "template_basket_id" => $templateBasketId,
    //                                     "task" => $t["task_name"],
    //                                     "created_at" => $request->created_at,
    //                                     "created_by" => $request->created_by,
    //                                     "total_time" => $t["total_time"], //days required to complete task
    //                                     "total_time_minute" =>$t["total_time"] * 8 * 60, //days required to complete task
    //                                     "days" => $t["days"], //after how many days task will start
    //                                     "total_hours" => $t["total_time"] * 8, //hours required to complete task
    //                                 ]);
    //                     }
    //                 }
    //             }
    //         }
    //         return response()->json([
    //             "status" => 1,
    //             "message" => "Record Inserted !!!",
    //             "data" => null,
    //         ]);
    //     }
    // }

    public function createTemplate(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if (!$request->template_name || !$request->template_data) {
            return response()->json(["status" => 0, "message" => "Empty Data !!!", "data" => null]);
        }


        $templateData = $request->template_data;

        // $checkDuplicateTemplateName = DB::table("tai_template_master")->where('tenant_id', $tenantId)->where("template_name", $request->template_name)->get();

        // if (count($templateData) && count($checkDuplicateTemplateName) == 0) {
        //     for ($k = 0; $k < count($templateData); $k++) {
        //         $checkDuplicateBasket = DB::table("tai_template_basket")->where("basket_name", $templateData[$k]["basket_name"])->get();
        //         if (count($checkDuplicateBasket)) {
        //             return response()->json(["status" => 0, "message" => "Basket name already exists!!!", "data" => null]);
        //         }
        //     }
        // } else {
        //     return response()->json(["status" => 0, "message" => "Tempalate Name not be Blank or Repetitive !!!", "data" => null]);
        // }

        $data = $request->toArray();

        $templateId = DB::table("tai_template_master")->insertGetId([
            "tenant_id" => $tenantId, //$request->tenant_id,
            "template_name" => $request->template_name,
            "created_at" => $request->created_at,
            "created_by" => $request->created_by,
            "calculate_from" => $request->calculate_from,
        ]);
        $checkTemplate = DB::table("tai_template_master")->where([
            "tenant_id" => $tenantId,
            "template_name" => $request->template_name,
        ])->first();
        if (!empty($checkTemplate)) {
            $basket = $task = "";
            if (count($templateData)) {
                for ($i = 0; $i < count($templateData); $i++) {
                    $check = DB::table("tai_template_basket")->where([
                        "tenant_id" => $tenantId,
                        "template_id" => $templateId,
                        "basket_name" => $templateData[$i]["basket_name"]
                    ])->first();

                    if (!$check) {
                        $templateBasketId = DB::table("tai_template_basket")->insertGetId([
                            "tenant_id" => $tenantId,
                            "template_id" => $templateId,
                            "basket_name" => $templateData[$i]["basket_name"],
                            "basket_owner" => $templateData[$i]["basket_owner"],
                            "created_at" => $request->created_at,
                            "created_by" => $request->created_by,
                        ]);
                        if (count($templateData[$i]["basket_task"])) {
                            foreach ($templateData[$i]["basket_task"] as $t) {
                                $already = DB::table("tai_template_basket_task")->where([
                                    "tenant_id" => $tenantId,
                                    "template_basket_id" => $templateBasketId,
                                    "task" => $t["task_name"],
                                ])->first();
                                if (!$already) {
                                    DB::table("tai_template_basket_task")->insert([
                                        "tenant_id" => $tenantId,
                                        "template_basket_id" => $templateBasketId,
                                        "task" => $t["task_name"],
                                        "created_at" => $request->created_at,
                                        "created_by" => $request->created_by,
                                        "total_time" => $t["total_time"], //days required to complete task
                                        "total_time_minute" => $t["total_time"] * 8 * 60, //days required to complete task
                                        "days" => $t["days"], //after how many days task will start
                                        "total_hours" => $t["total_time"] * 8, //hours required to complete task
                                    ]);
                                } else {
                                    $task = $t["task_name"] . ", ";
                                }
                            }
                        }
                    } else {
                        $basket .= $templateData[$i]["basket_name"] . ", ";
                    }
                }
            }
            $basket = rtrim($basket, ", ");
            $task = rtrim($task, ", ");

            $message = ($basket != "") ? $basket . " basket " : "";
            $message .= ($task != "") ? $task . " task " : "";

            if ($basket != "" || $task != "") {
                return response()->json(["status" => 0, "message" => $message . "already exist!!!", "data" => null]);
            }
            return response()->json(["status" => 1, "message" => "Record Inserted !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => $request->template_name . " template already exist!!!", "data" => null]);
        }
    }

    public function getTemplateById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $temp = [];

        $result = DB::table("tai_template_master as tm")
            ->where('tenant_id', $tenantId)
            ->where("id", $id)
            ->where("is_active", 1)
            ->first();

        $final = [];
        $final["template_name"] = $result->template_name;

        $templateBasket = DB::table("tai_template_basket")
            ->where("template_id", $id)
            ->where('tenant_id', $tenantId)
            ->where("is_active", 1)
            ->get();

        foreach ($templateBasket as $b) {
            $temp["basket_id"] = $b->id;
            $temp["basket_name"] = $b->basket_name;
            $temp["basket_owner"] = $b->basket_owner;
            $temp["basket_task"] = [];

            $task = DB::table("tai_template_basket_task")
                ->where("template_basket_id", $b->id)
                ->where('tenant_id', $tenantId)
                ->where("is_active", 1)
                ->get()
                ->toArray();

            foreach ($task as $t) {
                $temp["basket_task"][] = [
                    "task_id" => $t->id,
                    "task_name" => $t->task,
                    "task_total_time" => $t->total_time,
                    "task_days" => $t->days,
                    "AB" => $result->calculate_from,
                ];
            }
            $final["template_data"][] = $temp;
        }

        return response()->json([
            "status" => 1,
            "message" => "Record Found !!!",
            "data" => $final,
        ]);
        if (count($result) > 0) {
            return response()->json([
                "status" => 1,
                "message" => "Record Found !!!",
                "data" => $final,
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "No Record Found !!!",
                "data" => null,
            ]);
        }
    }

    public function updateTask(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        if (isset($data["total_time"])) {
            $data = array_merge($data, [
                "total_time_minute" => $data["total_time"] * 8 * 60,
            ]);
        }

        $result = DB::table("tai_template_basket_task")
            ->where("id", $id)
            ->where('tenant_id', $tenantId)
            ->where("is_active", 1)
            ->update($data);

        if ($result) {
            return response()->json([
                "status" => 1,
                "message" => "Record Updated !!!",
                "data" => null,
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Record Not Updated !!!",
                "data" => null,
            ]);
        }
    }

    public function updateBasket(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // return [$request->toArray(), $id];
        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;
        $result = DB::table("tai_template_basket")->where("id", $id)
            ->where("is_active", 1)
            ->update($data);
        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Updated !!!", "data" => null]);
        }
    }

    public function deleteTask(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;

        $result = DB::table("tai_template_basket_task")
            ->where("id", $id)
            ->where('tenant_id', $tenantId)
            ->update(["is_active" => 0]);

        if ($result) {
            return response()->json([
                "status" => 1,
                "message" => "Record Updated !!!",
                "data" => null,
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Record Not Updated !!!",
                "data" => null,
            ]);
        }
    }
}
