<?php
// live
namespace App\Http\Controllers;

use App\Models\Tenant;
use Illuminate\Http\Request;
use DB;
use JWTAuth;

class TenantController extends Controller
{
    public function getData(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 15-05-2023

        $result = DB::table('tai_tenant_master as t')
                    ->leftJoin('tai_employee_master as e','e.id','=','t.updated_by')
                    ->where('t.is_active', 1)
                    ->select('t.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"))
                    ->orderBy('t.id','DESC')
                    ->orderBy('t.is_active','DESC')
                    ->get();

        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record found !!!",'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record found !!!",'data' => null]);
        }        
    }
    
    public function postData(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 15-05-2023

        $check = DB::table('tai_tenant_master')
                    ->where('email_id', $request->email_id)    
                    ->get();
        if(count($check) == 0){

            $result = DB::table('tai_tenant_master')->insert($request->toArray());  
            if($result > 0){
                return response()->json(['status'=> 1, 'message'=> "Record Inserted !!!", 'data' => null]);
            }else{
                return response()->json(['status'=> 0, 'message'=> "Record Not Inserted !!!",'data' => null]);
            }    
        }else{
             return response()->json([ 'status'=> 0,'message'=> "Record Already Exists !!!", 'data' => null]);
        }   
    }

    public function putData(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 15-05-2023

        $result = DB::table('tai_tenant_master')->where('id', $id)->update($request->toArray());  
        if($result){
            return response()->json(['status'=> 1, 'message'=> "Record Updated !!!", 'data' => null]);
        }else{
            return response()->json(['status'=> 0, 'message'=> "Record Not Updated !!!", 'data' => null]);
        }         
    }

    public function deleteData($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 15-05-2023

        $result = DB::table('tai_tenant_master')->where('id', $id)->update(['is_active'=>1]);
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Deleted !!!", 'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "Record Not Deleted !!!", 'data' => null]);
        }        
    }

    public function getById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 15-05-2023
        
        $result = DB::table('tai_tenant_master')->where('id', $id)->where('is_active', 1)->first();
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Found !!!", 'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Found !!!", 'data' => null]);
        }
    }
}
