<?php

namespace App\Http\Controllers;

use App\Library\CommonController;
use App\Library\OwnershipController;
use App\Library\TaskSupportiveController as TaskSupportive;
use File;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;
use JWTAuth;
use DateTime;

class TestCaseController extends Controller
{

    public function sendNotification(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $userId = $token_data->id; //Date:

        $data  = $request->toArray();
        //  dd($data);
        $user_type = DB::table('tai_employee_master as emp')->select('r.role')
            ->leftJoin('tai_role_master as r', 'emp.role_id', 'r.id')
            ->where('emp.id', $userId)
            ->where('r.tenant_id', $tenantId)
            ->first();
        //Date: 21-06-2023 Bhagyashri Sonone TT12466

        $testCaseIds = "";
        $Iteration = $data['iteration'];
        if ($user_type->role == "Tester") {
            if (array_key_exists('test_case_id', $data) && array_key_exists('iteration', $data)) {
                $testCaseIds = $data['test_case_id'];
                if ($testCaseIds == null || $testCaseIds == "") {
                    return response()->json(['status' => 0, 'message' => "Please select test cases !", 'data' => null]);
                }
            } else {
                if (!array_key_exists('test_case_id', $data)) {
                    return response()->json(['status' => 0, 'message' => "Please select test cases !", 'data' => null]);
                }
            }
        }

        // $notify = DB::table('tai_ticket_user_mapping')
        //     ->whereNotIn('user_id', [$user_id])
        //     ->where('ticket_id', $request->ticket_id)
        //     ->where('is_active', 1)
        //     ->get();
        // // dd($notify);

        // $userInfo = CommonController::userInfo($user_id, ["first_name", "last_name",]);
        // $msg = $userInfo->first_name . " " . $userInfo->last_name . " says 'Please review testcases'. ";
        // foreach ($notify as $n) {
        //     CommonController::addNotification($user_id, $n->user_id, $msg);
        //     if ($notify) {
        //         $que = DB::table('tai_test_cases as ttc')
        //             ->where('ticket_id', $n->ticket_id)
        //             ->UPDATE(['reviewed' => 'REVIEWED']);
        //         if ($que) {
        //             return 'success';
        //         } else {
        //             return 'error';
        //         }
        //     }
        // }
        $ticketId = $data['ticket_id'];
        // $data['ticket_id']  = $ticketId;
        // dd($ticketId);
        $ticket_id = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $data['ticket_id'])->first()->ticket_id;
        if (is_array($data['user_id'])) {
            $userInfo = CommonController::userInfo($data['created_by'], ["first_name", "last_name",]);
            $msg = "Please check test cases under " . $ticket_id;
            $url = "getAllTestCases/" . $data['ticket_id'];
            //----------------------------------------------------------------end ----------------------------------------------------------------//
            // $msg = $userInfo->first_name . " " . $userInfo->last_name . " says 'Please review testcases'. ";
            foreach ($data['user_id'] as $n) {
                CommonController::addNotification($data['created_by'], $n, $msg, $url);
                $this->createHistory($testCaseIds, $Iteration, $tenantId, $ticketId, $userId);
            }
            if (array_key_exists('test_case_id', $data) && array_key_exists('iteration', $data)) {
                $this->createHistory($testCaseIds, $Iteration, $tenantId, $ticketId, $userId);
            }
            return response()->json(['status' => 1, 'message' => "Notification Sent", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Notification Not Sent", 'data' => null]);
        }
        return response()->json(['status' => 1, 'message' => "Notification Sent", 'data' => null]);
    }



    public function createHistory($testCaseIds, $Iteration, $tenantId, $ticketId, $n)
    {
        if ($testCaseIds != "") {
            $selectArray = [
                'tenant_id', 'test_case_id', 'ticket_id', 'task_id', 'function', 'module_id', 'submodule_id',
                'submodule', 'testing_type', 'platform', 'apk_version', 'os_version', 'steps_to_follow',
                'test_description', 'expected_result', 'actual_result', 'severity', 'priority', 'module_name',
                'tester_status', 'tester_comments', 'ba_status', 'ba_comments', 'dev_status', 'dev_comments',
                'reviewer_comments', 'approved_status_change_by', 'approved_status', 'approved_at', 'attachment_name',
                'field', 'reviewed', 'is_enabled', 'created_at', 'created_by', 'updated_at', 'updated_by', 'is_active', 'script_path'
            ];
            $Iteration = intval($Iteration);
            $selectArray[] = DB::raw($Iteration . " AS iteration_id");
            $data1 = DB::table('tai_test_cases')
                ->whereIn('id', explode(",", $testCaseIds))
                ->select($selectArray)
                ->get();
            $array = [];
            foreach ($data1 as $d) {
                $array[] = (array) $d;
            }
            DB::table('tai_test_cases_iteration_history')->insert($array);
        }

        //Date: 21-06-2023 Bhagyashri Sonone TT12466
        $user_type = DB::table('tai_employee_master as emp')->select('r.role')
            ->leftJoin('tai_role_master as r', 'emp.role_id', 'r.id')
            ->leftjoin('tai_iteration_turnaround as t', 'emp.id', 't.user_id')
            ->where('emp.id', $n)
            ->where('emp.tenant_id', $tenantId)
            ->where('r.tenant_id', $tenantId)
            ->first();

        if ($user_type->role == 'Developer') {
            //Developer time estimate
            // return [$user_type,$Iteration];
            //  dd($user_type,$Iteration);
            $upd = DB::table('tai_iteration_turnaround')
                ->where('ticket_id', $ticketId)
                ->where('iteration_id', $Iteration)
                ->update(['end_time' => date('Y-m-d H:i:s'), 'updated_by' => $n]);
        } elseif ($user_type->role == 'Tester') {
            $insert =   DB::table('tai_iteration_turnaround')->insert([
                'ticket_id' => $ticketId,
                'tenant_id' => $tenantId,
                'user_id' => $n,
                'iteration_id' => $Iteration,
                'start_time' => date('Y-m-d H:i:s'),
                'created_at' => date('Y-m-d H:i:s')
            ]);
        }
        //----------------------------------------------------------------end--------------------------------//
    }

    public function getLastId($ticket_id, $task_id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $last_id = DB::table('tai_test_cases')->where('ticket_id', $ticket_id)
            ->where('tenant_id', $tenantId)
            ->where('task_id', $task_id)
            ->orderBy('id', 'desc')->first();
        if ($last_id) {
            $break = explode('-', $last_id->test_case_id);
            $a = $break[1] + 1;
            $a = $a >= 10 ? $a : "0$a";
            return "TT-$a";
        } else {
            return "TT-01";
        }
    }

    public function getTestCases(Request $request, $user_id, $ticketId, $taskId = null)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $is_reviewer = DB::table('tai_owner_mapping_master')->where('user_id', $user_id)
            ->where('ticket_id', $ticketId)->where('type', 'TICKET_REV')
            ->first();
        if (!empty($is_reviewer)) {
            $is_reviewer = 1;
        } else {
            $is_reviewer = 0;
        }

        if ($taskId == null) {
            $taskId = $request->task_id;
        }


        if ($user_id) {
            $user_type = DB::table('tai_employee_master as emp')->select('r.role')
                ->leftJoin('tai_role_master as r', 'emp.role_id', 'r.id')
                ->where('emp.id', $user_id)
                ->where('emp.tenant_id', $tenantId)
                ->where('r.tenant_id', $tenantId)
                ->first();
            if ($user_type->role == "Tester") {
                $type = "TESTER";
            } elseif ($user_type->role == "Business Analyst") {
                $type = "BA";
            } elseif ($user_type->role == 'Developer') {
                $type = "DEV";
            } else {
                $type = strtoupper($user_type->role);
            }
        }

        $query = DB::table('tai_test_cases as tc')
            ->leftjoin('tai_ticket_master as tm', 'tc.ticket_id', 'tm.id')
            ->leftjoin('tai_project_modules as pm', 'tm.module_id', 'pm.id')
            ->leftjoin('tai_project_sub_modules as psm', 'tm.submodule_id', 'psm.id')
            // ->leftjoin('tai_iteration_turnaround as tr', 'tc.ticket_id', 'tr.ticket_id')
            // ->leftJoin('tai_ticket_master as tm', 'tc.ticket_id', 'tm.id')
            // ->leftJoin('tai_project_modules as pm', 'tc.module_id', 'pm.id')
            // ->leftJoin('tai_project_sub_modules as psm', 'tc.module_id', 'psm.id')

            ->leftJoin('tai_ticket_task as ttt', 'tc.task_id', 'ttt.id')
            ->leftJoin('tai_testing_type_master as ttm', 'tc.testing_type', 'ttm.id')
            ->where('tc.is_active', 1)
            ->where('tm.id', $ticketId)
            // ->where('tr.tenant_id',$tenantId)
            ->where('tc.tenant_id', $tenantId);
        // ->where('tm.tenant_id',$tenantId)
        // ->where('pm.tenant_id',$tenantId);

        $query->where(function ($q) use ($request, $taskId) {
            if ($taskId) {
                $is_review_task = DB::table('tai_testcases_task_mapping')->where('task_id', $taskId)->first();
                if ($is_review_task) {
                    $taskId = $is_review_task->testcase_task_id;
                    $q->where('tc.is_enabled', 1);
                }
                $q->where('tc.task_id', $taskId);
            }

            if ($request->testing_type) {
                $q->Where('tc.testing_type', $request->testing_type);
            }
            if ($request->severity) {
                $q->Where('tc.severity', $request->severity);
            }
            // if ($request->reviewed) {
            //     $q->Where('tc.reviewed', $request->reviewed);
            // }
            if ($request->task_name) {
                $q->Where('ttt.task_name', $request->task_name);
            }
            // if ($request->task_id) {
            //     $q->Where('tc.task_id', $request->task_id);
            // }
            if ($request->tester_status) {
                $q->Where('tc.tester_status', $request->tester_status);
            }
            if ($request->ba_status) {
                $q->Where('tc.ba_status', $request->ba_status);
            }
            if ($request->developer_status) {
                $q->Where('tc.dev_status', $request->developer_status);
            }
            if ($request->priority) {
                $q->Where('ttt.priority', $request->priority);
            }
        });

        // if ($request->approved_status) {
        //     $query->where('tc.approved_status', $request->approved_status);
        // }
        // DB::enableQueryLog();

        $query->select(
            'tc.*',
            'ttm.id as testing_type',
            'ttm.testing_type as testing_type_name',
            'pm.module_name',
            'psm.sub_module_name as submodule',
            'ttt.task_name'
            // 'tr.start_time',
            // 'tr.end_time'
        );  //add end time and start time Bhagyashri TT12466
        $data = $query->orderBy('id', 'ASC')->get();
        //  return response()->json(['status' => 0, 'message' => $request->testing_type  , 'data' => $query->toSql(), 'type' => NULL, 'execution' => 0]);

        // return DB::getQueryLog();

        if (!isset($request->task_id) && $taskId == null) {
            return response()->json(['status' => 1, 'message' => "No Record found !!!", 'data' => NULL, 'type' => $type, 'execution' => 0, 'show_review_btn' => 0, 'is_reviewer' => $is_reviewer]);
        }


        $execution = 0;

        if ($data) {
            $cnt = count($data);
            $i = 0;
            foreach ($data as $d) {

                if ($d->approved_status == 1) {
                    $i++;
                }
                $attachments = DB::table('tai_attachments')->where('type', "TEST_CASE")
                    ->select('id', 'name', 'path')
                    ->where('ref_id', $d->id)
                    ->orderBy('id')
                    ->get();
                $d->attachments = $attachments;
            }
            // return [$data, $cnt , $i];

            if ($cnt > 0) {
                if ($cnt == $i) {
                    $execution = 1;
                }
            }

            $result = DB::table('tai_owner_mapping_master')
                ->select(DB::raw('GROUP_CONCAT(user_id) as concatenated_user_ids'))
                ->where('type', 'TICKET_REV')
                ->where('ticket_id', $ticketId)
                ->where('tenant_id', $tenantId)
                ->where('is_active', 1)
                ->first();
            // return $result;

            if ($result && $result->concatenated_user_ids != NULL) {
                $show_review_btn = (count(array_unique(explode(",", $result->concatenated_user_ids))) > 0) ? 1 : 0;
            } else {
                $show_review_btn = 0;
            }


            $iterationData = DB::table('tai_test_cases_iteration_history as th')
                ->leftjoin('tai_iteration_turnaround as tu', 'th.ticket_id', '=', 'tu.ticket_id')
                ->where('th.is_active', 1)
                ->where('th.ticket_id', $ticketId)
                ->where('th.tenant_id', $tenantId);
            //   dd($taskId,$ticketId);
            if ($taskId) {
                $iterationData = $iterationData->where('th.task_id', $taskId);
            }
            $iterationData = $iterationData->orderBy('th.iteration_id')
                ->get();
            // dd($iterationData);

            $iteration = [];
            if (count($iterationData) > 0) {

                $pass = $fail = $pending = $total = 0;
                foreach ($iterationData as $id) {

                    $startTime = $id->start_time;
                    $endTime = $id->end_time;
                    $durationInDays = 0;

                    //add time duration 
                    //bhagyashri sonone 
                    $duration = "";
                    if ($startTime && $endTime) {
                        $startDateTime = new DateTime($startTime);
                        $endDateTime = new DateTime($endTime);
                        $interval = $startDateTime->diff($endDateTime);
                        $duration = $interval->format('%d d, %h h, %i m, %s s');
                        // dd($interval,  $interval->days);
                        if ($interval->days == 0) {
                            $durationInDays = 1;
                        } else {
                            $durationInDays = $interval->days;
                        }
                    }

                    $iterationId = $id->iteration_id;
                    if (!array_key_exists($iterationId, $iteration)) {
                        $iteration[$iterationId] = [
                            'pass' => 0,
                            'fail' => 0,
                            'pending' => 0,
                            'total' => 0,
                            'duration' => $durationInDays

                        ];
                    }
                    if ($id->tester_status == 'PASS') {
                        $pass++;
                        $iteration[$iterationId]['pass']++;
                    } elseif ($id->tester_status == 'FAIL') {
                        $fail++;
                        $iteration[$iterationId]['fail']++;
                    } else {
                        $pending++;
                        $iteration[$iterationId]['pending']++;
                    }
                    $total++;
                    $iteration[$iterationId]['total']++;
                    // $iteration['days'] = $durationInDays;
                    $iteration[$iterationId]['duration'] = $duration;
                    // $iteration[$iterationId]['days'] = $durationInDays;
                }
            }
            $iterationCount = count($iteration);

            return response()->json(['count' => count($data), 'status' => 1, 'message' => "Record found !!!", 'data' => $data, 'type' => $type, 'execution' => $execution, 'show_review_btn' => $show_review_btn,  'iterationData' => $iteration, 'iterationCount' => $iterationCount, 'is_reviewer' => $is_reviewer,]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => NULL, 'type' => NULL, 'execution' => 0, 'show_review_btn' => 0, 'is_reviewer' => $is_reviewer,]);
        }
    }

    // public function getTestCases(Request $request, $user_id, $ticketId, $taskId = null)
    // {
    //     if ($user_id) {
    //         $user_type = DB::table('tai_employee_master as emp')->select('r.role')
    //             ->leftJoin('tai_role_master as r', 'emp.role_id', 'r.id')
    //             ->where('emp.id', $user_id)
    //             ->first();
    //         if ($user_type->role == "Tester") {
    //             $type = "TESTER";
    //         } elseif ($user_type->role == "Business Analyst") {
    //             $type = "BA";
    //         } elseif ($user_type->role == 'Developer') {
    //             $type = "DEV";
    //         }
    //     }

    //     $query = DB::table('tai_test_cases as tc')
    //         ->leftJoin('tai_ticket_master as tm', 'tc.ticket_id', 'tm.id')
    //         ->leftJoin('tai_project_modules as pm', 'tc.module_id', 'pm.id')
    //         ->leftJoin('tai_project_sub_modules as psm', 'tc.module_id', 'psm.id')
    //         ->leftJoin('tai_ticket_task as ttt', 'tc.task_id', 'ttt.id')
    //         ->leftJoin('tai_testing_type_master as ttm', 'tc.testing_type', 'ttm.id')
    //         ->where('tm.id', $ticketId);

    //     $query->where(function ($q) use ($request, $taskId) {
    //         if ($taskId) {
    //             $is_review_task = DB::table('tai_testcases_task_mapping')->where('task_id', $taskId)->first();
    //             if ($is_review_task) {
    //                 $taskId = $is_review_task->testcase_task_id;
    //             }
    //             $q->where('tc.task_id', $taskId);
    //         }

    //         if ($request->testing_type) {
    //             $q->orWhere('tc.testing_type', $request->testing_type);
    //         }
    //         if ($request->severity) {
    //             $q->orWhere('tc.severity', $request->severity);
    //         }
    //         if ($request->reviewed) {
    //             $q->orWhere('tc.reviewed', $request->reviewed);
    //         }
    //         if ($request->task_name) {
    //             $q->orWhere('ttt.task_name', $request->task_name);
    //         }
    //         if ($request->tester_status) {
    //             $q->orWhere('tc.tester_status', $request->tester_status);
    //         }
    //         if ($request->ba_status) {
    //             $q->orWhere('tc.ba_status', $request->ba_status);
    //         }
    //         if ($request->developer_status) {
    //             $q->orWhere('tc.dev_status', $request->developer_status);
    //         }
    //         if ($request->priority) {
    //             $q->orWhere('ttt.priority', $request->priority);
    //         }

    //     });



    //     // if ($request->approved_status) {
    //     //     $query->where('tc.approved_status', $request->approved_status);
    //     // }
    //     DB::enableQueryLog();

    //     $query->select('tc.*', 'ttm.id as testing_type', 'ttm.testing_type as testing_type_name', 'pm.module_name', 'psm.sub_module_name', 'ttt.task_name');
    //     $data = $query->orderBy('id', 'ASC')->get();

    //     //  return response()->json(['status' => 0, 'message' => $request->testing_type  , 'data' => $query->toSql(), 'type' => NULL, 'execution' => 0]);

    //     return DB::getQueryLog();

    //     $execution = 0;

    //     if ($data) {
    //         $cnt = count($data);
    //         $i = 0;
    //         foreach ($data as $d) {
    //             if ($d->approved_status == 1) {
    //                 $i++;
    //             }
    //             $attachments = DB::table('tai_attachments')->where('type', "TEST_CASE")
    //                 ->select('id', 'name', 'path')
    //                 ->where('ref_id', $d->id)
    //                 ->orderBy('id')
    //                 ->get();
    //             $d->attachments = $attachments;
    //         }
    //         // return [$data, $cnt , $i];

    //         if ($cnt > 0) {
    //             if ($cnt == $i) {
    //                 $execution = 1;
    //             }
    //         }
    //         $data1 = ['data' => $data, 'type' => $type, 'execution' => $execution];
    //         return response()->json(['count' => count($data), 'status' => 1, 'message' => "Record found !!!", 'data' => $data, 'type' => $type, 'execution' => $execution]);
    //     } else {
    //         return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => NULL, 'type' => NULL, 'execution' => 0]);
    //     }
    // }

    public function getReviewTestCases(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // return response()->json(['status' => 0, 'message' =>"Start Date :".$start_date." End Date".$end_date, 'data' =>"Start Date :".$start_date." End Date".$end_date]);


        $data = $request->toArray();
        // return ($data);

        $reviewer = DB::table('tai_owner_mapping_master as omm')->select('omm.user_id')
            // ->where('tenant_id', '=', $data['tenant_id'])
            ->leftJoin('tai_employee_master as em', 'em.id', 'omm.user_id')
            ->where('omm.ticket_id', '=', $data['ticket_id'])
            ->where('omm.type', 'TICKET_REV')
            ->where('em.is_active', 1)
            ->where('omm.is_active', 1)
            ->first();

        $task = DB::table('tai_ticket_task')->where('ticket_id', '=', $data['ticket_id'])->where('id', '=', $data['task_id'])->first();

        $basket = DB::table('tai_ticket_basket')->where('ticket_id', '=', $data['ticket_id'])->where('basket_name', 'Reviewer')->first();

        if (!$basket) {
            if ($reviewer) {
                //PARTH PATEL
                $limit = 7;
                $n = 0;
                $start_date = date('Y-m-d', strtotime('+1 day'));
                $current_date = $start_date;
                if (date('D', strtotime($start_date)) == "Sat") {
                    $start_date = date('Y-m-d', strtotime('+2 day' . $start_date));
                } else if (date('D', strtotime($start_date)) == "Sun") {
                    $start_date = date('Y-m-d', strtotime('+1 day' . $start_date));
                }
                $end_date = "";
                $excluded = ["Sat", "Sun"];
                do {
                    $day = date('D', strtotime($current_date));
                    if (!in_array($day, $excluded)) {
                        $end_date = $current_date;
                        $n++;
                    }
                    $current_date = date('Y-m-d', strtotime('+1 day' . $current_date));
                } while ($n <= $limit);

                $basket = DB::table('tai_ticket_basket')->insertGetId([
                    'tenant_id' => $data['tenant_id'],
                    'ticket_id' => $data['ticket_id'],
                    'basket_name' => 'Reviewer',
                    'basket_owner' => $reviewer->user_id,
                    // 'start_date' => date('Y-m-d 00:00:00',1 strtotime('+1 day')),
                    // 'end_date' => date('Y-m-d 00:00:00', strtotime('+7 day')),
                    'start_date' => $start_date,
                    'end_date' => $end_date,
                    'created_at' => $data['created_at'],
                    'created_by' => $data['created_by'],
                ]);
            } else {
                return response()->json(['status' => 0, 'message' => "Please select reviewer for this project !!!", 'data' => null]);
            }
        } else {
            $basket = $basket->id;
        }

        if ($task) {

            $already = DB::table('tai_testcases_task_mapping as ttm')
                ->where([['ttm.testcase_task_id', '=', $task->id], ['ttm.is_active', '!=', 0]])
                ->orderByDesc('ttm.id')
                ->first();
            if ($already) {
                return response()->json(['status' => 0, 'message' => "Already sent to review !!!", 'data' => null]);
            }


            // $totalTestCases=DB::table('tai_test_cases')->where('task_id',$already->testcase_task_id)->where('is_active',1)->where('is_enabled',1)->get();

            $totalTestCases = DB::table('tai_test_cases')->where('task_id', $task->id)->where('is_active', 1)->where('is_enabled', 1)->get();

            if (count($totalTestCases) == 0) {
                return response()->json(['status' => 0, 'message' => "No Test Cases Found For Review !!!", 'data' => null]);
            }

            $start_date = date('Y-m-d', strtotime('+1 day'));
            $end_date = $start_date;

            // start date and end date should not be saturday or sunday
            if (date('D', strtotime($start_date)) == "Sat") {
                $start_date = date('Y-m-d', strtotime('+2 day' . $start_date));
            } else if (date('D', strtotime($start_date)) == "Sun") {
                $start_date = date('Y-m-d', strtotime('+1 day' . $start_date));
            }

            // To check each testcase 30 seconds for each
            $totalSeconds = count($totalTestCases) * 30;
            if ($totalSeconds < 60) {
                $secs = $totalSeconds;
                $mins = 0;
                $hrs = 0;

                $mins = $mins < 9 ? "0" . (int)$mins : $mins;
                $hrs = $hrs < 9 ? "0" . (int)$hrs : $hrs;

                $task_hours_in_min = $mins;
                $task_hours = $hrs . ":" . $mins;
            } else {
                $secs = $totalSeconds % 60;
                $totalMin = $totalSeconds / 60;
                $mins = $totalMin % 60;
                $hrs = $totalMin / 60;

                $mins = $mins < 9 ? "0" . (int)$mins : $mins;
                $hrs = $hrs < 9 ? "0" . (int)$hrs : $hrs;

                $task_hours_in_min = $totalMin;
                $task_hours = $hrs . ":" . $mins;
            }

            $taskId = DB::table('tai_ticket_task')->insertGetId([
                'tenant_id' => $data['tenant_id'],
                'ticket_id' => $data['ticket_id'],
                'task_name' => "Review -" . $task->task_name,
                'ticket_basket_id' => $basket,
                'type' => 'TASK',
                'start_date' => $start_date,
                'end_date' => $end_date,
                'task_hours' => $task_hours,
                'task_hours_in_min' => $task_hours_in_min,
                'priority' => "High",
                'status' => "TO_DO"
            ]);
            if ($taskId) {
                DB::table('tai_testcases_task_mapping')->insert([
                    'testcase_task_id' => $task->id,
                    'task_id' => $taskId,
                    'created_at' => $data['created_at'],
                    'created_by' => $data['created_by']
                ]);

                TaskSupportive::assignedUser("INSERTION", $data['tenant_id'], $data['ticket_id'], $basket, $taskId, $reviewer->user_id, date('Y-m-d H:i:s'), $data['created_by']);
                OwnershipController::mapping('Insert', 'TASK', $reviewer->user_id, 0, $data['ticket_id'], $basket, $taskId, $data['created_by'], $data['created_at']);

                if ($task_hours != null) {
                    TaskSupportive::taskAllocation(
                        "INSERTION",
                        $data['tenant_id'],
                        $data['ticket_id'],
                        $basket,
                        $taskId,
                        $reviewer->user_id,
                        $data['created_at'],
                        $data['created_by'],
                        $start_date,
                        $end_date,
                        $task_hours
                    );
                }

                $ticket = DB::table('tai_ticket_master')->where('id', $data['ticket_id'])->first();

                $userInfo = CommonController::userInfo($data['created_by'], ["first_name", "last_name"]);
                $assignPersonInfo = CommonController::userInfo($reviewer->user_id, ["first_name", "last_name",]);
                $url = "Ticket/Task/" . $data['ticket_id'];

                $msg = "New Basket has been created for" . $ticket->ticket_id . " by " . $userInfo->first_name . " " . $userInfo->last_name;

                $msg1 = $userInfo->first_name . " " . $userInfo->last_name . " has been created task for Ticket " . $ticket->ticket_id . " and assigned to " . $assignPersonInfo->first_name . " " . $assignPersonInfo->last_name;

                CommonController::addNotification($data["created_by"], $reviewer->user_id, $msg);
                CommonController::addNotification($data["created_by"], $reviewer->user_id, $msg1, $url);

                return response()->json(['status' => 1, 'message' => "Testcases sent to review !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Something went wrong !!!", 'data' => null]);
            }
        }
    }

    function convert(&$item, $key)
    {
        $item = (array) $item;
    }

    public function getAssignTestCasesTo(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        // dd($data);
        if ($data['test_case_id'] && $request->test_case_id != "") {
            $data['test_case_id'] = explode(",", $data['test_case_id']);
        } else {
            return response()->json(['status' => 0, 'message' => "Please select test cases !!!", 'data' => null]);
        }

        $already = DB::table('tai_testcases_task_mapping')->where([['task_id', '=', $data['task_id']], ['is_active', '=', 2]])->orderByDesc('id')->first();

        if (!empty($already)) {
            return response()->json(['status' => 0, 'message' => "Already sent to Tester !!!", 'data' => null]);
        }

        $testCaseTask = DB::table('tai_testcases_task_mapping')->where('task_id', $data['task_id'])->first();
        if ($testCaseTask) {
            $task = DB::table('tai_ticket_task')->where('ticket_id', '=', $data['ticket_id'])->where('id', '=', $testCaseTask->testcase_task_id)->first();

            $basket = DB::table('tai_ticket_task')->where('id', '=', $testCaseTask->testcase_task_id)->first()->ticket_basket_id;

            $tester = DB::table('tai_owner_mapping_master')->select('user_id')->where('ticket_id', '=', $data['ticket_id'])
                ->where('type', 'TASK')->where('is_active', 1)
                ->first();

            $totalTestCases = DB::table('tai_test_cases')->where('task_id', $task->id)->where('is_active', 1)->where('is_enabled', 1)->get();

            if (count($totalTestCases) == 0) {
                return response()->json(['status' => 0, 'message' => "No Test Cases Found For Review !!!", 'data' => null]);
            }

            $start_date = date('Y-m-d', strtotime('+1 day'));
            $end_date = $start_date;

            // start date and end date should not be saturday or sunday
            if (date('D', strtotime($start_date)) == "Sat") {
                $start_date = date('Y-m-d', strtotime('+2 day' . $start_date));
            } else if (date('D', strtotime($start_date)) == "Sun") {
                $start_date = date('Y-m-d', strtotime('+1 day' . $start_date));
            }

            // To check each testcase 30 seconds for each
            $totalSeconds = count($totalTestCases) * 30;
            if ($totalSeconds < 60) {
                $secs = $totalSeconds;
                $mins = 0;
                $hrs = 0;

                $mins = $mins < 9 ? "0" . (int)$mins : $mins;
                $hrs = $hrs < 9 ? "0" . (int)$hrs : $hrs;

                $task_hours_in_min = $mins;
                $task_hours = $hrs . ":" . $mins;
            } else {
                $secs = $totalSeconds % 60;
                $totalMin = $totalSeconds / 60;
                $mins = $totalMin % 60;
                $hrs = $totalMin / 60;

                $mins = $mins < 9 ? "0" . (int)$mins : $mins;
                $hrs = $hrs < 9 ? "0" . (int)$hrs : $hrs;

                $task_hours_in_min = $totalMin;
                $task_hours = $hrs . ":" . $mins;
            }

            $taskId = DB::table('tai_ticket_task')->insertGetId([
                'tenant_id' => $data['tenant_id'],
                'ticket_id' => $data['ticket_id'],
                'task_name' => $task->task_name . " Recheck",
                'ticket_basket_id' => $basket,
                'type' => 'TASK',
                'start_date' => $start_date,
                'end_date' => $end_date,
                'task_hours' => $task_hours,
                'task_hours_in_min' => "120",
                'priority' => $task->priority,
                'status' => "TO_DO"
            ]);

            if ($taskId) {
                DB::table('tai_testcases_task_mapping')->where([['task_id', '=', $data['task_id']],])->update(['is_active' => 2]);

                $data1 = DB::table('tai_test_cases')
                    ->select('test_case_id', 'ticket_id', DB::raw("$taskId as task_id"), 'module_id', 'function', 'submodule_id', 'submodule', 'testing_type', 'platform', 'apk_version', 'os_version', 'steps_to_follow', 'test_description', 'expected_result', 'actual_result', 'severity', 'module_name', 'field', 'reviewer_comments')
                    ->whereIn('id', $data['test_case_id'])
                    // ->where('approved_status', 2)
                    ->get();
                $array = [];
                foreach ($data1 as $d) {
                    $array[] = (array)$d;
                }
                DB::table('tai_test_cases')->insert($array);

                $data1 = DB::table('tai_test_cases')
                    ->whereIn('id', $data['test_case_id'])
                    ->update(['is_active' => 0]);

                TaskSupportive::assignedUser("INSERTION", $data['tenant_id'], $data['ticket_id'], $basket, $taskId, $tester->user_id, date('Y-m-d H:i:s'), $data['created_by']);
                OwnershipController::mapping('Insert', 'TASK', $tester->user_id, 0, $data['ticket_id'], $basket, $taskId, $data['created_by'], $data['created_at']);
                if ($request->task_hours) {
                    TaskSupportive::taskAllocation(
                        "INSERTION",
                        $data['tenant_id'],
                        $data['ticket_id'],
                        $basket,
                        $taskId,
                        $tester->user_id,
                        $data['created_at'],
                        $data['created_by'],
                        $start_date,
                        $end_date,
                        $task_hours
                    );
                }

                $ticket = DB::table('tai_ticket_master')->where('id', $data['ticket_id'])->first();

                $userInfo = CommonController::userInfo($data['created_by'], ["first_name", "last_name"]);
                $assignPersonInfo = CommonController::userInfo($tester->user_id, ["first_name", "last_name",]);
                $url = "Ticket/Task/" . $data['ticket_id'];

                $msg = "New Basket has been created for" . $ticket->ticket_id . " by " . $userInfo->first_name . " " . $userInfo->last_name;

                $msg1 = $userInfo->first_name . " " . $userInfo->last_name . " has been created task for Ticket " . $ticket->ticket_id . " and assigned to " . $assignPersonInfo->first_name . " " . $assignPersonInfo->last_name;

                CommonController::addNotification($data["created_by"], $tester->user_id, $msg);
                CommonController::addNotification($data["created_by"], $tester->user_id, $msg1, $url);

                return response()->json(['status' => 1, 'message' => "Testcaes sent back to tester !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Something went wrong !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Testcases task not found !!!", 'data' => null]);
        }
    }

    public function checkTaskHours($taskHours)
    {
        if (!preg_match('/^\d{2,3}:\d{2}$/', $taskHours)) {
            return ['status' => 0, 'message' => "Required time as HH:MM"];
        }
        return ['status' => 1, 'message' => NULL];
    }

    public function getAssignTestCasesToTester(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        if ($data['test_case_id'] && $request->test_case_id != "") {
            $data['test_case_id'] = explode(',', $data['test_case_id']);
        } else {
            return response()->json(['status' => 0, 'message' => "Please select test cases !!!", 'data' => null]);
        }

        // return $data;
        // $basket = DB::table('tai_ticket_basket')->where('ticket_id', '=', $data['ticket_id'])
        //     ->where('basket_name', 'Tester')->first();


        if ($request->tester_id) {
            $tester_id = $data['tester_id'];
            $basket = $data['basket_id'];


            // $taskId = DB::table('tai_testcases_task_mapping')->where('task_id', $data['task_id'])->first()->testcase_task_id;
            // $tester_id = DB::table('tai_owner_mapping_master')->where('task_id', $taskId)->where('type', 'TASK')->first()->user_id;

            // if (!$basket) {
            //     $basket = DB::table('tai_ticket_basket')->insertGetId([
            //         'tenant_id' => $data['tenant_id'],
            //         'ticket_id' => $data['ticket_id'],
            //         'basket_name' => $data['basket_name'],
            //         'basket_owner' => $tester_id,
            //         'start_date' => date('Y-m-d 00:00:00', strtotime('+1 day')),
            //         'end_date' => date('Y-m-d 00:00:00', strtotime('+7 day')),
            //         'created_at' => $data['created_at'],
            //         'created_by' => $data['created_by'],
            //     ]);
            // } else {
            //     $basket = $basket->id;
            // }

            //Validate Task Hours
            if ($data['task_hours']) {
                $checkTaskHours = $this->checkTaskHours($data['task_hours']);
                if ($checkTaskHours['status'] === 0) {
                    return response()->json(['status' => 0, 'message' => $checkTaskHours['message'], 'data' => null]);
                }

                if (strpos($data['task_hours'], ':') !== false) {
                    $temp = explode(':', $data['task_hours']);
                    if ($temp[0] > 0) {
                        $hourToMin = (int)$temp[0] * 60;
                    } else {
                        $hourToMin = 0;
                    }
                    $min = $temp[1];
                    $data['task_hours_in_min'] = $hourToMin + $min;
                }
            }

            $taskId = DB::table('tai_ticket_task')->insertGetId([
                'tenant_id' => $data['tenant_id'],
                'ticket_id' => $data['ticket_id'],
                'task_name' => $data['task_id'],
                'ticket_basket_id' => $basket,
                'type' => 'TASK',
                'start_date' => $data['start_date'],
                'end_date' => $data['end_date'],
                'task_hours' => $data['task_hours'],
                'task_hours_in_min' => $data['task_hours_in_min'],
                'priority' => "High",
                'status' => "TO_DO"
            ]);

            $ticket_id = $data['ticket_id'];
            $data1 = DB::table('tai_testsuit_testcase_master')
                ->select('id as testsuit_testcase_id', 'test_case_id', DB::raw("$ticket_id as ticket_id"), DB::raw("$taskId as task_id"), 'module_id', 'function', 'submodule_id', 'submodule', 'testing_type', 'platform', 'apk_version', 'os_version', 'steps_to_follow', 'test_description', 'expected_result', 'actual_result', 'severity', 'module_name', 'field', 'approved_status')
                ->whereIn('id', $data['test_case_id'])
                ->where('approved_status', 1)
                ->get();

            $array = [];
            $k = 1;
            foreach ($data1 as $d) {
                $t_id = $k;
                if ($k <= 9) {
                    $t_id = '0' . $k;
                }
                $d->test_case_id = "TT-" . $t_id;
                $array[] = (array)$d;
                $k++;
            }

            if (is_array($data['test_case_id'])) {
                DB::table('tai_test_cases')->insert($array);
            }
        } else {
            $taskId = DB::table('tai_testcases_task_mapping')->where('task_id', $data['task_id'])->first()->testcase_task_id;
            $tester_id = DB::table('tai_owner_mapping_master')->where('task_id', $taskId)->where('type', 'TASK')->where('is_active', 1)->orderByDesc('id')->first()->user_id;
            $basket = DB::table('tai_ticket_task')->where('id', $taskId)->first()->ticket_basket_id;

            if (is_array($data['test_case_id'])) {
                foreach ($data['test_case_id'] as $t) {
                    DB::table('tai_test_cases')->where('task_id', $taskId)->whereNotIn('id', $data['test_case_id'])->update(['is_active' => 0]);
                }
            }
        }

        if ($taskId) {
            TaskSupportive::assignedUser("INSERTION", $data['tenant_id'], $data['ticket_id'], $basket, $taskId, $tester_id, date('Y-m-d H:i:s'), $data['created_by']);
            OwnershipController::mapping('Insert', 'TASK', $tester_id, 0, $data['ticket_id'], $basket, $taskId, $data['created_by'], $data['created_at']);
            if ($request->task_hours) {
                TaskSupportive::taskAllocation(
                    "INSERTION",
                    $data['tenant_id'],
                    $data['ticket_id'],
                    $basket,
                    $taskId,
                    $tester_id,
                    $data['created_at'],
                    $data['created_by'],
                    $data['start_date'],
                    $data['end_date'],
                    $data['task_hours']
                );
            }

            $ticket = DB::table('tai_ticket_master')->where('id', $data['ticket_id'])->first();

            $userInfo = CommonController::userInfo($data['created_by'], ["first_name", "last_name"]);
            $assignPersonInfo = CommonController::userInfo($tester_id, ["first_name", "last_name",]);
            $url = "Ticket/Task/" . $data['ticket_id'];

            $msg = "New Basket has been created for" . $ticket->ticket_id . " by " . $userInfo->first_name . " " . $userInfo->last_name;

            $msg1 = $userInfo->first_name . " " . $userInfo->last_name . " has been created task for Ticket " . $ticket->ticket_id . " and assigned to " . $assignPersonInfo->first_name . " " . $assignPersonInfo->last_name;

            CommonController::addNotification($data["created_by"], $tester_id, $msg);
            CommonController::addNotification($data["created_by"], $tester_id, $msg1, $url);

            return response()->json(['status' => 1, 'message' => "Testcaes sent to Tester !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Something went wrong !!!", 'data' => null]);
        }
    }

    public function getAddToTestSuit(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $data = $request->toArray();

        if ($request->test_case_id == "") {
            return response()->json(['status' => 0, 'message' => "Please select test cases!!!", 'data' => null]);
        }

        // DB::table('tai_test_cases')->whereIn('id', explode(",", $data['test_case_id']))->where('approved_status', '!=', 2)
        //     ->update([
        //         'approved_status' => 1,
        //         'approved_status_change_by' => $request->created_by,
        //         'updated_at' => $request->created_by,
        //         'updated_at' => NOW()
        //     ]);

        // $selectArray = [
        //     'test_case_id', 'testing_type', 'ticket_id', 'module_id', 'function', 'submodule_id', 'submodule', 'testing_type', 'platform',
        //     'apk_version', 'os_version', 'steps_to_follow', 'test_description', 'expected_result', 'actual_result', 'severity', 'module_name',
        //     'field'
        // ];

        // dd($data);
        $selectArray = [];
        if (array_key_exists('testsuit_id', $data)) {
            // $selectArray = array_merge($selectArray, DB::raw($data['testsuit_id'] . " as testsuit_id"));
            //$data['testsuit_id'] . " as testsuit_id"
            // $testsuitId = intval($data['testsuit_id']);
            // $selectArray = array_merge($selectArray, ["'.$testsuitId .'"." as testsuit_id"]);

            $testsuitId = intval($data['testsuit_id']);
            $selectArray[] = DB::raw($testsuitId . " AS testsuit_id");
        }

        // $data1 = DB::table('tai_test_cases')
        //     ->select($selectArray)
        //     ->whereIn('id', explode(",", $data['test_case_id']))
        //     ->where('approved_status', '!=', 2)
        //     ->get();

        // $data1 = DB::table('tai_testsuit_testcase_master')
        $data1 = DB::table('tai_test_cases')
            ->select(
                'test_case_id',
                'testing_type',
                'ticket_id',
                'module_id',
                'function',
                'submodule_id',
                'submodule',
                'testing_type',
                'platform',
                'apk_version',
                'os_version',
                'steps_to_follow',
                'test_description',
                'expected_result',
                'actual_result',
                'severity',
                'module_name',
                'field'
            )
            ->addSelect($selectArray)
            ->whereIn('id', explode(",", $data['test_case_id']))
            // ->where('approved_status', '!=', 2)
            ->get();

        // dd($data1);
        $array = [];
        foreach ($data1 as $d) {
            $d->approved_status = 1;
            $temp = (array)$d;
            $temp["testsuit_id"] = NULL;
            if (array_key_exists('testsuit_id', $data)) {
                $temp["testsuit_id"] = $data['testsuit_id'];
            }
            $temp["approved_status"] = 1;
            $temp['created_at'] = NOW();
            $temp['created_by'] = $request->created_by;
            $array[] = $temp;
        }
        // return $array;
        $ins = DB::table('tai_testsuit_testcase_master')->insert($array);
        if ($ins) {
            return response()->json(['status' => 1, 'message' => "Testcaes sent to test suite !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Something went wrong !!!", 'data' => null]);
        }
    }





    public function getExport(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = DB::table('tai_test_cases as tc')
            ->select('tc.id', 'test_case_id', 'testing_type', 'm.module_name as module_name', 'sm.sub_module_name as sub_module_name', 'platform', 'apk_version', 'os_version', 'test_description', 'expected_result', 'tester_comments', 'severity')
            ->leftJoin('tai_project_modules as m', 'tc.module_id', 'm.id')
            ->leftJoin('tai_project_sub_modules as sm', 'tc.submodule_id', 'sm.id')
            ->where('ticket_id', $request->ticket_id)
            ->where('tc.tenant_id', $tenantId) //Date:30-05-2023 PUNAM SHINDE
            ->get();

        header('Content-Type: application/csv');
        header('Content-Disposition: attachment; filename="Testcase Report.csv";');
        // dd($data);
        $f = fopen('php://output', 'w');
        $col = ['Id', 'Test Case Id', 'Testing Type', 'Module Name', 'Sub Module Name', 'Platform', 'Apk version', 'OS version', 'Test Description', 'Expected Result', 'Tester Comments', 'Severity'];
        fputcsv($f, $col);

        if (count($data)) {
            for ($j = 0; $j < count($data); $j++) {
                $temp = [$data[$j]->id, $data[$j]->test_case_id, $data[$j]->testing_type, $data[$j]->module_name, $data[$j]->sub_module_name, $data[$j]->platform, $data[$j]->apk_version, $data[$j]->os_version, $data[$j]->test_description, $data[$j]->expected_result, $data[$j]->tester_comments, $data[$j]->severity];
                fputcsv($f, $temp);
            }
            fclose($f);
            exit;
        }
    }

    public function submitTestCases(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // $data = $request->inputList;
        // return $data;

        $data = $request->toArray();

        unset($data['tenant_id']);
        unset($data['attachment']);

        $already = DB::table('tai_test_cases')->where('tenant_id', $tenantId)
            ->where('testing_type', $data['testing_type'])
            ->where('function', $data['function'])
            ->where('platform', $data['platform']);
        if ($data['platform'] == 'App') {
            $already = $already->where('apk_version', $data['apk_version'])
                ->where('os_version', $data['os_version']);
        }
        $already = $already->where('test_description', $data['test_description'])
            ->where('expected_result', $data['expected_result'])
            ->where('field', $data['field'])
            // ->where('tester_comments', $d['tester_comments'])
            ->where('severity', $data['severity'])
            ->first();

        if (empty($already)) {
            $testCaseId = DB::table('tai_test_cases')->insertGetId($data);
            if ($testCaseId) {
                if ($request->file('attachment')) {
                    CommonController::uploadAttachment($testCaseId, $request->file('attachment'), 'TEST_CASE', $data['created_by']);
                }
                CommonController::generateHistory("INSERT", 'tai_test_cases', $testCaseId);
            }

            if ($testCaseId > 0) {
                return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => $testCaseId + 1]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Record Already Exist !!!", 'data' => null]);
        }
    }

    public function updateTestCases(Request $request, $id)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // foreach($request->file('attachment') as $index=>$file)
        // {
        //     $path=CommonController::attachmentPath("TEST_CASE");
        //     if(!Storage::exists($path)) {
        //         Storage::makeDirectory($path); 
        //     }

        //     $fileName=$file->getClientOriginalName(); 

        //     $isUploaded = $file->storeAs($path,$fileName);
        //     return response()->json(['status' => 0, 'message' =>$isUploaded,'data' => null]);
        // }


        // $test=CommonController::uploadAttachment(9763, $request->file('attachment'), 'TEST_CASE',5130);

        // return response()->json(['status' => 0, 'message' =>$test,'data' => null]);

        // if($request->file('attachment'))
        // {
        //     return response()->json(['status' => 0, 'message' => "Attachment Found",'data' => null]);
        // }else{
        //     return response()->json(['status' => 0, 'message' => "No Attachment", 'data' =>null]);
        // }

        $data = $request->toArray();
        unset($data['task_name']);
        unset($data['attachment']);

        if ($request->file('attachment')) {
            CommonController::uploadAttachment($id, $request->file('attachment'), 'TEST_CASE', $data['updated_by']);
        }
        // if ($request->approved_status) {
        //     if ($request->approved_status == "true") {
        //         $data['approved_status'] = 1;
        //     } else {
        //         $data['approved_status'] = 0;
        //     }
        // }
        if ($request->approved_status) {
            $data['approved_status'] = $request->approved_status;
        }
        // return $request->all();

        $result = DB::table('tai_test_cases')->where('id', $request->id)->update($data);
        CommonController::generateHistory("UPDATE", 'tai_test_cases', $id);
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
        }
    }

    public function deleteTestCases(Request $request, $id)
    {
        $data = $request->toArray();
        unset($data['id']);
        $check = DB::table('tai_test_cases')->where('id', $request->id)->first();
        if ($check) {
            $result = DB::table('tai_test_cases')->where('id', $request->id)->update(['is_active' => 0]);
            if ($result) {
                return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Found !!!", 'data' => null]);
        }
    }

    public function importTestCase(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // Chcek the empty file and give Error
        if (!$request->file('attachment')) {
            return response()->json(["status" => 0, "message" => "Please Upload File !!!", "data" => null]);
        }

        $fileExtension = $request->file('attachment')->getClientOriginalExtension();

        $requiredExtention = ['csv'];
        if (!in_array($fileExtension, $requiredExtention)) {
            return response()->json(["status" => 0, "message" => "Required Only  " . implode(',', $requiredExtention) . " !!!", "data" => null]);
        }

        $testCase = array();
        $uploadData = \Excel::toArray(null, $request->file('attachment'));
        $data = $uploadData[0];
        $header = $data[0];
        if (!$header) {
            return response()->json(["status" => 0, "message" => "File Is empty !!!", "data" => null]);
        }
        unset($data[0]);

        if (count($data) == 0) {
            return response()->json(["status" => 0, "message" => "File Is EmptloadDatay or Missing Headers!!!", "data" => null]);
        }

        // check and insert data with validations
        $mainData = array();
        $issue = array();
        foreach ($data as $d) {
            $mainData[] = array_combine($header, $d);
        }

        $errorArray = [];   //STORE ARRAY OF UPLOADED DATA WITH ERROR

        foreach ($mainData as $m) {
            $d = (array) $m;
            $error = [];

            $check = DB::table('tai_test_cases')
                ->where('tenant_id', $tenantId)
                ->where('testing_type', $d['testing_type'])
                ->where('function', $d['function'])
                ->where('platform', $d['platform'])
                ->where('apk_version', $d['apk_version'])
                ->where('os_version', $d['os_version'])
                ->where('test_description', $d['test_description'])
                ->where('expected_result', $d['expected_result'])
                ->where('field', $d['field'])
                // ->where('tester_comments', $d['tester_comments'])
                ->where('severity', $d['severity'])
                // ->orwhere('attachment_name', $d['attachment_name'])
                // ->orwhere('tester_status', $d['tester_status'])
                ->select('testing_type', 'function', 'platform', 'test_description', 'expected_result', 'actual_result', 'tester_comments', 'tester_status', 'severity', 'attachment_name')
                ->first();

            if ($check) {
                $error[] = "Duplicate Data";
            }

            // Validation For Testing Type
            // if (strtolower($d['testing_type']) == 'functional' || strtolower($d['testing_type']) == 'integration' || strtolower($d['testing_type']) == 'validation' || strtolower($d['testing_type']) == 'ui/ux') {
            // } else {
            //     $d['error'] = 'Testing Type Is Not Valid';
            //     $tempErrors[] = $d;
            //     $flag = 1;
            // }


            // Validation for Platform
            $platformArray = ["website", "app"];

            if (!in_array(strtolower($d['platform']), $platformArray)) {
                $error[] = 'Platform is Missing';
            }

            // Validation for Tester status
            // if (strtolower($d['tester_status']) == 'pass' || strtolower($d['tester_status']) == 'fail') {
            // } else {
            //     $d['error'] = 'Tester Status Is Not Specified';
            //     $tempErrors[] = $d;
            //     $flag = 1;
            // }

            $severityArray = ['high', 'medium', 'low'];
            if (!in_array(strtolower($d['severity']), $severityArray)) {
                $error[] = 'Severity Is Not Specified';
            }


            $mId = DB::table('tai_ticket_master as tm')->where('tm.id', $request->ticket_id)->select('tm.module_id', 'tm.submodule_id')->first();

            // Prathmesh Shinde 10 aug 2023
            // $already = DB::table('tai_test_cases as tm')->where('tm.id', $request->ticket_id)->where('test_description', $d['test_description'])->first();
            // if ($already) {
            //     $error[] = 'Test Description Is Already Exists';
            // }

            // Check expected_result not empty
            if (empty($d['expected_result'])) {
                $error[] = 'Expected Result Is Missing';
            }

            $checkTestingType = DB::table('tai_testing_type_master')->where([
                "tenant_id" => $tenantId,
                "testing_type" => strtoupper($d['testing_type'])
            ])->first();

            if (!$checkTestingType) {
                // USED TO SAVE TESTING TYPE IN MASTER
                $testingTypeId = DB::table('tai_testing_type_master')->insertGetId([
                    "tenant_id" => $tenantId,
                    "testing_type" => strtoupper($d['testing_type']),
                    "is_active" => 1,
                    "created_at" => now(),
                    "created_by" => $request->created_by
                ]);
            } else {
                $testingTypeId = $checkTestingType->id;
            }

            // $d['ticket_id'] = $request->ticket_id;
            // $d['task_id'] = $request->task_id;
            // $d['test_case_id'] = $this->getLastId($request->ticket_id, $request->task_id);
            // $d['module_id'] = ($mId && $mId->module_id) ? $mId->module_id : null;
            // $d['submodule_id'] = ($mId && $mId->submodule_id) ? $mId->submodule_id : null;
            // $d['testing_type'] = $d['severity'];
            // $d['severity'] = strtoupper($d['severity']);
            // $d['platform'] = strtoupper( $d['platform']);
            // $d["created_by"] = $request->created_by;
            // $d["created_at"] = now();

            if (count($error) == 0) {
                $array = [
                    'test_case_id' => $this->getLastId($request->ticket_id, $request->task_id),
                    'ticket_id' => $request->ticket_id,
                    'task_id' => $request->task_id,
                    'function' => $d['function'],
                    'module_id' => ($mId && $mId->module_id) ? $mId->module_id : null,
                    'submodule_id' => ($mId && $mId->submodule_id) ? $mId->submodule_id : null,
                    'testing_type' => $testingTypeId,
                    'platform' => strtoupper($d['platform']),
                    'apk_version' => $d['apk_version'],
                    'os_version' => $d['os_version'],
                    'severity' => strtoupper($d['severity']),
                    'test_description' => $d['test_description'],
                    'expected_result' => $d['expected_result'],
                    'field' => $d['field'],
                    'tester_comments' => $d['tester_comment'],
                    'created_by' => $request->created_by,
                    'created_at' => now()
                ];
                // if ($d['tester_comments']) {
                //     $array['tester_comments'] = $d['tester_comments'];
                // }

                $insertd = DB::table('tai_test_cases')->insertGetId($array);
                CommonController::generateHistory("INSERT", 'tai_test_cases', $insertd);
            } else {
                $d['error'] = implode(",", $error);
                $errorArray[] = $d;
            }
        } //FOR

        if (count($errorArray)) {
            $delimeter = ',';
            $f = fopen(storage_path('app/Update_Error_File.csv'), 'w');

            $col = ['testing_type', 'function', 'platform', 'apk_version', 'os_version', 'test_description', 'expected_result', 'field', 'tester_comments', 'severity', 'error'];
            fputcsv($f, $col, $delimeter);

            foreach ($errorArray as $d) {
                $temp = [$d['testing_type'], $d['function'], $d['platform'], $d['apk_version'], $d['os_version'], $d['test_description'], $d['expected_result'], $d['field'], $d['tester_comment'], $d['severity'], $d['error']];
                fputcsv($f, $temp, $delimeter);
            }
            fclose($f);

            return response()->json(["status" => 1, "message" => "File to Download!!!", "data" => "storage/app/Update_Error_File.csv"]);
        } else {
            return response()->json(["status" => 1, "message" => "File Successfully Uploaded!!!", "data" => null]);
        }
    }

    public function BulkFormat()
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        return response()->json(['status' => 1, 'message' => 'File is ready to download', 'data' => 'storage/TestCases/sampleFormat.xlsx']);
    }

    public function getTestCaseHistory($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = DB::table('tai_test_cases_history as th')
            ->where('th.main_id', $id)
            ->leftjoin('tai_employee_master as em1', 'th.updated_by', 'em1.id')
            ->leftjoin('tai_employee_master as em2', 'th.created_by', 'em2.id')
            ->leftjoin('tai_employee_master as em3', 'th.approved_status_change_by', 'em3.id')
            ->leftjoin('tai_ticket_master as t', 'th.ticket_id', 't.id')
            ->leftjoin('tai_project_modules as tpm', 't.module_id', 'tpm.id')
            ->leftjoin('tai_project_sub_modules as tps', 't.submodule_id', 'tps.id')
            ->leftJoin('tai_testing_type_master as ttm', 'th.testing_type', 'ttm.id')
            ->leftjoin('tai_ticket_master as tm', 'th.ticket_id', 'tm.id')
            ->select(
                'th.*',
                'ttm.testing_type as testing_type_name',
                'tm.ticket_id as ticket_id',
                'tpm.module_name',
                'tps.sub_module_name',
                DB::raw("CONCAT(em1.first_name,' ',em1.last_name) AS updated_by"),
                DB::raw("CONCAT(em2.first_name,' ',em2.last_name) AS created_by"),
                DB::raw("CONCAT(em3.first_name,' ',em3.last_name) AS approved_status_change_by")
            )
            ->get();
        $temp = [];
        if (count($data) > 0) {
            foreach ($data as $d) {
                $temp[] = (array)$d;
            }
            if (count($temp) >= 2) {
                foreach ($temp as $key => $value) {
                    $temp[$key]['changes'] = [];
                    if ($key >= 1) {
                        $prevKey = $key - 1;

                        $tempPrevArray = $temp[$prevKey];
                        $tempCurrentArray = $temp[$key];

                        if (array_key_exists('changes', $tempPrevArray)) {
                            unset($tempPrevArray['changes']);
                        }
                        if (array_key_exists('changes', $tempCurrentArray)) {
                            unset($tempCurrentArray['changes']);
                        }
                        $diff = (array_diff_assoc($tempPrevArray, $tempCurrentArray));
                        unset($diff['id']);
                        unset($diff['operation']);


                        $temp[$key]['changes'] = array_keys($diff);
                    }
                }
            }

            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $temp]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }
}
