<?php

namespace App\Http\Controllers;

use App\Library\CommonController;
use File;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class TestCaseController extends Controller
{

    public function sendNotification(Request $request, $user_id){
        $data = $request-> toArray();
        $notify = DB::table('tai_ticket_user_mapping')
                    ->whereNotIn('user_id', [$user_id])
                    ->where('ticket_id', $request->ticket_id)
                    ->where('is_active', 1)
                    ->get();
                    dd($notify);

        $userInfo = CommonController::userInfo($user_id, ["first_name", "last_name",]);
        $msg = $userInfo->first_name . " " . $userInfo->last_name . " says 'Please review testcases'. ";
        foreach($notify as $n){
            CommonController::addNotification($user_id, $n->user_id, $msg);
            if($notify){
            
                $que = DB::table('tai_test_cases as ttc')
                ->where('ticket_id',$n->ticket_id)
                ->UPDATE (['reviewed' =>'REVIEWED']);
                if($que)
                {return 'success';}else{return 'error';}
            }
        }
        
        return response()->json(['status'=>1, 'message' => "Notification Sent", 'data' => null]);
    }

    public function getLastId($ticket_id, $task_id)
    {
        $last_id = DB::table('tai_test_cases')->where('ticket_id', $ticket_id)
            ->where('task_id', $task_id)
            ->orderBy('id', 'desc')->first();
        if ($last_id) {
            $break = explode('-', $last_id->test_case_id);
            $a = $break[1] + 1;
            $a = $a > 10 ? $a : "0$a";
            return "TT-$a";
        } else {
            return "TT-01";
        }
    }

    public function getTestCases(Request $request, $user_id, $ticketId,$taskId=null)
    {
        if ($user_id) {
            $user_type = DB::table('tai_employee_master as emp')->select('r.role')
                ->leftJoin('tai_role_master as r', 'emp.role_id', 'r.id')
                ->where('emp.id', $user_id)
                ->first();
            if ($user_type->role == "Tester") {
                $type = "TESTER";
            } elseif ($user_type->role == "Business Analyst") {
                $type = "BA";
            } elseif ($user_type->role == 'Developer') {
                $type = "DEV";
            }
        }

        $query = DB::table('tai_test_cases as tc')
            ->leftJoin('tai_ticket_master as tm', 'tc.ticket_id', 'tm.id')
            ->leftJoin('tai_project_modules as pm', 'tc.module_id', 'pm.id')
            ->leftJoin('tai_project_sub_modules as psm', 'tc.module_id', 'psm.id')
            ->leftJoin('tai_ticket_task as ttt', 'tc.task_id', 'ttt.id')
            ->where('tm.id', $ticketId);

        if($taskId && $type=="TESTER"){
            $query->where('tc.task_id', $taskId);
        }
           
        if ($request->task_name) {
            $query->where('ttt.task_name', $request->task_name);
        }
        if ($request->tester_status) {
            $query->where('tc.tester_status', $request->tester_status);
        }
        if ($request->ba_status) {
            $query->where('tc.ba_status', $request->ba_status);
        }
        if ($request->developer_status) {
            $query->where('tc.dev_status', $request->developer_status);
        }
        if ($request->priority) {
            $query->where('ttt.priority', $request->priority);
        }
        if ($request->severity) {
            $query->where('tc.severity', $request->severity);
        }
        //    DB::enableQueryLog();
        
        $data = $query->select('tc.*', 'pm.module_name', 'psm.sub_module_name', 'ttt.task_name')
                        ->orderBy('id', 'DESC')
                ->get();
        //  print_r(DB::getQueryLog());exit;
        if ($data) {
            foreach ($data as $d) {
                $attachments = DB::table('tai_attachments')->where('type', "TEST_CASE")
                    ->select('id', 'name', 'path')
                    ->where('ref_id', $d->id)
                    ->orderBy('id')
                    ->get();
                $d->attachments = $attachments;
            }
            $data1 = ['data' => $data, 'type' => $type];
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $data1]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function getReviewedTestCases (Request $request){

    }

    public function submitTestCases(Request $request)
    {
        // $data = $request->inputList;
        // return $data;

        $data = $request->toArray();

        unset($data['tenant_id']);
        unset($data['attachment']);

        $already = DB::table('tai_test_cases')->where('test_description', $data['test_description'])->first();
        if (!$already) {

            $testCaseId = DB::table('tai_test_cases')->insertGetId($data);
            if ($testCaseId) {
                if ($request->file('attachment')) {
                    CommonController::uploadAttachment($testCaseId, $request->file('attachment'), 'TEST_CASE', $data['created_by']);
                }
                CommonController::generateHistory("INSERT", 'tai_test_cases', $testCaseId);
            }

            if ($testCaseId > 0) {
                return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => $testCaseId + 1]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Record Already Exist !!!", 'data' => null]);
        }
    }

    public function updateTestCases(Request $request, $id)
    {
        $data = $request->toArray();
        $result = DB::table('tai_test_cases')->where('id', $request->id)->update($data);
        CommonController::generateHistory("UPDATE", 'tai_test_cases', $id);
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
        }
    }

    public function deleteTestCases(Request $request, $id)
    {
        $data = $request->toArray();
        unset($data['id']);
        $check = DB::table('tai_test_cases')->where('id', $request->id)->first();
        if ($check) {
            $result = DB::table('tai_test_cases')->where('id', $request->id)->update(['is_active' => 0]);
            if ($result) {
                return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Found !!!", 'data' => null]);
        }
    }

    public function importTestCase(Request $request)
    {
        // Chcek the empty file and give Error
        if (!$request->file('attachment')) {
            return response()->json(["status" => 0, "message" => "Please Upload File !!!", "data" => null]);
        }

        $fileExtension = $request->file('attachment')->getClientOriginalExtension();

        // return $fileExtension;

        $requiredExtention = ['csv'];
        // check if file extension is csv or not
        if (!in_array($fileExtension, $requiredExtention)) {
            return response()->json(["status" => 0, "message" => "Required Only  " . implode(',', $requiredExtention) . " !!!", "data" => null]);
        }

        $testCase = array();
        $uploadData = \Excel::toArray(null, $request->file('attachment'));
        $data = $uploadData[0];

        // return $data;

        $header = $data[0];
        // if file is empty gives error
        if (!$header) {
            return response()->json(["status" => 0, "message" => "File Is empty !!!", "data" => null]);
        }
        unset($data[0]);

        if (count($data) == 0) {
            return response()->json(["status" => 0, "message" => "File Is Empty or Missing Headers!!!", "data" => null]);
        }

        // check and insert data with validations
        $mainData = array();
        $issue = array();
        foreach ($data as $d) {
            $mainData[] = array_combine($header, $d);
        }
        $tempErrors = [];

        foreach ($mainData as $m) {
            $d = (array) $m;
            $flag = 0;
            $tempData = [];
            $check = DB::table('tai_test_cases')
                ->where('testing_type', $d['testing_type'])
                ->orwhere('function', $d['function'])
                ->orwhere('platform', $d['platform'])
                ->orwhere('test_description', $d['test_description'])
                ->orwhere('expected_result', $d['expected_result'])
                ->orwhere('actual_result', $d['actual_result'])
                ->orwhere('tester_comments', $d['tester_comments'])
                ->orwhere('tester_status', $d['tester_status'])
                ->orwhere('severity', $d['severity'])
                ->orwhere('attachment_name', $d['attachment_name'])
                ->select('testing_type', 'function', 'platform', 'test_description', 'expected_result', 'actual_result', 'tester_comments', 'tester_status', 'severity', 'attachment_name')
                ->first();

            // Validation For Testing Type
            if (strtolower($d['testing_type']) == 'functional' || strtolower($d['testing_type']) == 'integration' || strtolower($d['testing_type']) == 'validation' || strtolower($d['testing_type']) == 'ui/ux') {
            } else {
                $d['error'] = 'Testing Type Is Not Valid';
                $tempErrors[] = $d;
                $flag = 1;
            }
            

            // Validation for Platform
            if (strtolower($d['platform']) == 'website' || strtolower($d['platform']) == 'app') {
            } else {
                $d['error'] = 'Platform is not selected';
                $tempErrors[] = $d;
                $flag = 1;
            }

            // Validation for Tester status
            if (strtolower($d['tester_status']) == 'pass' || strtolower($d['tester_status']) == 'fail') {
            } else {
                $d['error'] = 'Tester Status Is Not Specified';
                $tempErrors[] = $d;
                $flag = 1;
            }

            if (strtolower($d['severity']) == 'high' || strtolower($d['severity']) == 'medium' || strtolower($d['severity']) == 'low') {
            } else {
                $d['error'] = 'Severity Is Not Specified';
                $tempErrors[] = $d;
                $flag = 1;
            }
            // dd($d);

            $mId = DB::table('tai_ticket_master as tm')->where('tm.id', $request->ticket_id)
                ->select('tm.module_id', 'tm.submodule_id')
                ->first();
            $already = DB::table('tai_test_cases')->where('test_description', $d['test_description'])->first();
            if ($already) {
                return response()->json(["status" => 1, "message" => "Already Exist !!!", "data" => null]);
            }

            $d['ticket_id'] = $request->ticket_id;
            $d['task_id'] = $request->task_id;
            $d['test_case_id'] = $this->getLastId($request->ticket_id, $request->task_id);
            $d['module_id'] = ($mId && $mId->module_id) ? $mId->module_id : null;
            $d['submodule_id'] = ($mId && $mId->submodule_id) ? $mId->submodule_id : null;
            $d['testing_type'] = strtoupper($d['testing_type']);
            $d['platform'] = strtoupper($d['platform']);
            $d['tester_status'] = strtoupper($d['tester_status']);
            $d['severity'] = strtoupper($d['severity']);

            if ($flag == 1) {
                $tempErrors[] = $d;
            } else {
                $insertd = DB::table('tai_test_cases')->insert($d);
            }
        }
        if (count($tempErrors) > 0) {
            $data = $tempErrors;
            $delimeter = ',';
            $f = fopen(storage_path('app/Update_Error_File.csv'), 'w');
            $col = ['testing_type', 'function', 'platform', 'test_description', 'expected_result', 'actual_result', 'tester_comments', 'tester_status', 'severity', 'attachment_name', 'error'];
            fputcsv($f, $col, $delimeter);
            foreach ($data as $d) {
                $temp = [$d['testing_type'], $d['function'], $d['platform'], $d['test_description'], $d['expected_result'], $d['actual_result'], $d['tester_comments'], $d['tester_status'], $d['severity'], $d['attachment_name'], $d['error']];
                fputcsv($f, $temp, $delimeter);
            }
            fclose($f);
            return response()->json(["status" => 1, "message" => "File to Download!!!", "data" => "storage/app/Update_Error_File.csv"]);
        } else {
            return response()->json(["status" => 1, "message" => "File Successfully Uploaded!!!", "data" => null]);
        }
    }

    public function BulkFormat()
    {

        return response()->json(['status' => 1, 'message' => 'File is ready to download', 'data' => 'storage/TestCases/downloadSampleFormat.csv']);
    }

    public function getTestCaseHistory(Request $request, $id)
    {
        $data = DB::table('tai_test_cases_history as th')
            ->where('th.main_id', $id)
            ->leftjoin('tai_employee_master as em1', 'th.updated_by', 'em1.id')
            ->leftjoin('tai_employee_master as em2', 'th.created_by', 'em2.id')
            ->leftjoin('tai_employee_master as em3', 'th.approved_status_change_by', 'em3.id')
            ->leftjoin('tai_project_modules as tpm', 'th.module_id', 'tpm.id')
            ->leftjoin('tai_project_sub_modules as tps', 'th.submodule_id', 'tps.id')
            ->select(
                'th.*',
                'tpm.module_name',
                'tps.sub_module_name',
                DB::raw("CONCAT(em1.first_name,' ',em1.last_name) AS updated_by"),
                DB::raw("CONCAT(em2.first_name,' ',em2.last_name) AS created_by"),
                DB::raw("CONCAT(em3.first_name,' ',em3.last_name) AS approved_status_change_by")
            )
            ->get();
        $temp = [];
        if (count($data) > 0) {

            foreach ($data as $d) {
                $temp[] = (array)$d;
            }

            if (count($temp) >= 2) {
                foreach ($temp as $key => $value) {
                    $temp[$key]['changes'] = [];
                    if ($key >= 1) {
                        $prevKey = $key - 1;

                        $tempPrevArray = $temp[$prevKey];
                        $tempCurrentArray = $temp[$key];

                        if (array_key_exists('changes', $tempPrevArray)) {
                            unset($tempPrevArray['changes']);
                        }
                        if (array_key_exists('changes', $tempCurrentArray)) {
                            unset($tempCurrentArray['changes']);
                        }
                        $diff = (array_diff_assoc($tempPrevArray, $tempCurrentArray));
                        unset($diff['id']);
                        unset($diff['operation']);


                        $temp[$key]['changes'] = array_keys($diff);
                    }
                }
            }

            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $temp]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }
}
