<?php
// dummy
namespace App\Http\Controllers;

use App\Library\CommonController;
use App\Library\OwnershipController;
use App\Library\TaskSupportiveController as TaskSupportive;
use File;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use JWTAuth;

class TestsuitController extends Controller
{
    public function getAllTestsuit(Request $request, $type = null, $sorted = null)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_testsuit_master as s')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 's.updated_by')
            ->leftJoin('tai_employee_master as ec', 'ec.id', '=', 's.created_by')
            // ->select('s.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"))
            ->select('s.id', 's.testsuit_name')
            ->where('s.tenant_id', $tenantId);
        if ($sorted != null) {
            $result = $result->orderby('s.testsuit_name')
                ->orderByDesc('s.is_active')
                ->orderBy('s.id', 'DESC')->get();
        } else {
            $result = $result->orderByDesc('s.is_active')
                ->orderBy('s.id', 'DESC');
            if ($type != null) {
                $result = $result->where('s.is_active', 1)->get();
            } else {
                $result = $result->get();
            }
        }
        return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
    }

    public function createTestsuit(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023

        $data = $request->toArray();
        $data['tenant_id'] = $token_data->tenant_id;

        $check = DB::table('tai_testsuit_master')
            ->where('testsuit_name', $request->testsuit_name)
            ->get();

        if (count($check) == 0) {
            $result = DB::table('tai_testsuit_master')->insert($data);
            if ($result > 0) {
                return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
        }
    }

    public function getUpdateTestsuit(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023

        $data = $request->toArray();
        $check = DB::table('tai_testsuit_master')
            ->where('tenant_id', $token_data->tenant_id)
            ->where('testsuit_name', $request->testsuit_name)
            ->get();

        if (count($check) == 0) {
            $result = DB::table('tai_testsuit_master')->insert($data);
            if ($result > 0) {
                return response()->json(['status' => 1, 'message' => "Record Updated !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Record Already Exists !!!", 'data' => null]);
        }
    }

    public function deleteTestsuit($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023

        $result = DB::table('tai_testsuit_master')->where('tenant_id', $token_data->tenant_id)->where('id', $id)->update(['is_active' => 0]);
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Deleted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Deleted !!!", 'data' => null]);
        }
    }

    public function getTestsuit($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023

        $result = DB::table('tai_testsuit_master')->where('tenant_id', $token_data->tenant_id)->where('id', $id)->first();
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }

    public function getTestCases(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //added by PUNAM 26-05-2023

        $ticketId = $request->ticket_id;
        $module_id = (int)$request->module_id;
        // DB::enableQueryLog();

        $query = DB::table('tai_testsuit_testcase_master as tc')
            ->leftJoin('tai_ticket_master as tm', 'tc.ticket_id', 'tm.id')
            ->leftJoin('tai_project_modules as pm', 'tc.module_id', 'pm.id')
            ->leftJoin('tai_project_sub_modules as psm', 'tc.module_id', 'psm.id')
            ->leftJoin('tai_ticket_task as ttt', 'tc.task_id', 'ttt.id')
            ->leftJoin('tai_testing_type_master as ttm', 'tc.testing_type', 'ttm.id')
            ->leftJoin('tai_project_master as p', 'p.id', '=', 'tm.project_id');


        if ($request->ticket_id) {
            $query = $query->where('tm.id', $ticketId);
        }
        if ($request->module_id) {
            $query = $query->where('tc.module_id', $module_id);
        }
        if ($request->testing_type) {
            $query = $query->Where('tc.testing_type', $request->testing_type);
        }


        if ($request->submodule_id) {
            $query = $query->where('tc.submodule_id', $request->submodule_id);
        }
        if ($request->testsuit_id) {
            $query = $query->where('tc.testsuit_id', $request->testsuit_id);
        }
        if ($request->tester_status) {
            $query = $query->where('tc.tester_status', $request->tester_status);
        }
        if ($request->ba_status) {
            $query = $query->where('tc.ba_status', $request->ba_status);
        }
        if ($request->developer_status) {
            $query = $query->where('tc.dev_status', $request->developer_status);
        }
        if ($request->priority) {
            $query = $query->where('tc.priority', $request->priority);
        }
        if ($request->severity) {
            $query = $query->where('tc.severity', $request->severity);
        }

        if ($request->project_id) {
            $tickets = DB::table('tai_ticket_master')->where('project_id', $request->project_id)->get()->pluck('id')->toArray();
            if ($request->ticket_id) {
                $tickets = $request->ticket_id;
            }
            if (is_array($tickets)) {
                $query = $query->whereIn('tc.ticket_id', $tickets);
            } else {
                $query = $query->where('tc.ticket_id', $tickets);
            }
        }

        $data = $query->select('tc.*', 'ttm.id as testing_type', 'ttm.testing_type as testing_type_name', 'tm.ticket_id as ticket_id', 'pm.module_name', 'psm.sub_module_name', 'p.project_name')
            // ->orderBy('id', 'DESC')
            ->get();
        //  return(DB::getQueryLog());
        if ($data) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function getAddToTestSuit(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $data = $request->toArray();

        if ($request->test_case_id == "") {
            return response()->json(['status' => 0, 'message' => "Please select test cases!!!", 'data' => null]);
        }
        // return $request->all();

        // DB::table('tai_test_cases')->whereIn('id', explode(",", $data['test_case_id']))->where('approved_status', '!=', 2)
        //     ->update([
        //         'approved_status' => 1,
        //         'approved_status_change_by' => $request->created_by,
        //         'updated_at' => $request->created_by,
        //         'updated_at' => NOW()
        //     ]);

        // $selectArray = [
        //     'test_case_id', 'testing_type', 'ticket_id', 'module_id', 'function', 'submodule_id', 'submodule', 'testing_type', 'platform',
        //     'apk_version', 'os_version', 'steps_to_follow', 'test_description', 'expected_result', 'actual_result', 'severity', 'module_name',
        //     'field'
        // ];

        $selectArray = [];
        if (array_key_exists('testsuit_id', $data)) {
            // $selectArray = array_merge($selectArray, DB::raw($data['testsuit_id'] . " as testsuit_id"));
            //$data['testsuit_id'] . " as testsuit_id"
            // $testsuitId = intval($data['testsuit_id']);
            // $selectArray = array_merge($selectArray, ["'.$testsuitId .'"." as testsuit_id"]);

            $testsuitId = intval($data['testsuit_id']);
            $selectArray[] = DB::raw($testsuitId . " AS testsuit_id");
        }

        // $data1 = DB::table('tai_test_cases')
        //     ->select($selectArray)
        //     ->whereIn('id', explode(",", $data['test_case_id']))
        //     ->where('approved_status', '!=', 2)
        //     ->get();

        $data1 = DB::table('tai_testsuit_testcase_master')
            ->select(
                'test_case_id',
                'testing_type',
                'ticket_id',
                'module_id',
                'function',
                'submodule_id',
                'submodule',
                'testing_type',
                'platform',
                'apk_version',
                'os_version',
                'steps_to_follow',
                'test_description',
                'expected_result',
                'actual_result',
                'severity',
                'module_name',
                'field'
            )
            ->addSelect($selectArray)
            ->whereIn('id', explode(",", $data['test_case_id']))
            // ->where('approved_status', '!=', 2)
            ->get();

        // return $data1;
        $array = [];
        foreach ($data1 as $d) {
            $d->approved_status = 1;
            $temp = (array)$d;
            $temp["testsuit_id"] = NULL;
            if (array_key_exists('testsuit_id', $data)) {
                $temp["testsuit_id"] = $data['testsuit_id'];
            }
            $temp["approved_status"] = 1;
            $temp['created_at'] = NOW();
            $temp['created_by'] = $request->created_by;
            $array[] = $temp;
        }
        $ins = DB::table('tai_testsuit_testcase_master')->insert($array);
        // return $ins;
        if ($ins) {
            return response()->json(['status' => 1, 'message' => "Testcaes sent to test suite !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Something went wrong !!!", 'data' => null]);
        }
    }
}
