<?php

namespace App\Http\Controllers;

use App\Library\CommonController;
use App\Library\OwnershipController;
use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use JWTAuth;

class TicketBasketController extends Controller
{
    public function getData(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_basket')->where('tenant_id', $tenantId)->where('is_active', 1)->get();

        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    public function createBasket(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date

        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;
        // $data['customer_id'] = $customerId;

        $insFlag = 0;

        if ($request->source && $request->source == "AFTER_TICKET_INSERT") {

            $ticket = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $data['ticket_id'])->where('status_id', '!=', 3)->first();

            if ($ticket) {
                // unset($data['source']);
                for ($i = 0; $i < count($data['basket_name']); $i++) {
                    $check_data = DB::table('tai_ticket_basket')
                        ->where('tenant_id', $tenantId)
                        ->where('is_active', 1)
                        ->where('basket_name', $data['basket_name'][$i])
                        ->where('ticket_id', $data['ticket_id'])
                        ->first();

                    if ($check_data) {
                        return response()->json(['status' => 0, 'message' => "Oops! Basket name already exist !!!", 'data' => null]);
                    }

                    $insFlag = DB::table('tai_ticket_basket')->insertGetId([
                        'tenant_id' => $tenantId, //$data['tenant_id'],
                        'ticket_id' => $data['ticket_id'],
                        'basket_name' => $data['basket_name'][$i],
                        'basket_owner' => $data['basket_owner'][$i] ? $data['basket_owner'][$i] : $data['created_by'],
                        'start_date' => $data['start_date'][$i],
                        'end_date' => $data['end_date'][$i] ?? NULL,
                        'created_at' => $data['created_at'],
                        'created_by' => $data['created_by'],
                    ]);

                    OwnershipController::mapping('Insert', 'BASKET', $data['basket_owner'][$i], 0, $data['ticket_id'], $insFlag, 0, $tenantId);
                }

                if ($insFlag > 0) {

                    $userInfo = CommonController::userInfo($ticket->created_by, ["first_name", "last_name",]);
                    $msg = "New Basket has been created for " . $ticket->ticket_id;
                    $url = "Ticket/Task/" . $data['ticket_id'];

                    foreach ($data['basket_owner'] as $b_user) {
                        if ($b_user != NUll || $b_user != '') {
                            CommonController::addNotification($data["created_by"], $b_user, $msg, $url);
                        } else {
                            CommonController::addNotification($data["created_by"], $data["created_by"], $msg, $url);
                        }
                    }

                    return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => $insFlag]);
                } else {
                    return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
                }
            } else {
                return response()->json(['status' => 0, 'message' => "Ticket is already solved !!!", 'data' => null]);
            }
        } else {


            $result = DB::table('tai_ticket_basket')->insertGetId($data);
            if ($result) {

                // Mapping
                OwnershipController::mapping('Insert', 'BASKET', $data['basket_owner'], 0, $data['ticket_id'], $insFlag, 0, $tenantId);


                $ticket = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $data['ticket_id'])->first();

                $userInfo = CommonController::userInfo($ticket->created_by, ["first_name", "last_name"]);
                $msg = "New Basket has been created for" . $ticket->ticket_id . " by " . $userInfo->first_name . " " . $userInfo->last_name;
                $url = "Ticket/Task/" . $data['ticket_id'];
                foreach ($data['basket_owner'] as $b_user) {
                    CommonController::addNotification($data["created_by"], $b_user, $msg, $url);
                }

                return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
            }
        }
    }

    public function updateBasket(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;

        if (array_key_exists("source", $data)) {
            unset($data["source"]);
        }

        $checkBasketOwner = DB::table('tai_ticket_basket')
            ->where('id', $id)
            ->where('basket_owner', $data['basket_owner'])
            ->where('tenant_id', $tenantId)
            ->first();
        if ($checkBasketOwner) {
            if ($checkBasketOwner->is_active == 0) {
                return response()->json(['status' => 0, 'message' => "User is already assigned but deactivated !!!", 'data' => null]);
            }
        }

        $ticket = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $request->ticket_id)->where('status_id', '!=', 3)->first();

        if ($ticket) {
            $check_data = DB::table('tai_ticket_basket')->where('tenant_id', $tenantId)->where('is_active', 1)->where('basket_name', $data['basket_name'])->where('id', '!=', $id)->first();
            if ($check_data) {
                return response()->json(['status' => 0, 'message' => "Oops! Basket name already exist !!!", 'data' => null]);
            }

            $result = DB::table('tai_ticket_basket')->where('id', $id)->update($data);


            // $basket=DB::table('tai_ticket_basket')->where('id', $id)->first();



            // Mapping

            OwnershipController::mapping('Update', 'BASKET', $data['basket_owner'], $ticket->project_id ? $ticket->project_id : 0, $ticket->id, $id, 0, $tenantId);


            if ($result) {

                $ticketOwnerInfo = CommonController::userInfo($ticket->assign_to_user_id, ["first_name", "last_name"]);
                $basketOwnerInfo = CommonController::userInfo($data['updated_by'], ["first_name", "last_name"]);
                $msg = 'Basket of ' . $ticket->ticket_id . " some changes has been done by " . $basketOwnerInfo->first_name . " " . $basketOwnerInfo->last_name;
                $url = 'Ticket/Task/' . $ticket->id;

                CommonController::addNotification($data['updated_by'], $ticket->assign_to_user_id, $msg, $url);

                return response()->json(['status' => 1, 'message' => "Basket details updated successfully !!!", 'data' => null]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Updated !!!", 'data' => null]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Ticket already solved !!!", 'data' => null]);
        }
    }

    public function deleteData($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_basket')->where('tenant_id', $tenantId)->where('id', $id)->update(['is_active' => 0, 'remark' => "DELETED"]);
        if ($result) {

            $ticket = DB::table('tai_ticket_master as t')->leftJoin('tai_ticket_basket as b', 't.id', '=', 'b.ticket_id')
                ->where('id', $id)
                ->where('t.tenant_id', $tenantId)
                ->where('b.tenant_id', $tenantId)
                ->select('t.assign_to_user_id')->first();
            if ($ticket) {
                $basketOwnerInfo = CommonController::userInfo($token_data->id, ["first_name", "last_name"]);
                $msg = 'Basket of ' . $ticket->ticket_id . " has been deleted by " . $basketOwnerInfo->first_name . " " . $basketOwnerInfo->last_name;
                CommonController::addNotification($token_data->id, $ticket->assign_to_user_id, $msg, 'Ticket/Task/' . $ticket->id);
            }

            return response()->json(['message' => "Record Deleted", 'status' => 1, 'data' => null]);
        } else {
            return response()->json(['message' => "Record Not Deleted", 'status' => 0, 'data' => null]);
        }
    }

    public function getById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_basket as tb')
            ->leftJoin('tai_ticket_master as tm', 'tm.id', '=', 'tb.ticket_id')
            ->where('tb.id', $id)
            ->where('tb.is_active', '1')
            ->where('tb.tenant_id', $tenantId)
            ->where('tm.tenant_id', $tenantId)
            ->select('tb.*', 'tm.ticket_id as ticket_name')
            ->first();

        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }

    public function taskDetails($basket_id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_task as t')
            ->leftJoin('tai_ticket_master as tm', 'tm.id', '=', 't.ticket_id')
            ->leftJoin('tai_ticket_basket as tb', 'tb.id', '=', 't.ticket_basket_id')
            ->where('t.ticket_basket_id', $basket_id)
            ->where('t.tenant_id', $tenantId)
            ->select('t.*', 'tm.ticket_id as ticket_name', 'tb.basket_name')
            ->get();

        foreach ($result as $res) {
            $data = DB::table('tai_ticket_task_time_history')->where('ticket_task_id', $res->id)
                ->orderBy('ticket_task_id', 'DESC')
                ->first();

            $task_owners = DB::table('tai_ticket_task_owner')
                ->where('tenant_id', $tenantId)
                ->where('ticket_task_id', $res->id)->pluck('task_owner_id')->toArray();
            $res->task_owners = $task_owners;

            if (count($data) > 0) {
                foreach ($data as $da) {
                    // return print_r($data->start_time);
                    if ($da->start_time != NULL && $da->stop_time != NULL) {
                        $is_yet = ['is_play' => 'START'];
                    } elseif ($da->start_time != NULL && $da->stop_time == NULl) {
                        $is_yet = ['is_play' => 'STOP'];
                    }
                    $resu = json_decode(json_encode($res), true);
                    $datares[] = array_merge($resu, $is_yet);
                }
            } else {
                $is_yet = ['is_play' => 'START'];
                $resu = json_decode(json_encode($res), true);
                $datares[] = array_merge($resu, $is_yet);
            }
        }

        // $result = DB::table('tai_ticket_task as tt')->leftjoin('tai_ticket_task_time_history as th','th.ticket_task_id','=','tt.id')->where('ticket_basket_id', $basket_id)->groupBy('th.ticket_task_id')->select('tt.*', 'th.start_time as th_start_time', 'th.ticket_task_id as th_ticket_task_id')->orderBy('th.start_time', 'DESC')->get();

        // return $datares;
        if (count($datares) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $datares]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }

        // $result = DB::table('tai_ticket_task as tt')->leftjoin('tai_ticket_task_time_history as th','th.ticket_task_id','=','tt.id')->where('ticket_basket_id', $basket_id)->select('tt.*')->whereRaw('th.id th.start_time from th)');->get();
    }

    public function task($ownership, $ticketId, $basketId, $userId = NULL)
    {

        $returnArray = [];

        $date = date('y-m-d');
        $taskQuery = DB::table('tai_ticket_task as t')
            ->leftjoin('tai_request_task_time as tt', 't.id', '=', 'tt.ticket_task_id')
            ->leftjoin('tai_ticket_master as tm', 't.ticket_id', '=', 'tm.id')
            // ->orderBy('t.time_status','DESC')
            // ->orderBy('t.status','DESC')
            // ->orderBy('t.start_date','DESC')
            // ->orderByRaw("MIN(t.start_date)",'ASC')
            ->orderByRaw("CASE WHEN t.status ='IN_PROGRESS' AND t.time_status = 'START' THEN t.status END DESC")
            ->orderByRaw("CASE WHEN t.status ='TO_DO' OR t.status='IN_PROGRESS' THEN t.end_date END DESC")
            ->orderByRaw("CASE WHEN t.status ='TO_DO' OR t.status='IN_PROGRESS' THEN t.start_date END DESC")
            ->orderByRaw("CASE WHEN t.status ='COMPLETED' THEN t.completed_at END ASC")

            // ->orderByRaw("CASE WHEN MIN(t.start_date) AND t.status ='IN_PROGRESS' OR t.status ='TO_DO' THEN t.start_date END ASC")

            // ->orderByRaw("CASE WHEN t.status ='IN_PROGRESS' THEN t.start_date END DESC")
            // ->orderByRaw("CASE WHEN t.status ='IN_PROGRESS' THEN t.end_date END DESC")
            // ->orderByRaw("CASE WHEN t.status ='TO_DO' THEN t.start_date END DESC")  
            // ->orderByRaw("CASE WHEN t.status ='TO_DO' THEN t.end_date END DESC")  
            // ->orderByRaw("CASE WHEN t.status !='IN_PROGRESS' AND t.status ='TO_DO' AND t.start_date < '".$date."' THEN t.start_date END ASC")
            // ->orderByRaw("CASE WHEN t.status !='COMPLETED' THEN t.start_date END DESC")
            // ->orderByRaw("CASE WHEN t.status !='COMPLETED' THEN t.end_date END DESC")
            // ->orderByRaw("CASE WHEN t.status ='COMPLETED' THEN t.completed_at END ASC")
            // ->orderByRaw("CASE WHEN t.status ='COMPLETED' DESC")
            ->orderBy('t.completed_at', 'ASC')
            ->orderBy('t.created_at', 'DESC');
        // dd('hi');

        if ($ownership == "TICKET") {
        } else if ($ownership == "BAKSET") {
        } else if ($ownership == "TASK") {
            $taskQuery->leftJoin('tai_ticket_task_owner as o', 'o.ticket_task_id', '=', 't.id')
                ->where('o.task_owner_id', $userId)
                ->where('o.is_active', 1);
        }
        //bhagyashri TT12694 add is_regularized
        $task = $taskQuery->where('t.ticket_basket_id', $basketId)
            ->where('t.is_active', 1)
            // ->select('t.*', 'tt.is_regularized', 'tm.ticket_id as ticket_id_name', 'tt.from_date', 'tt.to_date', 'tt.from_time', 'tt.to_time', 'tt.regularization_time_status', 'tt.remark')
            ->select('t.*',  'tm.ticket_id as ticket_id_name', 'tt.from_time', 'tt.to_time',  'tt.remark')
            ->distinct()
            ->get();

        foreach ($task as $t) {
            $t = (array)$t;

            $timerHistoryQuery = DB::table('tai_ticket_task_time_history')
                ->where('ticket_id', $ticketId)
                ->where('ticket_task_id', $t['id']);
            if ($ownership == "TASK") {
                $timerHistoryQuery->where('user_id', $userId);
            }

            $timer_history = $timerHistoryQuery->orderBy('id', 'desc')->first();
            if ($timer_history) {
                if ($timer_history->start_time && $timer_history->stop_time) {
                    $time_status = "START";
                } else if ($timer_history->start_time && !$timer_history->stop_time) {
                    $time_status = "STOP";
                } else {
                    $time_status = "START";
                }
                $t['time_status'] = $time_status;
            } else {
                $t['time_status'] = "START";
            }

            $taskOwners = DB::table('tai_ticket_task_owner as o')
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'o.task_owner_id')
                ->where('o.is_active', 1)
                ->where('o.ticket_id', $ticketId)
                ->where('o.ticket_task_id', $t['id'])
                ->select(
                    DB::raw("CONCAT(e.first_name,' ',e.last_name) AS taskOwnerName"),
                    'e.id',
                    DB::raw(
                        "(SELECT  CASE 
                                                WHEN start_time IS NULL AND stop_time IS NULL THEN 'NO'
                                                WHEN start_time IS NOT NULL AND stop_time IS NULL THEN 'YES'
                                                ELSE 'NO'
                                                END	
                                                FROM tai_ticket_task_time_history  WHERE  ticket_task_id = " . $t['id'] . " AND user_id = e.id ORDER BY id DESC LIMIT 1) AS is_started"
                    )
                )
                ->get()
                ->toArray();
            $t['taskOwners'] = $taskOwners;
            $t['taskOwnersId'] = array_column($taskOwners, 'id');


            $dependentTaskIds = DB::table('tai_ticket_dependent_task')->where('ticket_task_id', $t['id'])
                ->where('is_active', 1)
                ->pluck('dependent_task_id')
                ->toArray();

            $t['dependentTaskId'] = $dependentTaskIds;



            $checkUser = DB::table('tai_ticket_task_owner')->where('ticket_basket_id', $basketId)->where('task_owner_id', $userId)->where('is_active', 1)->first();
            if ($checkUser) {
                $t['canStartStop'] = 1;
            } else {
                $t['canStartStop'] = 0;
            }
            $returnArray[] = $t;
        }
        return $returnArray;
    }

    public function task2($ownership, $ticketId, $basketId, $userId = NULL)
    {
        $returnArray = [];

        $date = date('y-m-d');
        $taskQuery = DB::table('tai_ticket_task as t')
            ->orderByRaw("CASE WHEN t.status ='IN_PROGRESS' AND t.time_status = 'START' THEN t.status END DESC")
            ->orderByRaw("CASE WHEN t.status ='TO_DO' OR t.status='IN_PROGRESS' THEN t.end_date END DESC")
            ->orderByRaw("CASE WHEN t.status ='TO_DO' OR t.status='IN_PROGRESS' THEN t.start_date END DESC")
            ->orderByRaw("CASE WHEN t.status ='COMPLETED' THEN t.completed_at END ASC")
            ->orderBy('t.completed_at', 'ASC')
            ->orderBy('t.created_at', 'DESC');

        $task = $taskQuery->where('t.ticket_basket_id', $basketId)
            ->where('t.is_active', 1)
            ->select('t.*')
            ->get();

        foreach ($task as $t) {
            $t = (array)$t;

            $timerHistoryQuery = DB::table('tai_ticket_task_time_history')->where('ticket_id', $ticketId)->where('ticket_task_id', $t['id']);
            if ($ownership == "TASK") {
                $timerHistoryQuery->where('user_id', $userId);
            }

            $timer_history = $timerHistoryQuery->orderBy('id', 'desc')->first();
            if ($timer_history) {
                if ($timer_history->start_time && $timer_history->stop_time) {
                    $time_status = "START";
                } else if ($timer_history->start_time && !$timer_history->stop_time) {
                    $time_status = "STOP";
                } else {
                    $time_status = "START";
                }
                $t['time_status'] = $time_status;
            } else {
                $t['time_status'] = "START";
            }

            $taskOwners = DB::table('tai_ticket_task_owner as o')
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'o.task_owner_id')
                ->where('o.is_active', 1)
                ->where('o.ticket_id', $ticketId)
                ->where('o.ticket_task_id', $t['id'])
                ->select(
                    DB::raw("CONCAT(e.first_name,' ',e.last_name) AS taskOwnerName"),
                    'e.id',
                    DB::raw(
                        "(SELECT  CASE 
                                                WHEN start_time IS NULL AND stop_time IS NULL THEN 'NO'
                                                WHEN start_time IS NOT NULL AND stop_time IS NULL THEN 'YES'
                                                ELSE 'NO'
                                                END	
                                                FROM tai_ticket_task_time_history  WHERE  ticket_task_id = " . $t['id'] . " AND user_id = e.id ORDER BY id DESC LIMIT 1) AS is_started"
                    )
                )
                ->get()
                ->toArray();
            $t['taskOwners'] = $taskOwners;
            $t['taskOwnersId'] = array_column($taskOwners, 'id');


            $dependentTaskIds = DB::table('tai_ticket_dependent_task')->where('ticket_task_id', $t['id'])
                ->where('is_active', 1)
                ->pluck('dependent_task_id')
                ->toArray();

            $t['dependentTaskId'] = $dependentTaskIds;



            $checkUser = DB::table('tai_ticket_task_owner')->where('ticket_basket_id', $basketId)->where('task_owner_id', $userId)->where('is_active', 1)->first();
            if ($checkUser) {
                $t['canStartStop'] = 1;
            } else {
                $t['canStartStop'] = 0;
            }
            $returnArray[] = $t;
        }
        return $returnArray;
    }


    public function ticketBasket($ticketId, $userId = NULL, $basket = NULL)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if ($basket != null) {
            $ticketBaskets = DB::table('tai_ticket_basket')->where('tenant_id', $tenantId)->where('ticket_id', $ticketId)->get();
            if (count($ticketBaskets) > 0) {
                return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $ticketBaskets]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Found !!!", 'data' => null]);
            }
        }

        // ticketId = 107
        // created by = 17
        // assign to usser = 17
        // owner = 17,22,23


        $basket_id_array = [];

        $ownership = "";
        $taskBasketId = '';
        $final = [];

        $ticketData = DB::table('tai_ticket_master as t')
            ->where('t.id', $ticketId)
            ->first();

        if ($userId == $ticketData->assign_to_user_id) {
            $ownership = "TICKET";
            $ticketData = DB::table('tai_ticket_master')->where('id', $ticketId)->get();

            $basket = DB::table('tai_ticket_basket')->where('ticket_id', $ticketId)
                ->where('is_active', 1)
                ->orderBy('sort_order', 'ASC')
                ->orderBy('end_date', 'DESC')
                // ->orderBy('sort_order','ASC')
                ->orderBy('created_at', 'DESC')
                ->get();
            if (count($basket)) {

                foreach ($basket as $b) {
                    $taskDataArray = (array)$b;
                    $taskDataArray['total_hours'] = 0;
                    $taskDataArray['completed_hours'] = 0;

                    $taskArray = $this->task("TICKET", $ticketId, $b->id, $userId);


                    $total_hours = array_sum(array_column($taskArray, 'task_hours_in_min'));
                    $total_worked = array_sum(array_column($taskArray, 'total_worked_in_min'));

                    if ($total_hours && $total_hours > 0) {
                        $total_hours = CommonController::hoursandmins($total_hours, "%2d Hr");
                    } else {
                        $total_hours = 0;
                    }

                    if ($total_hours && $total_hours > 0) {
                        $total_worked = CommonController::hoursandmins($total_worked, "%2d Hr");
                    } else {
                        $total_hours = 0;
                    }
                    $taskDataArray['total_hours'] = $total_hours;
                    $taskDataArray['total_worked'] = $total_worked;

                    $taskDataArray['taskData'] = $taskArray;
                    $final[] = $taskDataArray;

                    $basket_id_array[] = $b->id;
                }
            }
        } else {

            //Assign User / Basket Owner
            // $basket = DB::table('tai_ticket_basket')->where('ticket_id', $ticketId)
            //     ->where('basket_owner', $userId)
            //     ->where('is_active', 1)
            //     ->orderBy('sort_order', 'ASC')
            //     ->orderBy('end_date', 'DESC')
            //     ->orderBy('created_at', 'DESC')
            //     ->get();

            // if (count($basket)) {
            //     $ownership = "BASKET";

            //     foreach ($basket as $b) {
            //         $taskDataArray = (array)$b;
            //         $taskDataArray['total_hours'] = 0;
            //         $taskDataArray['total_worked'] = 0;

            //         $taskArray = $this->task("BASKET", $ticketId, $b->id, $userId);

            //         $total_hours = array_sum(array_column($taskArray, 'task_hours_in_min'));
            //         $total_worked = array_sum(array_column($taskArray, 'total_worked_in_min'));


            //         $taskDataArray['total_hours'] = CommonController::hoursandmins($total_hours, "%2d Hr");
            //         $taskDataArray['total_worked'] = CommonController::hoursandmins($total_worked, "%2d Hr");

            //         if ($total_hours && $total_hours > 0) {
            //             $total_hours = CommonController::hoursandmins($total_hours, "%2d Hr");
            //         } else {
            //             $total_hours = 0;
            //         }
            //         if ($total_worked && $total_worked > 0) {
            //             $total_worked = CommonController::hoursandmins($total_worked, "%2d Hr");
            //         } else {
            //             $total_worked = 0;
            //         }
            //         $taskDataArray['total_hours'] = $total_hours;
            //         $taskDataArray['total_worked'] = $total_worked;

            //         $taskDataArray['taskData'] = $taskArray;
            //         $final[] = $taskDataArray;

            //         $basket_id_array[] = $b->id;
            //     }
            // } else {

            //     $basketIds = DB::table('tai_ticket_task_owner')
            //         ->where('ticket_id', $ticketId)
            //         ->where('task_owner_id', $userId)
            //         ->where('is_active', 1)
            //         ->pluck('ticket_basket_id')
            //         ->toArray();

            //     $basketIds = array_unique($basketIds);

            //     $basket = DB::table('tai_ticket_basket')->whereIn('id', $basketIds)
            //         ->where('is_active', 1)
            //         //   ->orderBy('sort_order','ASC')
            //         ->orderBy('end_date', 'DESC')
            //         ->orderBy('sort_order', 'ASC')
            //         ->orderBy('created_at', 'DESC')
            //         ->get();
            //     if (count($basket)) {
            //         foreach ($basket as $b) {
            //             $ownership = "TASK";

            //             $taskDataArray = (array)$b;
            //             $taskDataArray['total_hours'] = 0;
            //             $taskDataArray['completed_hours'] = 0;
            //             $completed_hours_temp = 0;

            //             $taskArray = $this->task("TASK", $ticketId, $b->id, $userId);

            //             $total_hours = array_sum(array_column($taskArray, 'task_hours_in_min'));
            //             $total_worked = array_sum(array_column($taskArray, 'total_worked_in_min'));

            //             if ($total_hours && $total_hours > 0) {
            //                 $total_hours = CommonController::hoursandmins($total_hours, "%2d Hr");
            //             } else {
            //                 $total_hours = 0;
            //             }
            //             if ($total_worked && $total_worked > 0) {
            //                 $total_worked = CommonController::hoursandmins($total_worked, "%2d Hr");
            //             } else {
            //                 $total_worked = 0;
            //             }
            //             $taskDataArray['total_hours'] = $total_hours;
            //             $taskDataArray['total_worked'] = $total_worked;
            //             $taskDataArray['taskData'] = $taskArray;
            //             $final[] = $taskDataArray;

            //             $basket_id_array[] = $b->id;
            //         }
            //     }
            // }

            // punam shinde date:15-05-2023
            // The issue is that when a user is assigned a task before a basket, the system should show the task and the basket together. 
            // Furthermore, if the user is assigned a basket for the same ticket ID, the system should display the previous task with the 
            // current basket for that ticket ID.

            $basket_id_array1 = [];
            $basket_id_array2 = [];
            $final1 = [];
            $final2 = [];

            $basket = DB::table('tai_ticket_basket')->where('ticket_id', $ticketId)
                ->where('basket_owner', $userId)
                ->where('is_active', 1)
                ->orderBy('sort_order', 'ASC')
                ->orderBy('end_date', 'DESC')
                // ->orderBy('sort_order','ASC')
                ->orderBy('created_at', 'DESC')
                ->get();
            if (count($basket)) {
                $ownership = "BASKET";

                foreach ($basket as $b) {
                    $taskDataArray = (array)$b;
                    $taskDataArray['total_hours'] = 0;
                    $taskDataArray['total_worked'] = 0;

                    $taskArray = $this->task("BASKET", $ticketId, $b->id, $userId);

                    $total_hours = array_sum(array_column($taskArray, 'task_hours_in_min'));
                    $total_worked = array_sum(array_column($taskArray, 'total_worked_in_min'));


                    $taskDataArray['total_hours'] = CommonController::hoursandmins($total_hours, "%2d Hr");
                    $taskDataArray['total_worked'] = CommonController::hoursandmins($total_worked, "%2d Hr");

                    if ($total_hours && $total_hours > 0) {
                        $total_hours = CommonController::hoursandmins($total_hours, "%2d Hr");
                    } else {
                        $total_hours = 0;
                    }
                    if ($total_worked && $total_worked > 0) {
                        $total_worked = CommonController::hoursandmins($total_worked, "%2d Hr");
                    } else {
                        $total_worked = 0;
                    }
                    $taskDataArray['total_hours'] = $total_hours;
                    $taskDataArray['total_worked'] = $total_worked;

                    $taskDataArray['taskData'] = $taskArray;
                    $final2[] = $taskDataArray;

                    $basket_id_array1[] = $b->id;
                }
            }
            // else {
            // Task Owner

            $basketIds = DB::table('tai_ticket_task_owner')
                ->where('ticket_id', $ticketId)
                ->where('task_owner_id', $userId)
                ->where('is_active', 1)
                ->pluck('ticket_basket_id')
                ->toArray();

            $basketIds = array_unique($basketIds);

            $basket = DB::table('tai_ticket_basket')->whereIn('id', $basketIds)
                ->where('is_active', 1)
                ->where('basket_owner', '!=', $userId)
                //   ->orderBy('sort_order','ASC')
                ->orderBy('end_date', 'DESC')
                ->orderBy('sort_order', 'ASC')
                ->orderBy('created_at', 'DESC')
                ->get();
            if (count($basket)) {
                foreach ($basket as $b) {
                    $ownership = "TASK";

                    $taskDataArray = (array)$b;
                    $taskDataArray['total_hours'] = 0;
                    $taskDataArray['completed_hours'] = 0;
                    $completed_hours_temp = 0;

                    $taskArray = $this->task("TASK", $ticketId, $b->id, $userId);

                    $total_hours = array_sum(array_column($taskArray, 'task_hours_in_min'));
                    $total_worked = array_sum(array_column($taskArray, 'total_worked_in_min'));

                    if ($total_hours && $total_hours > 0) {
                        $total_hours = CommonController::hoursandmins($total_hours, "%2d Hr");
                    } else {
                        $total_hours = 0;
                    }
                    if ($total_worked && $total_worked > 0) {
                        $total_worked = CommonController::hoursandmins($total_worked, "%2d Hr");
                    } else {
                        $total_worked = 0;
                    }
                    $taskDataArray['total_hours'] = $total_hours;
                    $taskDataArray['total_worked'] = $total_worked;
                    $taskDataArray['taskData'] = $taskArray;
                    $final1[] = $taskDataArray;

                    $basket_id_array2[] = $b->id;
                }
            }
            // }

            $basket_id_array = array_merge($basket_id_array1, $basket_id_array2);

            $final = array_merge($final1, $final2);
            // $flattenedArray = array_map('serialize', $f_data);
            // $uniqueArray = array_values(array_unique($flattenedArray));
            // $resultArray = array_map('unserialize', $uniqueArray);
            // return [$resultArray];
            // $final[] = array_unique(array_merge($final1, $final2));
            // -----------------------------------------------------------------------------------
        }


        // dd(key_values($basket_id_array));
        $basket_id_arrays = DB::table('tai_ticket_basket_sort')->where('ticket_id', $ticketId)->where('user_id', $userId)->first();
        if ($basket_id_arrays) {
            $basket_id_array = array_map('intval', explode(",", $basket_id_arrays->basket_order));
        }

        $is_reviewer = DB::table('tai_owner_mapping_master')->where('user_id', $userId)
            ->where('ticket_id', $ticketId)->where('type', 'TICKET_REV')
            ->first();
        if (!empty($is_reviewer)) {
            $is_reviewer = 1;
        } else {
            $is_reviewer = 0;
        }

        $user_type = DB::table('tai_employee_master as emp')->select('r.role')
            ->leftJoin('tai_role_master as r', 'emp.role_id', 'r.id')
            ->where('emp.id', $userId)
            ->where('emp.tenant_id', $tenantId)
            ->where('r.tenant_id', $tenantId)
            ->first();
        if ($user_type->role == "Tester") {
            $type = "TESTER";
        } elseif ($user_type->role == "Business Analyst") {
            $type = "BA";
        } elseif ($user_type->role == 'Developer') {
            $type = "DEV";
        } else {
            $type = $user_type->role;
        }

        return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $final, "ownership" => $ownership, 'is_reviewer' => $is_reviewer, 'basket_id_array' => $basket_id_array, 'type' => $type]);
    }

    public function ticketTask($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_task')
            ->where('tenant_id', $tenantId)
            ->where('ticket_basket_id', $id)
            ->order_by('start_time', 'DESC')
            ->orderBy('time_status', 'DESC')
            ->orderBy('end_date', 'DESC')
            ->orderBy('created_at', 'DESC')
            ->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }

    public function swapBasket(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if (!empty($request->basket_id_array)) {
            $already = DB::table('tai_ticket_basket_sort')
                ->where('ticket_id', $request->ticket_id)
                ->where("user_id", $request->user_id)
                ->first();

            // updated by punam date(26-04-2023)
            // remove zero from $request->basket_id_array
            $remove = array(0);
            $basket_id_array = array_diff((array)$request->basket_id_array, $remove);
            // ----
            $basket_id_array = implode(",", $request->basket_id_array);
            if ($already) {
                DB::table('tai_ticket_basket_sort')->where('id', $already->id)->update([
                    'basket_order' => $basket_id_array
                ]);
            } else {
                DB::table('tai_ticket_basket_sort')->insert([
                    'basket_order' => $basket_id_array,
                    'ticket_id' => $request->ticket_id,
                    "user_id" => $request->user_id
                ]);
            }
        } else {
            return response()->json(['status' => 0, 'message' => "Invalid Swap !!!", 'data' => null]);
        }

        // $arr = explode(',', $request->basket_id_array);
        // $val = array_search($request->basket_id, $arr);
        // $temp = [];
        // if ($request->button == 'RIGHT') {

        //     $last_index  = array_key_last($arr);

        //     unset($arr[$val]);

        //     if ($request->button == 'RIGHT' && $val == $last_index) {
        //         $pos = 0;
        //     } else {
        //         $pos = $val + 1;
        //     }
        //     $val = $request->basket_id;

        //     $result = array_merge(array_slice($arr, 0, $pos), array($val), array_slice($arr, $pos));
        //     // print_r($result);

        // } else {
        //     unset($arr[$val]);

        //     if ($request->button == 'LEFT' && $val == 0) {
        //         $pos = array_key_last($arr);
        //     } else {
        //         $pos = $val - 1;
        //     }
        //     $val = $request->basket_id;

        //     $result = array_merge(array_slice($arr, 0, $pos), array($val), array_slice($arr, $pos));
        //     // print_r($result);
        // }

        // foreach ($result as $key => $row) {
        //     DB::table('tai_ticket_basket')->where('id', $row)->update(['sort_order' => $key, 'remark' => $key]);

        //     $temp[] = $row;
        // }
        // $data =  DB::table('tai_ticket_basket')->whereIn('id', $temp)->select('id', 'sort_order')->get();
        // return response()->json(['status' => 0, 'message' => "Record Found !!!", 'data' => $data]);



    }
}
