<?php
// live
// TT9526 DATE:25-07-2023 PUNAM SHINDE TEMPLATE MASTER: when we create ticket then auto create basket and task against template master which was mapped with customer mappings

namespace App\Http\Controllers;

use App\Library\CommonController;
use App\Library\OwnershipController;
use App\Library\TemplateLibrary;
use App\Library\TaskSupportiveController;
use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use App\Models\DynamicForm;
use App\Models\DynamicFormTest;

use Illuminate\Support\Facades\Mail;
use App\Mail\TicketOtpMail;
use File;
use DateTime;
use DateInterval;
use Exception;
use Session;
use App\Exports\TicketExport;
use Maatwebsite\Excel\Facades\Excel;
use JWTAuth;
use App\Http\Controllers\TicketTaskController;
use App\Http\Controllers\TicketBasketController;

class TicketController extends Controller
{

    public function checkDynamicForm(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // return DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
        // return DynamicForm::find('6261682a421eb93cbf2f4e33')->dynamic_data;
        return DynamicForm::where(['ticket_id' => 'TT445'])->first();
        // $test=DynamicForm::all();
        // $a=DynamicForm::create(['id' => 1, 'title' => 'The Fault in Our Stars']);
        // $a=new DynamicForm();
        // $a->data=json_encode(["name"=>"parth patel","type"=>"code"]);
        // $a->save();
        // return $a;

    }

    public function getAllTicketId(Request $request, $type = null, $sorted = null)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_master as s')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 's.updated_by')
            ->leftJoin('tai_employee_master as ec', 'ec.id', '=', 's.created_by')
            // ->select('s.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS updated_by"), DB::raw("CONCAT(ec.first_name,' ',ec.last_name) AS created_by"))
            ->select('s.id', 's.ticket_id')
            ->where('s.tenant_id', $tenantId)
            ->where('s.passed_status', 'PASS');

        // if ($customerId != null) {
        //     $result = $result->where('s.customer_id', $customerId);
        // }
        if ($sorted != null) {
            $result = $result->orderby('s.ticket_id')
                ->orderByDesc('s.is_active')
                ->orderBy('s.id', 'DESC')->get();
        } else {
            $result = $result->orderByDesc('s.is_active')
                ->orderBy('s.id', 'DESC');
            if ($type != null) {
                $result = $result->where('s.is_active', 1)->get();
            } else {
                $result = $result->get();
            }
        }
        return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
    }

    public function passTicket(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:30-05-05 PUNAM SHINDE

        // dd($request->all()); 
        $update = DB::table('tai_ticket_master')
            ->where('tenant_id', $tenantId)
            // ->where('customer_id', $customerId)
            ->where('id', $request->id)
            ->update([
                'passed_status' => $request->pass_status,
                'passed_status_changed_by' => $request->user_id,
                'passed_status_changed_at' => $request->updated_at ?  $request->updated_at : NOW(),
                'passed_status_remark' => $request->remark
            ]);

        // CommonController::generateHistory("UPDATE", 'tai_ticket_master', $request->id);

        if ($update > 0) {

            CommonController::generateHistory("UPDATE", 'tai_ticket_master', $request->id);

            $asssigned_user = DB::table('tai_ticket_master as tm')
                ->select('tm.*')
                ->join('tai_employee_master as em', 'tm.assign_to_user_id', '=', 'em.id')
                ->where('tm.id', $request->id)
                ->where('em.is_active', 1)
                ->where('tm.tenant_id', $tenantId)->first();
            // if ($customerId != null) {
            //     $asssigned_user = $asssigned_user->where('tm.customer_id', $customerId);
            // }
            // $asssigned_user = $asssigned_user->first();

            if ($asssigned_user) {
                $authorityInfo = CommonController::userInfo($asssigned_user->created_by, ["first_name", "last_name",]);
                // return [$authorityInfo, $asssigned_user];
                // $msg = $request->pass_status == "PASS" ? $asssigned_user->ticket_id . " PASSED to " . $asssigned_user->first_name . " " . $asssigned_user->last_name : "REJECTED"  ;

                $msg = $request->pass_status == "PASS" ? $authorityInfo->first_name . " " . $authorityInfo->last_name . " has passed " . $asssigned_user->ticket_id . " to " . $asssigned_user->first_name . " " . $asssigned_user->last_name : $authorityInfo->first_name . " " . $authorityInfo->last_name . " has REJECTED " . $asssigned_user->ticket_id;
                // DD($msg);
                $url = "Ticket/View/" . $request->id;

                CommonController::addNotification($request->user_id, $asssigned_user->assign_to_user_id, $msg, $url);
                CommonController::addNotification($request->user_id, $asssigned_user->created_by, $msg, $url);
            }


            $m = $request->pass_status == "PASS" ? "Passed" : "Rejected";

            return response()->json(["status" => 1, "message" => "Ticket $m  !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Ticket Not passed !!!", "data" => null]);
        }
    }

    public function getAllTicketTest(Request $request, $userId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $ticketIds1 = DB::table("tai_ticket_basket")
            ->where('tenant_id', $tenantId)
            ->where("basket_owner", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();

        $ticketIds2 = DB::table("tai_ticket_task_owner")
            ->where('tenant_id', $tenantId)
            ->where("task_owner_id", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();

        $ticketIds = array_unique(array_merge($ticketIds1, $ticketIds2));
        if (count($ticketIds)) {
            $ticketIdImp = implode(",", $ticketIds);
        } else {
            $ticketIdImp = 0;
        }

        ////////////////////////////  MAIN QUERY ////////////////////////////////////////
        $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured, 
                CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department as assign_to_department, sm.status AS status_name, 
                CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                fd.department AS from_department_name,
                CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name, pm.project_name, pmod.module_name, smod.sub_module_name,
                qtm.query_type_name, te.template_name
                from tai_ticket_master AS tm 
                LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
                LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                LEFT JOIN tai_project_master AS pm ON pm.id = tm.project_id  
                LEFT JOIN tai_project_modules AS pmod ON pmod.id = tm.module_id
                LEFT JOIN tai_project_sub_modules AS smod ON smod.id = tm.submodule_id  
                LEFT JOIN tai_query_type_master AS qtm ON qtm.id = tm.query_type_id  
                LEFT JOIN tai_template_master AS te ON te.id = tm.template_id  
                WHERE tm.is_active = 1 AND tm.tenant_id =" . $tenantId . " AND tm.status_id !=3";

        //1.         ////////////////////////////  Created BY ME ////////////////////////////////////////
        $createdByMeSQL = $query . " AND tm.created_by = " . $userId . " ORDER BY tm.id desc";
        $createdByMe = DB::select(DB::raw($createdByMeSQL));

        //2.      //////////////////////////// MY TASK ////////////////////////////////////////
        $yourTaskSQL = $query . " AND ((tm.assign_to_user_id = " . $userId . ") OR tm.id IN (" . $ticketIdImp . ") ) AND tm.passed_status='PASS' ORDER BY tm.id desc";
        $yourTask = DB::select(DB::raw($yourTaskSQL));

        //3.
        $assignedToMeSQL = $query . " AND tm.assign_to_user_id = " . $userId . " AND tm.passed_status='PASS' ORDER BY tm.id desc";
        $assignedToMe = DB::select(DB::raw($assignedToMeSQL));

        //4.      ////////////////////////////  UNPASSED TICCKETS ////////////////////////////////////////
        $unpassedTicketsId = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)
            ->where('is_active', 1)
            ->where('ticket_passing_authority', 1)
            ->pluck('department_id')
            ->toArray();
        if (count($unpassedTicketsId) == 0) {
            $unpassedTicketsId[] = 0;
        }
        $unpassedTicketsSQL = $query . " AND tm.passed_status='UNPASS' AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")   
                                        ORDER BY tm.id desc";
        $unpassedTickets = DB::select(DB::raw($unpassedTicketsSQL));
        // dd($unpassedTickets);


        //5.      ////////////////////////////  DEPARTMENTWISE TICCKETS ////////////////////////////////////////   
        $mapping = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)->where('is_active', 1)->get();
        $assignedDepartmentTickets = [];
        $myDepartmentTickets = [];
        foreach ($mapping as $m) {
            if ($m->ticket_show_type == "DEPARTMENT_TICKETS") {
                $assignedDepartmentTickets[] = $m->department_id;
            } else {
                $myDepartmentTickets[] = $m->department_id;
            }
        };
        // dd($mapping);

        // return "a)".count($assignedDepartmentTickets)." b)".count($myDepartmentTickets);
        $departmentwiseTicketsSQL = $query;
        if (count($assignedDepartmentTickets)) {
            $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ")";
        } else {
            $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $myDepartmentTickets) . ")";
        }
        $departmentwiseTicketsSQL .= " AND tm.passed_status='PASS' ORDER BY tm.id desc";
        $departmentwiseTickets = DB::select(DB::raw($departmentwiseTicketsSQL));


        return response()->json([
            "status" => 1,
            "message" => "Data Found !!!",
            "data" => null,
            'unpassedTickets' => $unpassedTickets,
            'createdByMe' => $createdByMe,
            'yourTask' => $yourTask,
            'assignedToMe' => $assignedToMe,
            'departmentwiseTickets' => $departmentwiseTickets
        ]);
    }

    // DATE: 06-08-2023 PUNAM SHINDE 
    // Get My All Tickets START
    public function getAllTicketTest1(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $userId = $token_data->id; //user id
        $customerId = $token_data->customer_id;

        // dd($request->all(), $request->typeOf);
        // return $request->typeOf;

        $typeOf = isset($request->typeOf) ? $request->typeOf : '';
        $page = isset($request->page) ? $request->page : 1;
        $limit = isset($request->limit) ? $request->limit : 10;

        $offset = ($page - 1) * $limit;
        // $data = $request->all
        // return $request->all();

        ////////////////////////////  MAIN QUERY ////////////////////////////////////////
        $query = DB::table('tai_ticket_master AS tm')
            ->select(
                'tm.id',
                'tm.ticket_id',
                'tm.query_type_id',
                'tm.object_id',
                'tm.tenant_id',
                'tm.customer_id',
                'tm.description',
                'tm.ticket_date',
                'tm.expected_solve_date',
                'tm.priority',
                'tm.passed_status',
                'tm.status_id',
                'tm.assign_to_department_id',
                'tm.assign_to_user_id',
                DB::raw('(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id = tm.id AND is_active = 1) as basket_configured'),
                DB::raw('CONCAT(em.first_name, " ", em.last_name) AS assign_to_user'),
                'dm.department AS assign_to_department',
                'sm.status AS status_name',
                DB::raw('CONCAT(em_c.first_name, " ", em_c.last_name) AS created_by_name'),
                'fd.department AS from_department_name',
                DB::raw('CONCAT(em_passed.first_name, " ", em_passed.last_name) AS passed_status_changed_by_name'),
                'pm.project_name',
                'pmod.module_name',
                'smod.sub_module_name',
                'qtm.query_type_name',
                'te.template_name'
            )
            ->leftJoin('tai_employee_master AS em', 'em.id', '=', 'tm.assign_to_user_id')
            ->leftJoin('tai_employee_master AS em_c', 'em_c.id', '=', 'tm.created_by')
            ->leftJoin('tai_employee_master AS em_passed', 'em_passed.id', '=', 'tm.passed_status_changed_by')
            ->leftJoin('tai_status_master AS sm', 'sm.id', '=', 'tm.status_id')
            ->leftJoin('tai_department_master AS dm', 'dm.id', '=', 'tm.assign_to_department_id')
            ->leftJoin('tai_department_master AS fd', 'fd.id', '=', 'tm.from_department_id')
            ->leftJoin('tai_project_master AS pm', 'pm.id', '=', 'tm.project_id')
            ->leftJoin('tai_project_modules AS pmod', 'pmod.id', '=', 'tm.module_id')
            ->leftJoin('tai_project_sub_modules AS smod', 'smod.id', '=', 'tm.submodule_id')
            ->leftJoin('tai_query_type_master AS qtm', 'qtm.id', '=', 'tm.query_type_id')
            ->leftJoin('tai_template_master AS te', 'te.id', '=', 'tm.template_id')
            ->where('tm.is_active', 1)
            ->where('tm.tenant_id', $tenantId);


        if ($typeOf == 'CreatedByMe') {
            return  $this->getAllCreatedByMeTicket($query, $offset, $limit);
        } elseif ($typeOf == 'YouTask') {
            return $this->getAllYourTaskTicket($query, $offset, $limit);
        } elseif ($typeOf == 'AssignToMe') {
            return $this->getAllAssignToMeTicket($query, $offset, $limit);
        } elseif ($typeOf == 'UnPassed') {
            return $this->getAllUnPassTicket($query, $offset, $limit);
        } else if ($typeOf == 'DepartmentWise') {
            return $this->getAllDeptWiseTicket($query, $offset, $limit); //DepartmentWise
        } else {
            return $this->getAllAssignToMeTicket($query, $offset, $limit); // default assign to me
        }
    }

    // CreatedByMe =>create separate api for mobile applications
    public function getAllCreatedByMeTicket($query, $offset, $limit)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;
        $userId = $token_data->id;

        //1. ////////////////////////////  Created BY ME ////////////////////////////////////////

        $check_department_mapping_auth = DB::table('tai_employee_department_mapping as map')
            ->leftJoin('tai_department_master as m', 'm.id', 'map.department_id')
            ->leftJoin('tai_employee_department_mapping as emp_map', 'emp_map.department_id', 'm.id')
            ->LeftJoin('tai_employee_master as emp', 'emp.id', 'emp_map.employee_id')
            ->where('m.tenant_id', $tenantId)
            ->where('m.is_active', 1)
            ->where('map.tenant_id', $tenantId)
            ->where('map.employee_id', $userId)
            ->where('map.ticket_show_type', 'DEPARTMENT_TICKETS')
            ->where('map.is_active', 1)
            ->where('map.ticket_passing_authority', 1)
            ->where('emp_map.is_active', 1)
            ->where('emp_map.tenant_id', $tenantId)
            ->where('emp.is_active', 1)
            ->where('emp.tenant_id', $tenantId);

        if ($customerId && $customerId != NULL) {
            $check_department_mapping_auth = $check_department_mapping_auth->where('emp.customer_id', $customerId);
        }

        $check_department_mapping_auth = $check_department_mapping_auth->distinct()
            ->pluck('emp.id')
            ->toArray();

        if (count($check_department_mapping_auth) > 0) {
            $emp_id = array_unique(array_merge($check_department_mapping_auth, (array)(int)$userId));
            $createdByMe = $query->whereIn('tm.created_by', $emp_id)
                ->where('tm.status_id', '!=', 3)
                ->orderBy('tm.id', 'desc')
                ->skip($offset)
                ->take($limit)
                ->paginate($limit);
        } else {
            $createdByMe = $query->where('tm.created_by', $userId)
                ->where('tm.status_id', '!=', 3)
                ->orderBy('tm.id', 'desc')
                ->skip($offset)
                ->take($limit)
                ->paginate($limit);
        }

        foreach ($createdByMe as $as) {
            $as->attachment = CommonController::getAttachment($as->id, "Ticket");
        }

        return response()->json([
            "status" => 1,
            "message" => "Created By Me Tickets Found !!!",
            "data" => $createdByMe
        ]);
    }

    // YouTask
    public function getAllYourTaskTicket($query, $offset, $limit)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;
        $userId = $token_data->id;

        $ticketIds1 = DB::table("tai_ticket_basket as b")
            ->leftJoin('tai_employee_master as e', 'e.id', 'b.basket_owner')
            ->where('b.tenant_id', $tenantId)
            ->where("b.basket_owner", $userId);
        if ($customerId) {
            $ticketIds1 = $ticketIds1->where('e.customer_id', $customerId);
        }
        $ticketIds1 = $ticketIds1->pluck("b.ticket_id")
            ->toArray();

        $ticketIds2 = DB::table("tai_ticket_task_owner as o")
            ->leftJoin('tai_employee_master as e', 'e.id', 'o.task_owner_id')
            ->where('o.tenant_id', $tenantId)
            ->where("o.task_owner_id", $userId);
        if ($customerId) {
            $ticketIds2 = $ticketIds2->where('e.customer_id', $customerId);
        }
        $ticketIds2 = $ticketIds2->pluck("o.ticket_id")->toArray();

        $ticketIds = array_unique(array_merge($ticketIds1, $ticketIds2));
        if (count($ticketIds)) {
            $ticketIdImp = $ticketIds;
        } else {
            $ticketIdImp = 0;
        }

        // dd($ticketIdImp);
        //2.  //////////////////////////// MY TASK ////////////////////////////////////////
        if ($customerId) {
            $yourTask = $query->where(function ($query) use ($userId, $customerId, $ticketIdImp) {
                $query->where(function ($query) use ($userId, $customerId) {
                    $query->where('tm.assign_to_user_id', $userId)
                        ->where('em.customer_id', $customerId);
                });
                if ($ticketIdImp != 0 || $ticketIdImp != NULL) {
                    $query->orWhereIn('tm.id', $ticketIdImp);
                }
            })->where('tm.passed_status', 'PASS')
                ->where('tm.status_id', '!=', 3)
                ->orderBy('tm.id', 'desc')
                ->skip($offset)
                ->take($limit)
                ->paginate($limit);
        } else {
            $yourTask = $query->where(function ($query) use ($userId, $ticketIdImp) {
                $query->where('tm.assign_to_user_id', $userId);
                if ($ticketIdImp != 0 || $ticketIdImp != NULL) {
                    $query->orWhereIn('tm.id', $ticketIdImp);
                }
            })
                ->where('tm.passed_status', 'PASS')
                ->where('tm.status_id', '!=', 3)
                ->orderBy('tm.id', 'desc')
                ->skip($offset)
                ->take($limit)
                ->paginate($limit);
        }
        // $yourTask = DB::select(DB::raw($yourTask));

        foreach ($yourTask as $as) {
            $as->attachment = CommonController::getAttachment($as->id, "Ticket");
        }

        if ($yourTask && count($yourTask) > 0) {
            return response()->json([
                "status" => 1,
                "message" => "Your Task Tickets !!!",
                "data" => $yourTask
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Your Task Tickets Not Found !!!",
                "data" => $yourTask
            ]);
        }
    }

    // AssignToMe
    public function getAllAssignToMeTicket($query, $offset, $limit)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;
        $userId = $token_data->id;

        //3. //////////////////////////////// ASSIGN TO ME //////////////////////////////////
        if ($customerId) {
            $assignedToMe = $query
                ->where('tm.assign_to_user_id', $userId)
                ->where('em.customer_id', $customerId)
                ->where('tm.passed_status', 'PASS')
                ->where('tm.status_id', '!=', 3)
                ->orderBy('tm.id', 'desc')
                ->skip($offset)
                ->take($limit)
                ->paginate($limit);
        } else {
            $assignedToMe = $query->where('tm.assign_to_user_id', $userId)
                ->where('tm.passed_status', 'PASS')
                ->where('tm.status_id', '!=', 3)
                ->orderBy('tm.id', 'desc')
                ->skip($offset)
                ->take($limit)
                ->paginate($limit);
        }

        // dd($assignedToMe);
        foreach ($assignedToMe as $as) {
            $as->attachment = CommonController::getAttachment($as->id, "Ticket");
        }
        // ------------------------------------------------------------------------------------------------

        if ($assignedToMe && count($assignedToMe) > 0) {
            return response()->json([
                "status" => 1,
                "message" => "Assign To Tickets !!!",
                "data" => $assignedToMe
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Assign To Tickets Not Found !!!",
                "data" => $assignedToMe
            ]);
        }
    }

    // UnPassed
    public function getAllUnPassTicket($query, $offset, $limit)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;
        $userId = $token_data->id;

        //4.      ////////////////////////////  UNPASSED TICCKETS ////////////////////////////////////////
        $unpassedTicketsId = DB::table('tai_employee_department_mapping')
            ->where('employee_id', $userId)
            ->where('is_active', 1)
            ->where('ticket_passing_authority', 1)
            ->where('tenant_id', $tenantId)
            ->pluck('department_id')
            ->toArray();


        if (count($unpassedTicketsId) == 0) {
            $unpassedTicketsId[] = 0;
            $unpassedTickets = [];
        } else {
            if ($customerId) {
                $unpassedTickets = $query->where(function ($query) use ($customerId, $unpassedTicketsId) {
                    $query->where('em.customer_id', $customerId)
                        ->orWhere('em_c.customer_id', $customerId);
                })
                    ->where('tm.passed_status', 'UNPASS')
                    ->whereIn('tm.from_department_id', $unpassedTicketsId)
                    ->where('tm.status_id', '!=', 3)
                    ->orderBy('tm.id', 'desc')
                    ->skip($offset)
                    ->take($limit)
                    ->paginate($limit);
            } else {

                $unpassedTickets = $query
                    ->where('tm.passed_status', 'UNPASS')
                    ->whereIn('tm.from_department_id', $unpassedTicketsId)
                    ->where('tm.status_id', '!=', 3)
                    ->orderBy('tm.id', 'desc')
                    ->skip($offset)
                    ->take($limit)
                    ->paginate($limit);
            }

            // $unpassedTickets = DB::select(DB::raw($unpassedTickets));

            foreach ($unpassedTickets as $as) {
                $as->attachment = CommonController::getAttachment($as->id, "Ticket");
            }
        }

        // ------------------------------------------------------------------------------------------------

        if ($unpassedTickets && count($unpassedTickets) > 0) {
            return response()->json([
                "status" => 1,
                "message" => "Data Found !!!",
                "data" => $unpassedTickets
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Unpassed Tickets Not Found !!!",
                "data" => $unpassedTickets
            ]);
        }
    }

    // DepartmentWise
    public function getAllDeptWiseTicket($query, $offset, $limit)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;
        $customerId = $token_data->customer_id;
        $userId = $token_data->id;

        //5.      ////////////////////////////  DEPARTMENTWISE TICKETS ////////////////////////////////////////   
        $mapping = DB::table('tai_employee_department_mapping')->select('ticket_show_type', 'department_id')->where('employee_id', $userId)->where('is_active', 1)->get();

        $assignedDepartmentTickets = [];
        $myDepartmentTickets = [];
        foreach ($mapping as $m) {
            if ($m->ticket_show_type == "DEPARTMENT_TICKETS") {
                $assignedDepartmentTickets[] = $m->department_id;
            } else {
                $myDepartmentTickets[] = $m->department_id;
            }
        };

        $departmentwiseTickets = $query;

        // PUNAM SHINDE DATE: 10-05-2023
        if (count($assignedDepartmentTickets) > 0) {

            if ($customerId) {
                $departmentwiseTickets = $query->where(function ($query) use ($assignedDepartmentTickets, $customerId) {
                    $query->whereIn('tm.assign_to_department_id', $assignedDepartmentTickets)
                        ->where(function ($query) use ($customerId) {
                            $query->where('em.customer_id', $customerId)
                                ->orWhere('em_c.customer_id', $customerId);
                        })
                        ->where('tm.passed_status', 'PASS');
                })
                    ->whereNotIn('tm.status_id', [20, 3])
                    ->orderBy('tm.id', 'desc')
                    ->skip($offset)
                    ->take($limit)
                    ->paginate($limit);
            } else {
                $departmentwiseTickets = $query->whereIn('tm.assign_to_department_id', $assignedDepartmentTickets)
                    ->where('tm.passed_status', 'PASS')
                    ->whereNotIn('tm.status_id', [20, 3])
                    ->orderBy('tm.id', 'desc')
                    ->skip($offset)
                    ->take($limit)
                    ->paginate($limit);
            }

            foreach ($departmentwiseTickets as $as) {
                $as->attachment = CommonController::getAttachment($as->id, "Ticket");
            }
        } else {
            $departmentwiseTickets = [];
        }

        // ------------------------------------------------------------------------------------------------

        if ($departmentwiseTickets && count($departmentwiseTickets) > 0) {
            return response()->json([
                "status" => 1,
                "message" => "Department Wise Tickets !!!",
                "data" => $departmentwiseTickets
            ]);
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Department Wise Tickets Not Found !!!",
                "data" => $departmentwiseTickets
            ]);
        }
    }
    // END ///////////////////////////////////////////////////////////////////////////////////////////////////////////////



    // public function getAllTicketTest(Request $request, $userId)
    // {
    //     $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
    //     $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
    //     // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

    //     $ticketIds1 = DB::table("tai_ticket_basket as b")
    //         ->leftJoin('tai_employee_master as e', 'e.id', 'b.basket_owner')
    //         ->where('b.tenant_id', $tenantId)
    //         ->where("b.basket_owner", $userId);
    //     // if ($customerId) {
    //     //     $ticketIds1 = $ticketIds1->where('e.customer_id', $customerId);
    //     // }
    //     $ticketIds1 = $ticketIds1->pluck("b.ticket_id")
    //         ->toArray();

    //     $ticketIds2 = DB::table("tai_ticket_task_owner as o")
    //         ->leftJoin('tai_employee_master as e', 'e.id', 'o.task_owner_id')
    //         ->where('o.tenant_id', $tenantId)
    //         ->where("o.task_owner_id", $userId);
    //     // if ($customerId) {
    //     //     $ticketIds2 = $ticketIds2->where('e.customer_id', $customerId);
    //     // }
    //     $ticketIds2 = $ticketIds2->pluck("o.ticket_id")->toArray();

    //     $ticketIds = array_unique(array_merge($ticketIds1, $ticketIds2));
    //     if (count($ticketIds)) {
    //         $ticketIdImp = implode(",", $ticketIds);
    //     } else {
    //         $ticketIdImp = 0;
    //     }

    //     // dd($ticketIds2,$ticketIdImp);

    //     ////////////////////////////  MAIN QUERY ////////////////////////////////////////
    //     $query = "SELECT tm.*,(SELECT count(id) 
    //                             FROM tai_ticket_basket 
    //                             WHERE ticket_id=tm.id AND is_active=1
    //                         ) as basket_configured, 
    //                         CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, 
    //                         dm.department as assign_to_department, 
    //                         sm.status AS status_name, 
    //             CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
    //             fd.department AS from_department_name,
    //             CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name, pm.project_name, pmod.module_name, smod.sub_module_name,
    //             qtm.query_type_name, te.template_name
    //             from tai_ticket_master AS tm 
    //             LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
    //             LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
    //             LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
    //             LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
    //             LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
    //             LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
    //             LEFT JOIN tai_project_master AS pm ON pm.id = tm.project_id  
    //             LEFT JOIN tai_project_modules AS pmod ON pmod.id = tm.module_id
    //             LEFT JOIN tai_project_sub_modules AS smod ON smod.id = tm.submodule_id  
    //             LEFT JOIN tai_query_type_master AS qtm ON qtm.id = tm.query_type_id  
    //             LEFT JOIN tai_template_master AS te ON te.id = tm.template_id  
    //             WHERE tm.is_active = 1 AND tm.tenant_id =" . $tenantId . " AND tm.status_id !=3";
    //     // 



    //     //1. ////////////////////////////  Created BY ME ////////////////////////////////////////

    //     $check_department_mapping_auth = DB::table('tai_employee_department_mapping as map')
    //         ->leftJoin('tai_department_master as m', 'm.id', 'map.department_id')
    //         ->leftJoin('tai_employee_department_mapping as emp_map', 'emp_map.department_id', 'm.id')
    //         ->LeftJoin('tai_employee_master as emp', 'emp.id', 'emp_map.employee_id')
    //         ->where('m.tenant_id', $tenantId)
    //         ->where('m.is_active', 1)
    //         ->where('map.tenant_id', $tenantId)
    //         ->where('map.employee_id', $userId)
    //         ->where('map.ticket_show_type', 'DEPARTMENT_TICKETS')
    //         ->where('map.is_active', 1)
    //         ->where('map.ticket_passing_authority', 1)
    //         ->where('emp_map.is_active', 1)
    //         ->where('emp_map.tenant_id', $tenantId)
    //         ->where('emp.is_active', 1)
    //         ->where('emp.tenant_id', $tenantId)
    //         // ->where('emp.customer_id', $customerId)
    //         ->distinct()
    //         ->pluck('emp.id')
    //         ->toArray();


    //     // return [12, array_merge($check_department_mapping_auth, (array)(int)$userId)];
    //     if (count($check_department_mapping_auth) > 0) {
    //         $emp_id = implode(',', array_unique(array_merge($check_department_mapping_auth, (array)(int)$userId)));
    //         $createdByMeSQL = $query . " AND tm.created_by IN (" . $emp_id . ")  ORDER BY tm.id desc";
    //     } else {
    //         $createdByMeSQL = $query . " AND tm.created_by = " . $userId . " ORDER BY tm.id desc";
    //     }
    //     // echo $createdByMeSQL;
    //     $createdByMe = DB::select(DB::raw($createdByMeSQL));
    //     // dd($createdByMe);
    //     foreach ($createdByMe as $as) {
    //         $as->attachment = CommonController::getAttachment($as->id, "Ticket");
    //     }

    //     // ------------------------------------------------------------------------------------------------

    //     //2.  //////////////////////////// MY TASK ////////////////////////////////////////
    //     // if ($customerId) {
    //     //     $yourTaskSQL = $query . " AND ((tm.assign_to_user_id = " . $userId . " AND em.customer_id = " . $customerId . ") OR tm.id IN (" . $ticketIdImp . ") ) AND tm.passed_status='PASS' ORDER BY tm.id desc";
    //     // } else {
    //     $yourTaskSQL = $query . " AND ((tm.assign_to_user_id = " . $userId . ") OR tm.id IN (" . $ticketIdImp . ") ) AND tm.passed_status='PASS' ORDER BY tm.id desc";
    //     // }
    //     $yourTask = DB::select(DB::raw($yourTaskSQL));
    //     // dd($yourTask);
    //     foreach ($yourTask as $as) {
    //         $as->attachment = CommonController::getAttachment($as->id, "Ticket");
    //     }
    //     // ------------------------------------------------------------------------------------------------

    //     //3.
    //     $assignedToMeSQL = $query . " AND tm.assign_to_user_id = " . $userId . " AND tm.passed_status='PASS' ORDER BY tm.id desc";
    //     $assignedToMe = DB::select(DB::raw($assignedToMeSQL));
    //     // dd($assignedToMe);
    //     foreach ($assignedToMe as $as) {
    //         $as->attachment = CommonController::getAttachment($as->id, "Ticket");
    //     }
    //     // ------------------------------------------------------------------------------------------------

    //     //4.      ////////////////////////////  UNPASSED TICCKETS ////////////////////////////////////////
    //     $unpassedTicketsId = DB::table('tai_employee_department_mapping')
    //         ->where('employee_id', $userId)
    //         ->where('is_active', 1)
    //         ->where('ticket_passing_authority', 1)
    //         ->where('tenant_id', $tenantId)
    //         ->pluck('department_id')
    //         ->toArray();
    //     if (count($unpassedTicketsId) == 0) {
    //         $unpassedTicketsId[] = 0;
    //         $unpassedTickets = [];
    //     } else {
    //         // if ($customerId) {
    //         //     $unpassedTicketsSQL = $query . " AND tm.passed_status='UNPASS' AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")  ORDER BY tm.id desc ";
    //         // } else {
    //             // dd(2);
    //             $unpassedTicketsSQL = $query . " AND tm.passed_status='UNPASS' AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")   ORDER BY tm.id desc ";
    //         // }

    //         $unpassedTickets = DB::select(DB::raw($unpassedTicketsSQL));
    //         // dd($unpassedTickets);

    //         foreach ($unpassedTickets as $as) {
    //             $as->attachment = CommonController::getAttachment($as->id, "Ticket");
    //         }
    //     }

    //     // $unpassedTicketsSQL = $query . " AND tm.passed_status='UNPASS' AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")  ";
    //     // dd($customerId);

    //     // ------------------------------------------------------------------------------------------------

    //     //5.      ////////////////////////////  DEPARTMENTWISE TICKETS ////////////////////////////////////////   
    //     $mapping = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)->where('is_active', 1)->get();

    //     // dd($mapping);
    //     $assignedDepartmentTickets = [];
    //     $myDepartmentTickets = [];
    //     foreach ($mapping as $m) {
    //         if ($m->ticket_show_type == "DEPARTMENT_TICKETS") {
    //             $assignedDepartmentTickets[] = $m->department_id;
    //         } else {
    //             $myDepartmentTickets[] = $m->department_id;
    //         }
    //     };
    //     // dd($mapping);

    //     // return "a)".count($assignedDepartmentTickets)." b)".count($myDepartmentTickets);
    //     $departmentwiseTicketsSQL = $query;

    //     // if (count($assignedDepartmentTickets)) {
    //     //     $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ")";
    //     // } else {
    //     //     $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $myDepartmentTickets) . ")";
    //     // }
    //     // $departmentwiseTicketsSQL .= " AND tm.passed_status='PASS' ORDER BY tm.id desc";

    //     // TT11137 PUNAM SHINDE DATE:05-05-2023 ----------------

    //     // if(count($assignedDepartmentTickets) > 0 && count($myDepartmentTickets) > 0)
    //     // {
    //     //     $departmentwiseTicketsSQL .= " AND (tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ") OR  (tm.assign_to_department_id IN (" . implode(',', $myDepartmentTickets) . ") AND tm.assign_to_user_id = " . $userId . ")) ";
    //     // }
    //     // elseif (count($assignedDepartmentTickets) > 0) {
    //     //     $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ")";
    //     // } else {
    //     //     $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $myDepartmentTickets) . ") AND tm.assign_to_user_id = " . $userId . "";
    //     // }

    //     // // --------------------------------------------------------------------
    //     // $departmentwiseTicketsSQL .= " AND tm.passed_status='PASS' ORDER BY tm.id desc";
    //     // $departmentwiseTickets = DB::select(DB::raw($departmentwiseTicketsSQL));


    //     // dd($assignedDepartmentTickets);
    //     // PUNAM SHINDE DATE: 10-05-2023
    //     if (count($assignedDepartmentTickets) > 0 && count($myDepartmentTickets) > 0) {

    //         // $departmentwiseTicketsSQL .= " AND (tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ") OR  (tm.assign_to_department_id IN (" . implode(',', $myDepartmentTickets) . ") AND tm.assign_to_user_id = " . $userId . "))  AND em.customer_id = " . $customerId . " OR em_c.customer_id = " . $customerId . " AND tm.passed_status='PASS' ORDER BY tm.id desc";


    //         $departmentwiseTicketsSQL .= " AND (tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ")) AND tm.passed_status='PASS' ORDER BY tm.id desc";

    //         $departmentwiseTickets = DB::select(DB::raw($departmentwiseTicketsSQL));
    //         foreach ($departmentwiseTickets as $as) {
    //             $as->attachment = CommonController::getAttachment($as->id, "Ticket");
    //         }
    //     } else {
    //         $departmentwiseTickets = [];
    //     }

    //     // --------------------------------------------------------------------------------------------


    //     return response()->json([
    //         "status" => 1,
    //         "message" => "Data Found !!!",
    //         "data" => null,
    //         'unpassedTickets' => $unpassedTickets,
    //         'createdByMe' => $createdByMe,
    //         'yourTask' => $yourTask,
    //         'assignedToMe' => $assignedToMe,
    //         'departmentwiseTickets' => $departmentwiseTickets
    //     ]);
    // }


    //updated by Rushikesh Harkare 09/08/2023
    public function getOptionalExpectedSolvDate($customer_mapping_id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $date_data = [];

        $cust = DB::table('tai_customer_mapping')->where('is_active', 1)->where('id', $customer_mapping_id)->where('tenant_id', $tenantId)->first();

        if ($cust) {

            $temaplet_detail = DB::table("tai_template_master as tm")
                ->where('tenant_id', $tenantId)
                ->where("id", $cust->template_id)
                ->where("is_active", 1)
                ->first();


            if ($temaplet_detail) {
                $templateBasket = DB::table("tai_template_basket")->where("template_id", $cust->template_id)->where("is_active", 1)->get();

                foreach ($templateBasket as $b) {


                    $tasklist = DB::table('tai_template_basket_task as ts')
                        ->where('ts.template_basket_id', $b->id)
                        ->get();

                    if ($tasklist && count($tasklist)) {
                        foreach ($tasklist as $task) {

                            // task hours
                            $duration = \Carbon\CarbonInterval::hours($task->total_time)->cascade();
                            // Format the duration as "hh:mm"
                            $durationFormatted = $duration->format('%H:%I');

                            // cinvert into minut
                            $duration_in_hr = $duration->format('%H:%I');
                            $duration_in_hr = new DateInterval('PT2H30M');
                            $totalMinutes = ($duration_in_hr->h * 60) + $duration_in_hr->i;

                            // if ($temaplet_detail->calculate_from == 'START_FROM') {
                            $daysRequired = $task->days;
                            $startDays = $task->start_days;
                            // dd($daysRequired, $startDays);
                            $startDateString = date('Y-m-d');

                            // Create Carbon instances for start date and end date
                            $startDate = \Carbon\Carbon::createFromFormat('Y-m-d', $startDateString);
                            $endDate = $startDate->copy()->addDays($startDays - 1)->addDays($daysRequired)->format('Y-m-d');
                            // dd($daysRequired, $endDate);
                            // $startDate = $startDate->copy()->addDays($startDays)->format('Y-m-d');
                            //     // ---------------
                            // } else {
                            //     $daysRequired = $task->days;
                            //     $startDays = $task->start_days;
                            //     $startDateString = date('Y-m-d');

                            //     // Create Carbon instances for start date and end date
                            //     $startDate = \Carbon\Carbon::createFromFormat('Y-m-d', $startDateString);
                            //     $endDate = $startDate->copy()->addDays($startDays)->addDays($daysRequired)->format('Y-m-d');

                            //     $startDate = $startDate->copy()->addDays($startDays)->format('Y-m-d');
                            // }

                            $date_data[] = $endDate;
                        }
                    }
                }
            }
        }
        if ($date_data && count($date_data) > 0) {
            return response()->json(["status" => 1, "message" => "Found reflected date !!!", "data" => max($date_data)]);
            // return max($date_data);
        } else {
            return response()->json(["status" => 1, "message" => "Record Not Inserted !!!", "data" => date('Y-m-d')]);
            // return date('Y-m-d');
        }
    }

    public function getAllTicketNew(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // $tenantId = $request->tenant_id;
        $userId = $request->user_id;
        $query = "SELECT tm.* ,(SELECT COUNT(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) AS basket_configured, 
        CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department AS assign_to_department, sm.status AS status_name, 
        CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
        fd.department AS from_department_name,
        CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
        FROM tai_ticket_master AS tm 
        LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
        LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
        LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
        LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
        LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
        LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
        WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId;;


        if ($request->is_search && $request->is_search == "true") {
            $query .= " AND 1=1 ";

            if ($request->ticket_id) {
                $ticketIds = explode(',', $request->ticket_id);
                if (count($ticketIds)) {
                    $query .= " AND tm.ticket_id IN (" . implode(', ', array_map(function ($val) {
                        return sprintf("'%s'", $val);
                    }, $ticketIds)) . ")";
                }
            }

            if ($request->assign_to_user_id) {
                $userIds = $request->assign_to_user_id;
                if (count($userIds)) {
                    if ($userIds[0]) {
                        $query .= " AND ( tm.assign_to_user_id IN (" . implode(",", $request->assign_to_user_id) . ") OR
                        tm.created_by IN (" . implode(",", $request->assign_to_user_id) . ")
                        )";
                    }
                }
            }

            if ($request->assign_to_department_id) {
                $deparmentIds = $request->assign_to_department_id;
                if (count($deparmentIds)) {
                    if ($deparmentIds[0]) {
                        $query .= " AND (tm.assign_to_department_id IN (" . implode(",", $request->assign_to_department_id) . ")";
                    }
                }
            }

            if ($request->status_id) {
                $statusIds = $request->status_id;
                if (count($statusIds)) {
                    if ($statusIds[0]) {
                        $query .= " AND tm.status_id IN (" . implode(',', $request->status_id) . ")";
                    }
                }
            } else {
                $query .= " AND tm.status_id != '3'";
            }
            $allTicketsQuery = $query;
        } else {
            $allTicketsQuery = $query . " AND 
                    tm.id IN (
                        SELECT DISTINCT(my_task_ticket_id) FROM
                                (SELECT ticket_id AS my_task_ticket_id FROM tai_ticket_basket WHERE basket_owner=$userId AND is_active=1
                                    UNION
                                SELECT ticket_id AS my_task_ticket_id FROM tai_ticket_task_owner WHERE task_owner_id=$userId AND is_active=1
                                )  AS my_task_ticket_id
                        ) 
                OR ( tm.assign_to_department_id IN (SELECT department_id  FROM tai_employee_department_mapping WHERE employee_id=$userId AND is_active=1 AND ticket_show_type='DEPARTMENT_TICKETS')
                    AND ( tm.assign_to_department_id IN (SELECT department_id  FROM tai_employee_department_mapping WHERE employee_id=$userId AND is_active=1 AND ticket_show_type='MY_TICKETS')
                            AND
                        tm.assign_to_user_id = $userId)
                )
                OR (tm.created_by = $userId)
                AND tm.passed_status='PASS' AND tm.status_id!=3 ORDER BY tm.created_at DESC;";
        }
        $allTickets = DB::select(DB::raw($allTicketsQuery));


        //UNPASSED TICKETS
        $unpassedQuery = $query . " AND tm.assign_to_department_id IN ( SELECT department_id  FROM tai_employee_department_mapping WHERE employee_id=$userId AND is_active=1 AND ticket_passing_authority=1)
                            AND tm.passed_status='UNPASS' ORDER BY tm.created_at DESC";
        $unpassedTickets = DB::select(DB::raw($unpassedQuery));


        $data['allTickets'] = $allTickets;
        $data['unpassedTickets'] = $unpassedTickets;

        if (count($allTickets)) {
            return response()->json(["status" => 1, "message" => "Record found !!!", "data" => $data]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record found !!!", "data" => null]);
        }
    }


    public function getAllTicket(Request $request, $userId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date

        $ticketIds1 = DB::table("tai_ticket_basket")
            ->where('tenant_id', $tenantId)
            ->where("basket_owner", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();

        $ticketIds2 = DB::table("tai_ticket_task_owner")
            ->where('tenant_id', $tenantId)
            ->where("task_owner_id", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();
        $ticketIds = array_unique(array_merge($ticketIds1, $ticketIds2));
        $ticketIdImp = implode(",", $ticketIds);

        if (count($ticketIds) > 0) {
            $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured, 
                        CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department as assign_to_department, sm.status AS status_name, 
                        CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                        fd.department AS from_department_name,
                        CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
                        from tai_ticket_master AS tm 
                        LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
                        LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                        LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                        LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                        LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                        LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                        WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId . "
                        AND ((tm.assign_to_user_id = " . $userId . " OR tm.created_by = " . $userId . ") OR tm.id IN (" . $ticketIdImp . ") )
                        AND tm.status_id !=3 
                        AND tm.passed_status='PASS'
                        ORDER BY tm.id desc";
        } else {
            $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured,
                        CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department AS assign_to_department, sm.status AS status_name, 
                        CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                        fd.department AS from_department_name,
                        CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
                        FROM tai_ticket_master AS tm 
                        LEFT JOIN tai_employee_master AS em on em.id = tm.assign_to_user_id 
                        LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                        LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                        LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                        LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                        LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                        WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId . "
                        AND (tm.assign_to_user_id = " . $userId . " OR tm.created_by = " . $userId . ") 
                        AND tm.status_id!=3 
                        AND tm.passed_status='PASS'
                        ORDER BY tm.id desc";
        }

        $myTickets = DB::select(DB::raw($query));


        $unpassedTicketsId = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)
            ->where('is_active', 1)
            ->where('ticket_passing_authority', 1)
            ->pluck('department_id')
            ->toArray();

        if (count($unpassedTicketsId)) {
            $unpassedTicketsQuery = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured,
                    CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, 
                    dm.department AS assign_to_department, sm.status AS status_name, 
                    CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                    fd.department AS from_department_name,
                    CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
                    FROM tai_ticket_master AS tm 
                    INNER JOIN tai_employee_master AS em on em.id = tm.assign_to_user_id 
                    INNER JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                    LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                    INNER JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                    INNER JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id
                    INNER JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                    WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId . " AND passed_status='UNPASS'
                    AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")   
                    ORDER BY tm.id desc";
            $unpassedTickets = DB::select(DB::raw($unpassedTicketsQuery));
        } else {
            $unpassedTickets = array();
        }

        if (count($myTickets) > 0) {
            return response()->json([
                "status" => 1, "message" => "Record found !!!",
                "myTickets" => $myTickets,
                "unpassedTickets" => $unpassedTickets
            ]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record found !!!", "data" => null]);
        }
    }


    public function uploadBulkFormatTicket(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $ticket = array();
        $uploadData = \Excel::toArray(null, $request->file('file'));
        $data = $uploadData[0];
        $header = $data[0];
        unset($data[0]);

        $mainData = array();
        foreach ($data as $d) {
            $mainData[] = array_combine($header, $d);
        }
        $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master_test");

        foreach ($mainData as $m) {

            $queryType = DB::table('tai_query_type_master')->where('query_type_name', $d['query_type'])->first();
            if ($queryType) {

                $series = "TT";
                $lastTicket = DB::table("tai_ticket_master_test")->orderBy("id", "desc")->limit(1)->first();
                if (!$lastTicket) {
                    $ticket_id = "2022";
                } else {
                    $a = substr($lastTicket->ticket_id, 2);
                    $ticket_id = (int)$a + 1;
                }

                $ticket["ticket_id"] = $series . $ticket_id;

                $ticket = array_merge($ticket, $m);

                $customer_mapping = DB::table('tai_customer_mapping')->where('query_type_id', $queryType->id)->first();
                $confirmation_required = $ticket['confirmation_required'];

                if ($request->confirmation_required) {
                    $confirmation_required = $request->confirmation_required;
                }
                $customerData = $customer_mapping ? $this->getMappingData($customer_mapping->id, $tenantId) : "";

                $ticket = array_merge($ticket, $customerData);

                if (!$customer_mapping->dynamic_form_id) {
                    $form = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->first();
                    $customer_mapping->dynamic_form_id = $form->form_id;
                }

                $df = DB::table('tai_dynamic_form')->where('id', $customer_mapping->dynamic_form_id)->first();
                $form = json_decode($df->data);

                foreach ($form as $key => $value) {
                    $form[$key]->inputDefaultValue = $d[$value->inputLabel];
                    unset($ticket[$value->inputLabel]);
                }
                $submitToMongo = json_encode($form);

                $ticket['cuid'] = $ticket['ref_id'];
                unset($ticket['query_type']);
                unset($ticket['ref_id']);

                $result = DB::table("tai_ticket_master_test")->insertGetId($ticket);

                if ($result) {
                    $a = new DynamicForm();
                    $a->id = $result;
                    $a->ticket_id = $ticket["ticket_id"];
                    $a->dynamic_data = $submitToMongo;
                    $a->save();
                    DB::table('tai_ticket_master_test')->where('id', $result)->update(['object_id' => $a->_id]);
                }
            }
        }
    }

    public function createTicketThroughApi(Request $request)
    {
        // $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        // $tenant_id = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        // dd($request->all());
        $data = $request->toArray();
        // dd($data);

        if (!array_key_exists('created_by_name', $data)) {
            return response()->json(['status' => 0, 'message' => "No Created User Found !!!", 'data' => $data]);
        }



        $createdByName = explode(' ', $data['created_by_name']);
        $firstName = $createdByName[0];

        if (count($createdByName) == 2) {
            $lastName = $createdByName[1];
        }
        if (count($createdByName) == 3) {
            $lastName = $createdByName[2];
        }
        $findCreatedBy = DB::table('tai_employee_master')->where('first_name', $firstName)
            ->where('last_name', $lastName)
            ->first();

        $data['created_by'] = $findCreatedBy ? $findCreatedBy->id : NULL;
        if (!$data['created_by']) {
            return response()->json(['status' => 0, 'message' => "No Created User Found !!!", 'data' => $data]);
        }

        // $data['from_department_id']=DB::table('tai_employee_department_mapping')->where('employee_id',$data['created_by'])
        //                                                                         ->where('is_default',1)
        //                                                                         ->where('is_active',1)    
        //                                                                         ->first();  
        // // if(!$data['from_department_id']){   
        // //     return response()->json(['status'=>0,'message'=>"User Department Found !!!",'data'=>$data]);
        // // }

        $customer_mapping_id = DB::table('tai_customer_mapping')->where('is_active', 1)
            ->where('tenant_id', $data['tenant_id'])
            ->where('priority', $data['priority'])
            ->where('query_type_id', $data['query_type_id'])
            ->first();

        if (!$customer_mapping_id) {
            return response()->json(['status' => 0, 'message' => "Mapping not found !!!", 'data' => $data]);
        }

        if ($customer_mapping_id->is_active == 0) {
            return response()->json(['status' => 0, 'message' => "Mapping is deactivated !!!", 'data' => $data]);
        }

        $customer = $this->getMappingData($customer_mapping_id->id, $data['tenant_id']);


        if ($customer) {
            $data = array_merge($data, $customer);
        } else {
            return response()->json(['status' => 0, 'message' => "Mapping data not generated !!!", 'data' => $data]);
        }

        $data['confirmation_required'] = 0;
        $data['passed_status'] = "PASS";


        $series = "TT";
        $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
        if (!$lastTicket) {
            $ticket_id = "2022";
        } else {
            $a = substr($lastTicket->ticket_id, 2);
            $ticket_id = (int)$a + 1;
        }

        $data["ticket_id"] = $series . $ticket_id;
        $submitToMongo = "";


        $data['confirmation_required'] = 0;


        if ($data['query_type_id']) {
            //1.Compare actual columns required with all form data
            $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
            $ticketColumns[] = "attachment";

            //2.Filter and genrate dynamic form data received in request
            $dynamicForm = array();
            foreach ($data as $key => $value) {
                if (!in_array($key, $ticketColumns)) {
                    $dynamicForm[$key] = $value;
                    unset($data[$key]);
                }
            }
            //3. Get actual json form
            $dynamicFormData = DB::table('tai_query_type_master as t')
                ->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                ->where('t.id', $data['query_type_id'])
                ->select('d.data')
                ->first();

            // dd($dynamicFormData);
            if ($dynamicFormData) {
                $form = json_decode($dynamicFormData->data);

                foreach ($form as $key => $value) {
                    foreach ($value as $k => $v) {
                        // if ($k != "inputAddOn") {
                        //     if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                        //         $form[$key]->inputDefaultValue = $dynamicForm[$v];
                        //         $form[$key]->value = $dynamicForm[$v];
                        //     }
                        // }

                        if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                            if (strpos($dynamicForm[$v], "|") !== false) {
                                $form[$key]->inputDefaultValue = explode("|", $dynamicForm[$v])[1];
                                $form[$key]->inputDefaultId = explode("|", $dynamicForm[$v])[0];
                                $form[$key]->value = explode("|", $dynamicForm[$v])[1];
                            } else {
                                $form[$key]->inputDefaultValue = $dynamicForm[$v];
                                $form[$key]->value = $dynamicForm[$v];
                            }
                        }
                    }
                }
                $submitToMongo = json_encode($form);
            }
        }
        // $data['ticket_date']=date('Y-m-d');
        $data['status_id'] = 1;
        $data['passed_status'] = "PASS";
        $data['created_at'] = now();
        $data['confirmation_required'] = "1";
        // dd($data);
        $result = DB::table("tai_ticket_master")->insertGetId($data);

        if ($result) {
            if ($submitToMongo) {
                $a = new DynamicForm();
                $a->id = $result;
                $a->ticket_id = $data["ticket_id"];
                $a->dynamic_data = $submitToMongo;
                $a->save();
                DB::table('tai_ticket_master')
                    ->where('id', $result)->update(['object_id' => $a->_id]);
            }
            //Mapping
            if (array_key_exists('project_id', $data) && $data['project_id']) {
                OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], $data['project_id'], $result, 0, 0);
            } else {
                OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], 0, $result, 0, 0);
            }
            return response()->json(['status' => 1, 'message' => "Ticket Generated !!!", 'data' => $data['ticket_id']]);
        } else {
            return response()->json(["status" => 0, "message" => "Ticket Not Generated", "data" => $data]);
        }
    }

    public function tai_ticket_data()
    {
        $data = DB::table('z_tai_ticket_data')
            ->orderByDesc('id')
            ->get();

        foreach ($data as $k => $v) {
            $dynamic_form_data = DynamicForm::find($v->object_id);
            if ($dynamic_form_data) {
                // description is json string
                $description = [];

                if ($dynamic_form_data->dynamic_data) {
                    $v->dynamic_form = is_array($dynamic_form_data->dynamic_data) ? $dynamic_form_data->dynamic_data : json_decode($dynamic_form_data->dynamic_data);
                    foreach ($v->dynamic_form as $value) {
                        if (is_array($value)) {
                            if ($value['inputType'] == "text") {
                                // create key value pair json string
                                if (isset($value['value'])) {
                                    $description[$value['inputLabel']] = $value['value'];
                                } else if (isset($value['inputDefaultValue'])) {
                                    $description[$value['inputLabel']] = $value['inputDefaultValue'];
                                }
                            }
                        }
                    }
                    DB::table('z_tai_ticket_data')->where('id', $v->id)->update(['dynamic_data' => json_encode($description)]);
                    // dd($v->id, $description);
                    // update column description


                    // foreach ($dynamicFormData as $key => $form) {
                    //     if ($form->inputType == "select") {
                    //         $addOns = $form->inputAddOn;
                    //         $dropdown = DB::table('tai_dynamic_form_dropdown_data')
                    //                         ->where('dropdown_id', $addOns->inputDataSource)
                    //                         ->get();
                    //         $temp = array();

                    //         foreach ($dropdown as $d) {
                    //             $temp[] = array("value" => $d->value, "label" => $d->label);
                    //         }
                    //         $dynamicFormData[$key]->inputAddOn->inputDataSourceData = $temp;
                    //     }
                    // }
                }
            }
        }
    }

    // public function getMappingData($mappingId)   //98
    // {
    //     $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
    //     $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
    //     // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

    //     $data = array();
    //     $cust = DB::table('tai_customer_mapping')->where('is_active', 1)->where('id', $mappingId)->where('tenant_id', $tenantId)->first();
    //     // return $cust;
    //     if ($cust) {

    //         //SINGLE PESON APPROACH
    //         if ($cust->approach == "SP") {
    //             $assign_to_user_id = $cust->user_policy;
    //             // return $assign_to_user_id;
    //             $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
    //                 ->where('is_active', 1)->first();

    //             $assign_to_user_id = $users ? $users->user_id : NULL;
    //         }

    //         //DEPARTMENT WISE ROUND ROBIN APPROACH
    //         if ($cust->approach == "RR") {

    //             $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
    //                 ->where('last_issued_ticket', 0)
    //                 ->where('is_active', 1)
    //                 ->orderBy('id')
    //                 ->first();
    //             if ($users) {
    //                 $assign_to_user_id = $users->user_id;
    //                 DB::table('tai_customer_user_mapping')->where('id', $users->id)->update(['last_issued_ticket' => 1]);
    //             } else {
    //                 DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
    //                     ->update(['last_issued_ticket' => 0]);

    //                 $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
    //                     ->where('last_issued_ticket', 0)
    //                     ->where('is_active', 1)
    //                     ->orderBy('id')
    //                     ->first();
    //                 $assign_to_user_id = $users->user_id;
    //                 DB::table('tai_customer_user_mapping')->where('id', $users->id)->update(['last_issued_ticket' => 1]);
    //             }
    //         }

    //         //HAVING LESS TICKET APPROACH
    //         if ($cust->approach == "HLT" && $cust->user_policy) {
    //             // updated by punam Shinde Date: 30-03-2023
    //             $users = DB::table('tai_customer_user_mapping')
    //                 ->where('tai_customer_mapping_id', $cust->id)
    //                 ->where('is_active', 1)
    //                 ->orderBy('id')
    //                 ->pluck('user_id');

    //             // dd($users);
    //             $userArray = [];
    //             if (count($users) > 0) {
    //                 $totalAssign = DB::table('tai_ticket_master')
    //                     ->select('assign_to_user_id', DB::raw('COUNT(*) as totalAssign'))
    //                     ->where('status_id', '!=', 3)
    //                     ->where('is_active', 1)
    //                     // ->where('customer_id', $customerId)
    //                     ->where('tenant_id', $tenantId)
    //                     ->whereIn('assign_to_user_id', $users)
    //                     ->groupby('assign_to_user_id')
    //                     ->orderBy('totalAssign')
    //                     ->first();

    //                 if ($totalAssign) {
    //                     $assign_to_user_id = $totalAssign->assign_to_user_id;
    //                 } else {
    //                     $assign_to_user_id = NULL;
    //                 }
    //             } else {
    //                 $assign_to_user_id = NULL;
    //             }
    //         }


    //         // Date 20/02/2023 bhushan Patel add RW logic
    //         if ($cust->approach == "RW") {

    //             $totalTickets = DB::Select(DB::raw("Select count(*) as totalTickets from tai_ticket_master where is_active = 1 AND assign_to_department_id=$cust->department_id"));
    //             $tempCustomer = [];

    //             // dd($totalTickets, $cust);

    //             $user_policy = DB::table('tai_customer_user_mapping as m')
    //                 ->leftJoin('tai_employee_master as e', 'e.id', 'm.user_id')
    //                 ->where('m.tai_customer_mapping_id', $cust->id)
    //                 ->where('m.is_active', 1)
    //                 ->where('e.is_active', 1)
    //                 // ->where('m.tenant_id', $tenantId)
    //                 ->orderBy('m.percentage', 'DESC')
    //                 ->select('user_id', 'percentage')
    //                 ->get();

    //             foreach ($user_policy as $u) {
    //                 $tempUsers[$u->user_id] = $u->percentage;
    //             }
    //             $cust->user_policy = $tempUsers;
    //             arsort($tempUsers);

    //             $assign_to_user_id = array_key_first($tempUsers);  //ASSIGN FIRST USER AS DE FAULT USER 

    //             if ($totalTickets[0] && ($totalTickets[0]->totalTickets + 1) > 0) {
    //                 foreach ($tempUsers as $user_id => $ratio) {
    //                     if ($ratio > 0) {
    //                         $totalAssign = DB::table('tai_ticket_master')->where('is_active', 1)
    //                             ->where('assign_to_user_id', $user_id)
    //                             ->where('tenant_id', $tenantId)
    //                             // ->where('customer_id', $customerId)
    //                             ->select(DB::raw('COUNT(*) as totalAssign'))
    //                             ->first();

    //                         // DB::Select(DB::raw("Select count(*) as totalAssign from tai_ticket_master where is_active =1 AND assign_to_user_id = $user_id AND tenant_id = ". $tenantId ));

    //                         // dd($totalAssign , $totalAssign->totalAssign) ;
    //                         if ($totalAssign) {
    //                             // $calculatedRatioTemp = ($totalAssign[0]->totalAssign * 100) / $totalTickets[0]->totalTickets;

    //                             $calculatedRatioTemp = ($totalAssign->totalAssign * 100) / $totalTickets[0]->totalTickets;

    //                             if ($ratio > $calculatedRatioTemp) {
    //                                 $assign_to_user_id = $user_id;
    //                                 break;
    //                             }
    //                         } else {
    //                             $assign_to_user_id = NULL;
    //                             break;
    //                         }
    //                     }
    //                 }
    //             }
    //         }

    //         $data['query_type_id'] = $cust->query_type_id;
    //         $data['priority'] = $cust->priority;
    //         $data['assign_to_department_id'] = $cust->department_id;
    //         $data['confirmation_required'] = $cust->confirmation_required;
    //         $data['assign_to_user_id'] = $assign_to_user_id;

    //         return $data;
    //     } else {
    //         return;
    //     }
    // }

    public function getMappingData($mappingId, $tenantId)   //98
    {
        // $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        // $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = array();
        $cust = DB::table('tai_customer_mapping')->where('is_active', 1)->where('id', $mappingId)->where('tenant_id', $tenantId)->first();
        // return $cust;
        if ($cust) {

            //SINGLE PESON APPROACH
            if ($cust->approach == "SP") {
                $assign_to_user_id = $cust->user_policy;
                // return $assign_to_user_id;
                $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
                    ->where('is_active', 1)->first();

                $assign_to_user_id = $users ? $users->user_id : NULL;
            }

            //DEPARTMENT WISE ROUND ROBIN APPROACH
            if ($cust->approach == "RR") {
                // $assigned_to = explode(',', $cust->user_policy);
                // $last_entry = DB::table('tai_ticket_master')->whereIn('assign_to_user_id', $assigned_to)
                //                                             ->orderBy('id', 'DESC')
                //                                             ->limit(1)
                //                                             ->first();
                // $nextKey = 0;
                // foreach ($assigned_to  as $key => $value) {
                //     if ($last_entry) {
                //         if ($last_entry->assign_to_user_id == $value) {
                //             $nextKey = $key + 1;
                //             if ($nextKey >= count($assigned_to)) {
                //                 $nextKey = 0;
                //             }
                //             break;
                //         }
                //     }
                // }
                // $assign_to_user_id = $assigned_to[$nextKey];

                $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
                    ->where('last_issued_ticket', 0)
                    ->where('is_active', 1)
                    ->orderBy('id')
                    ->first();
                if ($users) {
                    $assign_to_user_id = $users->user_id;
                    DB::table('tai_customer_user_mapping')->where('id', $users->id)->update(['last_issued_ticket' => 1]);
                } else {
                    DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
                        ->update(['last_issued_ticket' => 0]);

                    $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
                        ->where('last_issued_ticket', 0)
                        ->where('is_active', 1)
                        ->orderBy('id')
                        ->first();
                    $assign_to_user_id = $users->user_id;
                    DB::table('tai_customer_user_mapping')->where('id', $users->id)->update(['last_issued_ticket' => 1]);
                }
            }

            //HAVING LESS TICKET APPROACH
            if ($cust->approach == "HLT" && $cust->user_policy) {
                // $cust->user_policy = str_replace(']', "", str_replace('[', "", str_replace('"', "", $cust->user_policy)));

                // $query = "SELECT assign_to_user_id,count(id) as less_ticket FROM tai_ticket_master where assign_to_user_id in ($cust->user_policy) GROUP BY assign_to_user_id order by less_ticket limit 1";
                // $lessAssignedUser = DB::SELECT(DB::RAW($query));
                // if(count($lessAssignedUser)){
                //     $assign_to_user_id = $lessAssignedUser ? $lessAssignedUser[0]->assign_to_user_id : '';
                // }else{
                //     $user=explode(",",$cust->user_policy);
                //     $assign_to_user_id = $user[0];
                // }

                // old
                // $users = DB::table('tai_customer_user_mapping')->where('tai_customer_mapping_id', $cust->id)
                //     ->where('is_active', 1)
                //     ->orderBy('id')
                //     ->get();
                // $userArray = [];
                // foreach ($users as $u) {
                //     $totalAssign = DB::Select(DB::raw("Select count(*) as totalAssign from tai_ticket_master where status_id!=3 and is_active = 1 and assign_to_user_id = $u->user_id"));

                //     $userArray[$u->user_id] = count($totalAssign) ? $totalAssign[0]->totalAssign : 0;
                // }


                // $minDiff = min($userArray);

                // $assignToUserArray = array_filter($userArray, function ($i) use ($minDiff) {
                //     return $minDiff === $i;
                // });
                // $keys = array_keys($assignToUserArray);
                // $assign_to_user_id = $keys[0];

                // updated by punam Shinde Date: 30-03-2023
                $users = DB::table('tai_customer_user_mapping')
                    ->where('tai_customer_mapping_id', $cust->id)
                    ->where('is_active', 1)
                    ->orderBy('id')
                    ->pluck('user_id');

                // dd($users);
                $userArray = [];
                if (count($users) > 0) {
                    $totalAssign = DB::table('tai_ticket_master')
                        ->select('assign_to_user_id', DB::raw('COUNT(*) as totalAssign'))
                        ->where('status_id', '!=', 3)
                        ->where('is_active', 1)
                        ->where('tenant_id', $tenantId)
                        ->whereIn('assign_to_user_id', $users)
                        ->groupby('assign_to_user_id')
                        ->orderBy('totalAssign')
                        ->first();
                    // dd($totalAssign);

                    // $userArray = [];
                    // foreach ($totalAssign as $key => $value) {
                    //     $userArray[$value->assign_to_user_id] = $value->totalAssign;
                    // }
                    // $min_count = min($userArray);
                    // $min_count_users = array_keys($userArray, $min_count);

                    // foreach ($min_count_users as $user_id) {
                    //     $assign_to_user_id = $user_id;
                    //     break;
                    // }
                    if ($totalAssign) {
                        $assign_to_user_id = $totalAssign->assign_to_user_id;
                    } else {
                        $assign_to_user_id = NULL;
                    }
                } else {
                    $assign_to_user_id = NULL;
                }
            }


            // Date 20/02/2023 bhushan Patel add RW logic
            if ($cust->approach == "RW") {

                $totalTickets = DB::Select(DB::raw("Select count(*) as totalTickets from tai_ticket_master where is_active = 1 AND assign_to_department_id=$cust->department_id"));
                $tempCustomer = [];


                // foreach ($cust->user_policy as $key => $customer) {
                //     $temp = explode(':', $customer);
                //     if ($temp[1]) {
                //         $tempCustomer[$temp[0]] = (int)$temp[1];
                //     }
                // }


                $user_policy = DB::table('tai_customer_user_mapping as m')
                    ->leftJoin('tai_employee_master as e', 'e.id', 'm.user_id')
                    ->where('m.tai_customer_mapping_id', $cust->id)
                    ->where('m.is_active', 1)
                    ->where('e.is_active', 1)
                    // ->orderBy('m.order_by', 'ASC')
                    ->orderBy('m.percentage', 'DESC')
                    ->select('user_id', 'percentage')
                    ->get();
                foreach ($user_policy as $u) {
                    $tempCustomer[$u->user_id] = $u->percentage;
                }
                $cust->user_policy = $tempCustomer;

                arsort($tempCustomer);

                $customer_arr = [];
                $tempAssign = [];

                // dd($user_policy);
                $assign_to_user_id = array_key_first($tempCustomer);
                foreach ($tempCustomer as $key => $row) {

                    if ($row > 0) {
                        $totalAssign = DB::Select(DB::raw("Select count(*) as totalAssign from tai_ticket_master where is_active =1 AND assign_to_user_id = $key AND tenant_id = $tenantId "));
                        $ratioTemp = (int)$row;
                        $totalTicketsTemp = $totalTickets[0]->totalTickets;
                        if ($totalTicketsTemp != 0) {
                            $totalAssignTicketsTemp = (int)$totalAssign[0]->totalAssign;
                            // $calculatedRatioTemp = ($totalAssign[0]->totalAssign * $totalTickets[0]->totalTickets) / 100;
                            $calculatedRatioTemp = ($totalAssign[0]->totalAssign * 100) / $totalTickets[0]->totalTickets;
                            $totalDiffTemp = (int) $ratioTemp - $calculatedRatioTemp;

                            if ($totalAssignTicketsTemp == 0) {
                                $totalDiffTemp = 0;
                            }

                            if ($totalDiffTemp >= 0) {

                                $customer_arr[$key]["ratio"] = $ratioTemp;
                                $customer_arr[$key]["totalTickets"] = $totalTicketsTemp;
                                $customer_arr[$key]["totalAssignTickets"] = $totalAssignTicketsTemp;
                                $customer_arr[$key]["calcuatedRatio"] = $calculatedRatioTemp;
                                $customer_arr[$key]["totalDiff"] = $totalDiffTemp;
                            }

                            if ($row > $calculatedRatioTemp) {
                                $assign_to_user_id = $key;
                                break;
                            }
                        } else {
                            $assign_to_user_id = $key;
                            break;
                        }
                    }
                }

                // if (count($customer_arr) > 0) {
                //     $minDiff = min(array_column($customer_arr, 'totalDiff'));
                //     $assignToUserArray = array_filter($customer_arr, function ($i) use ($minDiff) {
                //         return $minDiff === $i['totalDiff'];
                //     });
                //     $keys = array_keys($assignToUserArray);
                //     $assign_to_user_id = $keys[0];
                // } else {
                //     $assign_to_user_id = array_key_first($tempCustomer);
                // }


                // foreach($customer_arr as $key => $value){
                //     if ($value["ratio"] > $value["ratioValue"]) {
                //         $assign_to_user_id = $key;
                //         break;
                //     }   
                // }
            }

            $data['query_type_id'] = $cust->query_type_id;
            $data['priority'] = $cust->priority;
            $data['assign_to_department_id'] = $cust->department_id;
            // $data['confirmation_required'] = $cust->confirmation_required;
            $data['assign_to_user_id'] = $assign_to_user_id;

            return $data;
        } else {
            return;
        }
    }

    public function ticketSeries()
    {
        $series = "TT";
        $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
        if (!$lastTicket) {
            $ticket_id = "2022";
        } else {
            $a = substr($lastTicket->ticket_id, 2);
            $ticket_id = (int)$a + 1;
        }
        return $series . $ticket_id;
    }

    public function mapDynamicFormAndData($data, $query_type_id, $where = NULL)
    {
        //1.Compare actual columns required with all form data

        $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
        $additionalColumns = ["attachment", "customer_mapping_id", "bulk_upload_file", "ticket_uploading"];
        $ticketColumns = array_merge($additionalColumns, $ticketColumns);

        //2.Filter and genrate dynamic form data received in request
        $dynamicForm = array();
        foreach ($data as $key => $value) {
            if (!in_array($key, $ticketColumns)) {
                $t = $where ? strtolower(str_replace(" ", "_", $key)) : $key;
                $dynamicForm[$t] = $value;
                unset($data[$key]);
            }
        }

        // $dynamicFormData = [];

        $dataForm = "";
        //Check dynamic form id is present in customer mapping if present then use this id else chekc in qurey type master and get form
        $dynamicFormData = DB::table('tai_customer_mapping as map')->join('tai_dynamic_form as d', 'd.id', '=', 'map.dynamic_form_id')
            ->where('map.query_type_id', $query_type_id)
            ->select('d.data')
            ->first();
        if ($dynamicFormData) {
            $dataForm = $dynamicFormData->data;
        }

        if (!$dataForm) {
            $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                ->where('t.id', $query_type_id)
                ->select('d.data')
                ->first();
            if ($dynamicFormData) {
                $dataForm = $dynamicFormData->data;
            }
        }

        if ($dataForm) {
            // $form = json_decode($dynamicFormData->data);
            $form = json_decode($dataForm);

            //4.  Loop throuh json form
            //5.  inputAddOn will have array exclude from comparison
            //6.  compare value only if key=inputName;
            //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
            //8.   array_key is used to check the name is present in dynamicform array generated in step 2
            //9.  If value matches then change the value in object named as inputValue
            //10. Dynamic Form Json will be read


            foreach ($form as $key => $value) {
                foreach ($value as $k => $v) {
                    if ($k != "inputAddOn") {
                        if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                            $form[$key]->inputDefaultValue = $dynamicForm[$v];
                        }
                    }
                }
            }
            return ["status" => 1, "data" => $form];
        }
        return ["status" => 0, "data" => "Mapping Failed !!!"];
    }


    public function mongoDB($id, $ticket_id, $data, $object_id = NULL)
    {
        if ($data) {
            foreach ($data as $d) {
                if (property_exists($d, 'dropdownSourceData')) {
                    $d->dropdownSourceData = null;
                }
            }
        }

        if (!$object_id) {
            $a = new DynamicForm();
            $a->id = $id;
            $a->ticket_id = $ticket_id;
            $a->dynamic_data = $data;
            $a->save();
            DB::table('tai_ticket_master')->where('id', $id)->update(['object_id' => $a->_id]);
            return $a->_id;
        } else {
            return DynamicForm::where('_id', $object_id)->update(['dynamic_data' => $data]);
        }
    }

    public function checkAutoPassTicket($user_id, $department_id)
    {

        $checkPassingAuthority = DB::table('tai_employee_department_mapping')
            ->where('employee_id', $user_id)
            ->where('department_id', $department_id)
            ->where('is_active', 1)
            ->first();

        return $checkPassingAuthority->ticket_passing_authority == 1 ? 1 : 0;
    }

    // punam shinde date : 10-05-2023   
    // working code hide for testing with latest dynamic form
    // public function createTicket(Request $request)
    // {
    //     $data = $request->toArray();
    //     // return [$data['dynamic_form']];

    //     if ($request->ticket_uploading == "REGULAR") {

    //         if (!$request->from_department_id) {
    //             return response()->json(["status" => 0, "message" => "Department not found !!!", "data" => null]);
    //         }
    //         if (!$request->created_by) {
    //             return response()->json(["status" => 0, "message" => "Created User not found !!!", "data" => null]);
    //         }
    //         if (!$request->customer_mapping_id) {
    //             return response()->json(["status" => 0, "message" => "Mapping not found !!!", "data" => null]);
    //         }
    //         if (!$request->query_type_id) {
    //             return response()->json(["status" => 0, "message" => "Query Mapping not found !!!", "data" => null]);
    //         }

    //         $mainData['ticket_id'] = $this->ticketSeries();
    //         $mainData['tenant_id'] = $request->tenant_id ?  $request->tenant_id : 1;
    //         $mainData['query_type_id'] = $request->query_type_id;
    //         $mainData['cuid'] = $request->cuid;
    //         $mainData['description'] = $request->description;
    //         $mainData['ticket_date'] = date("Y-m-d");
    //         $mainData['status_id'] = 1;
    //         $mainData['from_department_id'] = $request->from_department_id;
    //         $mainData['assign_to_user_id'] = $request->assign_to_user_id;
    //         // $mainData['confirmation_required'] = $request->confirmation_required; 
    //         $mainData['created_by'] = $request->created_by;
    //         $mainData['created_at'] = $request->created_at;

    //         // please map user before submitting
    //         $customerMapping = $this->getMappingData($request->customer_mapping_id);

    //         // return $customerMapping;

    //         if ($customerMapping && $customerMapping["assign_to_user_id"] && $customerMapping["assign_to_user_id"] != NULL) {
    //             $mainData = array_merge($mainData, $customerMapping);
    //         } else {
    //             return response()->json(["status" => 0, "message" => "Error while assigning to user !!!", "data" => null]);
    //         }

    //         $mainData["priority"] = $request->priority ? $request->priority : $mainData["priority"];


    //         //If user has authority then ticket will automatically PASS
    //         $checkAuth = $this->checkAutoPassTicket($data['created_by'], $data['from_department_id']);
    //         if ($checkAuth == 1) {
    //             $mainData['passed_status'] = "PASS";
    //             $mainData['passed_status_changed_by'] = $mainData['created_by'];
    //             $mainData['passed_status_remark'] = "AUTO PASS";
    //             $mainData['passed_status_changed_at'] = now();
    //         }

    //         $mainData['confirmation_required'] = $request->confirmation_required;

    //         // dd($mainData);
    //         $ticket_inserted_id = DB::table("tai_ticket_master")->insertGetId($mainData);

    //         if ($ticket_inserted_id){
    //             if ($request->dynamic_form){
    //                 $request->dynamic_form = is_array($request->dynamic_form) ? $request->dynamic_form : json_decode($request->dynamic_form);
    //                 $object_id = $this->mongoDB($ticket_inserted_id, $mainData['ticket_id'], $request->dynamic_form);
    //                 // dd($object_id);
    //             }

    //             //If Upload has attachment then upload
    //             if ($request->file("attachment")) {
    //                 CommonController::uploadAttachment($ticket_inserted_id, $request->attachment, "TICKET", $request->created_at);
    //             }

    //             //OWNERSHIP
    //             // OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], $data['project_id'], $result, 0, 0);                
    //             OwnershipController::mapping('Insert', 'TICKET', $mainData['assign_to_user_id'], 0, $ticket_inserted_id, 0, 0);


    //             CommonController::generateHistory("INSERT", 'tai_ticket_master', $ticket_inserted_id);

    //             //Add Notification for user
    //             $userInfo = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);
    //             $msg = "Ticket " . $mainData["ticket_id"] . " has been assigned by " . $userInfo->first_name . " " . $userInfo->last_name;
    //             $url = "Ticket/View/" . $mainData['ticket_id'];
    //             CommonController::addNotification($mainData["created_by"], $mainData["assign_to_user_id"], $msg, $url);
    //             CommonController::addNotification($mainData["assign_to_user_id"], $mainData["created_by"], $msg, $url);

    //             return response()->json(["status" => 1, "message" => 'Ticket - ' . $mainData["ticket_id"] . ' has been created !!!', "data" => $object_id]);
    //         } else {
    //             return response()->json(["status" => 0, "message" => "Record Not Inserted !!!", "data" => null]);
    //         }
    //     } else {
    //         //BULK UPLOAD
    //         $success = 0;
    //         $fail = 0;


    //         if (!$request->file('bulk_upload_file')) {
    //             return response()->json(["status" => 0, "message" => "Upload file for processing !!!", "data" => null]);
    //         }
    //         $fileExtension = $request->file('bulk_upload_file')->getClientOriginalExtension();
    //         $requiredExtension = ['csv'];
    //         if (!in_array($fileExtension, $requiredExtension)) {
    //             return response()->json(["status" => 0, "message" => "Required Only  " . implode(',', $requiredExtension) . " !!!", "data" => null]);
    //         }

    //         $ticket = array();
    //         $uploadData = \Excel::toArray(null, $request->file('bulk_upload_file'));
    //         $header = $uploadData[0][0];        //Consider 1st row as header

    //         // return [$uploadData, $request->all()];

    //         foreach ($header as $k => $v) {
    //             if ($v == "query_type") {
    //                 $header[$k] = "query_type_id";
    //             }
    //             if ($v == "ref_id") {
    //                 $header[$k] = "cuid";
    //             }
    //         }

    //         $data = $uploadData[0];   // All Data Expect 1st Index
    //         unset($data[0]);
    //         if (count($data) < 1) {
    //             return response()->json(["status" => 0, "message" => "File Is Empty or Missing Headers!!!", "data" => null]);
    //         }

    //         foreach ($data as $key => $value) {
    //             $data[$key] = array_combine($header, $value);
    //         }
    //         $exceptionData = [];

    //         foreach ($data as $d) {

    //             $flag = 0;
    //             $error = [];
    //             if (array_key_exists('remark', $d)) {
    //                 unset($d['remark']);
    //             }

    //             $queryType = DB::table('tai_query_type_master')->where('query_type_name', $d['query_type_id'])->first();
    //             if ($queryType) {
    //                 $customer_mapping = DB::table('tai_customer_mapping')->where('query_type_id', $queryType->id)->first();
    //                 // return [$customer_mapping];
    //                 if ($customer_mapping) {

    //                     $customerMapping = $this->getMappingData($customer_mapping->id);
    //                     // return [$customerMapping['priority']];

    //                     // $ticket['priority'] = $customer_mapping->priority; 

    //                     if (array_key_exists('priority', $d)) {
    //                         $priority_array = ['Low', 'High', 'Medium', 'Very High'];
    //                         if ($d['priority']) {
    //                             $d['priority'] = ucwords(strtolower($d['priority']));

    //                             if (in_array($d['priority'], $priority_array)) {
    //                                 $ticket['priority'] = $d['priority'];
    //                             } else {
    //                                 $error[] = 'Invalid Priority';
    //                             }
    //                         } else {
    //                             $ticket['priority'] = $customerMapping['priority'];
    //                         }
    //                     } else {
    //                         $ticket['priority'] = $customerMapping['priority']; //punam
    //                     }


    //                     if ($customerMapping && $customerMapping["assign_to_user_id"] && $customerMapping["assign_to_user_id"] != NULL) {
    //                         $ticket = array_merge($ticket, $customerMapping);
    //                     }
    //                     $dynamicForm = $this->mapDynamicFormAndData($d, $queryType->id, "BULK");
    //                     if ($dynamicForm['status'] == 0) {
    //                         $error[] = $dynamicForm['data'];
    //                     }


    //                     // return [$d['confirmation_required']];
    //                     if ($d['confirmation_required']) {
    //                         $yesArray = ["YES", "Yes", "yes"];
    //                         $noArray = ['NO', 'No', 'no'];
    //                         if (in_array($d['confirmation_required'], $yesArray)) {
    //                             $ticket['confirmation_required'] = 1;
    //                         } elseif (in_array($d['confirmation_required'], $noArray)) {
    //                             $ticket['confirmation_required'] = 0;
    //                         }
    //                     } else {
    //                         $ticket['confirmation_required'] = $customerMapping['confirmation_required'];  //punam
    //                     }

    //                     // dd($ticket);
    //                     if (count($error) == 0) {
    //                         $ticket['cuid'] = $d['cuid'] ? $d['cuid'] : NULL;
    //                         $ticket['description'] = $d['description'];
    //                         $ticket['ticket_id'] = $this->ticketSeries();
    //                         $ticket['ticket_date'] = date('Y-m-d');
    //                         $ticket['status_id'] = 1;
    //                         $ticket['created_at'] = $request->created_at;
    //                         $ticket['created_by'] = $request->created_by;
    //                         $ticket['tenant_id'] = $request->tenant_id;
    //                         $ticket['from_department_id'] = $request->from_department_id;

    //                         //If user has authority then ticket will automatically PASS
    //                         $checkAuth = $this->checkAutoPassTicket($ticket['created_by'], $ticket['from_department_id']);
    //                         if ($checkAuth == 1) {
    //                             $ticket['passed_status'] = "PASS";
    //                             $ticket['passed_status_changed_by'] = $ticket['created_by'];
    //                             $ticket['passed_status_remark'] = "AUTO PASS";
    //                             $ticket['passed_status_changed_at'] = now();
    //                         }

    //                         $ticket_inserted_id = DB::table("tai_ticket_master")->insertGetId($ticket);
    //                         if ($ticket_inserted_id) {

    //                             $success++;

    //                             if (count($dynamicForm) && $dynamicForm['status'] == 1) {
    //                                 $object_id = $this->mongoDB($ticket_inserted_id, $ticket['ticket_id'], $dynamicForm['data']);
    //                             }

    //                             CommonController::generateHistory("INSERT", 'tai_ticket_master', $ticket_inserted_id);
    //                         }
    //                     } //CHECK ERRROR COUNT
    //                 } else { //CUSTOMER MAPPING
    //                     $error[] = "Unable to find mapping";
    //                 }
    //             } else {
    //                 $error[] = "Unable to find query type";
    //             } //QUERY TYPE END 

    //             if (count($error)) {
    //                 $d['remark'] = implode(',', $error);
    //                 $exceptionData[] = $d;
    //             }
    //         }    //FOR LOOP

    //         if (count($exceptionData) > 0) {
    //             $delimeter = ',';
    //             $filename = 'create_ticket_error_file' . date('YmdHis') . '.csv';
    //             $f = fopen(storage_path('app/' . $filename), 'w');

    //             $header = array_merge($header, array('error_remark'));

    //             // foreach ($header as $key => $value) {
    //             //     $header[$key] = str_replace('_', ' ', ucwords($value));
    //             // }

    //             fputcsv($f, $header, $delimeter);
    //             foreach ($exceptionData as $d) {
    //                 fputcsv($f, array_values($d), $delimeter);
    //             }
    //             fclose($f);
    //             $message = 'Download Error File';
    //             $type = 'danger';

    //             return response()->json(["status" => 0, "message" => "Found Error in File !!!", "data" => "storage/app/" . $filename]);
    //         } else {
    //             return response()->json(["status" => 1, "message" => "$success Tickets Created !!!", "data" => null]);
    //         }
    //     }
    // }

    // punam shinde date : 10-05-2023   
    // live ticket code -> paste here for testing purposes
    public function createTicket(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();

        if ($request->ticket_uploading == "REGULAR") {

            if (!$request->from_department_id) {
                return response()->json(["status" => 0, "message" => "Department not found !!!", "data" => null]);
            }
            if (!$request->created_by) {
                return response()->json(["status" => 0, "message" => "Created User not found !!!", "data" => null]);
            }
            if (!$request->customer_mapping_id) {
                return response()->json(["status" => 0, "message" => "Mapping not found !!!", "data" => null]);
            }
            if (!$request->query_type_id) {
                return response()->json(["status" => 0, "message" => "Query Mapping not found !!!", "data" => null]);
            }

            $mainData['ticket_id'] = $this->ticketSeries();
            $data['ticket_id'] = $mainData['ticket_id'];

            $mainData['tenant_id'] = $tenantId;
            // $mainData['customer_id'] = $customerId;
            $mainData['query_type_id'] = $request->query_type_id;
            $mainData['cuid'] = $request->cuid;
            $mainData['description'] = $request->description;
            $mainData['expected_solve_date'] = $request->expected_solve_date;
            $mainData['ticket_date'] = date("Y-m-d");
            $mainData['status_id'] = 1;
            $mainData['from_department_id'] = $request->from_department_id;
            $mainData['assign_to_user_id'] = $request->assign_to_user_id;
            $mainData['confirmation_required'] = $request->confirmation_required == 0 ? $request->confirmation_required : 1;
            $mainData['created_by'] = $request->created_by;
            $mainData['created_at'] = $request->created_at;

            // please map user before submitting
            $customerMapping = $this->getMappingData($request->customer_mapping_id, $tenantId);

            if ($customerMapping && $customerMapping["assign_to_user_id"] && $customerMapping["assign_to_user_id"] != NULL) {
                $mainData = array_merge($mainData, $customerMapping);
            } else {
                return response()->json(["status" => 0, "message" => "Error while assigning to user !!!", "data" => null]);
            }

            $submitToMongo = NULL;
            if ($request->query_type_id) {
                //LOGIN
                //1.Compare actual columns required with all form data
                $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
                $ticketColumns[] = "attachment";

                //2.Filter and genrate dynamic form data received in request
                $dynamicForm = array();
                foreach ($data as $key => $value) {
                    if (!in_array($key, $ticketColumns)) {
                        $dynamicForm[$key] = $value;
                        unset($data[$key]);
                    }
                }
                //3. Get actual json form
                $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                    ->where('t.id', $request->query_type_id)
                    ->where('t.tenant_id', $tenantId)
                    ->select('d.data')
                    ->first();
                if ($dynamicFormData) {
                    $form = json_decode($dynamicFormData->data);
                    //4.  Loop throuh json form
                    //5.  inputAddOn will have array exclude from comparison
                    //6.  compare value only if key=inputName;
                    //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
                    //8.   array_key is used to check the name is present in dynamicform array generated in step 2
                    //9.  If value matches then change the value in object named as inputValue
                    //10. Dynamic Form Json will be read
                    // dd($form);
                    if ($form != null) {
                        foreach ($form as $key => $value) {
                            foreach ($value as $k => $v) {
                                if ($k != "inputAddOn") {
                                    if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                                        if (strpos($dynamicForm[$v], "|") !== false) {
                                            $form[$key]->inputDefaultValue = explode("|", $dynamicForm[$v])[1];
                                            $form[$key]->inputDefaultId = explode("|", $dynamicForm[$v])[0];
                                            $form[$key]->value = explode("|", $dynamicForm[$v])[1];
                                        } else {
                                            $form[$key]->inputDefaultValue = $dynamicForm[$v];
                                            $form[$key]->value = $dynamicForm[$v];
                                        }
                                    }
                                }
                            }
                        }
                    } else {
                        return response()->json(["status" => 0, "message" => "Invalid dynamic form !!!", "data" => null]);
                    }


                    $submitToMongo = json_encode($form);
                    $submitToMongo = $form;
                }
            }
            unset($data["attachment"]);


            $mainData["priority"] = $request->priority ? $request->priority : $mainData["priority"];


            //If user has authority then ticket will automatically PASS
            $checkAuth = $this->checkAutoPassTicket($data['created_by'], $data['from_department_id']);
            if ($checkAuth == 1 || $request->query_type_id == 70) {
                $mainData['passed_status'] = "PASS";
                $mainData['passed_status_changed_by'] = $mainData['created_by'];
                $mainData['passed_status_remark'] = "AUTO PASS";
                $mainData['passed_status_changed_at'] = now();
            }


            $ticket_inserted_id = DB::table("tai_ticket_master")->insertGetId($mainData);

            if ($ticket_inserted_id) {

                //TT9526  date:27/06/2023 PUNAM SHINDE
                // Auto basket and task  
                $cust = DB::table('tai_customer_mapping')->where('is_active', 1)->where('id', $request->customer_mapping_id)->where('tenant_id', $tenantId)->first();

                if ($cust) {

                    $temaplet_detail = DB::table("tai_template_master as tm")
                        ->where('tenant_id', $tenantId)
                        ->where("id", $cust->template_id)
                        ->where("is_active", 1)
                        ->first();


                    if ($temaplet_detail) {
                        $templateBasket = DB::table("tai_template_basket")->where("template_id", $cust->template_id)->where("is_active", 1)->get();

                        foreach ($templateBasket as $b) {

                            $basketdata = [
                                "ticket_id" => $ticket_inserted_id,
                                "basket_name" => array($b->basket_name),
                                "basket_owner" => array($b->basket_owner),
                                "start_date" => array(now()),
                                "end_date" => array($request->expected_solve_date),
                                "source" => 'AFTER_TICKET_INSERT',
                                'tenant_id' => $tenantId,
                                'created_at' => now(),
                                'is_active' => 1,
                                'created_by' => $request->created_by
                            ];
                            // dd($basketdata);
                            $request_data = new Request($basketdata);
                            $basketController = new TicketBasketController();
                            $basketId = $basketController->createBasket($request_data);
                            $basket_response = json_decode(json_encode($basketId));

                            if ($basket_response->original->status == 1) {
                                $tasklist = DB::table('tai_template_basket_task as ts')
                                    ->where('ts.template_basket_id', $b->id)
                                    ->get();

                                if ($tasklist && count($tasklist)) {
                                    foreach ($tasklist as $task) {
                                        // dd($task);
                                        // task hours
                                        $duration = \Carbon\CarbonInterval::hours($task->total_time)->cascade();
                                        // Format the duration as "hh:mm"
                                        $durationFormatted = $duration->format('%H:%I');

                                        // cinvert into minut
                                        $duration_in_hr = $duration->format('%H:%I');
                                        $duration_in_hr = new DateInterval('PT2H30M');
                                        $totalMinutes = ($duration_in_hr->h * 60) + $duration_in_hr->i;

                                        if ($temaplet_detail->calculate_from == 'START_FROM') {
                                            $daysRequired = $task->days;
                                            $startDays = $task->start_days;
                                            $startDateString = date('Y-m-d');

                                            // Create Carbon instances for start date and end date
                                            $startDate = \Carbon\Carbon::createFromFormat('Y-m-d', $startDateString);
                                            $endDate = $startDate->copy()->addDays($startDays)->addDays($daysRequired - 1)->format('Y-m-d');

                                            $startDate = $startDate->copy()->addDays($startDays)->format('Y-m-d');
                                            // ---------------
                                        } else {
                                            $daysRequired = $task->days;
                                            $daysToAdd = $task->start_days;

                                            $expectedSolvedDate = $request->expected_solve_date;

                                            $endDate = date('Y-m-d', strtotime($expectedSolvedDate . ' -' . $daysToAdd . ' days'));
                                            $startDate = date('Y-m-d', strtotime($endDate . ' -' . ($daysRequired - 1) . ' days'));
                                        }


                                        $insertion = [
                                            'tenant_id' => $tenantId,
                                            'ticket_id' => $ticket_inserted_id,
                                            'ticket_basket_id' => $basket_response->original->data,
                                            'task_name' => $task->task,
                                            'task_desc' => '',
                                            'task_hours' => $task->total_time, // $durationFormatted,
                                            'task_hours_in_min' => $totalMinutes,
                                            'priority' => 'Medium',
                                            "start_date" => $startDate,
                                            "end_date" =>  $endDate,
                                            'type' => 'TASK',
                                            'status' => 'TO_DO',
                                            'is_active' => 1,
                                            'created_at' => now(),
                                            'created_by' => $request->created_by,
                                            'assign_to_user' => array($b->basket_owner),
                                        ];

                                        $request_task_data = new Request($insertion);
                                        $taskController = new TicketTaskController();
                                        $taskId = $taskController->postData($request_task_data);
                                    }
                                }
                            }
                        }
                    }
                }
                // /------------------------------------------------end --------------------

                if ($submitToMongo) {
                    $a = new DynamicForm();
                    $a->id = $ticket_inserted_id;
                    $a->ticket_id = $data["ticket_id"];
                    $a->dynamic_data = $submitToMongo;
                    $a->save();
                    DB::table('tai_ticket_master')->where('id', $ticket_inserted_id)->update(['object_id' => $a->_id]);
                }
                //NEW OLD
                // if ($request->dynamic_form) 
                // {
                //     $request->dynamic_form = is_array($request->dynamic_form) ? $request->dynamic_form : json_decode($request->dynamic_form);
                //     $object_id = $this->mongoDB($ticket_inserted_id, $mainData['ticket_id'], $request->dynamic_form);
                // }

                //If Upload has attachment then upload
                if ($request->file("attachment")) {
                    CommonController::uploadAttachment($ticket_inserted_id, $request->attachment, "TICKET", $request->created_at);
                }

                //Add Notification for user
                // $userInfo = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);
                // $msg = "Ticket " . $data["ticket_id"] . " has been assigned by " . $userInfo->first_name . " " . $userInfo->last_name;
                // $url = "Ticket/" . $result;
                // CommonController::addNotification($data["created_by"], $data["assign_to_user_id"], $msg, $url);
                // CommonController::addNotification($data["created_by"], $checkPassingAuthority->employee_id, $msg, $url);

                //OWNERSHIP
                // OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], $data['project_id'], $result, 0, 0);                
                OwnershipController::mapping('Insert', 'TICKET', $mainData['assign_to_user_id'], 0, $ticket_inserted_id, 0, 0, $tenantId);


                CommonController::generateHistory("INSERT", 'tai_ticket_master', $ticket_inserted_id);

                return response()->json(["status" => 1, "message" => 'Ticket - ' . $mainData["ticket_id"] . ' has been created !!!', "data" => null]);
            } else {
                return response()->json(["status" => 0, "message" => "Record Not Inserted !!!", "data" => null]);
            }
        } else {
            //BULK UPLOAD
            $success = 0;
            $fail = 0;

            if (!$request->file('bulk_upload_file')) {
                return response()->json(["status" => 0, "message" => "Upload file for processing !!!", "data" => null]);
            }
            $fileExtension = $request->file('bulk_upload_file')->getClientOriginalExtension();
            $requiredExtension = ['csv'];
            if (!in_array($fileExtension, $requiredExtension)) {
                return response()->json(["status" => 0, "message" => "Required Only  " . implode(',', $requiredExtension) . " !!!", "data" => null]);
            }

            $ticket = array();
            $uploadData = \Excel::toArray(null, $request->file('bulk_upload_file'));
            $header = $uploadData[0][0];        //Consider 1st row as header

            // return [$uploadData, $request->all()];

            foreach ($header as $k => $v) {
                if ($v == "query_type") {
                    $header[$k] = "query_type_id";
                }
                if ($v == "ref_id") {
                    $header[$k] = "cuid";
                }
            }

            $data = $uploadData[0];   // All Data Expect 1st Index
            unset($data[0]);
            if (count($data) < 1) {
                return response()->json(["status" => 0, "message" => "File Is Empty or Missing Headers!!!", "data" => null]);
            }

            foreach ($data as $key => $value) {
                $data[$key] = array_combine($header, $value);
            }
            $exceptionData = [];

            foreach ($data as $d) {

                $flag = 0;
                $error = [];
                if (array_key_exists('remark', $d)) {
                    unset($d['remark']);
                }

                $queryType = DB::table('tai_query_type_master')->where('query_type_name', $d['query_type_id'])->first();
                if ($queryType) {
                    $customer_mapping = DB::table('tai_customer_mapping')->where('query_type_id', $queryType->id)->first();
                    // return [$customer_mapping];
                    if ($customer_mapping) {

                        $customerMapping = $this->getMappingData($customer_mapping->id, $tenantId);
                        // return [$customerMapping['priority']];

                        // $ticket['priority'] = $customer_mapping->priority; 

                        if (array_key_exists('priority', $d)) {
                            $priority_array = ['Low', 'High', 'Medium', 'Very High'];
                            if ($d['priority']) {
                                $d['priority'] = ucwords(strtolower($d['priority']));

                                if (in_array($d['priority'], $priority_array)) {
                                    $ticket['priority'] = $d['priority'];
                                } else {
                                    $error[] = 'Invalid Priority';
                                }
                            } else {
                                $ticket['priority'] = $customerMapping['priority'];
                            }
                        } else {
                            $ticket['priority'] = $customerMapping['priority']; //punam
                        }
                        if ($customerMapping && $customerMapping["assign_to_user_id"] && $customerMapping["assign_to_user_id"] != NULL) {
                            $ticket = array_merge($ticket, $customerMapping);
                        }

                        // $dynamicForm = $this->mapDynamicFormAndData($d, $queryType->id, "BULK");
                        // if ($dynamicForm['status'] == 0) {
                        //     $error[] = $dynamicForm['data'];
                        // }
                        $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
                        $additionalColumns = ["attachment", "customer_mapping_id", "bulk_upload_file", "ticket_uploading"];
                        $ticketColumns = array_merge($additionalColumns, $ticketColumns);
                        //2.Filter and genrate dynamic form data received in request
                        $dynamicForm = array();
                        foreach ($d as $key => $value) {
                            if (!in_array($key, $ticketColumns)) {
                                $t = strtolower(str_replace(" ", "_", $key));
                                $dynamicForm[$t] = $value;
                                unset($d[$key]);
                            }
                        }
                        $dataForm = "";
                        $dynamicFormData = DB::table('tai_customer_mapping as map')
                            ->join('tai_dynamic_form as d', 'd.id', '=', 'map.dynamic_form_id')
                            ->where('map.query_type_id', $queryType->id)
                            ->select('d.data')
                            ->first();
                        if ($dynamicFormData) {
                            $dataForm = $dynamicFormData->data;
                        }

                        if (!$dataForm) {
                            $dynamicFormData = DB::table('tai_query_type_master as t')
                                ->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                                ->where('t.id', $query_type_id)
                                ->select('d.data')
                                ->first();
                            if ($dynamicFormData) {
                                $dataForm = $dynamicFormData->data;
                            }
                        }

                        if ($dataForm) {
                            $submitToMongo = json_decode($dataForm);
                            foreach ($submitToMongo as $key => $value) {
                                foreach ($value as $k => $v) {
                                    if ($k != "inputAddOn") {
                                        if ($k === "inputName" && in_array($submitToMongo[$key]->inputName, array_keys($dynamicForm))) {
                                            $submitToMongo[$key]->inputDefaultValue = $dynamicForm[$v];
                                        }
                                    }
                                }
                            }
                        }

                        if ($d['confirmation_required']) {
                            $yesArray = ["YES", "Yes", "yes"];
                            $noArray = ['NO', 'No', 'no'];
                            if (in_array($d['confirmation_required'], $yesArray)) {
                                $ticket['confirmation_required'] = 1;
                            } elseif (in_array($d['confirmation_required'], $noArray)) {
                                $ticket['confirmation_required'] = 0;
                            }
                        } else {
                            $ticket['confirmation_required'] = $customerMapping['confirmation_required'];  //punam
                        }


                        if (count($error) == 0) {
                            $ticket['cuid'] = $d['cuid'] ? $d['cuid'] : NULL;
                            $ticket['description'] = $d['description'];
                            $ticket['ticket_id'] = $this->ticketSeries();
                            $ticket['ticket_date'] = date('Y-m-d');
                            $ticket['status_id'] = 1;
                            $ticket['created_at'] = $request->created_at;
                            $ticket['created_by'] = $request->created_by;
                            $ticket['tenant_id'] = $request->tenant_id;
                            $ticket['from_department_id'] = $request->from_department_id;

                            //If user has authority then ticket will automatically PASS
                            $checkAuth = $this->checkAutoPassTicket($ticket['created_by'], $ticket['from_department_id']);
                            if ($checkAuth == 1 || $queryType->id) {
                                $ticket['passed_status'] = "PASS";
                                $ticket['passed_status_changed_by'] = $ticket['created_by'];
                                $ticket['passed_status_remark'] = "AUTO PASS";
                                $ticket['passed_status_changed_at'] = now();
                            }

                            $ticket_inserted_id = DB::table("tai_ticket_master")->insertGetId($ticket);
                            if ($ticket_inserted_id) {

                                if ($submitToMongo) {
                                    $a = new DynamicForm();
                                    $a->id = $ticket_inserted_id;
                                    $a->ticket_id = $ticket['ticket_id'];
                                    $a->dynamic_data = $submitToMongo;
                                    $a->save();
                                    DB::table('tai_ticket_master')
                                        ->where('id', $ticket_inserted_id)
                                        ->update(['object_id' => $a->_id]);
                                }
                                $success++;
                                CommonController::generateHistory("INSERT", 'tai_ticket_master', $ticket_inserted_id);
                            }
                        } //CHECK ERRROR COUNT
                    } else { //CUSTOMER MAPPING
                        $error[] = "Unable to find mapping";
                    }
                } else {
                    $error[] = "Unable to find query type";
                } //QUERY TYPE END 

                if (count($error)) {
                    $d['remark'] = implode(',', $error);
                    $exceptionData[] = $d;
                }
            }    //FOR LOOP

            if (count($exceptionData) > 0) {
                $delimeter = ',';
                $filename = 'create_ticket_error_file' . date('YmdHis') . '.csv';
                $f = fopen(storage_path('app/' . $filename), 'w');

                $header = array_merge($header, array('error_remark'));

                // foreach ($header as $key => $value) {
                //     $header[$key] = str_replace('_', ' ', ucwords($value));
                // }

                fputcsv($f, $header, $delimeter);
                foreach ($exceptionData as $d) {
                    fputcsv($f, array_values($d), $delimeter);
                }
                fclose($f);
                $message = 'Download Error File';
                $type = 'danger';

                return response()->json(["status" => 0, "message" => "Found Error in File !!!", "data" => "storage/app/" . $filename]);
            } else {
                return response()->json(["status" => 1, "message" => "$success Tickets Created !!!", "data" => null]);
            }
        }
    }

    public function getDownloadErrorFile($data)
    {
        if (count($data) > 0) {
            header('Content-Type: text/csv');
            header('Content-Disposition: attachment; filename="sample.csv"');

            $header = array_keys($data[0]);

            foreach ($header as $key => $value) {
                $header[$key] = str_replace('_', ' ', ucwords($value));
            }

            $delimiter = ",";
            $f1  = fopen(storage_path('app/Update_Error_File.csv'), 'w');
            fputcsv($f1, $header, $delimiter);

            foreach ($data as $d) {
                fputcsv($f1, array_values($d), $delimiter);
            }
            fclose($f1);
        }
    }



    // Date : 20-10-2022
    public function updateTicket(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id;

        // return ($request->toArray());
        if (!$request->expected_solve_date) {
            return response()->json(["status" => 0, "message" => "Required Expected Solve Date !!!", "data" => NULL]);
        }
        if (!$request->project_id || !$request->module_id) {
            return response()->json(["status" => 0, "message" => "Missing Project Id or Module Id !!!", "data" => NULL]);
        }
        if (!$request->assign_to_department_id) {
            return response()->json(["status" => 0, "message" => "Select assign to department !!!", "data" => NULL]);
        }
        if (!$request->assign_to_user_id) {
            return response()->json(["status" => 0, "message" => "Select assign to user !!!", "data" => NULL]);
        }
        if (!$request->priority) {
            return response()->json(["status" => 0, "message" => "Select Priority !!!", "data" => NULL]);
        }
        if (!$request->status_id) {
            return response()->json(["status" => 0, "message" => "Select Ticket Status !!!", "data" => NULL]);
        }
        // validation
        if ($request->id && $request->ticket_date && $request->expected_solve_date && $request->project_id && $request->module_id) {
            $data = $request->toArray();
            $ticketReviewer = $data['ticket_reviewer'];
            unset($data['ticket_reviewer']);
            // $data = array_merge($dataOne, ["template_id" => "63"]);
            // $dates = TaskSupportiveController::getBetweenDates($data["ticket_date"], $data["expected_solve_date"]);

            $submitToMongo = "";
            // if ($request->query_type_id) {
            //     //LOGIN
            //     //1.Compare actual columns required with all form data
            //     $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
            //     $ticketColumns[] = "attachment";

            //     //2.Filter and genrate dynamic form data received in request
            //     $dynamicForm = array();
            //     foreach ($data as $key => $value) {
            //         if (!in_array($key, $ticketColumns)) {
            //             $dynamicForm[$key] = $value;
            //             unset($data[$key]);
            //         }
            //     }

            //     //3. Get actual json form
            //     $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
            //         ->where('t.id', $request->query_type_id)
            //         ->select('d.data')
            //         ->first();
            //     if ($dynamicFormData) {
            //         $form = json_decode($dynamicFormData->data);
            //         //4.  Loop throuh json form
            //         //5.  inputAddOn will have array exclude from comparison
            //         //6.  compare value only if key=inputName;
            //         //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
            //         //8.   array_key is used to check the name is present in dynamicform array generated in step 2
            //         //9.  If value matches then change the value in object named as inputValue
            //         //10. Dynamic Form Json will be read
            //         foreach ($form as $key => $value) {
            //             foreach ($value as $k => $v) {
            //                 if ($k != "inputAddOn") {
            //                     if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
            //                         $form[$key]->inputDefaultValue = $dynamicForm[$v];
            //                     }
            //                 }
            //             }
            //         }
            //         $submitToMongo = json_encode($form);
            //     }
            // }


            $mainData['expected_solve_date'] = $request->expected_solve_date;
            $mainData['project_id'] = $request->project_id;
            $mainData['module_id'] = $request->module_id;
            $mainData['submodule_id'] = $request->submodule_id;
            $mainData['assign_to_department_id'] = $request->assign_to_department_id;
            $mainData['assign_to_user_id'] = $request->assign_to_user_id;
            $mainData['priority'] = $request->priority;
            $mainData['status_id'] = $request->status_id;
            $mainData['updated_at'] = now();
            $mainData['updated_by'] = $request->updated_by;
            if ($request->cuid) {
                $mainData['cuid'] = $request->cuid;
            }

            $is_updated = DB::table("tai_ticket_master")->where("id", $id)->where('tenant_id', $tenantId);
            // if ($customerId) {
            //     $is_updated = $is_updated->where('customer_id', $customerId);
            // }
            $is_updated = $is_updated->update($mainData);

            $ticket = DB::table("tai_ticket_master")->where("id", $id)->where('tenant_id', $tenantId);
            // if ($customerId) {
            //     $ticket = $ticket->where('customer_id', $customerId);
            // }
            $ticket = $ticket->first();

            // $request->dynamic_form = is_array($request->dynamic_form) ? $request->dynamic_form : json_decode($request->dynamic_form);
            // $object_id = $this->mongoDB($ticket->id, $ticket->ticket_id, $request->dynamic_form, $ticket->object_id);

            //UPDATE ATTACHMENTS
            if ($request->file("attachment")) {
                CommonController::uploadAttachment($id, $request->attachment, "TICKET", $request->updated_by);
            }

            //UPDATE PROJECT MAPPING
            if ($request->project_id) {
                OwnershipController::mapping('Update', 'TICKET', $request->assign_to_user_id, $request->project_id, $id, 0, 0, $tenantId);
                if ($ticketReviewer) {
                    OwnershipController::mapping('Update', 'TICKET_REVIEWER', $ticketReviewer, $request->project_id, $id, 0, 0, $tenantId);
                }
            } else {
                OwnershipController::mapping('Update', 'TICKET', $request->assign_to_user_id, 0, $id, 0, 0, $tenantId);
                if ($ticketReviewer) {
                    OwnershipController::mapping('Update', 'TICKET_REVIEWER', $ticketReviewer, 0, $id, 0, 0, $tenantId);
                }
            }

            //GENERATE HISTORY
            CommonController::generateHistory("UPDATE", 'tai_ticket_master', $id);

            //SEND NOTIFICATIONS
            // dd($data);
            if ($data["status_id"] == 3) {

                $ticket_data = DB::table('tai_ticket_master')->where('id', $id)->where('tenant_id', $tenantId);
                // if ($customerId) {
                //     $ticket_data = $ticket_data->where('customer_id', $customerId);
                // }
                $ticket_data = $ticket_data->first();

                $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
                $msg = "Ticket " . $ticket_data->ticket_id . " has been solved by - " . $userInfo->first_name . " " . $userInfo->last_name;
                $url = "Ticket/View/" . $id;

                CommonController::addNotification($request->updated_by, $ticket_data->assign_to_user_id, $msg, $url);

                return response()->json(["status" => 1, "message" => "Ticket- " . $ticket_data->ticket_id . " has been solved", "data" => null]);
            } else {
                // if project & ticket id found => deactivate user_id 
                $check_map = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                    ->where('ticket_id', $request->id)->update(['is_active' => 0]);
                // dd($check_map);
                if ($check_map) {
                    // dd('in');
                    return $request;
                    foreach ($request->ba_id as $b_id) {
                        $ba_res = DB::table('tai_ticket_user_mapping')->select('user_id')->where('project_id', $request->project_id)
                            ->where('ticket_id', $request->id)->where('user_id', $b_id)->first();
                        if (!is_null($ba_res->user_id)) {
                            $que = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                                ->where('ticket_id', $request->id)
                                ->where('user_id', $ba_res)->update(['is_active' => 1]);
                        } else {
                            $que = DB::table('tai_ticket_user_mapping')->insert([
                                'tenant_id' => $request->tenant_id, 'user_type' => 'BA',
                                'user_id' => $b_id, 'project_id' => $request->project_id,
                                'ticket_id' => $request->id, 'is_active' => 1
                            ]);
                        }
                    }
                    foreach ($request->dev_id as $d_id) {
                        $dev_res = DB::table('tai_ticket_user_mapping')->select('user_id')->where('project_id', $request->project_id)
                            ->where('ticket_id', $request->id)->where('user_id', $d_id)->first();
                        if (!is_null($dev_res->user_id)) {
                            $que = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                                ->where('ticket_id', $request->id)
                                ->where('user_id', $dev_res)->update(['is_active' => 1]);
                        } else {
                            $que = DB::table('tai_ticket_user_mapping')->insert([
                                'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                'user_id' => $d_id, 'project_id' => $request->project_id,
                                'ticket_id' => $request->id, 'is_active' => 1
                            ]);
                        }
                    }

                    foreach ($request->dev_id as $t_id) {
                        $tes_res = DB::table('tai_ticket_user_mapping')->select('user_id')->where('project_id', $request->project_id)
                            ->where('ticket_id', $request->id)->where('user_id', $t_id)->first();
                        if (!is_null($tes_res->user_id)) {
                            $que = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                                ->where('ticket_id', $request->id)
                                ->where('user_id', $tes_res)->update(['is_active' => 1]);
                        } else {
                            $que = DB::table('tai_ticket_user_mapping')->insert([
                                'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                'user_id' => $t_id, 'project_id' => $request->project_id,
                                'ticket_id' => $request->id, 'is_active' => 1
                            ]);
                        }
                    }
                } else {
                    // return [$request->ba_id];
                    if ($request->ba_id && count($request->ba_id) > 0) {
                        foreach ($request->ba_id as $b_id) {

                            $check = DB::table('tai_ticket_user_mapping')->where([
                                'tenant_id' => $request->tenant_id,
                                'user_type' => 'BA',
                                'user_id' => $b_id, 'project_id' => $request->project_id,
                                'ticket_id' => $request->id, 'is_active' => 1
                            ])->first();
                            if ($check) {
                                $que = DB::table('tai_ticket_user_mapping')->where('id', $check->id)->update([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'BA',
                                    'user_id' => $b_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            } else {
                                $que = DB::table('tai_ticket_user_mapping')->insert([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'BA',
                                    'user_id' => $b_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            }
                        }
                    }

                    if ($request->dev_id && count($request->dev_id) > 0) {
                        foreach ($request->dev_id as $d_id) {


                            $check = DB::table('tai_ticket_user_mapping')->where([
                                'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                'user_id' => $d_id, 'project_id' => $request->project_id,
                                'ticket_id' => $request->id, 'is_active' => 1
                            ])->first();
                            if ($check) {
                                $que = DB::table('tai_ticket_user_mapping')->update([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                    'user_id' => $d_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            } else {
                                $que = DB::table('tai_ticket_user_mapping')->insert([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                    'user_id' => $d_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            }
                        }
                    }

                    if ($request->tester_id && count($request->tester_id) > 0) {
                        foreach ($request->tester_id as $t_id) {

                            $check =  $que = DB::table('tai_ticket_user_mapping')->where([
                                'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                'user_id' => $t_id, 'project_id' => $request->project_id,
                                'ticket_id' => $request->id, 'is_active' => 1
                            ])->first();

                            if ($check) {
                                $que = DB::table('tai_ticket_user_mapping')->where('id', $check->id)->update([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                    'user_id' => $t_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            } else {
                                $que = DB::table('tai_ticket_user_mapping')->insert([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                    'user_id' => $t_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            }
                        }
                    }
                }

                $ticket_data = DB::table('tai_ticket_master')->where('id', $id)->where('tenant_id', $tenantId);
                // if ($customerId) {
                //     $ticket_data = $ticket_data->where('customer_id', $customerId)->first();;
                // }else{
                $ticket_data = $ticket_data->first();
                // }

                //                                 $d = is_array($d) ? (object)$d : $d;

                //                                 if ($d->id == $form->inputDefaultValue) {
                //                                     $temp[] = array("value" => $d->id, "label" => $d->label);
                //                                 }
                //                             }

                $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
                // $assignUserInfo = CommonController::userInfo($ticket_data->assign_to_user_id, ["first_name", "last_name"]);
                $msg = "You has been assigned for Ticket " . $ticket_data->ticket_id . " by " . $userInfo->first_name . " " . $userInfo->last_name;
                $url = "Ticket/View/" . $id;

                CommonController::addNotification($request->updated_by, $ticket_data->assign_to_user_id, $msg, $url);

                // dd('hello');
                return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null]);
            }
        }
    }


    public function deleteTicket(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_ticket_master")->where("id", $id)->where('tenant_id', $tenantId)->delete();
        if ($result) {
            return response()->json(["message" => "Record Deleted", "status" => 1, "data" => null,]);
        } else {
            return response()
                ->json(["message" => "Record Not Deleted", "status" => 0, "data" => null,]);
        }
    }

    public function getTicketById(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $query = "SELECT tm.id,tm.query_type_id,tm.object_id,tm.tenant_id,tm.ticket_id,tm.confirmation_required,tm.project_id,tm.module_id,tm.submodule_id,
                tm.cuid,tm.ticket_date,tm.expected_solve_date,tm.assign_to_department_id,tm.assign_to_user_id,tm.priority,tm.status_id,
                tm.description,tm.from_department_id,tm.created_by,tm.created_at,tm.updated_by,tm.updated_at,tm.passed_status,
                tm.passed_status_changed_by,tm.passed_status_changed_at,tm.passed_status_remark,
                CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department as assign_to_department, 
                sm.status AS status_name, 
                CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                fd.department AS from_department_name,
                CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name, 
                pm.project_name, pmod.module_name, smod.sub_module_name,
                qtm.query_type_name
                FROM tai_ticket_master AS tm 
                LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
                LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                LEFT JOIN tai_project_master AS pm ON pm.id = tm.project_id  
                LEFT JOIN tai_project_modules AS pmod ON pmod.id = tm.module_id
                LEFT JOIN tai_project_sub_modules AS smod ON smod.id = tm.submodule_id  
                LEFT JOIN tai_query_type_master AS qtm ON qtm.id = tm.query_type_id  
                WHERE tm.is_active = 1 AND tm.id =" . $id . " AND tm.tenant_id = " . $tenantId;
        // if ($customerId) {
        //     $query .= " AND em.customer_id = " . $customerId . " OR em_c.customer_id = " . $customerId;
        // }


        $result = DB::select(DB::raw($query));

        $query2 = "
            SELECT t2.user_id FROM tai_owner_mapping_master AS t1
            LEFT JOIN tai_owner_mapping_master AS t2 ON t1.project_id = t2.project_id
            WHERE t1.ticket_id = " . $id . " AND t2.type = 'PROJECT' 
            AND t1.type = 'TICKET' AND t2.tenant_id = " . $tenantId;

        $result2 = DB::select(DB::raw($query2));


        // $result = DB::table("tai_ticket_master as t")

        //             ->leftJoin("tai_query_type_master as q", "q.id", "=", "t.query_type_id")
        //             ->leftJoin("tai_employee_master as e", "e.id", "=", "t.created_by")
        //             ->leftJoin("tai_status_master as s", "s.id", "=", "t.status_id")
        //             ->select(
        //                 "t.*",
        //                 't.created_by as created_user_id',
        //                 'q.id as query_id',
        //                 'q.query_type_name',
        //                 DB::raw("CONCAT(e.first_name,' ',e.last_name) AS created_by"),
        //                 "s.status"
        //             )
        //             ->where("t.id", $id)
        //             ->first();

        if ($result && count($result) > 0) {

            $result = $result[0];

            $result->attachment = CommonController::getAttachment($id, "Ticket");
            $dynamicFormData = NULL;
            if ($result->object_id) {
                $dynamic_form_data = DynamicForm::find($result->object_id);

                // return [4, $dynamic_form_data];
                if ($dynamic_form_data) {

                    if ($dynamic_form_data->dynamic_data) {
                        $result->dynamic_form = is_array($dynamic_form_data->dynamic_data) ? $dynamic_form_data->dynamic_data : json_decode($dynamic_form_data->dynamic_data);


                        // foreach ($dynamicFormData as $key => $form) {
                        //     if ($form->inputType == "select") {
                        //         $addOns = $form->inputAddOn;
                        //         $dropdown = DB::table('tai_dynamic_form_dropdown_data')
                        //                         ->where('dropdown_id', $addOns->inputDataSource)
                        //                         ->get();
                        //         $temp = array();

                        //         foreach ($dropdown as $d) {
                        //             $temp[] = array("value" => $d->value, "label" => $d->label);
                        //         }
                        //         $dynamicFormData[$key]->inputAddOn->inputDataSourceData = $temp;
                        //     }
                        // }
                    }
                }
            }

            // tested code done by harkare
            $user_data['BA'] = DB::table('tai_ticket_user_mapping as m')
                ->leftJoin('tai_employee_master as emp', 'emp.id', '=', 'm.user_id')
                ->where('m.ticket_id', $id)
                ->where('m.is_active', 1)
                ->where('user_type', 'BA')
                ->select('m.ticket_id', 'emp.id', DB::raw("CONCAT(emp.first_name,' ',emp.last_name) AS name"), 'm.user_type')
                ->get();

            $user_data['DEV'] = DB::table('tai_ticket_user_mapping as m')
                ->leftJoin('tai_employee_master as emp', 'emp.id', '=', 'm.user_id')
                ->where('m.ticket_id', $id)
                ->where('m.is_active', 1)
                ->where('user_type', 'DEV')
                ->select('m.ticket_id', 'emp.id', DB::raw("CONCAT(emp.first_name,' ',emp.last_name) AS name"), 'm.user_type')
                ->get();

            $user_data['TESTER'] = DB::table('tai_ticket_user_mapping as m')
                ->leftJoin('tai_employee_master as emp', 'emp.id', '=', 'm.user_id')
                ->where('m.ticket_id', $id)
                ->where('m.is_active', 1)
                ->where('user_type', 'TESTER')
                ->select('m.ticket_id', 'emp.id', DB::raw("CONCAT(emp.first_name,' ',emp.last_name) AS name"), 'm.user_type')
                ->get();

            $user_data['REVIEWER'] = DB::table('tai_owner_mapping_master as m')
                ->leftJoin('tai_employee_master as emp', 'emp.id', '=', 'm.user_id')
                ->where('m.ticket_id', $id)
                ->where('m.is_active', 1)
                ->where('type', 'TICKET_REV')
                ->select('m.ticket_id', 'emp.id', DB::raw("CONCAT(emp.first_name,' ',emp.last_name) AS name"), 'm.type')
                ->get();

            $result->ticket_users = $user_data;
            $result->project_owner = $result2;


            // return response()->json(["status" => 1, "message" => "Record Found !!!", "data" => $result,  "dynamicFormData" => $dynamicFormData,]);

            return response()->json(["status" => 1, "message" => "Record Found !!!", "data" => $result]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record Found !!!", "data" => null,]);
        }
    }

    public function getTaskByTicket(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_ticket_task as t")
            ->select("t.id", "t.task_name")
            ->where("t.ticket_id", $id)
            ->where("t.tenant_id", $tenantId)
            // ->where("t.status", '!=', 'COMPLETED')
            ->get();
        if ($result) {
            return response()->json(["status" => 1, "message" => "Record Found !!!", "data" => $result]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record Found !!!", "data" => null,]);
        }
    }

    public function createComment(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        // return $request;
        $data = $request->toArray();
        $data['tenant_id'] = $tenantId;
        // $data['customer_id'] = $customerId;

        $data['mentions_id'] = rtrim($data['mentions_id'], ',');

        $result = DB::table("tai_ticket_comment")->insert($data);
        if ($result) {
            $ticket = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $data['ticket_id'])->first();

            // add notification for project owner
            $project_owner_id = DB::table('tai_ticket_master as e')->leftJoin('tai_project_master as p', 'p.id', '=', 'e.project_id')->where('e.tenant_id', $tenantId)->select('p.created_by')->first();
            // dd($project_owner_id, $ticket);
            if ($project_owner_id && $project_owner_id->created_by) {
                $mention_from = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);

                $users = explode(',', $data['mentions_id']);
                foreach ($users as $u) {
                    $mention_to = CommonController::userInfo($u, ["first_name", "last_name",]);

                    $msg = $mention_from->first_name . " " . $mention_from->last_name . " has mentioned " . $mention_to->first_name . " " . $mention_to->last_name . " in " . $ticket->ticket_id;
                    $url = "Ticket/View/" . $data['ticket_id'];
                    CommonController::addNotification($data["created_by"], $u, $msg, $url);
                }
            } else {

                //Add Notification for user
                $userInfo = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);


                $msg = $userInfo->first_name . " " . $userInfo->last_name . " has mentioned you in " . $ticket->ticket_id;

                $users = explode(',', $data['mentions_id']);
                $url = "Ticket/View/" . $data['ticket_id'];

                foreach ($users as $u) {
                    CommonController::addNotification($data["created_by"], $u, $msg, $url);
                }
            }

            return response()->json(["status" => 1, "message" => "Record Inserted !!!", "data" => $data,]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Inserted !!!", "data" => null,]);
        }
    }

    public function getComment($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE
        // $customerId = $token_data->customer_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table("tai_ticket_comment as tc")
            ->join("tai_employee_master as em", "em.id", "=", "tc.created_by")
            ->join("tai_ticket_master as tm", "tm.id", "=", "tc.ticket_id")
            ->where("tc.ticket_id", $id)
            ->select("tc.*", "em.first_name", "em.last_name")
            ->where('tm.tenant_id', $tenantId)
            ->orderBy("tc.id", "desc")
            ->get();
        $temp = [];
        $final = [];

        if (count($result) > 0) {
            $temp = ["ticketId" => $result[0]->ticket_id, "userId" => "",];
            foreach ($result as $key => $b) {
                $final["cmt"] = $b->comment;
                $final["time"] = $b->created_at;
                $final["user_id"] = $b->first_name . " " . $b->last_name;
                $temp["comments"][] = $final;
            }
            return response()->json(["status" => 1, "message" => "Record found !!!", "data" => $temp]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record found !!!", "data" => null]);
        }
    }

    public function sendTicketConfirmationOtp(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if ($id) {
            $ticket = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $id)->first();
            if ($ticket) {
                $user = DB::table('tai_employee_master')->where('tenant_id', $tenantId)->where('id', $ticket->created_by)->first();
                $otp = rand(999999, 111111);

                if ($user->preferred_communication) {

                    if ($user->preferred_communication == "SMS") {
                        // return response()->json(['status' => 0, 'message' => "SMS Gateway not defined", 'data' => null]);
                        return response()->json(['status' => 0, 'message' => "Preferred Communication Need To Be EMAIL ", 'data' => null]);
                    } else if ($user->preferred_communication == "EMAIL") {
                        $data = [
                            'title' => 'Mail from Techneai',
                            'body' => 'Ticket Confirmation',
                            'name' =>  $user->first_name . " " . $user->last_name,
                            'ticket_id' => $ticket->ticket_id,
                            'email' => $user->email_id,
                            'mobile' => $user->contact_no,
                            'otp' => $otp
                        ];

                        try {
                            Mail::to($user->email_id)->send(new TicketOtpMail($data));
                        } catch (Exception $e) {
                            return response()->json(['status' => 0, 'message' => "Mail Not Sent", 'data' => null]);
                        }
                    } else if ($user->preferred_communication == "WHATS_APP") {
                        $data = [
                            'title' => 'Mail from Techneai',
                            'body' => 'Ticket Confirmation',
                            'name' =>  $user->first_name . " " . $user->last_name,
                            'ticket_id' => $ticket->ticket_id,
                            'email' => $user->email_id,
                            'mobile' => $user->contact_no,
                            'otp' => $otp
                        ];
                        $response = $this->sendWhatsApp($data);
                        if ($response["status"] != "success") {
                            return response()->json(['status' => 0, 'message' => "OTP Not Sent", 'data' => null]);
                        }
                    }

                    DB::table('tai_ticket_master')
                        ->where('id', $id)
                        ->where('tenant_id', $tenantId)
                        ->update([
                            'ticket_confirmation_otp' => $otp,
                            'ticket_confirmation_otp_created_at' => now()
                        ]);

                    return response()->json([
                        "status" => 1,
                        "message" => "OTP Sent to $user->first_name $user->last_name",
                        "data" => $otp
                    ]);
                } else {
                    return response()->json([
                        "status" => 0,
                        "message" => "User Communication Preferrance is not set",
                        "data" => null
                    ]);
                }
            } else {
                return response()->json([
                    "status" => 0,
                    "message" => "Id not found",
                    "data" => null
                ]);
            }
        }
    }



    public function sendWhatsApp($ticket)
    {
        $msg = "OTP for Confirmation of Ticket ID : " . $ticket['ticket_id'] . " is " . $ticket['otp'] . ". Please do share with " . $ticket['name'] . " for the completion of the ticket.";
        $msg .= "\n\n";
        $msg .= "From Team Techneai.";

        $ticket['mobile'] = "8999394004";

        $ticket['mobile'] = $ticket['mobile'];
        $ticket['body'] = $msg;


        $this->optinUser($ticket);

        $userId = '2000193115';
        $pass = 'NkoXDsE7t';

        $phoneNo = "91" . $ticket['mobile'];

        $url = "https://media.smsgupshup.com/GatewayAPI/rest?";
        $url .= "userid=$userId";
        $url .= "&password=$pass";
        $url .= "&send_to=$phoneNo";
        $url .= "&v=1.1";
        $url .= "&format=json&";
        $url .= "&msg_type=TEXT";
        $url .= "&method=SENDMESSAGE";
        $url .= "&msg=" . urlencode($ticket['body']) . "";

        $response = $this->callCurl($url);
        $response = json_decode($response, true);
        return $response["response"];
        // return true;
    }


    public function optinUser($data)
    {
        $userId = '2000193115';
        $pass = 'NkoXDsE7t';

        $url = 'https://media.smsgupshup.com/GatewayAPI/rest?';
        $phoneNo = '91' . $data['mobile'];

        $url .= 'method=OPT_IN&format=json&userid=' . $userId . '&password=' . $pass . '&phone_number=' . $phoneNo . '&v=1.1&auth_scheme=plain&channel=WHATSAPP';

        if (is_numeric($data['body']) && (strlen((string)$data['body'])) == 6) {
            $pincode = $data['body'];
        } else {
            $pincode = '';
        }

        $opt_in = DB::table('bot_customer_master')->where('mobile_no', $data['mobile'])->orderBy('id', 'desc')->first();

        if ($opt_in) {
            if ($opt_in->is_opt_in == 'Y') {
                if (($opt_in->whatsapp_pincode == '') && ($pincode != $opt_in->whatsapp_pincode || $pincode != '')) {
                    $arrayName = array(
                        'whatsapp_pincode' => $pincode,
                    );

                    DB::table('bot_customer_master')->where('id', $opt_in->id)->update($arrayName);
                }
                return true;
            } else {
                $response = $this->callCurl($url);

                $result = json_decode($response);

                $optInStatus = 'N';
                if ($result->response->status == 'success') {
                    $optInStatus = 'Y';
                    $optDate = date('Y-m-d H:i:s');
                } else {
                    $optInStatus = 'N';
                    $optDate = $opt_in->opt_in_when;
                }
                if (isset($opt_in->whatsapp_pincode) && ($pincode == $opt_in->whatsapp_pincode)) {
                    $pincode = $opt_in->whatsapp_pincode;
                }

                if (strtoupper($result->data->response_messages[0]->details) == strtoupper('YOU ARE ALREADY OPTED IN.')) {
                    $pincode = $opt_in->whatsapp_pincode;
                    $optInStatus = 'Y';
                }

                if (strtoupper($result->data->response_messages[0]->details) == strtoupper('YOU ARE ALREADY OPTED IN.')) {
                    $pincode = $opt_in->whatsapp_pincode;
                    $optInStatus = 'Y';
                }

                $arrayName = array(
                    'mobile_no'          => $data['mobile'],
                    'whatsapp_pincode'   => $pincode,
                    'is_opt_in'          => $optInStatus,
                    'opt_in_when'        => $optDate,
                    'opt_in_res'         => $response
                );

                DB::table('bot_customer_master')->where('id', $opt_in->id)->update($arrayName);
                if ($result->response->status == 'success') {
                    return true;
                } else {
                    return false;
                }
            }
        } else {
            $response = $this->callCurl($url);
            $result = json_decode($response);

            $optInStatus = 'N';
            if ($result->response->status == 'success') {
                $optInStatus = 'Y';
            } else {
                $optInStatus = 'N';
            }

            $arrayName = array(
                'mobile_no'          => $phoneNo,
                'whatsapp_name'      => $data['name'],
                'customer_name'      => $data['name'],
                'whatsapp_pincode'   => $pincode,
                'is_opt_in'          => $optInStatus,
                'opt_in_when'        => date('Y-m-d H:i:s'),
                'opt_in_by'          => NULL,
                'opt_in_res'         => $response
            );

            DB::table('bot_customer_master')->insert($arrayName);

            if ($result->response->status == 'success') {
                return true;
            } else {
                return false;
            }
        }
    }

    public function callCurl($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded', 'Content-Type: multipart/form-data;boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }


    public function updateEveryDependancy($ticket_id)
    {
    }

    public function verifyTicketConfirmationOtp(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if ($id) {
            $makeItSolved = 1;
            $ticket = DB::table('tai_ticket_master')->where('id', $id)->first();
            if ($request->otp) {
                if ($ticket->ticket_confirmation_otp == $request->otp) {
                    $makeItSolved = 1;
                } else {
                    $makeItSolved = 0;
                    return response()->json([
                        "status" => 0,
                        "message" => "OTP is not matched !!!",
                        "data" => null
                    ]);
                }
            } else {
                $makeItSolved = 1;
            }

            if ($makeItSolved == 1) {

                // $updated = 1;

                $updated = DB::table('tai_ticket_master')->where('id', $id)
                    ->where('tenant_id', $tenantId)
                    ->update([
                        'status_id' => 3,
                        'updated_at' => $request->updated_by,
                        'updated_by' => $request->updated_at
                    ]);

                if ($updated) {

                    $taskUsers = [];

                    // if ($ticket->passed_status_changed_by) {
                    //     $taskUsers[] = $ticket->passed_status_changed_by;
                    // }

                    $taskUsers = DB::table('tai_owner_mapping_master')->where('ticket_id', $id)
                        ->where('is_active', 1)
                        ->pluck('user_id')
                        ->toArray();
                    if (count($taskUsers)) {
                        $taskUsers = array_unique($taskUsers);
                    }

                    $taskOwners = DB::table('tai_ticket_task_owner as ttto')->select('ttto.id as task_owner_id')->get()->toArray();
                    $basketOwners = DB::table('tai_ticket_basket as ttb')->select('ttb.basket_owner as basket_owner_id')->get()->toArray();
                    $taskOwners = array_column($taskOwners, 'task_owner_id');
                    $basketOwners = array_column($basketOwners, 'basket_owner_id');

                    $users = array_unique(array_intersect($taskOwners, $basketOwners));
                    $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
                    $msg = "Ticket confirmed by - " . $userInfo->first_name . " " . $userInfo->last_name . " for " . $ticket->ticket_id;
                    $url = "Ticket/View/" . $id;

                    foreach ($users as $u) {
                        CommonController::addNotification($request->updated_by, $u, $msg, $url);
                    }
                    DB::table('tai_ticket_master')->where('id', $id)->update(['status_id' => 3, 'updated_at' => now()]);
                    CommonController::generateHistory("UPDATE", 'tai_ticket_master', $id);
                    DB::table('tai_ticket_task')->where('ticket_id', $id)->update(['status' => 'COMPLETED', 'updated_at' => now()]);

                    return response()->json(["status" => 1, "message" => "Ticket Solved !!! !!!", "data" => null]);
                }
            }
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Id not found",
                "data" => null
            ]);
        }
    }




    public function getBulkFormat(Request $request)
    {

        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $unique_key = "Query_Type_" . date("Y_m_d_H_i_s") . "_" . $request->created_by;

        // Excel::store(new TicketExport(2018), "unique_key.xlsx");

        // return Excel::download(new UsersExport, 'users.xlsx');

        $customer_mapping = DB::table('tai_customer_mapping')->where('id', $request->customer_mapping_id)->first();

        // dd($customer_mapping);

        if (!$customer_mapping->dynamic_form_id) {
            $form = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->where('tenant_id', $tenantId)->first();
            $customer_mapping->dynamic_form_id = $form->form_id;
        }

        $df = DB::table('tai_dynamic_form')->where('id', $customer_mapping->dynamic_form_id)->where('tenant_id', $tenantId)->first();
        if (!$df) {
            return response()->json(['status' => 0, 'message' => 'NO mapping form found !!!', 'data' => NULL]);
        }

        $form = json_decode($df->data);

        $query_type = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->where('tenant_id', $tenantId)->first()->query_type_name;

        $fields = array();
        $fields = ['query_type', 'confirmation_required', 'ref_id', 'priority', 'description'];

        foreach ($form as $f) {

            $fields[] = $f->inputLabel;
        }

        $filename = storage_path('app/' . $unique_key . '.csv');
        $delimiter = ",";
        $f = fopen($filename, 'w');
        fputcsv($f, $fields, $delimiter);

        $array = [$query_type];
        fputcsv($f, $array, $delimiter);

        fclose($f);

        return response()->json(['status' => 1, 'message' => 'File is ready to download', 'data' => 'storage/app/' . $unique_key . '.csv']);
    }


    public function getTicketHistory(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = DB::table('tai_ticket_master_history as th')
            ->where('th.main_id', $id)
            ->leftjoin('tai_query_type_master as tq', 'th.query_type_id', 'tq.id')
            ->leftjoin('tai_tenant_master as tm', 'th.tenant_id', 'tm.id')
            ->leftjoin('tai_employee_master as em1', 'th.updated_by', 'em1.id')
            ->leftjoin('tai_employee_master as em2', 'th.created_by', 'em2.id')
            ->leftjoin('tai_employee_master as em3', 'th.passed_status_changed_by', 'em3.id')
            ->leftjoin('tai_employee_master as em4', 'th.assign_to_user_id', 'em4.id')
            ->leftjoin('tai_project_master as pm', 'th.project_id', 'pm.id')
            ->leftjoin('tai_project_modules as tpm', 'th.module_id', 'tpm.id')
            ->leftjoin('tai_project_sub_modules as tps', 'th.submodule_id', 'tps.id')
            ->leftjoin('tai_department_master as tdm', 'th.assign_to_department_id', 'tdm.id')
            ->leftjoin('tai_department_master as tdm1', 'th.from_department_id', 'tdm1.id')
            ->leftjoin('tai_status_master as tsm', 'th.status_id', 'tsm.id')
            ->leftjoin('tai_template_master as ttm', 'th.template_id', 'ttm.id')
            ->select(
                'th.*',
                'tq.query_type_name',
                'tm.company_name',
                'pm.project_name',
                'tpm.module_name',
                'tps.sub_module_name',
                'tdm.department',
                'tsm.status',
                'ttm.template_name',
                'tdm1.department AS from_department',
                DB::raw("CONCAT(em1.first_name,' ',em1.last_name) AS updated_by"),
                DB::raw("CONCAT(em2.first_name,' ',em2.last_name) AS created_by"),
                DB::raw("CONCAT(em3.first_name,' ',em3.last_name) AS passed_status_changed_by"),
                DB::raw("CONCAT(em4.first_name,' ',em4.last_name) AS assign_to_user")
            )
            ->where('th.tenant_id', $tenantId)
            ->orderBy('id', 'desc')
            ->get();
        $temp = [];
        if (count($data) > 0) {

            foreach ($data as $d) {
                $temp[] = (array)$d;
            }

            if (count($temp) >= 2) {
                foreach ($temp as $key => $value) {
                    $temp[$key]['changes'] = [];
                    if ($key >= 1) {
                        $prevKey = $key - 1;

                        $tempPrevArray = $temp[$prevKey];
                        $tempCurrentArray = $temp[$key];

                        if (array_key_exists('changes', $tempPrevArray)) {
                            unset($tempPrevArray['changes']);
                        }
                        if (array_key_exists('changes', $tempCurrentArray)) {
                            unset($tempCurrentArray['changes']);
                        }
                        $diff = (array_diff_assoc($tempPrevArray, $tempCurrentArray));
                        unset($diff['id']);
                        unset($diff['operation']);


                        $temp[$key]['changes'] = array_keys($diff);
                    }
                }
            }

            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $temp]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }
    public function uploadNewAttachment(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $data = $request->toArray();
        if ($data['attachment']) {
            CommonController::uploadAttachment($id, $request->attachment, "TICKET", $data["updated_by"]);
            return response()->json(['status' => 1, 'message' => "New attachments inserted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "No attachment added !!!", 'data' => null]);
        }
    }
    public function getAllRecords()
    {
        $records = DynamicForm::all();

        echo "<pre>";
        $i = 0;
        foreach ($records as $r) {
            echo $r->ticket_id . "<br>";
            if ($r->ticket_id == "TT11114") {
                // dd(json_decode($r->dynamic_data, true));
                if (!is_array($r->dynamic_data)) {
                    $dynamic_data = json_decode($r->dynamic_data, true);
                    $keys = array_keys(array_column($dynamic_data, 'inputType'), 'select');
                    if (count($keys) > 0) {
                        foreach ($keys as $key) {
                            // if (
                            //     strpos($dynamic_data[$key]['inputLabel'], 'item') !== false ||
                            //     strpos($dynamic_data[$key]['inputLabel'], 'category') !== false ||
                            //     strpos($dynamic_data[$key]['inputLabel'], 'vendor') !== false
                            // ) {
                            //     continue;
                            // }

                            $dynamic_data[$key]['inputType'] = 'text';
                            if (array_key_exists('inputDefaultValue', $dynamic_data[$key])) {
                                if ($dynamic_data[$key]['inputDefaultValue'] !== null) {
                                    if (isset($dynamic_data[$key]['inputAddOn'])) {
                                        $inputAddOnValue = $dynamic_data[$key]['inputAddOn'];
                                        if (isset($inputAddOnValue['inputDataSource'])) {
                                            $inputDataSourceDataValue = $inputAddOnValue['inputDataSource'];
                                        }
                                    } else {
                                        if (isset($dynamic_data[$key]['inputDataSource'])) {
                                            $inputDataSourceDataValue = $dynamic_data[$key]['inputDataSource'];
                                        }
                                    }
                                    if ($inputDataSourceDataValue && $inputDataSourceDataValue > 0) {
                                        $dropdownData = DB::table('tai_dynamic_form_dropdown_master as dm')
                                            ->leftjoin('tai_dynamic_form_dropdown_data as dd', 'dm.id', '=', 'dd.dropdown_id')
                                            ->where('dm.id', $inputDataSourceDataValue)
                                            ->get()->toArray();
                                        if (count($dropdownData) > 0) {
                                            $labelId = array_search($dynamic_data[$key]['inputDefaultValue'], array_column($dropdownData, 'id'));
                                            $dynamic_data[$key]['inputDefaultLabel'] = $dropdownData[$labelId]->label;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    foreach ($dynamic_data as &$d) {
                        if (isset($d['inputDefaultLabel'])) {
                            $temp = $d['inputDefaultValue'];
                            $d['inputDefaultValue'] = $d['inputDefaultLabel'];
                            $d['inputDefaultId'] = $temp;
                            unset($d['inputDefaultLabel']);
                        } else {
                            if (isset($d['inputDefaultValue'])) {
                                $d['inputDefaultId'] = $d['inputDefaultValue'];
                                unset($d['inputDefaultValue']);
                            }
                        }
                    }
                    $r->dynamic_data = $dynamic_data;
                    // print_r([$r->ticket_id, $r->dynamic_data]);
                    $r->save();
                    $i++;
                }

                // if (is_array($r->dynamic_data)) {
                //     $r->dynamic_data = json_encode($r->dynamic_data, true);
                //     // dd($r->dynamic_data);
                //     $r->save();
                // }

                break;
            }
        }
        return $i;
        // return response()->json($records);
    }

    public function updateDynamicFieldData($id)
    {
        // Retrieve the record from MongoDB
        $record = DynamicForm::find($id);

        // Decode the dynamic_data field into an array
        $dynamicData = json_decode($record->dynamic_data, true);

        // Modify the dynamic data array
        foreach ($dynamicData as &$field) {
            if ($field['inputType'] === 'Select') {
                $field['inputType'] = 'Text';
            }
        }

        // Encode the modified dynamic data back to JSON
        $modifiedDynamicData = json_encode($dynamicData);

        // Update the record in MongoDB
        $record->dynamic_data = $modifiedDynamicData;
        // $record->save();

        return response()->json(['message' => 'Dynamic field data updated successfully']);
    }
}
