<?php

namespace App\Http\Controllers;

use App\Library\CommonController;
use App\Library\OwnershipController;
use App\Library\TemplateLibrary;
use App\Library\TaskSupportiveController;
use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\DB;
use App\Models\DynamicForm;
use App\Models\DynamicFormTest;
use Illuminate\Support\Facades\Mail;
use App\Mail\TicketOtpMail;
use File;
use DateTime;
use Exception;
use Session;

class TicketControllerBackup extends Controller
{

    public function checkDynamicForm(Request $request)
    {
        // return DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
        // return DynamicForm::find('6261682a421eb93cbf2f4e33')->dynamic_data;
        return DynamicForm::where(['ticket_id' => 'TT445'])->first();
        // $test=DynamicForm::all();
        // $a=DynamicForm::create(['id' => 1, 'title' => 'The Fault in Our Stars']);
        // $a=new DynamicForm();
        // $a->data=json_encode(["name"=>"parth patel","type"=>"code"]);
        // $a->save();
        // return $a;
    }

    public function passTicket(Request $request)
    {
        $update = DB::table('tai_ticket_master')
            ->where('id', $request->id)
            ->update([
                'passed_status' => $request->pass_status,
                'passed_status_changed_by' => $request->user_id,
                'passed_status_changed_at' => $request->updated_at,
                // 'passed_status_remark' => $request->remark
            ]);
        CommonController::generateHistory("UPDATE", 'tai_ticket_master', $request->id);

        if ($update > 0) {
            $asssigned_user = DB::table('tai_ticket_master as tm')->join('tai_employee_master as em', 'tm.assign_to_user_id', '=', 'em.id')->where('tm.id', $request->id)->first();

            $authorityInfo = CommonController::userInfo($request->user_id, ["first_name", "last_name",]);

            // $msg = $request->pass_status == "PASS" ? $asssigned_user->ticket_id . " PASSED to " . $asssigned_user->first_name . " " . $asssigned_user->last_name : "REJECTED"  ;

            $msg = $request->pass_status == "PASS" ? $authorityInfo->first_name . " " . $authorityInfo->last_name . " has passed " . $asssigned_user->ticket_id . " to " . $asssigned_user->first_name . " " . $asssigned_user->last_name : $authorityInfo->first_name . " " . $authorityInfo->last_name . " has REJECTED " . $asssigned_user->ticket_id;
            // DD($msg);
            CommonController::addNotification($request->user_id, $asssigned_user->assign_to_user_id, $msg);
            CommonController::addNotification($request->user_id, $asssigned_user->created_by, $msg);

            $m = $request->pass_status == "PASS" ? "Passed" : "Rejected";

            return response()->json(["status" => 1, "message" => "Ticket $m  !!!", "data" => null]);
        } else {
            return response()->json(["status" => 0, "message" => "Ticket Not passed !!!", "data" => null]);
        }
    }


    public function getAllTicketTest(Request $request, $tenantId, $userId)
    {
        $ticketIds1 = DB::table("tai_ticket_basket")
            ->where('tenant_id', $tenantId)
            ->where("basket_owner", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();

        $ticketIds2 = DB::table("tai_ticket_task_owner")
            ->where('tenant_id', $tenantId)
            ->where("task_owner_id", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();

        $ticketIds = array_unique(array_merge($ticketIds1, $ticketIds2));
        if (count($ticketIds)) {
            $ticketIdImp = implode(",", $ticketIds);
        } else {
            $ticketIdImp = 0;
        }

        ////////////////////////////  MAIN QUERY ////////////////////////////////////////
        $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured, 
                CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department as assign_to_department, sm.status AS status_name, 
                CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                fd.department AS from_department_name,
                CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name, pm.project_name, pmod.module_name, smod.sub_module_name,
                qtm.query_type_name, te.template_name
                from tai_ticket_master AS tm 
                LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
                LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                LEFT JOIN tai_project_master AS pm ON pm.id = tm.project_id  
                LEFT JOIN tai_project_modules AS pmod ON pmod.id = tm.module_id
                LEFT JOIN tai_project_sub_modules AS smod ON smod.id = tm.submodule_id  
                LEFT JOIN tai_query_type_master AS qtm ON qtm.id = tm.query_type_id  
                LEFT JOIN tai_template_master AS te ON te.id = tm.template_id  
                WHERE tm.is_active = 1 AND tm.tenant_id =" . $tenantId . " AND tm.status_id !=3";

        //1.         ////////////////////////////  Created BY ME ////////////////////////////////////////
        $createdByMeSQL = $query . " AND tm.created_by = " . $userId . " ORDER BY tm.id desc";
        $createdByMe = DB::select(DB::raw($createdByMeSQL));

        //2.      //////////////////////////// MY TASK ////////////////////////////////////////
        $yourTaskSQL = $query . " AND ((tm.assign_to_user_id = " . $userId . ") OR tm.id IN (" . $ticketIdImp . ") ) AND tm.passed_status='PASS' ORDER BY tm.id desc";
        $yourTask = DB::select(DB::raw($yourTaskSQL));

        //3.
        $assignedToMeSQL = $query . " AND tm.assign_to_user_id = " . $userId . " AND tm.passed_status='PASS' ORDER BY tm.id desc";
        $assignedToMe = DB::select(DB::raw($assignedToMeSQL));

        //4.      ////////////////////////////  UNPASSED TICCKETS ////////////////////////////////////////
        $unpassedTicketsId = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)
            ->where('is_active', 1)
            ->where('ticket_passing_authority', 1)
            ->pluck('department_id')
            ->toArray();
        if (count($unpassedTicketsId) == 0) {
            $unpassedTicketsId[] = 0;
        }
        $unpassedTicketsSQL = $query . " AND tm.passed_status='UNPASS' AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")   
                                        ORDER BY tm.id desc";
        $unpassedTickets = DB::select(DB::raw($unpassedTicketsSQL));
        // dd($unpassedTickets);


        //5.      ////////////////////////////  DEPARTMENTWISE TICCKETS ////////////////////////////////////////   
        $mapping = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)->where('is_active', 1)->get();
        $assignedDepartmentTickets = [];
        $myDepartmentTickets = [];
        foreach ($mapping as $m) {
            if ($m->ticket_show_type == "DEPARTMENT_TICKETS") {
                $assignedDepartmentTickets[] = $m->department_id;
            } else {
                $myDepartmentTickets[] = $m->department_id;
            }
        };
        // dd($mapping);

        // return "a)".count($assignedDepartmentTickets)." b)".count($myDepartmentTickets);
        $departmentwiseTicketsSQL = $query;
        if (count($assignedDepartmentTickets)) {
            $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $assignedDepartmentTickets) . ")";
        } else {
            $departmentwiseTicketsSQL .= " AND tm.assign_to_department_id IN (" . implode(',', $myDepartmentTickets) . ")";
        }
        $departmentwiseTicketsSQL .= " AND tm.passed_status='PASS' ORDER BY tm.id desc";
        $departmentwiseTickets = DB::select(DB::raw($departmentwiseTicketsSQL));


        return response()->json([
            "status" => 1,
            "message" => "Data Found !!!",
            "data" => null,
            'unpassedTickets' => $unpassedTickets,
            'createdByMe' => $createdByMe,
            'yourTask' => $yourTask,
            'assignedToMe' => $assignedToMe,
            'departmentwiseTickets' => $departmentwiseTickets
        ]);
    }


    public function getAllTicketNew(Request $request)
    {
        $tenantId = $request->tenant_id;
        $userId = $request->user_id;
        $query = "SELECT tm.* ,(SELECT COUNT(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) AS basket_configured, 
        CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department AS assign_to_department, sm.status AS status_name, 
        CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
        fd.department AS from_department_name,
        CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
        FROM tai_ticket_master AS tm 
        LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
        LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
        LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
        LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
        LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
        LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
        WHERE tm.is_active = 1 ";


        if ($request->is_search && $request->is_search == "true") {
            $query .= " AND 1=1 ";

            if ($request->ticket_id) {
                $ticketIds = explode(',', $request->ticket_id);
                if (count($ticketIds)) {
                    $query .= " AND tm.ticket_id IN (" . implode(', ', array_map(function ($val) {
                        return sprintf("'%s'", $val);
                    }, $ticketIds)) . ")";
                }
            }

            if ($request->assign_to_user_id) {
                $userIds = $request->assign_to_user_id;
                if (count($userIds)) {
                    if ($userIds[0]) {
                        $query .= " AND ( tm.assign_to_user_id IN (" . implode(",", $request->assign_to_user_id) . ") OR
                        tm.created_by IN (" . implode(",", $request->assign_to_user_id) . ")
                        )";
                    }
                }
            }

            if ($request->assign_to_department_id) {
                $deparmentIds = $request->assign_to_department_id;
                if (count($deparmentIds)) {
                    if ($deparmentIds[0]) {
                        $query .= " AND (tm.assign_to_department_id IN (" . implode(",", $request->assign_to_department_id) . ")";
                    }
                }
            }

            if ($request->status_id) {
                $statusIds = $request->status_id;
                if (count($statusIds)) {
                    if ($statusIds[0]) {
                        $query .= " AND tm.status_id IN (" . implode(',', $request->status_id) . ")";
                    }
                }
            } else {
                $query .= " AND tm.status_id != '3'";
            }
            $allTicketsQuery = $query;
        } else {
            $allTicketsQuery = $query . " AND 
                    tm.id IN (
                        SELECT DISTINCT(my_task_ticket_id) FROM
                                (SELECT ticket_id AS my_task_ticket_id FROM tai_ticket_basket WHERE basket_owner=$userId AND is_active=1
                                    UNION
                                SELECT ticket_id AS my_task_ticket_id FROM tai_ticket_task_owner WHERE task_owner_id=$userId AND is_active=1
                                )  AS my_task_ticket_id
                        ) 
                OR ( tm.assign_to_department_id IN (SELECT department_id  FROM tai_employee_department_mapping WHERE employee_id=$userId AND is_active=1 AND ticket_show_type='DEPARTMENT_TICKETS')
                    AND ( tm.assign_to_department_id IN (SELECT department_id  FROM tai_employee_department_mapping WHERE employee_id=$userId AND is_active=1 AND ticket_show_type='MY_TICKETS')
                            AND
                        tm.assign_to_user_id = $userId)
                )
                OR (tm.created_by = $userId)
                AND tm.passed_status='PASS' AND tm.status_id!=3 ORDER BY tm.created_at DESC;";
        }
        $allTickets = DB::select(DB::raw($allTicketsQuery));


        //UNPASSED TICKETS
        $unpassedQuery = $query . " AND tm.assign_to_department_id IN ( SELECT department_id  FROM tai_employee_department_mapping WHERE employee_id=$userId AND is_active=1 AND ticket_passing_authority=1)
                            AND tm.passed_status='UNPASS' ORDER BY tm.created_at DESC";
        $unpassedTickets = DB::select(DB::raw($unpassedQuery));


        $data['allTickets'] = $allTickets;
        $data['unpassedTickets'] = $unpassedTickets;

        if (count($allTickets)) {
            return response()->json([
                "status" => 1,
                "message" => "Record found !!!",
                "data" => $data,
            ]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record found !!!", "data" => null]);
        }
    }


    public function getAllTicket(Request $request, $tenantId, $userId)
    {
        $ticketIds1 = DB::table("tai_ticket_basket")
            ->where('tenant_id', $tenantId)
            ->where("basket_owner", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();

        $ticketIds2 = DB::table("tai_ticket_task_owner")
            ->where('tenant_id', $tenantId)
            ->where("task_owner_id", $userId)->get()
            ->pluck("ticket_id")
            ->toArray();
        $ticketIds = array_unique(array_merge($ticketIds1, $ticketIds2));
        $ticketIdImp = implode(",", $ticketIds);

        if (count($ticketIds) > 0) {
            $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured, 
                        CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department as assign_to_department, sm.status AS status_name, 
                        CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                        fd.department AS from_department_name,
                        CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
                        from tai_ticket_master AS tm 
                        LEFT JOIN tai_employee_master AS em ON em.id = tm.assign_to_user_id 
                        LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                        LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                        LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                        LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                        LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                        WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId . "
                        AND ((tm.assign_to_user_id = " . $userId . " OR tm.created_by = " . $userId . ") OR tm.id IN (" . $ticketIdImp . ") )
                        AND tm.status_id !=3 
                        AND tm.passed_status='PASS'
                        ORDER BY tm.id desc";
        } else {
            $query = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured,
                        CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, dm.department AS assign_to_department, sm.status AS status_name, 
                        CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                        fd.department AS from_department_name,
                        CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
                        FROM tai_ticket_master AS tm 
                        LEFT JOIN tai_employee_master AS em on em.id = tm.assign_to_user_id 
                        LEFT JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                        LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                        LEFT JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                        LEFT JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id 
                        LEFT JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                        WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId . "
                        AND (tm.assign_to_user_id = " . $userId . " OR tm.created_by = " . $userId . ") 
                        AND tm.status_id!=3 
                        AND tm.passed_status='PASS'
                        ORDER BY tm.id desc";
        }

        $myTickets = DB::select(DB::raw($query));


        $unpassedTicketsId = DB::table('tai_employee_department_mapping')->where('employee_id', $userId)
            ->where('is_active', 1)
            ->where('ticket_passing_authority', 1)
            ->pluck('department_id')
            ->toArray();

        if (count($unpassedTicketsId)) {
            $unpassedTicketsQuery = "SELECT tm.*,(SELECT count(id) FROM tai_ticket_basket WHERE ticket_id=tm.id AND is_active=1) as basket_configured,
                    CONCAT(em.first_name,' ',em.last_name) AS assign_to_user, 
                    dm.department AS assign_to_department, sm.status AS status_name, 
                    CONCAT(em_c.first_name,' ',em_c.last_name) AS created_by_name,
                    fd.department AS from_department_name,
                    CONCAT(em_passed.first_name,' ',em_passed.last_name) AS passed_status_changed_by_name
                    FROM tai_ticket_master AS tm 
                    INNER JOIN tai_employee_master AS em on em.id = tm.assign_to_user_id 
                    INNER JOIN tai_employee_master AS em_c ON em_c.id = tm.created_by 
                    LEFT JOIN tai_employee_master AS em_passed ON em_passed.id = tm.passed_status_changed_by
                    INNER JOIN tai_status_master AS sm ON sm.id = tm.status_id 
                    INNER JOIN tai_department_master AS dm ON dm.id = tm.assign_to_department_id
                    INNER JOIN tai_department_master AS fd ON fd.id = tm.from_department_id  
                    WHERE tm.is_active = 1 AND tm.tenant_id = " . $tenantId . " AND passed_status='UNPASS'
                    AND tm.from_department_id IN (" . implode(',', $unpassedTicketsId) . ")   
                    ORDER BY tm.id desc";
            $unpassedTickets = DB::select(DB::raw($unpassedTicketsQuery));
        } else {
            $unpassedTickets = array();
        }

        if (count($myTickets) > 0) {
            return response()->json([
                "status" => 1, "message" => "Record found !!!",
                "myTickets" => $myTickets,
                "unpassedTickets" => $unpassedTickets
            ]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record found !!!", "data" => null]);
        }
    }

    public function getMappingData($mappingId)
    {
        $data = array();
        $cust = DB::table('tai_customer_mapping')->where('id', $mappingId)->first();
        if ($cust) {
            // $nextKey = '';
            //SINGLE PESON APPROACH
            if ($cust->approach == "SP") {
                $assign_to_user_id = $cust->user_policy;
            }
            //DEPARTMENT WISE ROUND ROBIN APPROACH
            if ($cust->approach == "RR") {
                $assigned_to = explode(',', $cust->user_policy);
                $last_entry = DB::table('tai_ticket_master')->whereIn('assign_to_user_id', $assigned_to)
                    ->orderBy('id', 'DESC')
                    ->limit(1)
                    ->first();
                // dd($last_entry, $assigned_to, $cust->user_policy);
                $nextKey = 0;
                foreach ($assigned_to  as $key => $value) {
                    if ($last_entry) {
                        if ($last_entry->assign_to_user_id == $value) {
                            $nextKey = $key + 1;
                            if ($nextKey >= count($assigned_to)) {
                                $nextKey = 0;
                            }
                            break;
                        }
                    }
                }
                $assign_to_user_id = $assigned_to[$nextKey];
            }
            //HAVING LESS TICKET APPROACH
            if ($cust->approach == "HLT" && $cust->user_policy) {

                // $cust->user_policy = str_replace(']', "", str_replace('[', "", str_replace('"', "", $cust->user_policy)));

                $query = "SELECT assign_to_user_id,count(id) as less_ticket FROM tai_ticket_master where assign_to_user_id in ($cust->user_policy) GROUP BY assign_to_user_id order by less_ticket limit 1";
                $lessAssignedUser = DB::SELECT(DB::RAW($query));

                $assign_to_user_id = $lessAssignedUser ? $lessAssignedUser[0]->assign_to_user_id : '';
            }


            // Date 20/02/2023 bhushan Patel add RW logic
            if ($cust->approach == "RW") {

                $explode_customer = [];
                $customer_arr = [];
                foreach (explode(',', $cust->user_policy) as $key => $customer) {
                    $explode_customer[] = explode(':', $customer);
                }
                foreach ($explode_customer as $key => $row) {
                    $customer_arr[$row[0]] = $row[1];
                }
                arsort($customer_arr);

                foreach ($customer_arr as $key => $percentage) {

                    $total_no_of_customer_assign_ticket = DB::table('tai_ticket_master')
                        ->where(['assign_to_user_id' => $key, 'assign_to_department_id' => $cust->department_id])
                        ->get();

                    $total_no_of_tickets = DB::table('tai_ticket_master')
                        ->where(['assign_to_department_id' => $cust->department_id])
                        ->get();

                    $total_percentage = count($total_no_of_customer_assign_ticket) * 100 / count($total_no_of_tickets);

                    if ($total_percentage < $percentage) {
                        $assign_to_user_id = $key;
                        break;
                    }
                }
            }

            //Percentage Wise
            // if($cust->approach=="HLT" && $cust->user_policy)
            // {
            //     $policy=explode(','$cust->user_policy);
            //     $userPolicy=array();
            //     $users=array();
            //     foreach($policy as $p){
            //         $poli=explode(';',$p);
            //         $users[]=$p[0];
            //         $userPolicy[$poli[0]]["assigned"]=$poli[1];
            //         $userPolicy[$poli[0]]["found"]=0;
            //     }

            //     $sql="SELECT main.*,((main.individual_ticket/100)*main.total_tickets) AS percentage FROM (
            //         SELECT COUNT(*) AS individual_ticket,assign_to_user_id,
            //         (SELECT COUNT(*) AS total_ticket FROM tai_ticket_master  WHERE  assign_to_user_id IN (implode(',',$users))) AS total_tickets
            //         FROM tai_ticket_master  WHERE  assign_to_user_id IN (implode(',',$users))  GROUP BY assign_to_user_id
            //         ) AS main";

            //     $result=DB::SELECT(DB::RAW($sql));
            //     if($result){
            //         foreach($result as $r){
            //             $userPolicy[$r->assign_to_user_id]['found']=$r->percentage;
            //         }
            //     }              
            $data['query_type_id'] = $cust->query_type_id;
            $data['priority'] = $cust->priority;
            $data['assign_to_department_id'] = $cust->department_id;
            // $data['template_id']=$cust->template_id;
            // $data['project_id']=$cust->project_id;
            // $data['module_id']=$cust->module_id;
            // $data['submodule_id']=$cust->submodule_id;
            $data['assign_to_user_id'] = $assign_to_user_id;
            return $data;
        } else {
            return;
        }
    }

    public function uploadBulkFormatTicket(Request $request)
    {
        $ticket = array();
        $uploadData = \Excel::toArray(null, $request->file('file'));
        $data = $uploadData[0];
        $header = $data[0];
        unset($data[0]);

        $mainData = array();
        foreach ($data as $d) {
            $mainData[] = array_combine($header, $d);
        }
        $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master_test");

        foreach ($mainData as $m) {

            $queryType = DB::table('tai_query_type_master')->where('query_type_name', $m['query_type'])->first();
            if ($queryType) {

                $series = "TT";
                $lastTicket = DB::table("tai_ticket_master_test")->orderBy("id", "desc")->limit(1)->first();
                if (!$lastTicket) {
                    $ticket_id = "2022";
                } else {
                    $a = substr($lastTicket->ticket_id, 2);
                    $ticket_id = (int)$a + 1;
                }

                $ticket["ticket_id"] = $series . $ticket_id;

                $ticket = array_merge($ticket, $m);

                $customer_mapping = DB::table('tai_customer_mapping')->where('query_type_id', $queryType->id)->first();
                $confirmation_required = $ticket['confirmation_required'];

                if ($request->confirmation_required) {
                    $confirmation_required = $request->confirmation_required;
                }
                $customerData = $customer_mapping ? $this->getMappingData($customer_mapping->id) : "";

                $ticket = array_merge($ticket, $customerData);

                if (!$customer_mapping->dynamic_form_id) {
                    $form = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->first();
                    $customer_mapping->dynamic_form_id = $form->form_id;
                }

                $df = DB::table('tai_dynamic_form')->where('id', $customer_mapping->dynamic_form_id)->first();
                $form = json_decode($df->data);

                foreach ($form as $key => $value) {
                    $form[$key]->inputDefaultValue = $m[$value->inputLabel];
                    unset($ticket[$value->inputLabel]);
                }
                $submitToMongo = json_encode($form);

                $ticket['cuid'] = $ticket['ref_id'];
                unset($ticket['query_type']);
                unset($ticket['ref_id']);

                $result = DB::table("tai_ticket_master_test")->insertGetId($ticket);

                if ($result) {
                    $a = new DynamicFormTest();
                    $a->id = $result;
                    $a->ticket_id = $ticket["ticket_id"];
                    $a->dynamic_data = $submitToMongo;
                    $a->save();
                    DB::table('tai_ticket_master_test')->where('id', $result)->update(['object_id' => $a->_id]);
                }
            }
        }
    }

    public function createTicketThroughApi(Request $request)
    {
        $data = $request->toArray();


        if (!array_key_exists('created_by_name', $data)) {
            return response()->json(['status' => 0, 'message' => "No Created User Found !!!", 'data' => $data]);
        }



        $createdByName = explode(' ', $data['created_by_name']);
        $firstName = $createdByName[0];

        if (count($createdByName) == 2) {
            $lastName = $createdByName[1];
        }
        if (count($createdByName) == 3) {
            $lastName = $createdByName[2];
        }
        $findCreatedBy = DB::table('tai_employee_master')->where('first_name', $firstName)
            ->where('last_name', $lastName)
            ->first();

        $data['created_by'] = $findCreatedBy ? $findCreatedBy->id : NULL;
        if (!$data['created_by']) {
            return response()->json(['status' => 0, 'message' => "No Created User Found !!!", 'data' => $data]);
        }

        // $data['from_department_id']=DB::table('tai_employee_department_mapping')->where('employee_id',$data['created_by'])
        //                                                                         ->where('is_default',1)
        //                                                                         ->where('is_active',1)    
        //                                                                         ->first();  
        // // if(!$data['from_department_id']){   
        // //     return response()->json(['status'=>0,'message'=>"User Department Found !!!",'data'=>$data]);
        // // }


        $customer_mapping_id = DB::table('tai_customer_mapping')->where('is_active', 1)
            ->where('tenant_id', $data['tenant_id'])
            ->where('priority', $data['priority'])
            ->where('query_type_id', $data['query_type_id'])
            ->first();

        if (!$customer_mapping_id) {
            return response()->json(['status' => 0, 'message' => "Mapping not found !!!", 'data' => $data]);
        }

        if ($customer_mapping_id->is_active == 0) {
            return response()->json(['status' => 0, 'message' => "Mapping is deactivated !!!", 'data' => $data]);
        }

        $customer = $this->getMappingData($customer_mapping_id->id);


        if ($customer) {
            $data = array_merge($data, $customer);
        } else {
            return response()->json(['status' => 0, 'message' => "Mapping data not generated !!!", 'data' => $data]);
        }

        $data['confirmation_required'] = 0;
        $data['passed_status'] = "PASS";


        $series = "TT";
        $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
        if (!$lastTicket) {
            $ticket_id = "2022";
        } else {
            $a = substr($lastTicket->ticket_id, 2);
            $ticket_id = (int)$a + 1;
        }

        $data["ticket_id"] = $series . $ticket_id;
        $submitToMongo = "";


        $data['confirmation_required'] = 0;


        if ($data['query_type_id']) {
            //1.Compare actual columns required with all form data
            $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
            $ticketColumns[] = "attachment";

            //2.Filter and genrate dynamic form data received in request
            $dynamicForm = array();
            foreach ($data as $key => $value) {
                if (!in_array($key, $ticketColumns)) {
                    $dynamicForm[$key] = $value;
                    unset($data[$key]);
                }
            }
            //3. Get actual json form
            $dynamicFormData = DB::table('tai_query_type_master as t')
                ->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                ->where('t.id', $data['query_type_id'])
                ->select('d.data')
                ->first();


            if ($dynamicFormData) {
                $form = json_decode($dynamicFormData->data);

                foreach ($form as $key => $value) {
                    foreach ($value as $k => $v) {
                        if ($k != "inputAddOn") {
                            if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                                $form[$key]->inputDefaultValue = $dynamicForm[$v];
                            }
                        }
                    }
                }
                $submitToMongo = json_encode($form);
            }
        }


        // $data['ticket_date']=date('Y-m-d');
        $data['status_id'] = 1;
        $data['passed_status'] = "PASS";
        $data['created_at'] = now();
        $data['confirmation_required'] = "1";

        $result = DB::table("tai_ticket_master")->insertGetId($data);
        if ($result) {
            if ($submitToMongo) {
                $a = new DynamicForm();
                $a->id = $result;
                $a->ticket_id = $data["ticket_id"];
                $a->dynamic_data = $submitToMongo;
                $a->save();
                DB::table('tai_ticket_master')
                    ->where('id', $result)->update(['object_id' => $a->_id]);
            }

            //Mapping
            if (array_key_exists('project_id', $data) && $data['project_id']) {
                OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], $data['project_id'], $result, 0, 0);
            } else {
                OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], 0, $result, 0, 0);
            }


            return response()->json(['status' => 1, 'message' => "Ticket Generated !!!", 'data' => $data['ticket_id']]);
        } else {
            return response()->json(["status" => 0, "message" => "Ticket Not Generated", "data" => $data]);
        }
    }

    // public function createTicket(Request $request)
    // {
    //     $data = $request->toArray();
    //     if (!array_key_exists('ticket_uploading', $data)) {
    //         $data['ticket_uploading'] = "REGULAR";
    //     }

    //     if ($data['ticket_uploading'] == "REGULAR") {
    //         unset($data['ticket_uploading']);

    //         if (array_key_exists('ticket_uploading', $data)) {
    //             unset($data['ticket_uploading']);
    //         }

    //         if (array_key_exists('from_department_id', $data)) {
    //             if (!$data['from_department_id']) {
    //                 return response()->json(["status" => 0, "message" => "Department not found !!!", "data" => null]);
    //             }
    //         }

    //         if (array_key_exists('created_by', $data)) {
    //             if (!$data['created_by']) {
    //                 return response()->json(["status" => 0, "message" => "Didnt found user id...Please Logout and try login again !!!", "data" => null]);
    //             }
    //         }
    //         //Generate Ticket Id
    //         $series = "TT";
    //         $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
    //         if (!$lastTicket) {
    //             $ticket_id = "2022";
    //         } else {
    //             $a = substr($lastTicket->ticket_id, 2);
    //             $ticket_id = (int)$a + 1;
    //         }

    //         $data["ticket_id"] = $series . $ticket_id;
    //         $submitToMongo = "";

    //         //Creat Mapping Data
    //         $customer = $request->customer_mapping_id ? $this->getMappingData($request->customer_mapping_id) : "";
    //         if ($customer) {
    //             $data = array_merge($data, $customer);
    //         }

    //         if (array_key_exists('confirmation_required', $data)) {
    //             $data['confirmation_required'] = $data['confirmation_required'];
    //             if ($request->confirmation_required) {
    //                 $data['confirmation_required'] = $request->confirmation_required;
    //             }
    //         } else {
    //             $data['confirmation_required'] = 1;
    //         }

    //         if (!array_key_exists("assign_to_user_id", $data)) {
    //             return response()->json(["status" => 0, "message" => "Error while assigning to user !!!", "data" => null]);
    //         } else if (array_key_exists("assign_to_user_id", $data) && !$data['assign_to_user_id']) {
    //             return response()->json(["status" => 0, "message" => "Error while assigning to user !!!", "data" => null]);
    //         }

    //         if ($request->query_type_id) {
    //             //LOGIN
    //             //1.Compare actual columns required with all form data
    //             $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
    //             $ticketColumns[] = "attachment";

    //             //2.Filter and genrate dynamic form data received in request
    //             $dynamicForm = array();
    //             foreach ($data as $key => $value) {
    //                 if (!in_array($key, $ticketColumns)) {
    //                     $dynamicForm[$key] = $value;
    //                     unset($data[$key]);
    //                 }
    //             }
    //             //3. Get actual json form
    //             $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
    //                 ->where('t.id', $request->query_type_id)
    //                 ->select('d.data')
    //                 ->first();
    //             if ($dynamicFormData) {
    //                 $form = json_decode($dynamicFormData->data);
    //                 //4.  Loop throuh json form
    //                 //5.  inputAddOn will have array exclude from comparison
    //                 //6.  compare value only if key=inputName;
    //                 //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
    //                 //8.   array_key is used to check the name is present in dynamicform array generated in step 2
    //                 //9.  If value matches then change the value in object named as inputValue
    //                 //10. Dynamic Form Json will be read
    //                 foreach ($form as $key => $value) {
    //                     foreach ($value as $k => $v) {
    //                         if ($k != "inputAddOn") {
    //                             if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
    //                                 $form[$key]->inputDefaultValue = $dynamicForm[$v];
    //                             }
    //                         }
    //                     }
    //                 }
    //                 $submitToMongo = json_encode($form);
    //             }
    //         }
    //         unset($data["attachment"]);

    //         $data['ticket_date'] = date('Y-m-d');
    //         $data['status_id'] = 1;

    //         //If user has authority then ticket will automatically PASS
    //         $checkPassingAuthority = DB::table('tai_employee_department_mapping')->where('employee_id', $data['created_by'])
    //             ->where('department_id', $data['from_department_id'])
    //             ->where('is_active', 1)
    //             ->first();
    //         if ($checkPassingAuthority->ticket_passing_authority == 1) {
    //             $data['passed_status'] = "PASS";
    //             $data['passed_status_changed_by'] = $data['created_by'];
    //             $data['passed_status_remark'] = "AUTO PASS";
    //             $data['passed_status_changed_at'] = now();
    //         }

    //         $result = DB::table("tai_ticket_master")->insertGetId($data);

    //         if ($result) {
    //             if ($submitToMongo) {
    //                 $a = new DynamicForm();
    //                 $a->id = $result;
    //                 $a->ticket_id = $data["ticket_id"];
    //                 $a->dynamic_data = $submitToMongo;
    //                 $a->save();
    //                 DB::table('tai_ticket_master')
    //                     ->where('id', $result)->update(['object_id' => $a->_id]);
    //             }

    //             //If Upload has attachment then upload
    //             if ($request->file("attachment")) {
    //                 CommonController::uploadAttachment($result, $request->file("attachment"), "TICKET", $data["created_at"]);
    //             }

    //             //Add Notification for user
    //             $userInfo = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);
    //             $msg = "Ticket " . $data["ticket_id"] . " has been assigned by " . $userInfo->first_name . " " . $userInfo->last_name;
    //             $url = "Ticket/" . $result;
    //             CommonController::addNotification($data["created_by"], $data["assign_to_user_id"], $msg, $url);


    //             $tick_id = $data['ticket_id'];

    //             //Mapping
    //             if (array_key_exists('project_id', $data) && $data['project_id']) {
    //                 OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], $data['project_id'], $result, 0, 0);
    //             } else {
    //                 OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], 0, $result, 0, 0);
    //             }

    //             CommonController::generateHistory("INSERT", 'tai_ticket_master', $result);


    //             return response()->json(["status" => 1, "message" => "Ticket - $tick_id has been created !!!", "data" => null]);
    //         } else {
    //             return response()->json(["status" => 0, "message" => "Record Not Inserted !!!", "data" => null]);
    //         }
    //     } else {
    //         if (!$request->file('bulk_upload_file')) {
    //             return response()->json(["status" => 0, "message" => "Upload file for processing !!!", "data" => null]);
    //         }

    //         $fileExtension = $request->file('bulk_upload_file')->getClientOriginalExtension();
    //         $requiredExtension = ['csv'];

    //         if (!in_array($fileExtension, $requiredExtension)) {
    //             return response()->json(["status" => 0, "message" => "Required Only  " . implode(',', $requiredExtension) . " !!!", "data" => null]);
    //         }

    //         unset($data['ticket_uploading']);
    //         if (array_key_exists('ticket_uploading', $data)) {
    //             unset($data['ticket_uploading']);
    //         }


    //         $ticket = array();
    //         $uploadData = \Excel::toArray(null, $request->file('bulk_upload_file'));
    //         $dataMain = $data;
    //         $data = $uploadData[0];     //get all value of data present in 0 index


    //         //Consider 1st row as header
    //         $header = $data[0];
    //         // dd($header);
    //         //Check 1st Row is present
    //         if (!$header) {
    //             return response()->json(["status" => 0, "message" => "File Is empty !!!", "data" => null]);
    //         }
    //         unset($data[0]);

    //         if (count($data) == 0) {
    //             return response()->json(["status" => 0, "message" => "File Is Empty or Missing Headers!!!", "data" => null]);
    //         }

    //         $mainData = array();
    //         // dd($data);
    //         foreach ($data as $d) {
    //             $mainData[] = array_combine($header, $d);
    //         }

    //         $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master_test");

    //         foreach ($mainData as $m) {
    //             // dd($mainData);
    //             // query type
    //             $queryType = DB::table('tai_query_type_master')->where('query_type_name', $m['query_type'])->first();
    //             if ($queryType) {

    //                 $series = "TT";
    //                 $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
    //                 if (!$lastTicket) {
    //                     $ticket_id = "2022";
    //                 } else {
    //                     $a = substr($lastTicket->ticket_id, 2);
    //                     $ticket_id = (int)$a + 1;
    //                 }

    //                 $ticket["ticket_id"] = $series . $ticket_id;

    //                 $ticket = array_merge($ticket, $m);


    //                 $customer_mapping = DB::table('tai_customer_mapping')->where('query_type_id', $queryType->id)->first();
    //                 $customerData = $customer_mapping ? $this->getMappingData($customer_mapping->id) : "";
    //                 $ticket = array_merge($ticket, $customerData);

    //                 if (!$customer_mapping->dynamic_form_id) {
    //                     $form = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->first();
    //                     $customer_mapping->dynamic_form_id = $form->form_id;
    //                 }




    //                 $df = DB::table('tai_dynamic_form')->where('id', $customer_mapping->dynamic_form_id)->first();
    //                 $form = json_decode($df->data);
    //                 // dd($form);
    //                 foreach ($form as $key => $value) {
    //                     // dd($key, $value);
    //                     $form[$key]->inputDefaultValue = $m[$value->inputLabel];
    //                     unset($ticket[$value->inputLabel]);
    //                 }
    //                 $submitToMongo = json_encode($form);

    //                 $ticket['cuid'] = $ticket['ref_id'];
    //                 unset($ticket['query_type']);
    //                 unset($ticket['ref_id']);

    //                 $ticket['ticket_date'] = date('Y-m-d');
    //                 $ticket['status_id'] = 1;
    //                 $ticket['created_at'] = $request->created_at;
    //                 $ticket['created_by'] = $request->created_by;
    //                 $ticket['tenant_id'] = $request->tenant_id;
    //                 $ticket['from_department_id'] = $request->from_department_id;


    //                 if (array_key_exists('confirmation_required', $data)) {
    //                     $data['confirmation_required'] = $data['confirmation_required'];
    //                     if ($request->confirmation_required) {
    //                         $data['confirmation_required'] = $request->confirmation_required;
    //                     }
    //                 } else {
    //                     $data['confirmation_required'] = 1;
    //                 }

    //                 //If user has authority then ticket will automatically PASS
    //                 $checkPassingAuthority = DB::table('tai_employee_department_mapping')
    //                     ->where('employee_id', $dataMain['created_by'])
    //                     ->where('department_id', $dataMain['from_department_id'])
    //                     ->where('is_active', 1)
    //                     ->first();

    //                 if ($checkPassingAuthority->ticket_passing_authority == 1) {
    //                     $data['passed_status'] = "PASS";
    //                     $data['passed_status_changed_by'] = $dataMain['created_by'];
    //                     $data['passed_status_remark'] = "AUTO PASS";
    //                     $data['passed_status_changed_at'] = now();
    //                 }
    //                 // dd($ticket);
    //                 $result = DB::table("tai_ticket_master")->insertGetId($ticket);

    //                 if ($result) {
    //                     $a = new DynamicFormTest();
    //                     $a->id = $result;
    //                     $a->ticket_id = $ticket["ticket_id"];
    //                     $a->dynamic_data = $submitToMongo;
    //                     $a->save();
    //                     DB::table('tai_ticket_master')->where('id', $result)->update(['object_id' => $a->_id]);

    //                     CommonController::generateHistory("INSERT", 'tai_ticket_master', $result);
    //                 }
    //             }
    //             else{
    //                 return response()
    //             ->json(["status" => 1, "message" => "Invalid Query Type  !!!", "data" => null]);
    //             }
    //         }

    //         return response()
    //             ->json(["status" => 1, "message" => "Tickets Created !!!", "data" => null]);
    //     }
    // }

    public function createTicket(Request $request)
    {
        $data = $request->toArray();
        // dd($data);
        if (!array_key_exists('ticket_uploading', $data)) {
            $data['ticket_uploading'] = "REGULAR";
        }

        if ($data['ticket_uploading'] == "REGULAR") {

            if (array_key_exists('ticket_uploading', $data)) {
                unset($data['ticket_uploading']);
            }

            if (array_key_exists('from_department_id', $data)) {
                if (!$data['from_department_id']) {
                    return response()->json(["status" => 0, "message" => "Department not found !!!", "data" => null]);
                }
            } else {
                return response()->json(["status" => 0, "message" => "Department Key not found !!!", "data" => null]);
            }

            if (array_key_exists('created_by', $data)) {
                if (!$data['created_by']) {
                    return response()->json(["status" => 0, "message" => "Didnt found user id...Please Logout and try login again !!!", "data" => null]);
                }
            } else {
                return response()->json(["status" => 0, "message" => "Created User Key not found !!!", "data" => null]);
            }

            //Generate Ticket Id
            $series = "TT";
            $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
            if (!$lastTicket) {
                $ticket_id = "2022";
            } else {
                $a = substr($lastTicket->ticket_id, 2);
                $ticket_id = (int)$a + 1;
            }

            $data["ticket_id"] = $series . $ticket_id;
            $submitToMongo = "";


            //Create Mapping Data

            //QUE : Here we get assign user what is point of calling method ?
            //NEW UPDATE

            //*********************************************************************/
            //    if(!array_key_exists("assign_to_user_id", $data))
            //    { 
            //         $customer = $request->customer_mapping_id ? $this->getMappingData($request->customer_mapping_id) : "";
            //         if($customer){
            //             $data["assign_to_user_id"] = $customer;
            //         }else{
            //             return response()->json(["status" => 0, "message" => "Error while assigning to user  !!!", "data" => null]);   
            //         }
            //     }
            //OLD CODE
            $customer = $request->customer_mapping_id ? $this->getMappingData($request->customer_mapping_id) : "";
            if ($customer) {

                // new code generation 27-02-2023 START                
                if (!array_key_exists("assign_to_user_id", $data)) {
                    $assign_to_user_id = $this->getMappingData($request->customer_mapping_id);
                    if ($assign_to_user_id) {
                        $data["assign_to_user_id"] = $assign_to_user_id;
                    } else {
                        return response()->json(["status" => 0, "message" => "Error while assigning to user 123 !!!", "data" => null]);
                    }
                } else if (array_key_exists("assign_to_user_id", $data) && !$data['assign_to_user_id']) {
                    return response()->json(["status" => 0, "message" => "Error while assigning to user!!!", "data" => null]);
                }
                // new code generation 27-02-2023 END
                $data = array_merge($data, $customer);   // ?
            }

            //*********************************************************************/

            if (array_key_exists('confirmation_required', $data)) {
                $data['confirmation_required'] = $data['confirmation_required'];
                if ($request->confirmation_required) {
                    $data['confirmation_required'] = $request->confirmation_required;
                }
            } else {
                $data['confirmation_required'] = 1;
            }

            // dd($data);
            // if (!array_key_exists("assign_to_user_id", $data)) {
            //     return response()->json(["status" => 0, "message" => "Error while assigning to user !!!", "data" => null]);
            // } else if (array_key_exists("assign_to_user_id", $data) && !$data['assign_to_user_id']) {
            //     return response()->json(["status" => 0, "message" => "Error while assigning to user !!!", "data" => null]);
            // }

            if ($request->query_type_id) {
                //LOGIN
                //1.Compare actual columns required with all form data
                $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
                $ticketColumns[] = "attachment";

                //2.Filter and genrate dynamic form data received in request
                $dynamicForm = array();
                foreach ($data as $key => $value) {
                    if (!in_array($key, $ticketColumns)) {
                        $dynamicForm[$key] = $value;
                        unset($data[$key]);
                    }
                }
                //3. Get actual json form
                $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                    ->where('t.id', $request->query_type_id)
                    ->select('d.data')
                    ->first();
                if ($dynamicFormData) {
                    $form = json_decode($dynamicFormData->data);
                    //4.  Loop throuh json form
                    //5.  inputAddOn will have array exclude from comparison
                    //6.  compare value only if key=inputName;
                    //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
                    //8.   array_key is used to check the name is present in dynamicform array generated in step 2
                    //9.  If value matches then change the value in object named as inputValue
                    //10. Dynamic Form Json will be read
                    foreach ($form as $key => $value) {
                        foreach ($value as $k => $v) {
                            if ($k != "inputAddOn") {
                                if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                                    $form[$key]->inputDefaultValue = $dynamicForm[$v];
                                }
                            }
                        }
                    }
                    $submitToMongo = json_encode($form);
                }
            }
            unset($data["attachment"]);

            $data['ticket_date'] = date('Y-m-d');
            $data['status_id'] = 1;

            //If user has authority then ticket will automatically PASS
            $checkPassingAuthority = DB::table('tai_employee_department_mapping')->where('employee_id', $data['created_by'])
                ->where('department_id', $data['from_department_id'])
                ->where('is_active', 1)
                ->first();

            if ($checkPassingAuthority->ticket_passing_authority == 1) {
                $data['passed_status'] = "PASS";
                $data['passed_status_changed_by'] = $data['created_by'];
                $data['passed_status_remark'] = "AUTO PASS";
                $data['passed_status_changed_at'] = now();
            }

            $result = DB::table("tai_ticket_master")->insertGetId($data);

            if ($result) {
                if ($submitToMongo) {
                    $a = new DynamicForm();
                    $a->id = $result;
                    $a->ticket_id = $data["ticket_id"];
                    $a->dynamic_data = $submitToMongo;
                    $a->save();
                    DB::table('tai_ticket_master')
                        ->where('id', $result)->update(['object_id' => $a->_id]);
                }

                //If Upload has attachment then upload
                if ($request->file("attachment")) {
                    CommonController::uploadAttachment($result, $request->file("attachment"), "TICKET", $data["created_at"]);
                }

                // if(!$data["created_by"]){
                //Add Notification for user
                // $userInfo = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);
                // $msg = "Ticket " . $data["ticket_id"] . " has been assigned by " . $userInfo->first_name . " " . $userInfo->last_name;
                // $url = "Ticket/" . $result;
                // CommonController::addNotification($data["created_by"], $data["assign_to_user_id"], $msg, $url);
                // CommonController::addNotification($data["created_by"], $checkPassingAuthority->employee_id, $msg, $url);


                $tick_id = $data['ticket_id'];

                //Mapping
                if (array_key_exists('project_id', $data) && $data['project_id']) {
                    OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], $data['project_id'], $result, 0, 0);
                } else {
                    OwnershipController::mapping('Insert', 'TICKET', $data['assign_to_user_id'], 0, $result, 0, 0);
                }

                CommonController::generateHistory("INSERT", 'tai_ticket_master', $result);
                // }

                return response()->json(["status" => 1, "message" => "Ticket - $tick_id has been created !!!", "data" => null]);
            } else {
                return response()->json(["status" => 0, "message" => "Record Not Inserted !!!", "data" => null]);
            }
        } else {
            if (!$request->file('bulk_upload_file')) {
                return response()->json(["status" => 0, "message" => "Upload file for processing !!!", "data" => null]);
            }

            $fileExtension = $request->file('bulk_upload_file')->getClientOriginalExtension();
            $requiredExtension = ['csv'];

            if (!in_array($fileExtension, $requiredExtension)) {
                return response()->json(["status" => 0, "message" => "Required Only  " . implode(',', $requiredExtension) . " !!!", "data" => null]);
            }

            unset($data['ticket_uploading']);
            if (array_key_exists('ticket_uploading', $data)) {
                unset($data['ticket_uploading']);
            }


            $ticket = array();
            $uploadData = \Excel::toArray(null, $request->file('bulk_upload_file'));
            $dataMain = $data;
            $data = $uploadData[0];     //get all value of data present in 0 index


            //Consider 1st row as header
            $header = $data[0];
            // dd($header);
            //Check 1st Row is present
            if (!$header) {
                return response()->json(["status" => 0, "message" => "File Is empty !!!", "data" => null]);
            }
            unset($data[0]);

            if (count($data) == 0) {
                return response()->json(["status" => 0, "message" => "File Is Empty or Missing Headers!!!", "data" => null]);
            }

            $mainData = array();
            // dd($data);
            foreach ($data as $d) {
                $mainData[] = array_combine($header, $d);
            }

            $exceptionData = [];
            $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master_test");

            foreach ($mainData as $m) {

                $flag = 0;

                $error = [];

                // dd($mainData, $m);
                // query type
                $queryType = DB::table('tai_query_type_master')->where('query_type_name', $m['query_type'])->first();
                if ($queryType) {

                    $customer_mapping = DB::table('tai_customer_mapping')->where('query_type_id', $queryType->id)->first();
                    if ($customer_mapping) {
                        $customerData = $customer_mapping ? $this->getMappingData($customer_mapping->id) : "";
                        $ticket = array_merge($ticket, $customerData);
                        // dd($ticket);
                        if (!$customer_mapping->dynamic_form_id) {
                            $form = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->first();
                            $customer_mapping->dynamic_form_id = $form->form_id;
                        }

                        $df = DB::table('tai_dynamic_form')->where('id', $customer_mapping->dynamic_form_id)->first();
                        $form = json_decode($df->data);
                        // dd($form);
                        foreach ($form as $key => $value) {
                            // dd($key, $value);/
                            $form[$key]->inputDefaultValue = $m[$value->inputLabel];
                            unset($ticket[$value->inputLabel]);
                            // } else {
                        }
                        $submitToMongo = json_encode($form);
                    }

                    if ($m['ref_id']) {
                        $ticket['cuid'] = $m['ref_id'];
                        unset($ticket['query_type']);
                        // unset($m['ref_id']);
                    } else {
                        // $error[] = 'Invalid Ref Id';
                    }


                    $priority_array = ['Low', 'High', 'Medium', 'Very High','LOW', 'HIGH', 'MEDIUM', 'VERY HIGH','low', 'high', 'medium', 'very high'];
                    if ($m['priority']) {
                        if (in_array($m['priority'], $priority_array)) {
                            $ticket['priority'] = $m['priority'];
                        } else {
                            $error[] = 'Invalid Priority';
                        }
                    } else {
                        $error[] = 'Priority Missing';
                    }

                    // $ticket['ref_id'] = $m['ref_id'];


                    if (array_key_exists('confirmation_required', $data)) {
                        $data['confirmation_required'] = $data['confirmation_required'];
                        if ($request->confirmation_required) {
                            if ($request->confirmation_required == 'Yes') {
                                $data['confirmation_required'] = 1; //$request->confirmation_required;
                            } elseif ($request->confirmation_required == 'No') {
                                $data['confirmation_required'] = 0; //$request->confirmation_required;
                            } else {
                                $error[] = 'Invalid confirmation required';
                            }
                        }
                    } else {
                        $data['confirmation_required'] = 1;
                    }

                    if ($m['description']) {
                        $ticket['description'] = $m['description'];
                    } else {
                        $error[] = 'Description Missing';
                    }
                } else {
                    $error[] = 'Invalid Query Type';
                }

                // dd($error, $m);
                if (count($error) == 0) {

                    // dd($ticket);
                    $series = "TT";
                    $lastTicket = DB::table("tai_ticket_master")->orderBy("id", "desc")->limit(1)->first();
                    if (!$lastTicket) {
                        $ticket_id = "2022";
                    } else {
                        $a = substr($lastTicket->ticket_id, 2);
                        $ticket_id = (int)$a + 1;
                    }


                    // $ticket = array_merge($ticket, $m);
                    // dd($ticket);
                    $ticket["ticket_id"] = $series . $ticket_id;

                    $ticket['ticket_date'] = date('Y-m-d');
                    $ticket['status_id'] = 1;
                    $ticket['created_at'] = $request->created_at;
                    $ticket['created_by'] = $request->created_by;
                    $ticket['tenant_id'] = $request->tenant_id;
                    $ticket['from_department_id'] = $request->from_department_id;


                    //If user has authority then ticket will automatically PASS
                    $checkPassingAuthority = DB::table('tai_employee_department_mapping')
                        ->where('employee_id', $dataMain['created_by'])
                        ->where('department_id', $dataMain['from_department_id'])
                        ->where('is_active', 1)
                        ->first();

                    if ($checkPassingAuthority->ticket_passing_authority == 1) {
                        $data['passed_status'] = "PASS";
                        $data['passed_status_changed_by'] = $dataMain['created_by'];
                        $data['passed_status_remark'] = "AUTO PASS";
                        $data['passed_status_changed_at'] = now();
                    }
                    // dd($ticket);

                    $result = DB::table("tai_ticket_master")->insertGetId($ticket);
                    if ($result) {
                        $a = new DynamicFormTest();
                        $a->id = $result;
                        $a->ticket_id = $ticket["ticket_id"];
                        $a->dynamic_data = $submitToMongo;
                        $a->save();
                        DB::table('tai_ticket_master')->where('id', $result)->update(['object_id' => $a->_id]);

                        CommonController::generateHistory("INSERT", 'tai_ticket_master', $result);
                    } else {
                    }
                } else {
                    if ($form && count($form) > 0) {
                        foreach ($form as $value) {
                            $ticket[$value->inputLabel] = $m[$value->inputLabel];
                        }
                    }
                    $m['remark'] = implode(',', $error);
                    $exceptionData[] = $m;
                }
                // } else {

                //     // $error[] = 'Invalid Query Type';
                //     return response()
                //         ->json(["status" => 1, "message" => "Invalid Query Type  !!!", "data" => null]);
                // }
            }

            if (count($exceptionData) > 0) {

                // dd($error, $exceptionData);
                $delimeter = ',';
                // dd(storage_path());
                $filename = 'create_ticket_error_file' . date('YmdHis') . '.csv';
                $f = fopen(storage_path('app/' . $filename), 'w');

                $header = array_merge($header, array('Error Remark'));

                foreach ($header as $key => $value) {
                    $header[$key] = str_replace('_', ' ', ucwords($value));
                }
                fputcsv($f, $header, $delimeter);
                foreach ($exceptionData as $d) {
                    fputcsv($f, array_values($d), $delimeter);
                }
                fclose($f);

                $message = 'Download Error File';
                $type = 'danger';

                return response()
                    ->json(["status" => 0, "message" => "Download Error File!!!", "data" => "storage/app/" . $filename]);
            } else {
                return response()
                    ->json(["status" => 1, "message" => "Tickets Created !!!", "data" => null]);
            }
        }
    }

    public function getDownloadErrorFile($data)
    {
        if (count($data) > 0) {
            header('Content-Type: text/csv');
            header('Content-Disposition: attachment; filename="sample.csv"');

            $header = array_keys($data[0]);

            foreach ($header as $key => $value) {
                $header[$key] = str_replace('_', ' ', ucwords($value));
            }

            $delimiter = ",";
            $f1  = fopen(storage_path('app/Update_Error_File.csv'), 'w');
            fputcsv($f1, $header, $delimiter);

            foreach ($data as $d) {
                fputcsv($f1, array_values($d), $delimiter);
            }
            fclose($f1);
        }
    }


    // old parth sir
    // public function updateTicket(Request $request, $id)
    // {

    //     $data = $request->toArray();
    //     // $data = array_merge($dataOne, ["template_id" => "63"]);
    //     // $dates = TaskSupportiveController::getBetweenDates($data["ticket_date"], $data["expected_solve_date"]);

    //     $submitToMongo = "";
    //     if ($request->query_type_id) {
    //         //LOGIN
    //         //1.Compare actual columns required with all form data
    //         $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
    //         $ticketColumns[] = "attachment";

    //         //2.Filter and genrate dynamic form data received in request
    //         $dynamicForm = array();
    //         foreach ($data as $key => $value) {
    //             if (!in_array($key, $ticketColumns)) {
    //                 $dynamicForm[$key] = $value;
    //                 unset($data[$key]);
    //             }
    //         }

    //         //3. Get actual json form
    //         $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
    //             ->where('t.id', $request->query_type_id)
    //             ->select('d.data')
    //             ->first();
    //         if ($dynamicFormData) {
    //             $form = json_decode($dynamicFormData->data);
    //             //4.  Loop throuh json form
    //             //5.  inputAddOn will have array exclude from comparison
    //             //6.  compare value only if key=inputName;
    //             //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
    //             //8.   array_key is used to check the name is present in dynamicform array generated in step 2
    //             //9.  If value matches then change the value in object named as inputValue
    //             //10. Dynamic Form Json will be read
    //             foreach ($form as $key => $value) {
    //                 foreach ($value as $k => $v) {
    //                     if ($k != "inputAddOn") {
    //                         if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
    //                             $form[$key]->inputDefaultValue = $dynamicForm[$v];
    //                         }
    //                     }
    //                 }
    //             }
    //             $submitToMongo = json_encode($form);
    //         }
    //     }

    //     //check date of ticket are matching to template task required days
    //     // if ($data["template_id"]) {
    //     //     //Update Template
    //     //     $pp = DB::table('tai_ticket_master as tm')
    //     //         ->join('tai_ticket_basket as tb','tb.ticket_id','=','tm.id')
    //     //         ->join('tai_ticket_task as tt','tb.id','=','tt.ticket_basket_id')
    //     //         ->where('tm.id', $id)
    //     //         ->update(['tb.is_active'=>'0', 'tt.is_active'=>'0']);
    //     //     $selectTemplateBasket = DB::table("tai_template_basket")
    //     //         ->where("template_id", $data["template_id"])
    //     //         ->get();
    //     //     foreach ($selectTemplateBasket as $key => $value) {
    //     //         $selectTemplateBasketTask = DB::table(
    //     //             "tai_template_basket_task"
    //     //         )
    //     //             ->where("template_basket_id", $value->id)
    //     //             ->get();
    //     //         foreach ($selectTemplateBasketTask as $key1 => $value1) {
    //     //             if(count($dates)>0){
    //     //                 $d1 = strtotime($dates[array_key_first($dates)]);
    //     //                 $d2 = strtotime($dates[array_key_last($dates)]);
    //     //                 $interval = (int) (($d2 - $d1) / 86400);
    //     //                 // echo $interval;
    //     //                 if ($interval < $value1->total_time) {
    //     //                     return response()->json([
    //     //                         "status" => 0,
    //     //                         "message" => "Choose Proper Dates Also Check Sat/Sun !!!",
    //     //                         "data" => null,
    //     //                     ]);
    //     //                 }
    //     //             }else{
    //     //                 return response()->json([
    //     //                         "status" => 0,
    //     //                         "message" => "Choose Proper Dates Also Check Sat/Sun !!!",
    //     //                         "data" => null,
    //     //                     ]);
    //     //             }
    //     //         }
    //     //     }
    //     // }
    //     //Add Basket and Task through template
    //     // if ($data["template_id"]) {
    //     //     $selectTemplate = DB::table("tai_template_master")
    //     //         ->where("id", $data["template_id"])
    //     //         ->first();
    //     //     $cal_from = $selectTemplate->calculate_from;
    //     //     $selectTemplateBasket = DB::table("tai_template_basket")
    //     //         ->where("template_id", $data["template_id"])
    //     //         ->get();
    //     //     foreach ($selectTemplateBasket as $key => $value) {
    //     //         $basketId = DB::table("tai_ticket_basket")->insertGetId([
    //     //             // "tenant_id" => $data["tenant_id"],
    //     //             "ticket_id" => $id,
    //     //             "basket_name" => $value->basket_name,
    //     //             "basket_owner" => $value->basket_owner,
    //     //             "start_date" => $data["ticket_date"],
    //     //             "end_date" => $data["expected_solve_date"],
    //     //             "created_at" => $data["updated_at"],
    //     //             "created_by" => $data["updated_by"],
    //     //         ]);
    //     //         $selectTemplateBasketTask = DB::table(
    //     //             "tai_template_basket_task"
    //     //         )
    //     //             ->where("template_basket_id", $value->id)
    //     //             ->get();
    //     //         foreach ($selectTemplateBasketTask as $key1 => $value1) {
    //     //             $fd = $value1->days - 1;
    //     //             $td = $value1->total_time - 1;
    //     //             $d1 = strtotime($dates[array_key_first($dates)]);
    //     //             $d2 = strtotime($dates[array_key_last($dates)]);
    //     //             $interval = (int) (($d2 - $d1) / 86400);
    //     //             if ($interval < $value1->total_time) {
    //     //                 return response()->json([
    //     //                     "status" => 0,
    //     //                     "message" => "Failed !!!",
    //     //                     "data" => null,
    //     //                 ]);
    //     //             } else {
    //     //                 if ($cal_from == "START_FROM") {
    //     //                     $start_date = date("Y-m-d",
    //     //                         strtotime(
    //     //                             "" . $fd . " day ",
    //     //                             strtotime($dates[array_key_first($dates)])
    //     //                         )
    //     //                     );
    //     //                     $end_date = date(
    //     //                         "Y-m-d",
    //     //                         strtotime(
    //     //                             "" . $td . " day ",
    //     //                             strtotime($start_date)
    //     //                         )
    //     //                     );
    //     //                 } elseif ($cal_from == "END_FROM") {
    //     //                     $end_date = date(
    //     //                         "Y-m-d",
    //     //                         strtotime(
    //     //                             "-" . $fd . " day ",
    //     //                             strtotime($dates[array_key_last($dates)])
    //     //                         )
    //     //                     );
    //     //                     $start_date = date(
    //     //                         "Y-m-d",
    //     //                         strtotime(
    //     //                             "-" . $td . " day ",
    //     //                             strtotime($end_date)
    //     //                         )
    //     //                     );
    //     //                 }
    //     //                 // $dates=TaskSupportiveController::getBetweenDates($data["ticket_date"],$data["expected_solve_date"]);
    //     //                 // print_r($dates);
    //     //                 $htom = CommonController::hoursandmins(($value1->total_time * 8)*60);
    //     //                 $taskId = DB::table("tai_ticket_task")->insertGetId([
    //     //                     // "tenant_id" => $data["tenant_id"],
    //     //                     "ticket_id" => $id,
    //     //                     "ticket_basket_id" => $basketId,
    //     //                     "task_name" => $value1->task,
    //     //                     "task_days" => $value1->total_time,
    //     //                     "task_hours" => $htom,
    //     //                     "start_date" => $start_date,
    //     //                     "end_date" => $end_date,
    //     //                     "created_at" => $data["updated_at"],
    //     //                     "created_by" => $data["updated_by"],
    //     //                 ]);
    //     //             }
    //     //         }
    //     //     }
    //     // }

    //     unset($data["attachment"]);
    //     $result = DB::table("tai_ticket_master")->where("id", $id)->update($data);

    //     $ticketData = DB::table('tai_ticket_master')->where('id', $id)->first();

    //     if ($submitToMongo) {
    //         // $a=new DynamicForm();
    //         // $a->id=$result;
    //         // $a->ticket_id=$data["ticket_id"];
    //         // $a->dynamic_data=$submitToMongo;
    //         // $a->save();
    //         // $device = DynamicForm::where(['_id'=>$id])->update(['dynamic_data' => $submitToMongo]);

    //         $result = DynamicForm::where('_id', $request->object_id)->update(['dynamic_data' => $submitToMongo]);
    //     }

    //     if ($request->file("attachment")) {
    //         CommonController::uploadAttachment($id, $request->file("attachment"), "TICKET", $data["updated_by"]);
    //     }

    //     // //Mapping
    //     // if ($request->project_id) {
    //     //     OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], $request->project_id, $id);
    //     // } else {
    //     //     OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], 0, $id);
    //     // }

    //     //Mapping
    //     if ($request->project_id) {
    //         OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], $request->project_id, $id, 0, 0);
    //     } else {
    //         OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], 0, $id, 0, 0);
    //     }


    //     CommonController::generateHistory("UPDATE", 'tai_ticket_master', $id);

    //     if ($result) {
    //         if ($data["status_id"] == 3) {
    //             return response()->json(["status" => 1, "message" => "Ticket- $ticketData->ticket_id has been solved", "data" => null,]);
    //         } else {
    //             return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null,]);
    //         }
    //     } else {
    //         return response()
    //             ->json(["status" => 0, "message" => "Record Not Updated !!!", "data" => null,]);
    //     }
    // }

    // Date : 20-10-2022
    public function updateTicket(Request $request, $id)
    {
        // validation
        if ($request->id && $request->ticket_date && $request->expected_solve_date && $request->project_id && $request->module_id) {
            $data = $request->toArray();
            // $data = array_merge($dataOne, ["template_id" => "63"]);
            // $dates = TaskSupportiveController::getBetweenDates($data["ticket_date"], $data["expected_solve_date"]);

            $submitToMongo = "";
            if ($request->query_type_id) {
                //LOGIN
                //1.Compare actual columns required with all form data
                $ticketColumns = DB::getSchemaBuilder()->getColumnListing("tai_ticket_master");
                $ticketColumns[] = "attachment";

                //2.Filter and genrate dynamic form data received in request
                $dynamicForm = array();
                foreach ($data as $key => $value) {
                    if (!in_array($key, $ticketColumns)) {
                        $dynamicForm[$key] = $value;
                        unset($data[$key]);
                    }
                }

                //3. Get actual json form
                $dynamicFormData = DB::table('tai_query_type_master as t')->join('tai_dynamic_form as d', 'd.id', '=', 't.form_id')
                    ->where('t.id', $request->query_type_id)
                    ->select('d.data')
                    ->first();
                if ($dynamicFormData) {
                    $form = json_decode($dynamicFormData->data);
                    //4.  Loop throuh json form
                    //5.  inputAddOn will have array exclude from comparison
                    //6.  compare value only if key=inputName;
                    //7.  $form[$key]->inputName will give then value of name attribute taken while creating dynmic form
                    //8.   array_key is used to check the name is present in dynamicform array generated in step 2
                    //9.  If value matches then change the value in object named as inputValue
                    //10. Dynamic Form Json will be read
                    foreach ($form as $key => $value) {
                        foreach ($value as $k => $v) {
                            if ($k != "inputAddOn") {
                                if ($k === "inputName" && in_array($form[$key]->inputName, array_keys($dynamicForm))) {
                                    $form[$key]->inputDefaultValue = $dynamicForm[$v];
                                }
                            }
                        }
                    }
                    $submitToMongo = json_encode($form);
                }
            }

            // dd($submitToMongo);
            //check date of ticket are matching to template task required days
            // if ($data["template_id"]) {
            //     //Update Template
            //     $pp = DB::table('tai_ticket_master as tm')
            //         ->join('tai_ticket_basket as tb','tb.ticket_id','=','tm.id')
            //         ->join('tai_ticket_task as tt','tb.id','=','tt.ticket_basket_id')
            //         ->where('tm.id', $id)
            //         ->update(['tb.is_active'=>'0', 'tt.is_active'=>'0']);
            //     $selectTemplateBasket = DB::table("tai_template_basket")
            //         ->where("template_id", $data["template_id"])
            //         ->get();
            //     foreach ($selectTemplateBasket as $key => $value) {
            //         $selectTemplateBasketTask = DB::table(
            //             "tai_template_basket_task"
            //         )
            //             ->where("template_basket_id", $value->id)
            //             ->get();
            //         foreach ($selectTemplateBasketTask as $key1 => $value1) {
            //             if(count($dates)>0){
            //                 $d1 = strtotime($dates[array_key_first($dates)]);
            //                 $d2 = strtotime($dates[array_key_last($dates)]);
            //                 $interval = (int) (($d2 - $d1) / 86400);
            //                 // echo $interval;
            //                 if ($interval < $value1->total_time) {
            //                     return response()->json([
            //                         "status" => 0,
            //                         "message" => "Choose Proper Dates Also Check Sat/Sun !!!",
            //                         "data" => null,
            //                     ]);
            //                 }
            //             }else{
            //                 return response()->json([
            //                         "status" => 0,
            //                         "message" => "Choose Proper Dates Also Check Sat/Sun !!!",
            //                         "data" => null,
            //                     ]);
            //             }
            //         }
            //     }
            // }
            //Add Basket and Task through template
            // if ($data["template_id"]) {
            //     $selectTemplate = DB::table("tai_template_master")
            //         ->where("id", $data["template_id"])
            //         ->first();
            //     $cal_from = $selectTemplate->calculate_from;
            //     $selectTemplateBasket = DB::table("tai_template_basket")
            //         ->where("template_id", $data["template_id"])
            //         ->get();
            //     foreach ($selectTemplateBasket as $key => $value) {
            //         $basketId = DB::table("tai_ticket_basket")->insertGetId([
            //             // "tenant_id" => $data["tenant_id"],
            //             "ticket_id" => $id,
            //             "basket_name" => $value->basket_name,
            //             "basket_owner" => $value->basket_owner,
            //             "start_date" => $data["ticket_date"],
            //             "end_date" => $data["expected_solve_date"],
            //             "created_at" => $data["updated_at"],
            //             "created_by" => $data["updated_by"],
            //         ]);
            //         $selectTemplateBasketTask = DB::table(
            //             "tai_template_basket_task"
            //         )
            //             ->where("template_basket_id", $value->id)
            //             ->get();
            //         foreach ($selectTemplateBasketTask as $key1 => $value1) {
            //             $fd = $value1->days - 1;
            //             $td = $value1->total_time - 1;
            //             $d1 = strtotime($dates[array_key_first($dates)]);
            //             $d2 = strtotime($dates[array_key_last($dates)]);
            //             $interval = (int) (($d2 - $d1) / 86400);
            //             if ($interval < $value1->total_time) {
            //                 return response()->json([
            //                     "status" => 0,
            //                     "message" => "Failed !!!",
            //                     "data" => null,
            //                 ]);
            //             } else {
            //                 if ($cal_from == "START_FROM") {
            //                     $start_date = date("Y-m-d",
            //                         strtotime(
            //                             "" . $fd . " day ",
            //                             strtotime($dates[array_key_first($dates)])
            //                         )
            //                     );
            //                     $end_date = date(
            //                         "Y-m-d",
            //                         strtotime(
            //                             "" . $td . " day ",
            //                             strtotime($start_date)
            //                         )
            //                     );
            //                 } elseif ($cal_from == "END_FROM") {
            //                     $end_date = date(
            //                         "Y-m-d",
            //                         strtotime(
            //                             "-" . $fd . " day ",
            //                             strtotime($dates[array_key_last($dates)])
            //                         )
            //                     );
            //                     $start_date = date(
            //                         "Y-m-d",
            //                         strtotime(
            //                             "-" . $td . " day ",
            //                             strtotime($end_date)
            //                         )
            //                     );
            //                 }
            //                 // $dates=TaskSupportiveController::getBetweenDates($data["ticket_date"],$data["expected_solve_date"]);
            //                 // print_r($dates);
            //                 $htom = CommonController::hoursandmins(($value1->total_time * 8)*60);
            //                 $taskId = DB::table("tai_ticket_task")->insertGetId([
            //                     // "tenant_id" => $data["tenant_id"],
            //                     "ticket_id" => $id,
            //                     "ticket_basket_id" => $basketId,
            //                     "task_name" => $value1->task,
            //                     "task_days" => $value1->total_time,
            //                     "task_hours" => $htom,
            //                     "start_date" => $start_date,
            //                     "end_date" => $end_date,
            //                     "created_at" => $data["updated_at"],
            //                     "created_by" => $data["updated_by"],
            //                 ]);
            //             }
            //         }
            //     }
            // }

            // dd($data, $data['status_id']);
            unset($data["attachment"]);
            $result = DB::table("tai_ticket_master")->where("id", $id)->update($data);

            $ticketData = DB::table('tai_ticket_master')->where('id', $id)->first();

            if ($submitToMongo) {
                // dd('hi');
                // $a=new DynamicForm();
                // $a->id=$result;
                // $a->ticket_id=$data["ticket_id"];
                // $a->dynamic_data=$submitToMongo;
                // $a->save();
                // $device = DynamicForm::where(['_id'=>$id])->update(['dynamic_data' => $submitToMongo]);

                $result = DynamicForm::where('_id', $request->object_id)->update(['dynamic_data' => $submitToMongo]);
            }

            if ($request->file("attachment")) {
                CommonController::uploadAttachment($id, $request->file("attachment"), "TICKET", $data["updated_by"]);
            }

            // dd('hi');
            // //Mapping
            // if ($request->project_id) {
            //     OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], $request->project_id, $id);
            // } else {
            //     OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], 0, $id);
            // }

            //Mapping
            if ($request->project_id) {
                OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], $request->project_id, $id, 0, 0);
            } else {
                OwnershipController::mapping('Update', 'TICKET', $data['assign_to_user_id'], 0, $id, 0, 0);
            }


            CommonController::generateHistory("UPDATE", 'tai_ticket_master', $id);

            // dd($result);
            if ($result) {
                if ($data["status_id"] == 3) {

                    $ticket_data = DB::table('tai_ticket_master')->where('id', $id)->first();
                    $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
                    $msg = "Ticket " . $ticket_data->ticket_id . " has been solved by - " . $userInfo->first_name . " " . $userInfo->last_name;
                    CommonController::addNotification($request->updated_by, $ticket_data->assign_to_user_id, $msg);

                    return response()->json(["status" => 1, "message" => "Ticket- $ticketData->ticket_id has been solved", "data" => null]);
                } else {
                    // if project & ticket id found => deactivate user_id 
                    $check_map = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                        ->where('ticket_id', $request->id)->update(['is_active' => 0]);
                    // dd($check_map);
                    if ($check_map) {
                        // dd('in');
                        return $request;
                        foreach ($request->ba_id as $b_id) {
                            $ba_res = DB::table('tai_ticket_user_mapping')->select('user_id')->where('project_id', $request->project_id)
                                ->where('ticket_id', $request->id)->where('user_id', $b_id)->first();
                            if (!is_null($ba_res->user_id)) {
                                $que = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                                    ->where('ticket_id', $request->id)
                                    ->where('user_id', $ba_res)->update(['is_active' => 1]);
                            } else {
                                $que = DB::table('tai_ticket_user_mapping')->insert([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'BA',
                                    'user_id' => $b_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            }
                        }
                        foreach ($request->dev_id as $d_id) {
                            $dev_res = DB::table('tai_ticket_user_mapping')->select('user_id')->where('project_id', $request->project_id)
                                ->where('ticket_id', $request->id)->where('user_id', $d_id)->first();
                            if (!is_null($dev_res->user_id)) {
                                $que = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                                    ->where('ticket_id', $request->id)
                                    ->where('user_id', $dev_res)->update(['is_active' => 1]);
                            } else {
                                $que = DB::table('tai_ticket_user_mapping')->insert([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                    'user_id' => $d_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            }
                        }

                        foreach ($request->dev_id as $t_id) {
                            $tes_res = DB::table('tai_ticket_user_mapping')->select('user_id')->where('project_id', $request->project_id)
                                ->where('ticket_id', $request->id)->where('user_id', $t_id)->first();
                            if (!is_null($tes_res->user_id)) {
                                $que = DB::table('tai_ticket_user_mapping')->where('project_id', $request->project_id)
                                    ->where('ticket_id', $request->id)
                                    ->where('user_id', $tes_res)->update(['is_active' => 1]);
                            } else {
                                $que = DB::table('tai_ticket_user_mapping')->insert([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                    'user_id' => $t_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ]);
                            }
                        }
                    } else {
                        if (count($request->ba_id) > 0) {
                            foreach ($request->ba_id as $b_id) {

                                $check = DB::table('tai_ticket_user_mapping')->where([
                                    'tenant_id' => $request->tenant_id,
                                    'user_type' => 'BA',
                                    'user_id' => $b_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ])->first();
                                if ($check) {
                                    $que = DB::table('tai_ticket_user_mapping')->where('id', $check->id)->update([
                                        'tenant_id' => $request->tenant_id, 'user_type' => 'BA',
                                        'user_id' => $b_id, 'project_id' => $request->project_id,
                                        'ticket_id' => $request->id, 'is_active' => 1
                                    ]);
                                } else {
                                    $que = DB::table('tai_ticket_user_mapping')->insert([
                                        'tenant_id' => $request->tenant_id, 'user_type' => 'BA',
                                        'user_id' => $b_id, 'project_id' => $request->project_id,
                                        'ticket_id' => $request->id, 'is_active' => 1
                                    ]);
                                }
                            }
                        }

                        if (count($request->dev_id) > 0) {
                            foreach ($request->dev_id as $d_id) {


                                $check = DB::table('tai_ticket_user_mapping')->where([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                    'user_id' => $d_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ])->first();
                                if ($check) {
                                    $que = DB::table('tai_ticket_user_mapping')->update([
                                        'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                        'user_id' => $d_id, 'project_id' => $request->project_id,
                                        'ticket_id' => $request->id, 'is_active' => 1
                                    ]);
                                } else {
                                    $que = DB::table('tai_ticket_user_mapping')->insert([
                                        'tenant_id' => $request->tenant_id, 'user_type' => 'DEV',
                                        'user_id' => $d_id, 'project_id' => $request->project_id,
                                        'ticket_id' => $request->id, 'is_active' => 1
                                    ]);
                                }
                            }
                        }

                        if (count($request->tester_id) > 0) {
                            foreach ($request->tester_id as $t_id) {

                                $check =  $que = DB::table('tai_ticket_user_mapping')->where([
                                    'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                    'user_id' => $t_id, 'project_id' => $request->project_id,
                                    'ticket_id' => $request->id, 'is_active' => 1
                                ])->first();

                                if ($check) {
                                    $que = DB::table('tai_ticket_user_mapping')->where('id', $check->id)->update([
                                        'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                        'user_id' => $t_id, 'project_id' => $request->project_id,
                                        'ticket_id' => $request->id, 'is_active' => 1
                                    ]);
                                } else {
                                    $que = DB::table('tai_ticket_user_mapping')->insert([
                                        'tenant_id' => $request->tenant_id, 'user_type' => 'TESTER',
                                        'user_id' => $t_id, 'project_id' => $request->project_id,
                                        'ticket_id' => $request->id, 'is_active' => 1
                                    ]);
                                }
                            }
                        }
                    }

                    $ticket_data = DB::table('tai_ticket_master')->where('id', $id)->first();
                    $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
                    // $assignUserInfo = CommonController::userInfo($ticket_data->assign_to_user_id, ["first_name", "last_name"]);
                    $msg = "You has been assigned for Ticket " . $ticket_data->ticket_id . " by " . $userInfo->first_name . " " . $userInfo->last_name;
                    CommonController::addNotification($request->updated_by, $ticket_data->assign_to_user_id, $msg);

                    // dd('hello');
                    return response()->json(["status" => 1, "message" => "Record Updated !!!", "data" => null]);
                }
            } else {
                return response()
                    ->json(["status" => 0, "message" => "Record Not Updated !!!", "data" => null]);
            }
        } else {
            return response()->json(["status" => 0, "message" => "Project and module fields required !!!", "data" => null]);
        }
    }


    public function deleteTicket(Request $request, $id)
    {
        $result = DB::table("tai_ticket_master")->where("id", $id)->delete();
        if ($result) {
            return response()->json(["message" => "Record Deleted", "status" => 1, "data" => null,]);
        } else {
            return response()
                ->json(["message" => "Record Not Deleted", "status" => 0, "data" => null,]);
        }
    }

    public function getTicketById(Request $request, $id)
    {
        $result = DB::table("tai_ticket_master as t")
            ->leftJoin("tai_query_type_master as q", "q.id", "=", "t.query_type_id")
            ->leftJoin("tai_employee_master as e", "e.id", "=", "t.created_by")
            ->leftJoin("tai_status_master as s", "s.id", "=", "t.status_id")
            ->select(
                "t.*",
                't.created_by as created_user_id',
                'q.id as query_id',
                'q.query_type_name',
                DB::raw("CONCAT(e.first_name,' ',e.last_name) AS created_by"),
                "s.status"
            )
            ->where("t.id", $id)
            ->first();

        if ($result) {
            $result->attachment = CommonController::getAttachment($id, "Ticket");
            $dynamicFormData = NULL;
            if ($result->object_id) {
                $findForm = DynamicForm::find($result->object_id);
                if ($findForm) {
                    if ($findForm->dynamic_data) {

                        $dynamicFormData = json_decode($findForm->dynamic_data);

                        foreach ($dynamicFormData as $key => $form) {

                            if ($form->inputType == "select") {
                                $addOns = $form->inputAddOn;
                                $dropdown = DB::table('tai_dynamic_form_dropdown_data')->where('dropdown_id', $addOns->inputDataSource)->get();
                                $temp = array();

                                foreach ($dropdown as $d) {

                                    // $temp.=$d->label."|".$d->value.";";

                                    $temp[] = array("value" => $d->value, "label" => $d->label);
                                }
                                $dynamicFormData[$key]->inputAddOn->inputDataSourceData = $temp;
                            }
                        }
                    }
                }
            }

            // tested code done by harkare
            $user_data = DB::table('tai_ticket_user_mapping as m')
                ->leftJoin('tai_employee_master as emp', 'emp.id', '=', 'm.user_id')
                ->where('m.ticket_id', $id)
                ->where('m.is_active', 1)
                ->select('m.ticket_id', 'emp.id', DB::raw("CONCAT(emp.first_name,' ',emp.last_name) AS name"), 'm.user_type')
                ->get();
            $result->ticket_users = $user_data;


            return response()->json(["status" => 1, "message" => "Record Found !!!", "data" => $result,  "dynamicFormData" => $dynamicFormData,]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record Found !!!", "data" => null,]);
        }
    }

    public function createComment(Request $request)
    {
        // return $request;
        $data = $request->toArray();

        $data['mentions_id'] = rtrim($data['mentions_id'], ',');

        $result = DB::table("tai_ticket_comment")->insert($data);
        if ($result) {
            $ticket = DB::table('tai_ticket_master')->where('id', $data['ticket_id'])->first();

            // add notification for project owner
            $project_owner_id = DB::table('tai_ticket_master as e')->leftJoin('tai_project_master as p', 'p.id', '=', 'e.project_id')->select('p.created_by')->first();
            // dd($project_owner_id, $ticket);
            if ($project_owner_id && $project_owner_id->created_by) {
                $mention_from = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);

                $users = explode(',', $data['mentions_id']);
                foreach ($users as $u) {
                    $mention_to = CommonController::userInfo($u, ["first_name", "last_name",]);

                    $msg = $mention_from->first_name . " " . $mention_from->last_name . " has mentioned " . $mention_to->first_name . " " . $mention_to->last_name . " in " . $ticket->ticket_id;

                    CommonController::addNotification($data["created_by"], $u, $msg, NULL);
                }
            } else {

                //Add Notification for user
                $userInfo = CommonController::userInfo($data["created_by"], ["first_name", "last_name",]);


                $msg = $userInfo->first_name . " " . $userInfo->last_name . " has mentioned you in " . $ticket->ticket_id;

                $users = explode(',', $data['mentions_id']);

                foreach ($users as $u) {
                    CommonController::addNotification($data["created_by"], $u, $msg, NULL);
                }
            }

            return response()->json(["status" => 1, "message" => "Record Inserted !!!", "data" => $data,]);
        } else {
            return response()->json(["status" => 0, "message" => "Record Not Inserted !!!", "data" => null,]);
        }
    }

    public function getComment($id)
    {
        $result = DB::table("tai_ticket_comment as tc")
            ->join("tai_employee_master as em", "em.id", "=", "tc.created_by")
            ->where("tc.ticket_id", $id)->select("tc.*", "em.first_name", "em.last_name")
            ->orderBy("tc.id", "desc")
            ->get();
        $temp = [];
        $final = [];

        if (count($result) > 0) {
            $temp = ["ticketId" => $result[0]->ticket_id, "userId" => "",];
            foreach ($result as $key => $b) {
                $final["cmt"] = $b->comment;
                $final["time"] = $b->created_at;
                $final["user_id"] = $b->first_name . " " . $b->last_name;
                $temp["comments"][] = $final;
            }
            return response()->json(["status" => 1, "message" => "Record found !!!", "data" => $temp]);
        } else {
            return response()->json(["status" => 0, "message" => "No Record found !!!", "data" => null]);
        }
    }

    public function sendTicketConfirmationOtp(Request $request, $id)
    {
        if ($id) {
            $ticket = DB::table('tai_ticket_master')->where('id', $id)->first();
            if ($ticket) {
                $user = DB::table('tai_employee_master')->where('id', $ticket->created_by)->first();
                $otp = rand(999999, 111111);

                if ($user->preferred_communication) {

                    if ($user->preferred_communication == "SMS") {
                    } else if ($user->preferred_communication == "EMAIL") {
                        $data = [
                            'title' => 'Mail from Techneai',
                            'body' => 'Ticket Confirmation',
                            'name' =>  $user->first_name . " " . $user->last_name,
                            'ticket_id' => $ticket->ticket_id,
                            'email' => $user->email_id,
                            'mobile' => $user->contact_no,
                            'otp' => $otp
                        ];

                        try {
                            Mail::to($user->email_id)->send(new TicketOtpMail($data));
                            // return view('emails.TicketOtpMail')->with(['data' => $data]);
                        } catch (Exception $e) {
                            //    return $ex->getMessage();
                            return response()->json(['status' => 0, 'message' => "Mail Not Sent", 'data' => null]);
                        }
                    } else if ($user->preferred_communication == "WHATS_APP") {
                        $data = [
                            'title' => 'Mail from Techneai',
                            'body' => 'Ticket Confirmation',
                            'name' =>  $user->first_name . " " . $user->last_name,
                            'ticket_id' => $ticket->ticket_id,
                            'email' => $user->email_id,
                            'mobile' => $user->contact_no,
                            'otp' => $otp
                        ];
                        $this->sendWhatsApp($data);
                    }

                    DB::table('tai_ticket_master')->where('id', $id)->update([
                        'ticket_confirmation_otp' => $otp,
                        'ticket_confirmation_otp_created_at' => now()
                    ]);

                    return response()->json([
                        "status" => 1,
                        "message" => "OTP Sent to $user->first_name $user->last_name",
                        "data" => $otp
                    ]);
                } else {
                    return response()->json([
                        "status" => 0,
                        "message" => "User Communication Preferrance is not set",
                        "data" => null
                    ]);
                }
            } else {
                return response()->json([
                    "status" => 0,
                    "message" => "Id not found",
                    "data" => null
                ]);
            }
        }
    }



    public function sendWhatsApp($ticket)
    {

        $msg = "OTP for Confirmation of Ticket ID : " . $ticket['ticket_id'] . " is " . $ticket['otp'] . ". Please do share with " . $ticket['name'] . " for the completion of the ticket.";
        $msg .= "\n\n";
        $msg .= "From Team Techneai.";


        $ticket['mobile'] = $ticket['mobile'];
        $ticket['body'] = $msg;


        $this->optinUser($ticket);

        // $userId = '2000193113';
        // $pass = 'kxNGjq5sg';

        $userId = '2000193115';
        $pass = 'NkoXDsE7t';

        // $userId = '2000193114';
        // $pass = 'UeNwp7eco';

        $phoneNo = "91" . $ticket['mobile'];
        $url = "https://media.smsgupshup.com/GatewayAPI/rest?";
        $url .= "userid=$userId";
        $url .= "&password=$pass";
        $url .= "&send_to=$phoneNo";
        $url .= "&v=1.1";
        $url .= "&format=json&";
        $url .= "&msg_type=TEXT";
        $url .= "&method=SENDMESSAGE";
        $url .= "&msg=" . urlencode($ticket['body']) . "";
        $response = $this->callCurl($url);
        // return true;
    }


    public function optinUser($data)
    {
        $userId = '2000193113';
        $pass = 'kxNGjq5sg';
        // $userId = '2000193114';
        // $pass = 'UeNwp7eco';

        $url = 'https://media.smsgupshup.com/GatewayAPI/rest?';
        $phoneNo = '91' . $data['mobile'];

        $url .= 'method=OPT_IN&format=json&userid=' . $userId . '&password=' . $pass . '&phone_number=' . $phoneNo . '&v=1.1&auth_scheme=plain&channel=WHATSAPP';

        if (is_numeric($data['body']) && (strlen((string)$data['body'])) == 6) {
            $pincode = $data['body'];
        } else {
            $pincode = '';
        }

        $opt_in = DB::table('bot_customer_master')->where('mobile_no', $data['mobile'])->orderBy('id', 'desc')->first();

        if ($opt_in) {
            if ($opt_in->is_opt_in == 'Y') {
                if (($opt_in->whatsapp_pincode == '') && ($pincode != $opt_in->whatsapp_pincode || $pincode != '')) {
                    $arrayName = array(
                        'whatsapp_pincode' => $pincode,
                    );

                    DB::table('bot_customer_master')->where('id', $opt_in->id)->update($arrayName);
                }
                return true;
            } else {
                $response = $this->callCurl($url);

                $result = json_decode($response);

                $optInStatus = 'N';
                if ($result->response->status == 'success') {
                    $optInStatus = 'Y';
                    $optDate = date('Y-m-d H:i:s');
                } else {
                    $optInStatus = 'N';
                    $optDate = $opt_in->opt_in_when;
                }
                if (isset($opt_in->whatsapp_pincode) && ($pincode == $opt_in->whatsapp_pincode)) {
                    $pincode = $opt_in->whatsapp_pincode;
                }

                if (strtoupper($result->data->response_messages[0]->details) == strtoupper('YOU ARE ALREADY OPTED IN.')) {
                    $pincode = $opt_in->whatsapp_pincode;
                    $optInStatus = 'Y';
                }

                if (strtoupper($result->data->response_messages[0]->details) == strtoupper('YOU ARE ALREADY OPTED IN.')) {
                    $pincode = $opt_in->whatsapp_pincode;
                    $optInStatus = 'Y';
                }

                $arrayName = array(
                    'mobile_no'          => $data['mobile'],
                    'whatsapp_pincode'   => $pincode,
                    'is_opt_in'          => $optInStatus,
                    'opt_in_when'        => $optDate,
                    'opt_in_res'         => $response
                );

                DB::table('bot_customer_master')->where('id', $opt_in->id)->update($arrayName);
                if ($result->response->status == 'success') {
                    return true;
                } else {
                    return false;
                }
            }
        } else {
            $response = $this->callCurl($url);
            $result = json_decode($response);

            $optInStatus = 'N';
            if ($result->response->status == 'success') {
                $optInStatus = 'Y';
            } else {
                $optInStatus = 'N';
            }

            $arrayName = array(
                'mobile_no'          => $phoneNo,
                'whatsapp_name'      => $data['name'],
                'customer_name'      => $data['name'],
                'whatsapp_pincode'   => $pincode,
                'is_opt_in'          => $optInStatus,
                'opt_in_when'        => date('Y-m-d H:i:s'),
                'opt_in_by'          => NULL,
                'opt_in_res'         => $response
            );

            DB::table('bot_customer_master')->insert($arrayName);

            if ($result->response->status == 'success') {
                return true;
            } else {
                return false;
            }
        }
    }

    public function callCurl($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded', 'Content-Type: multipart/form-data;boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }


    public function verifyTicketConfirmationOtp(Request $request, $id)
    {
        if ($id) {

            $makeItSolved = 1;

            $ticket = DB::table('tai_ticket_master')->where('id', $id)->first();

            if ($request->otp) {
                if ($ticket->ticket_confirmation_otp == $request->otp) {
                    $makeItSolved = 1;
                } else {
                    $makeItSolved = 0;
                    return response()->json([
                        "status" => 0,
                        "message" => "OTP is not matched !!!",
                        "data" => null
                    ]);
                }
            } else {
                $makeItSolved = 1;
            }

            if ($makeItSolved == 1) {

                $updated = 1;

                // $updated = DB::table('tai_ticket_master')->where('id', $id)->update([
                //     'status_id' => 3,
                //     'updated_at' => $request->updated_by,
                //     'updated_by' => $request->updated_at
                // ]);

                if ($updated) {

                    $taskUsers = [];
                    if ($ticket->passed_status_changed_by) {
                        $taskUsers[] = $ticket->passed_status_changed_by;
                    }

                    $taskUsers = DB::table('tai_owner_mapping_master_new')->where('ticket_id', $id)->where('is_active', 1)->pluck('user_id')->toArray();

                    if (count($taskUsers)) {
                        $taskUsers = array_unique($taskUsers);
                    }


                    $taskOwners = DB::table('tai_ticket_task_owner as ttto')->select('ttto.id as task_owner_id')->get()->toArray();
                    $basketOwners = DB::table('tai_ticket_basket as ttb')->select('ttb.basket_owner as basket_owner_id')->get()->toArray();
                    $taskOwners = array_column($taskOwners, 'task_owner_id');
                    $basketOwners = array_column($basketOwners, 'basket_owner_id');

                    $users = array_unique(array_intersect($taskOwners, $basketOwners));
                    $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
                    $msg = "Ticket confirmed by - " . $userInfo->first_name . " " . $userInfo->last_name . " for " . $ticket->ticket_id;
                    foreach ($users as $u) {
                        CommonController::addNotification($request->updated_by, $u, $msg);
                    }
                    DB::table('tai_ticket_master')->where('id', $id)->update(['status_id' => 3]);
                    CommonController::generateHistory("UPDATE", 'tai_ticket_master', $id);
                    DB::table('tai_ticket_task')->where('ticket_id', $id)->update(['status' => 'COMPLETED']);

                    return response()->json([
                        "status" => 1,
                        "message" => "Ticket Solved !!! !!!",
                        "data" => null
                    ]);
                }
            }
        } else {
            return response()->json([
                "status" => 0,
                "message" => "Id not found",
                "data" => null
            ]);
        }
    }




    public function getBulkFormat(Request $request)
    {

        $unique_key = "Query_Type_" . date("Y_m_d_H_i_s") . "_" . $request->created_by;

        // $employee=DB::table('tai_employee_master')->where('id',$request->created_by)->first();
        // if($employee){
        // }

        $customer_mapping = DB::table('tai_customer_mapping')->where('id', $request->customer_mapping_id)->first();

        if (!$customer_mapping->dynamic_form_id) {
            $form = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->first();
            $customer_mapping->dynamic_form_id = $form->form_id;
        }

        $df = DB::table('tai_dynamic_form')->where('id', $customer_mapping->dynamic_form_id)->first();
        if (!$df) {
            return response()->json(['status' => 0, 'message' => 'NO mapping form found !!!', 'data' => NULL]);
        }

        $form = json_decode($df->data);

        $query_type = DB::table('tai_query_type_master')->where('id', $customer_mapping->query_type_id)->first()->query_type_name;

        $fields = array();
        $fields = ['query_type', 'confirmation_required', 'ref_id', 'priority', 'description'];

        foreach ($form as $f) {

            $fields[] = $f->inputLabel;
        }

        $filename = storage_path('app/' . $unique_key . '.csv');
        $delimiter = ",";
        $f = fopen($filename, 'w');
        fputcsv($f, $fields, $delimiter);

        $array = [$query_type];
        fputcsv($f, $array, $delimiter);

        fclose($f);

        return response()->json(['status' => 1, 'message' => 'File is ready to download', 'data' => 'storage/app/' . $unique_key . '.csv']);
    }


    public function getTicketHistory(Request $request, $id)
    {
        $data = DB::table('tai_ticket_master_history as th')
            ->where('th.main_id', $id)
            ->leftjoin('tai_query_type_master as tq', 'th.query_type_id', 'tq.id')
            ->leftjoin('tai_tenant_master as tm', 'th.tenant_id', 'tm.id')
            ->leftjoin('tai_employee_master as em1', 'th.updated_by', 'em1.id')
            ->leftjoin('tai_employee_master as em2', 'th.created_by', 'em2.id')
            ->leftjoin('tai_employee_master as em3', 'th.passed_status_changed_by', 'em3.id')
            ->leftjoin('tai_employee_master as em4', 'th.assign_to_user_id', 'em4.id')
            ->leftjoin('tai_project_master as pm', 'th.project_id', 'pm.id')
            ->leftjoin('tai_project_modules as tpm', 'th.module_id', 'tpm.id')
            ->leftjoin('tai_project_sub_modules as tps', 'th.submodule_id', 'tps.id')
            ->leftjoin('tai_department_master as tdm', 'th.assign_to_department_id', 'tdm.id')
            ->leftjoin('tai_department_master as tdm1', 'th.from_department_id', 'tdm1.id')
            ->leftjoin('tai_status_master as tsm', 'th.status_id', 'tsm.id')
            ->leftjoin('tai_template_master as ttm', 'th.template_id', 'ttm.id')
            ->select(
                'th.*',
                'tq.query_type_name',
                'tm.company_name',
                'pm.project_name',
                'tpm.module_name',
                'tps.sub_module_name',
                'tdm.department',
                'tsm.status',
                'ttm.template_name',
                'tdm1.department AS from_department',
                DB::raw("CONCAT(em1.first_name,' ',em1.last_name) AS updated_by"),
                DB::raw("CONCAT(em2.first_name,' ',em2.last_name) AS created_by"),
                DB::raw("CONCAT(em3.first_name,' ',em3.last_name) AS passed_status_changed_by"),
                DB::raw("CONCAT(em4.first_name,' ',em4.last_name) AS assign_to_user")
            )
            ->get();
        $temp = [];
        if (count($data) > 0) {

            foreach ($data as $d) {
                $temp[] = (array)$d;
            }

            if (count($temp) >= 2) {
                foreach ($temp as $key => $value) {
                    $temp[$key]['changes'] = [];
                    if ($key >= 1) {
                        $prevKey = $key - 1;

                        $tempPrevArray = $temp[$prevKey];
                        $tempCurrentArray = $temp[$key];

                        if (array_key_exists('changes', $tempPrevArray)) {
                            unset($tempPrevArray['changes']);
                        }
                        if (array_key_exists('changes', $tempCurrentArray)) {
                            unset($tempCurrentArray['changes']);
                        }
                        $diff = (array_diff_assoc($tempPrevArray, $tempCurrentArray));
                        unset($diff['id']);
                        unset($diff['operation']);


                        $temp[$key]['changes'] = array_keys($diff);
                    }
                }
            }

            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $temp]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }
    public function uploadNewAttachment(Request $request, $id)
    {
        $data = $request->toArray();
        if ($data['attachment']) {
            CommonController::uploadAttachment($id, $request->attachment, "TICKET", $data["updated_by"]);
            return response()->json(['status' => 1, 'message' => "New attachments inserted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "No attachment added !!!", 'data' => null]);
        }
    }
}
