<?php

namespace App\Http\Controllers;

use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use JWTAuth;

class TicketSubtaskController extends Controller
{

    public function getSubtask($taskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_task_subtask')->where('tenant_id',$tenantId)->where('ticket_task_id', $taskId)->where('is_active',1)->get();
        if(count($result)>0){
            return response()->json([ 'status'=> 1, 'message'=> "Record Found !!!", 'data' => $result]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Found !!!", 'data' => null]);
        }
    }

    public function postSubtask(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $check=DB::table('tai_ticket_task_subtask')->where('ticket_id',$request->ticket_id)
                                                ->where('ticket_task_id',$request->ticket_task_id)
                                                ->where('subtask',$request->subtask)
                                                ->where('tenant_id',$tenantId)
                                                ->first();
        if($check){
            return response()->json(['status'=>0, 'message'=> "Subtask Already Present !!!", 'data' => null]);
        }

        $result = DB::table('tai_ticket_task_subtask')->insert($request->toArray());
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!", 'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Inserted !!!", 'data' => null]);
        }
    }

    public function completeSubtask(Request $request,$subtaskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_task_subtask')->where('tenant_id',$tenantId)->where('id',$subtaskId)->update($request->toArray());
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!", 'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Inserted !!!", 'data' => null]);
        }
    }



    public function deleteSubtask(Request $request,$subtaskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $result = DB::table('tai_ticket_task_subtask')
        ->where('tenant_id',$tenantId)
        ->where('id', $subtaskId)
        ->update(['is_active'=>0]);
        if($result){
            return response()->json([ 'status'=> 1, 'message'=> "Record Deleted !!!", 'data' => null]);
        }else{
            return response()->json([ 'status'=> 0, 'message'=> "No Record Deleted !!!", 'data' => null]);
        }
    }

  
}
