<?php

namespace App\Http\Controllers;

use App\Library\CommonController;
use App\Library\TaskSupportiveController as TaskSupportive;
use App\Library\OwnershipController;
use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use Carbon\Carbon;
use JWTAuth;
use DateTime;
use DateInterval;

class TicketTaskController extends Controller
{

    public function getData(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_ticket_task')->where('tenant_id', $tenantId)->where('is_active', 1)->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }
    // public function getVariantsReport(Request $request)
    // {
    //     // dd($request->toArray());
    //     // $result = DB::table('tai_ticket_task as task')
    //     //     ->select('ticket.ticket_id', DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'), 'task.task_name as task_name', 'task.created_at as task_creation_Date', 'task.start_date as task_start_Date', 'task.task_hours as task_scheduled_Hours', 'task.total_worked as task_actual_worked', 'task.end_date as task_delivery_scheduled', 'task.completed_at as task_completed_at', 'task.status as task_status')
    //     //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
    //     //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
    //     //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
    //     // if ($request->from_date) {
    //     //     $result = $result->where('task.created_at', '>=', $request->from_date." 00:00:00")->where('task.created_at', '<=', $request->to_date." 23:59:59");
    //     // }
    //     // // dd($request->user_id);
    //     // if (count($request->user_id) > 0 && $request->user_id[0] != "") {
    //     //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
    //     //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
    //     // }

    //     $result = DB::table('tai_ticket_task as task')
    //         ->select(
    //             'ticket.ticket_id',
    //             DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
    //             'task.task_name as task_name',
    //             'task.created_at as task_creation_Date',
    //             'task.start_date as task_start_Date',
    //             'task.task_hours as task_scheduled_Hours',
    //             'task.total_worked as task_actual_worked',
    //             'task.end_date as task_delivery_scheduled',
    //             'task.completed_at as task_completed_at',
    //             'task.status as task_status',
    //             'task.task_hours_in_min',
    //             'task.total_worked_in_min',
    //             'task.updated_at'
    //         )
    //         ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
    //         ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
    //         ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
    //     if ($request->from_date) {
    //         $result = $result->where('task.start_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
    //     }
    //     if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
    //         $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
    //         $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
    //     }

    //     $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->get();

    //     // dd($result);
    //     foreach ($result as $r) {
    //         if ($r->task_status != 'COMPLETED' && $r->task_delivery_scheduled != null) {
    //             if ($r->task_delivery_scheduled < date('Y-m-d')) {
    //                 $r->task_actual_status = 'DELAYED';
    //             } else {
    //                 if ($r->task_hours_in_min < $r->total_worked_in_min) {
    //                     $r->task_actual_status = 'DELAYED';
    //                 } else {
    //                     $r->task_actual_status = $r->task_status;
    //                 }
    //             }
    //         } else {
    //             if ($r->task_hours_in_min < $r->total_worked_in_min) {
    //                 $r->task_actual_status = 'DELAYED';
    //             } else {
    //                 $r->task_actual_status = $r->task_status;
    //             }
    //             // $r->task_actual_status = $r->task_status;
    //         }
    //         $r->task_actual_worked ? $r->task_actual_worked = $r->task_actual_worked : $r->task_actual_worked = '00:00:00';  
    //     }

    //     // dd($result);
    //     if (count($result) > 0) {
    //         return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
    //     } else {
    //         return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
    //     }
    // }

    // Commented on  08-08-2023
    // public function getVariantsReport(Request $request)
    // {
    //     $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
    //     $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

    //     // dd($request->toArray());
    //     // $result = DB::table('tai_ticket_task as task')
    //     //     ->select('ticket.ticket_id', DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'), 'task.task_name as task_name', 'task.created_at as task_creation_Date', 'task.start_date as task_start_Date', 'task.task_hours as task_scheduled_Hours', 'task.total_worked as task_actual_worked', 'task.end_date as task_delivery_scheduled', 'task.completed_at as task_completed_at', 'task.status as task_status')
    //     //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
    //     //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
    //     //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
    //     // if ($request->from_date) {
    //     //     $result = $result->where('task.created_at', '>=', $request->from_date." 00:00:00")->where('task.created_at', '<=', $request->to_date." 23:59:59");
    //     // }
    //     // // dd($request->user_id);
    //     // if (count($request->user_id) > 0 && $request->user_id[0] != "") {
    //     //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
    //     //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
    //     // }

    //     // $result = DB::table('tai_ticket_task as task')
    //     //     ->select(
    //     //         'task.id',
    //     //         'taskOwner.task_owner_id',

    //     //         'ticket.ticket_id',
    //     //         DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
    //     //         'task.task_name as task_name',
    //     //         'task.created_at as task_creation_Date',
    //     //         'task.start_date as task_start_Date',
    //     //         'task.task_hours as task_scheduled_Hours',
    //     //         'task.total_worked as task_actual_worked',
    //     //         'task.end_date as task_delivery_scheduled',
    //     //         'task.completed_at as task_completed_at',
    //     //         'task.status as task_status',
    //     //         'task.task_hours_in_min',
    //     //         'task.total_worked_in_min',
    //     //         'task.updated_at',
    //     //         DB::raw('SUM( TIME_TO_SEC(history.total_time)/60 ) AS abc')
    //     //     )
    //     //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
    //     //     ->leftjoin('tai_ticket_task_time_history as history', 'task.id', 'history.ticket_task_id')
    //     //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
    //     //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
    //     // if ($request->from_date) {
    //     //     $result = $result->where('task.start_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
    //     // }else{
    //     //     $result = $result->where('task.start_date', '>=', date("Y-m-01 00:00:00"))->where('task.end_date', '<=', date("Y-m-31 23:59:59"));
    //     // }
    //     // if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
    //     //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
    //     //     // dd($user_id);
    //     //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
    //     // }

    //     // $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->orderBy('task_owner')->get();


    //     // $result = DB::table('tai_ticket_task as task')
    //     //     ->select(
    //     //         'task.id',
    //     //         'taskOwner.task_owner_id',
    //     //         'ticket.ticket_id',
    //     //         DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
    //     //         'task.task_name as task_name',
    //     //         'task.created_at as task_creation_Date',
    //     //         'task.start_date as task_start_Date',
    //     //         'task.task_hours as task_scheduled_Hours',
    //     //         // 'task.total_worked as task_actual_worked',
    //     //         'task.end_date as task_delivery_scheduled',
    //     //         'task.completed_at as task_completed_at',
    //     //         'task.status as task_status',
    //     //         'task.task_hours_in_min',
    //     //         'task.total_worked_in_min',
    //     //         'task.updated_at',
    //     //         DB::raw('(SELECT SUM(total_time_min) FROM tai_ticket_task_time_history WHERE user_id=taskOwner.task_owner_id AND ticket_task_id=task.id) AS task_actual_worked')
    //     //     )
    //     //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
    //     //     ->leftjoin('tai_ticket_task_time_history as history', 'task.id', 'history.ticket_task_id')
    //     //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
    //     //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
    //     // if ($request->from_date) {
    //     //     $result = $result->where('task.start_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
    //     // }else{
    //     //     $result = $result->where('task.start_date', '>=', date("Y-m-01 00:00:00"))->where('task.end_date', '<=', date("Y-m-31 23:59:59"));
    //     // }
    //     // if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
    //     //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
    //     //     // dd($user_id);
    //     //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
    //     // }

    //     // $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->groupBy('taskOwner.task_owner_id')->groupBy('task.id')->orderBy('task_owner')->get();

    //     $result = DB::table('tai_ticket_task as task')
    //         ->select(
    //             'task.id',
    //             'taskOwner.task_owner_id',
    //             'ticket.ticket_id',
    //             DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
    //             'task.task_name as task_name',
    //             'task.created_at as task_creation_Date',
    //             'task.start_date as task_start_Date',
    //             'task.task_hours as task_scheduled_Hours',
    //             'task.total_worked as task_actual_worked',
    //             'task.end_date as task_delivery_scheduled',
    //             'task.completed_at as task_completed_at',
    //             'task.status as task_status',
    //             'task.task_hours_in_min',
    //             'task.total_worked_in_min',
    //             'task.updated_at',
    //             // DB::raw('(SELECT SUM(total_time_min) FROM tai_ticket_task_time_history WHERE user_id=taskOwner.task_owner_id AND ticket_task_id=task.id) AS task_actual_worked')
    //         )
    //         ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
    //         ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
    //         ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id')
    //         ->where('ticket.tenant_id', $tenantId)
    //         ->where('taskOwner.tenant_id', $tenantId)
    //         ->where('empMaster.tenant_id', $tenantId);

    //     // Prathmesh Shinde 15 jul 2023 : changed date bewtwwtn from start_date->end_date to end_date->end_date
    //     if ($request->from_date) {
    //         $result = $result->where('task.end_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
    //     } else {
    //         $result = $result->where('task.end_date', '>=', date("Y-m-01 00:00:00"))->where('task.end_date', '<=', date("Y-m-31 23:59:59"));
    //     }

    //     if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
    //         $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
    //         // dd($user_id);
    //         $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
    //     }

    //     $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->groupBy('taskOwner.task_owner_id')->groupBy('task.id')->orderBy('task_owner')->get();

    //     // dd($result);
    //     foreach ($result as $r) {
    //         if ($r->task_status != 'COMPLETED' && $r->task_delivery_scheduled != null) {
    //             if ($r->task_delivery_scheduled < date('Y-m-d')) {
    //                 $r->task_actual_status = 'DELAYED';
    //             } else {
    //                 if ($r->task_hours_in_min < $r->total_worked_in_min) {
    //                     $r->task_actual_status = 'DELAYED';
    //                 } else {
    //                     $r->task_actual_status = $r->task_status;
    //                 }
    //             }
    //         } else {
    //             if ($r->task_hours_in_min < $r->total_worked_in_min) {
    //                 $r->task_actual_status = 'DELAYED';
    //             } else {
    //                 $r->task_actual_status = $r->task_status;
    //             }
    //             // $r->task_actual_status = $r->task_status;
    //         }

    //         // total hours scheduled for task
    //         // Prathmesh Shinde 03/07/2023
    //         // $res = DB::table('tai_task_planner')->where('user_id', $r->task_owner_id)->where('tenant_id', $tenantId)
    //         //     ->where('ticket_task_id', $r->id)->where('is_active', 1)->first();
    //         // if ($res) {
    //         //     $r->task_scheduled_Hours = $res->total_hours;
    //         // } else {
    //         //     $r->task_scheduled_Hours = 0;
    //         // }

    //         // task actual worked
    //         $total_worked = DB::select('SELECT SUM(total_time_min) as total_time_data FROM tai_ticket_task_time_history where ticket_task_id = ' . $r->id . ' AND user_id = ' . $r->task_owner_id . ' GROUP BY ticket_task_id, user_id');

    //         // dd($total_worked);
    //         if (count($total_worked) > 0) {
    //             $r->task_actual_worked = $this->hoursandmins($total_worked[0]->total_time_data);
    //         } else {
    //             $r->task_actual_worked = '00:00';
    //         }
    //         // $r->task_actual_worked ? $r->task_actual_worked = $r->task_actual_worked : $r->task_actual_worked = '00:00:00';
    //     }

    //     // dd($result);
    //     if (count($result) > 0) {
    //         return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
    //     } else {
    //         return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
    //     }
    // }

    public function getVariantsReport(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        // dd($request->toArray());
        // $result = DB::table('tai_ticket_task as task')
        //     ->select('ticket.ticket_id', DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'), 'task.task_name as task_name', 'task.created_at as task_creation_Date', 'task.start_date as task_start_Date', 'task.task_hours as task_scheduled_Hours', 'task.total_worked as task_actual_worked', 'task.end_date as task_delivery_scheduled', 'task.completed_at as task_completed_at', 'task.status as task_status')
        //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
        //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
        //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
        // if ($request->from_date) {
        //     $result = $result->where('task.created_at', '>=', $request->from_date." 00:00:00")->where('task.created_at', '<=', $request->to_date." 23:59:59");
        // }
        // // dd($request->user_id);
        // if (count($request->user_id) > 0 && $request->user_id[0] != "") {
        //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
        //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
        // }

        // $result = DB::table('tai_ticket_task as task')
        //     ->select(
        //         'task.id',
        //         'taskOwner.task_owner_id',

        //         'ticket.ticket_id',
        //         DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
        //         'task.task_name as task_name',
        //         'task.created_at as task_creation_Date',
        //         'task.start_date as task_start_Date',
        //         'task.task_hours as task_scheduled_Hours',
        //         'task.total_worked as task_actual_worked',
        //         'task.end_date as task_delivery_scheduled',
        //         'task.completed_at as task_completed_at',
        //         'task.status as task_status',
        //         'task.task_hours_in_min',
        //         'task.total_worked_in_min',
        //         'task.updated_at',
        //         DB::raw('SUM( TIME_TO_SEC(history.total_time)/60 ) AS abc')
        //     )
        //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
        //     ->leftjoin('tai_ticket_task_time_history as history', 'task.id', 'history.ticket_task_id')
        //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
        //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
        // if ($request->from_date) {
        //     $result = $result->where('task.start_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
        // }else{
        //     $result = $result->where('task.start_date', '>=', date("Y-m-01 00:00:00"))->where('task.end_date', '<=', date("Y-m-31 23:59:59"));
        // }
        // if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
        //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
        //     // dd($user_id);
        //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
        // }

        // $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->orderBy('task_owner')->get();


        // $result = DB::table('tai_ticket_task as task')
        //     ->select(
        //         'task.id',
        //         'taskOwner.task_owner_id',
        //         'ticket.ticket_id',
        //         DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
        //         'task.task_name as task_name',
        //         'task.created_at as task_creation_Date',
        //         'task.start_date as task_start_Date',
        //         'task.task_hours as task_scheduled_Hours',
        //         // 'task.total_worked as task_actual_worked',
        //         'task.end_date as task_delivery_scheduled',
        //         'task.completed_at as task_completed_at',
        //         'task.status as task_status',
        //         'task.task_hours_in_min',
        //         'task.total_worked_in_min',
        //         'task.updated_at',
        //         DB::raw('(SELECT SUM(total_time_min) FROM tai_ticket_task_time_history WHERE user_id=taskOwner.task_owner_id AND ticket_task_id=task.id) AS task_actual_worked')
        //     )
        //     ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
        //     ->leftjoin('tai_ticket_task_time_history as history', 'task.id', 'history.ticket_task_id')
        //     ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
        //     ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id');
        // if ($request->from_date) {
        //     $result = $result->where('task.start_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
        // }else{
        //     $result = $result->where('task.start_date', '>=', date("Y-m-01 00:00:00"))->where('task.end_date', '<=', date("Y-m-31 23:59:59"));
        // }
        // if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
        //     $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
        //     // dd($user_id);
        //     $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
        // }

        // $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->groupBy('taskOwner.task_owner_id')->groupBy('task.id')->orderBy('task_owner')->get();

        $result = DB::table('tai_ticket_task as task')
            ->select(
                'task.id',
                'taskOwner.task_owner_id',
                'ticket.ticket_id',
                DB::raw('CONCAT(empMaster.first_name," ",empMaster.last_name) as task_owner'),
                'task.task_name as task_name',
                'task.created_at as task_creation_Date',
                'task.start_date as task_start_Date',
                'task.task_hours as task_scheduled_Hours',
                'task.total_worked as task_actual_worked',
                'task.end_date as task_delivery_scheduled',
                'task.completed_at as task_completed_at',
                'task.status as task_status',
                'task.task_hours_in_min',
                'task.total_worked_in_min',
                'task.updated_at',
                // DB::raw('(SELECT SUM(total_time_min) FROM tai_ticket_task_time_history WHERE user_id=taskOwner.task_owner_id AND ticket_task_id=task.id) AS task_actual_worked')
            )
            ->leftjoin('tai_ticket_master as ticket', 'task.ticket_id', 'ticket.id')
            ->leftjoin('tai_ticket_task_owner as taskOwner', 'task.id', 'taskOwner.ticket_task_id')
            ->leftjoin('tai_employee_master as empMaster', 'taskOwner.task_owner_id', 'empMaster.id')
            ->where('ticket.tenant_id', $tenantId)
            ->where('taskOwner.tenant_id', $tenantId)
            ->where('empMaster.tenant_id', $tenantId);

        if ($request->from_date) {
            $result = $result->where('task.start_date', '>=', $request->from_date . " 00:00:00")->where('task.end_date', '<=', $request->to_date . " 23:59:59");
        } else {
            $result = $result->where('task.start_date', '>=', date("Y-m-01 00:00:00"))->where('task.end_date', '<=', date("Y-m-31 23:59:59"));
        }

        if (is_array($request->user_id) && count($request->user_id) > 0 && $request->user_id[0] != "") {
            $user_id = (!is_array($request->user_id)) ? explode(',', $request->user_id) : $request->user_id;
            // dd($user_id);
            $result = $result->whereIn('taskOwner.task_owner_id', $user_id);
        }

        $result = $result->where('task.is_active', 1)->where('taskOwner.is_active', 1)->groupBy('taskOwner.task_owner_id')->groupBy('task.id')->orderBy('task_owner')->get();

        // dd($result);
        foreach ($result as $r) {
            //dd($r);
            if ($r->task_status != 'COMPLETED' && $r->task_delivery_scheduled != null) {
                if ($r->task_delivery_scheduled < date('Y-m-d')) {
                    $r->task_actual_status = 'DELAYED';
                } else {
                    if ($r->task_hours_in_min < $r->total_worked_in_min) {
                        $r->task_actual_status = 'DELAYED';
                    } else {
                        $r->task_actual_status = $r->task_status;
                    }
                }
            } else {
                if ($r->task_hours_in_min < $r->total_worked_in_min) {
                    $r->task_actual_status = 'DELAYED';
                } else {
                    $r->task_actual_status = $r->task_status;
                }
                // $r->task_actual_status = $r->task_status;
            }

            // total hours scheduled for task
            $res = DB::table('tai_task_planner')->where('user_id', $r->task_owner_id)
                ->where('ticket_task_id', $r->id)->where('is_active', 1)->first();
            if ($res) {
                $r->task_scheduled_Hours = $res->total_hours;
            } else {
                $r->task_scheduled_Hours = 0;
                // $r->task_scheduled_Hours = $res->total_hours;
            }

            // task actual worked
            $total_worked = DB::select('SELECT SEC_TO_TIME(SUM(TIME_TO_SEC(total_time_min))) AS total_time_data,
            (SUM(TIME_TO_SEC(total_time_min)) / 60) AS total_minutes
            -- SUM(total_time_min) as total_time_data 
            FROM tai_ticket_task_time_history where ticket_task_id = ' . $r->id . ' AND user_id = ' . $r->task_owner_id .
                '');

            // dd($total_worked);

            // if (count($total_worked) > 0) {
            //     $r->task_actual_worked = $this->hoursandmins($total_worked[0]->total_time_data);
            // } else {
            //     $r->task_actual_worked = '00:00';
            // }
            $r->task_actual_worked ? $r->task_actual_worked = $r->task_actual_worked : $r->task_actual_worked = '00:00:00';

            // $formateActualTaskWorked = DateTime::createFromFormat('H:i:s', $r->task_actual_worked);
            // $r->task_actual_worked = $formateActualTaskWorked->format('H:i');

        }

        // dd($result);
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record found !!!", 'data' => null]);
        }
    }

    function hoursandmins($time, $format = '%02d:%02d')
    {
        if ($time < 1) {
            return;
        }
        $hours = floor($time / 60);
        $minutes = ($time % 60);
        return sprintf($format, $hours, $minutes);
    }

    public function checkAssignUser($assignUser)
    {
        if (!$assignUser) {
            return ['status' => 0, 'message' => "Assign to user required !!!"];
        } else {
            $flag = 1;
            if (count($assignUser)) {
                foreach ($assignUser as $a) {
                    if (!$a) {
                        $flag = 0;
                        break;
                    }
                }
            }
            if ($flag == 1) {
                return ['status' => 1, 'message' => NULL];
            } else {
                return ['status' => 0, 'message' => "Assign to user required !!!"];
            }
        }
    }

    public function checkBasketDate($ticketBasketId, $startDate, $endDate)
    {
        $basket = DB::table('tai_ticket_basket')->where('id', $ticketBasketId)->first();
        if ($basket) {
            if ($basket->start_date && $basket->start_date > $startDate) {
                return ['status' => 0, 'message' => "Start and End Date must be in between $basket->start_date & $basket->end_date"];
            }
            if ($basket->end_date && $basket->end_date < $endDate) {
                return ['status' => 0, 'message' => "Start and End Date must be in between $basket->start_date & $basket->end_date"];
            }
            return ['status' => 1, 'message' => NULL];
        }
    }

    public function checkSameTaskName($ticketId, $title, $status)
    {
        $check = DB::table('tai_ticket_task')->where('ticket_id', $ticketId)
            ->where('task_name', $title)
            ->where('status', $status)
            ->where('is_active', 1)
            ->get();
        if (count($check) > 0) {
            return ['status' => 0, 'message' => "Same task already present"];
        }
        return ['status' => 1, 'message' => NULL];
    }

    public function checkTaskHours($taskHours)
    {
        if (!preg_match('/^\d{2,3}:\d{2}$/', $taskHours)) {
            return ['status' => 0, 'message' => "Required time as HH:MM"];
        }
        return ['status' => 1, 'message' => NULL];
    }

    public function convertToMin($taskHours)
    {
        if (strpos($taskHours, ':') !== false) {
            $temp = explode(':', $taskHours);
            if ($temp[0] > 0) {
                $hourToMin = (int)$temp[0] * 60;
            } else {
                $hourToMin = 0;
            }
            $min = $temp[1];
            return $hourToMin + $min;
        }
        return 0;
    }

    public $removables = ['assign_to_user', 'attachment', 'show_to_customer', 'show_to_project_owner', 'dependent_task'];

    // add task
    public function postData(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = $request->toArray();

        $request->tenant_id = $tenantId;

        $ticket_id = DB::table('tai_ticket_master')->where('id', $request->ticket_id)->first();
        if ($ticket_id->status_id == 3 || $ticket_id->is_active == 0) {
            return response()->json(['status' => 0, 'message' => 'Ticket already solved', 'data' => null]);
        }

        $data['status'] = "TO_DO";

        foreach ($this->removables as $r) {
            if (array_key_exists($r, $data)) {
                unset($data[$r]);
            }
        }

        //Assign User
        $checkAssignUser = $this->checkAssignUser($request->assign_to_user);
        if ($checkAssignUser['status'] === 0) {
            return response()->json(['status' => 0, 'message' => $checkAssignUser['message'], 'data' => null]);
        }

        //Check Basket Date
        // $checkBasketDate=$this->checkBasketDate($data['ticket_basket_id'],$data['start_date'],$data['end_date']);
        // if($checkBasketDate['status']===0){
        //     return response()->json(['status'=> 0, 'message'=>$checkBasketDate['message'], 'data' => null]);
        // }

        //Check Same Task Name
        $checkSameTaskName = $this->checkSameTaskName($request->ticket_id, $request->task_name, $request->status);
        if ($checkSameTaskName['status'] === 0) {
            return response()->json(['status' => 0, 'message' => $checkSameTaskName['message'], 'data' => null]);
        }

        //Validate Task Hours
        if ($request->task_hours) {
            $checkTaskHours = $this->checkTaskHours($request->task_hours);
            if ($checkTaskHours['status'] === 0) {
                return response()->json(['status' => 0, 'message' => $checkTaskHours['message'], 'data' => null]);
            }
            $request->task_hours_in_min = $this->convertToMin($request->task_hours);
        }

        $data['tenant_id'] = $tenantId; //$request->tenant_id;
        $data['ticket_id'] = $request->ticket_id;
        $data['ticket_basket_id'] = $request->ticket_basket_id;
        $data['task_name'] = $request->task_name;
        $data['task_desc'] = $request->task_desc;
        $data['task_hours'] = $request->task_hours;
        $data['task_hours_in_min'] = $request->task_hours_in_min;
        $data['priority'] = $request->priority;
        $data['start_date'] = $request->start_date;
        $data['end_date'] = $request->end_date;
        $data['type'] = $request->type ? $data['type'] : "TASK";
        $data['status'] = "TO_DO";
        $data['is_active'] = 1;
        $data['created_at'] = $request->created_at;
        $data['created_by'] = $request->created_by;

        $taskId = $this->taskGenerator($data);

        //$taskId = DB::table('tai_ticket_task')->insertGetId($data);

        if ($taskId > 0) {

            //$this->afterTaskActivity($request);
            //Assigned User
            if ($request->assign_to_user) {
                $assignedUser = $request->assign_to_user;
                if (!is_array($assignedUser)) {
                    $assignedUser = explode(',', $assignedUser);
                }

                if (count($assignedUser)) {
                    TaskSupportive::assignedUser("INSERTION", $tenantId, $request->ticket_id, $request->ticket_basket_id, $taskId, $assignedUser, $request->created_at, $request->created_by);
                    //Mapping
                    OwnershipController::mapping('Insert', 'TASK', $assignedUser, 0, $request->ticket_id, $request->ticket_basket_id, $taskId, $request->created_by, $request->created_at);
                }

                if ($request->task_hours) {
                    TaskSupportive::taskAllocation(
                        "INSERTION",
                        $tenantId,
                        $request->ticket_id,
                        $request->ticket_basket_id,
                        $taskId,
                        $assignedUser,
                        $request->created_at,
                        $request->created_by,
                        $request->start_date,
                        $request->end_date,
                        $request->task_hours
                    );
                }
            }

            //Add Notification for user
            $cretatedUser = CommonController::userInfo($request->created_by, ["first_name", "last_name",]);
            foreach ($request->assign_to_user as $assignUser) {
                $assignPersonInfo = CommonController::userInfo($assignUser, ["first_name", "last_name",]);
                if ($data['type'] == 'GROUP_ACTIVITY') {
                    $msg = $cretatedUser->first_name . " " . $cretatedUser->last_name . " has been created group activity for Ticket " . $ticket_id->ticket_id . " and assigned to " . $assignPersonInfo->first_name . " " . $assignPersonInfo->last_name;
                } else {
                    $msg = $cretatedUser->first_name . " " . $cretatedUser->last_name . " has been created task for Ticket " . $ticket_id->ticket_id . " and assigned to " . $assignPersonInfo->first_name . " " . $assignPersonInfo->last_name;
                }
                $url = "Ticket/Task/" . $data['ticket_id'];

                $ticket_owner = DB::table('tai_ticket_master as t')->where('id', $request->ticket_id)->first();

                if ($ticket_owner && $ticket_owner->assign_to_user_id) {
                    CommonController::addNotification($request->created_by, $ticket_owner->assign_to_user_id, $msg, $url);
                }
                CommonController::addNotification($request->created_by, $assignUser, $msg, $url);
            }


            //File Uploading

            if ($request->file('attachment')) {
                if (is_array($request->file('attachment')) && count($request->file('attachment')) > 0) {
                    foreach ($request->file('attachment') as $key => $row) {

                        CommonController::uploadAttachment($taskId, $row, 'TASK', $request->created_by, $request->show_to_customer[$key], $request->show_to_project_owner[$key]);
                    }
                } else {
                    CommonController::uploadAttachment($taskId, $request->file('attachment'), 'TASK', $request->created_by, $request->show_to_customer, $request->show_to_project_owner);
                }
            }

            //Dependent Task
            if ($request->dependent_task && count($request->dependent_task) > 0) {
                TaskSupportive::dependentTask("INSERTION", $tenantId, $request->ticket_id, $request->ticket_basket_id, $taskId, $request->dependent_task, $request->created_at, $request->created_by);
            }


            return response()->json(['status' => 1, 'message' => "Task Created successfully !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
        }
    }


    public function taskGenerator($data)
    {
        $insertion['tenant_id'] = $data['tenant_id'];
        $insertion['ticket_id'] = $data['ticket_id'];
        $insertion['ticket_basket_id'] = $data['ticket_basket_id'];
        $insertion['task_name'] = $data['task_name'];
        $insertion['task_desc'] = $data['task_desc'];
        $insertion['task_hours'] = $data['task_hours'];
        $insertion['task_hours_in_min'] = $data['task_hours_in_min'];
        $insertion['priority'] = $data['priority'];
        $insertion['start_date'] = $data['start_date'];
        $insertion['end_date'] = $data['end_date'];
        $insertion['type'] = $data['type'] ? $data['type'] : "TASK";
        $insertion['status'] = "TO_DO";
        $insertion['is_active'] = 1;
        $insertion['created_at'] = $data['created_at'];
        $insertion['created_by'] = $data['created_by'];
        $id = DB::table('tai_ticket_task')->insertGetId($insertion);
        CommonController::generateHistory("INSERT", 'tai_ticket_task', $id);
        return $id;
    }

    public function getTaskHistory($taskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:18-07-2023 RUSHIKESH HARKARE
        $tenantId = $token_data->tenant_id; //Date:18-07-2023 RUSHIKESH HARKARE

        $result = DB::table('tai_ticket_task_history as th')
            ->leftJoin('tai_employee_master as e', 'e.id', '=', 'th.created_by')
            ->leftJoin('tai_employee_master as em', 'em.id', '=', 'th.updated_by')
            ->leftJoin('tai_ticket_basket as ttb', 'ttb.id', '=', 'th.ticket_basket_id')
            ->where('th.main_id', $taskId)
            ->where('th.tenant_id', $tenantId)
            ->select('th.*', DB::raw("CONCAT(e.first_name, ' ', e.last_name) as created_by_name"), DB::raw("CONCAT(em.first_name, ' ', em.last_name) as updated_by_name"), 'ttb.basket_name')
            ->get();
        if ($result) {
            return response()->json(['status' => 1, 'message' => "Record found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not found !!!", 'data' => NULL]);
        }
    }

    public function putData(Request $request, $taskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        // $data = $request->toArray();
        $data['tenant_id'] = $tenantId;

        if (!$request->status) {
            return response()->json(['status' => 0, 'message' => "Select Status !!!", 'data' => null]);
        }

        //Assign User
        $checkAssignUser = $this->checkAssignUser($request->assign_to_user);
        if ($checkAssignUser['status'] === 0) {
            return response()->json(['status' => 0, 'message' => $checkAssignUser['message'], 'data' => null]);
        }

        if ($request->status == "COMPLETED") {
            $request->completed_at = date('Y-m-d H:i:s');
            $checkTimeHistory = DB::table('tai_ticket_task_time_history')->where('is_active', 1)->where('ticket_task_id', $taskId)->whereNull('stop_time')->get();
            if (count($checkTimeHistory) > 0) {
                return response()->json(['status' => 0, 'message' => "Another User Is Working On Task !!!", 'data' => null]);
            }
        }

        //Check Time Format
        if ($request->task_hours) {
            $checkTaskHours = $this->checkTaskHours($request->task_hours);
            if ($checkTaskHours['status'] === 0) {
                return response()->json(['status' => 0, 'message' => $checkTaskHours['message'], 'data' => null]);
            }
            $request->task_hours_in_min = $this->convertToMin($request->task_hours);
        }


        $data['task_hours'] = $request->task_hours;
        $data['task_hours_in_min'] = $request->task_hours_in_min;
        $data['priority'] = $request->priority;
        $data['status'] = $request->status;
        $data['updated_at'] = NOW();
        if ($request->type) {
            $data['type'] = $request->type ? $request->type : "TASK";
        }
        $data['updated_by'] = $request->updated_by;
        $data['task_name'] = $request->task_name;
        $data['task_desc'] = $request->task_desc;
        $data['start_date'] = $request->start_date;
        $data['end_date'] = $request->end_date;
        if ($request->status == 'COMPLETED') {
            $data['completed_at'] = now();
        }

        $result = DB::table('tai_ticket_task')->where('id', $taskId)->update($data);

        if ($request->status != 'COMPLETED') {
            if ($request->assign_to_user) {
                $assignedUser = $request->assign_to_user;
                if (!is_array($assignedUser)) {
                    $assignedUser = explode(',', $assignedUser);
                }
                TaskSupportive::assignedUser("UPDATION", $tenantId, $request->ticket_id, $request->ticket_basket_id, $taskId, $assignedUser, $request->updated_at, $request->updated_by);

                //Mapping
                OwnershipController::mapping('Update', 'TASK', $assignedUser, 0, $request->ticket_id, $request->ticket_basket_id, $taskId, $request->updated_by, $request->updated_at, $tenantId);

                if (array_key_exists('task_hours', $request->toArray())) {
                    $checkPlanner = DB::table('tai_task_planner')
                        ->where('ticket_task_id', $taskId)
                        ->where('ticket_id', $request->ticket_id)
                        ->where('ticket_basket_id', $request->ticket_basket_id)
                        ->where('is_active', '1')
                        ->get();
                    if (count($checkPlanner) == 0) {
                        TaskSupportive::taskAllocation(
                            "INSERTION",
                            $tenantId,
                            $request->ticket_id,
                            $request->ticket_basket_id,
                            $taskId,
                            $assignedUser,
                            $request->updated_at,
                            $request->updated_by,
                            $request->start_date,
                            $request->end_date,
                            $request->task_hours
                        );
                    } else {
                        TaskSupportive::taskAllocation(
                            "UPDATION",
                            $tenantId,
                            $request->ticket_id,
                            $request->ticket_basket_id,
                            $taskId,
                            $assignedUser,
                            $request->updated_at,
                            $request->updated_by,
                            $request->start_date,
                            $request->end_date,
                            $request->task_hours
                        );
                    }
                }
            }

            //File Uploading
            if ($request->file('attachment')) {
                CommonController::uploadAttachment($taskId, $request->file('attachment'), 'TASK', $request->updated_by, $request->show_to_customer, $request->show_to_project_owner);
            }

            if ($request->dependent_task) {
                TaskSupportive::dependentTask("UPDATION", $tenantId, $request->ticket_id, $request->ticket_basket_id, $taskId, $request->dependent_task, $request->updated_at, $request->updated_by);
            }
        }

        $teck_id = DB::table('tai_ticket_master')->where('id', $request->ticket_id)->first();

        $ticket_owner = DB::table('tai_ticket_master')->where('id', $request->ticket_id)->first();
        $basket_owner = DB::table('tai_ticket_basket')->where('id', $request->ticket_basket_id)->first();

        // ticket_owner
        if ($ticket_owner && $ticket_owner->assign_to_user_id == $request->updated_by) {

            $ticketPersonInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name",]);

            if ($request->status == 'COMPLETED') {
                $msg =  $request->task_hours . " " . $request->task_name . " for  Ticket " . $teck_id->ticket_id . " has been completed by " . $ticketPersonInfo->first_name . " " . $ticketPersonInfo->last_name;
            } else {
                $msg =  "Ticket " . $teck_id->ticket_id .  ", Some changes have been made by ticket owner " . $ticketPersonInfo->first_name . " " . $ticketPersonInfo->last_name;
            }

            // $msg = $request->task_name." for Ticket ". $teck_id->ticket_id ." has been updated by ticket owner ".$ticketPersonInfo->first_name . " " . $ticketPersonInfo->last_name;
            $url = "Ticket/Task/" . $request->ticket_id;

            foreach ($request->assign_to_user as $u) {
                CommonController::addNotification($request->updated_by, $ticket_owner->assign_to_user_id, $msg, $url);
            }

            CommonController::addNotification($request->updated_by, $u, $msg, $url);
            CommonController::addNotification($request->updated_by, $basket_owner->basket_owner, $msg, $url);
        } else if ($basket_owner && $basket_owner->basket_owner == $request->updated_by) {
            $basketPersonInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name",]);

            if ($request->status == 'COMPLETED') {
                $msg =  $request->task_name . " for Ticket " . $teck_id->ticket_id . " has been completed by " . $basketPersonInfo->first_name . " " . $basketPersonInfo->last_name;
            } else {
                $msg =   "Ticket " . $teck_id->ticket_id . " Some changes has been made by basket owner " . $basketPersonInfo->first_name . " " . $basketPersonInfo->last_name;
            }
            $url = "Ticket/Task/" . $request->ticket_id;
            foreach ($request->assign_to_user as $u) {
                CommonController::addNotification($request->updated_by, $u, $msg, $url);
            }

            CommonController::addNotification($request->updated_by, $ticket_owner->assign_to_user_id, $msg, $url);
            CommonController::addNotification($request->updated_by, $basket_owner->basket_owner, $msg, $url);
        } else {
            $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name"]);
            foreach ($request->assign_to_user as $u) {

                $assignPersonInfo = CommonController::userInfo($u, ["first_name", "last_name",]);
                if ($request->status == 'COMPLETED') {
                    $msg = $request->task_name . " for Ticket " . $teck_id->ticket_id . " has been completed by " . $userInfo->first_name . " " . $userInfo->last_name;
                } else {
                    $msg =  "Ticket " . $teck_id->ticket_id .  ", Some changes have been made by ticket owner " . $assignPersonInfo->first_name . " " . $assignPersonInfo->last_name;
                }
                $url = "Ticket/Task/" . $request->ticket_id;

                if ($ticket_owner && $ticket_owner->assign_to_user_id) {
                    CommonController::addNotification($request->updated_by, $ticket_owner->assign_to_user_id, $msg, $url);
                }

                CommonController::addNotification($request->updated_by, $u, $msg, $url);
                CommonController::addNotification($request->updated_by, $basket_owner->basket_owner, $msg, $url);
            }
        }

        CommonController::generateHistory("UPDATE", 'tai_ticket_task', $taskId);
        return response()->json(['status' => 1, 'message' => "Task Updated Successfully !!!", 'data' => null]);
    }

    public function deleteData($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        // $result = DB::table('tai_ticket_task')->where('id', $id)->delete();
        $result = DB::table('tai_ticket_task')->where('tenant_id', $tenantId)->where('id', $id)->update(['is_active' => 0, 'remark' => "DELETED"]);
        if ($result) {

            // DB::table('tai_ticket_task_subtask')->where('ticket_task_id', $id)->delete();
            // DB::table('tai_ticket_task_time_history')->where('ticket_task_id', $id)->delete();
            DB::table('tai_ticket_dependent_task')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->update(['is_active' => 0]);

            DB::table('tai_ticket_task_owner')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->update(['is_active' => 0]);

            DB::table('tai_ticket_task_subtask')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->update(['is_active' => 0]);

            DB::table('tai_ticket_task_time_history')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->update(['is_active' => 0]);

            DB::table('tai_task_planner')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->update(['is_active' => 0]);

            return response()->json(['message' => "Record Deleted", 'status' => 1, 'data' => null]);
        } else {
            return response()->json(['message' => "Record Not Deleted", 'status' => 0, 'data' => null]);
        }
    }

    public function getById($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_ticket_task')->where('id', $id)->first();
        if ($result) {
            $dependentTaskIds = DB::table('tai_ticket_dependent_task')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->where('is_active', 1)->where('is_active', 1)
                ->pluck('dependent_task_id')
                ->toArray();
            $result->dependentTaskId = $dependentTaskIds;

            $taskOwners = DB::table('tai_ticket_task_owner as o')
                ->leftJoin('tai_employee_master as e', 'e.id', '=', 'o.task_owner_id')
                ->where('o.is_active', 1)
                ->where('o.ticket_id', $result->ticket_id)
                ->where('o.ticket_task_id', $id)
                ->select('e.id')
                ->pluck('e.id')
                ->toArray();

            $result->assign_to_user = $taskOwners;

            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }


    public function ticketUser($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_ticket_task_owner')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->where('is_active', 1)->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }

    public function getTaskUser($taskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_ticket_task_owner as o')
            ->join('tai_employee_master as e', 'e.id', '=', 'o.task_owner_id')
            ->where('o.ticket_task_id', $taskId)
            ->where('o.is_active', 1)
            ->select('o.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) as taskUsers"), 'e.id as userId')
            ->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }

    public function allTicketUser($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $result = DB::table('tai_ticket_task_owner')->where('tenant_id', $tenantId)->where('ticket_task_id', $id)->get();
        if (count($result) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $result]);
        } else {
            return response()->json(['status' => 0, 'message' => "No Record Found !!!", 'data' => null]);
        }
    }


    public function postTimerDataBackup(Request $request)
    {
        $check = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();

        if ($request->status == "START" || $request->status == "Start") {
            if (!$check->start_time) {
                DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->update(['start_time' => $request->time, 'time_status' => "START", 'status' => 'IN_PROGRESS']);
            } else {
                DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->update(['status' => 'IN_PROGRESS', 'time_status' => "START"]);
            }
        } else {
            if ($request->status == "STOP" || $request->status == "Stop") {
                DB::table('tai_ticket_task')->where('id', $check->id)->update(['time_status' => "STOP"]);
            }
        }

        $timer = DB::table('tai_ticket_task_time_history')->where([
            'ticket_id' => $request->ticket_id,
            'ticket_task_id' => $request->ticket_task_id,
            'user_id' => $request->user_id
        ])
            ->orderBy('id', 'desc')
            ->first();
        if ($timer) {
            if ($timer->start_time &&  $timer->stop_time) {
                if ($request->status == "STOP" || $request->status == "Stop") {
                    DB::table('tai_ticket_task_time_history')->where([
                        'ticket_id' => $request->ticket_id,
                        'ticket_task_id' => $request->ticket_task_id,
                        'user_id' => $request->user_id
                    ])
                        ->update(['stop_time' => $request->time]);
                } else {
                    DB::table('tai_ticket_task_time_history')->where([
                        'ticket_id' => $request->ticket_id,
                        'ticket_task_id' => $request->ticket_task_id,
                        'user_id' => $request->user_id
                    ])
                        ->update(['start_time' => $request->time]);
                }
            } else {
                DB::table('tai_ticket_task_time_history')->insert([
                    'ticket_id' => $request->ticket_id,
                    'ticket_task_id' => $request->ticket_task_id,
                    'user_id' => $request->user_id,
                    'start_time' => $request->time,
                    'created_at' => now()
                ]);
            }
        } else {
            DB::table('tai_ticket_task_time_history')->insert([
                'ticket_id' => $request->ticket_id,
                'ticket_task_id' => $request->ticket_task_id,
                'user_id' => $request->user_id,
                'start_time' => $request->time,
                'created_at' => now()
            ]);
        }
        return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
    }

    public function taskUtil(Request $request)
    {
        $data = DB::table('tai_ticket_task_time_history')->get();
        foreach ($data as $d) {
            if ($d->start_time && $d->stop_time) {
                $start = new Carbon($d->start_time);
                $finish = new Carbon($d->stop_time);
                $total_time_hr = $start->diff($finish)->format('%H:%I:%S');
                $total_time_min = Carbon::parse($start)->diffInMinutes($finish);
                DB::table('tai_ticket_task_time_history')->where('id', $d->id)->update(['total_time_min' => $total_time_min]);
            }
        }
        $task = DB::table('tai_ticket_task')->get();
        foreach ($task as $t) {
            $sum = DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history where ticket_task_id=$t->id"));
            DB::table('tai_ticket_task')->where('id', $t->id)->update(['total_worked_in_min' => $sum[0]->time_in_min]);
        }
    }

    public function getTaskPlanner(Request $request, $taskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $planner = DB::table('tai_task_planner as p')
            ->join('tai_employee_master as e', 'e.id', '=', 'p.user_id')
            ->where('p.ticket_task_id', $taskId)
            ->where('p.is_active', 1)
            ->select('p.*', DB::raw("CONCAT(e.first_name,' ',e.last_name) AS username"))
            ->get();

        if (count($planner)) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $planner]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Found !!!", 'data' => NULL]);
        }
    }

    public function resourcePlanningUserTask(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = DB::table('tai_task_planner as p')
            ->join('tai_ticket_task as t', 't.id', '=', 'p.ticket_task_id')
            ->whereBetween('p.date', [$request->toDate, $request->fromDate])
            ->where('p.user_id', $request->user_id)
            ->select('p.*', 't.task_name')
            ->get();
        if (count($data)) {
            return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Found !!!", 'data' => NULL]);
        }
    }

    function sum_time()
    {
        $i = 0;
        foreach (func_get_args() as $time) {
            sscanf($time, '%d:%d', $hour, $min);
            $i += $hour * 60 + $min;
        }
        if ($h = floor($i / 60)) {
            $i %= 60;
        }
        return sprintf('%02d:%02d', $h, $i);
    }

    public function updateTaskPlanner(Request $request, $taskId)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $task = DB::table('tai_ticket_task')->where('id', $taskId)->first();
        $data = $request->toArray();
        $total_min = 0;

        for ($i = 0; $i < count($data['id']); $i++) {
            $t = str_replace(":", ".", $data['total_hours'][$i]);
            $total_min += (float)$t * 60;
        }

        if ($task->task_hours_in_min < $total_min) {
            return response()->json(['status' => 0, 'message' => "Total time must be equal to or less than $task->task_hours", 'data' => $data]);
        }
        // }else{

        for ($i = 0; $i < count($data['id']); $i++) {
            $hours_in_min = str_replace(":", ".", $data['total_hours'][$i]);
            $hours = explode(".", $hours_in_min);

            $min = ($hours[0] * 60) + $hours[1];

            // $total_hours_in_min=(float)$hours_in_min*60;     

            DB::table('tai_task_planner')->where('id', $data['id'][$i])->update([
                'user_id' => $data['user_id'][$i],
                'date' => $data['date'][$i],
                'total_hours' => $data['total_hours'][$i],
                'total_hours_in_min' => $min,
                'updated_at' => $data['updated_at'],
                'updated_by' => $data['updated_by'],
            ]);
        }
        return response()->json(['status' => 1, 'message' => "Task planning updated !!!", 'data' => $data]);
        // }
    }

    public function addPlanner()
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $task = DB::table('tai_ticket_task')->where('status', '!=', 'COMPLETE')
            ->whereNotNull('start_date')
            ->whereNotNull('end_date')
            ->where('is_active', '1')
            ->get();

        foreach ($task as $t) {
            $assignedUser = DB::table('tai_ticket_task_owner')->where('ticket_task_id', $t->id)->where('is_active', 1)->pluck('task_owner_id')->toArray();
            if ($assignedUser) {
                TaskSupportive::taskAllocation(
                    "INSERTION",
                    $tenantId,
                    $t->ticket_id,
                    $t->ticket_basket_id,
                    $t->id,
                    $assignedUser,
                    now(),
                    $t->created_by,
                    $t->start_date,
                    $t->end_date,
                    $t->task_hours
                );
            }
        }
    }

    public function getTaskOwnerTime(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        // $data = DB::table('tai_ticket_task_time_history')->where('ticket_task_id', $request->task_id)
        //                                                  ->where('stop_time', NULL)->groupBy('user_id')->latest()->get();
        // return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $data]);
        $userIds = explode(',', $request->user_id);

        $sql = "SELECT * FROM tai_ticket_task_time_history WHERE id IN (SELECT MAX(id) FROM tai_ticket_task_time_history 
              WHERE ticket_task_id=" . $request->task_id . " AND user_id IN (" . $request->user_id . ") GROUP BY user_id ORDER BY id DESC);";

        $lastTime = DB::SELECT(DB::RAW($sql));
        $data = [];

        if (count($lastTime)) {
            foreach ($userIds as $u) {
                foreach ($lastTime as $t) {
                    if ($t->user_id == $u) {
                        $status = "START";
                        if ($t->start_time && $t->stop_time) {
                            $status = "START";
                        } else if ($t->start_time && !$t->stop_time) {
                            $status = "STOP";
                        }
                        $data[] = ["user_id" => $u, 'status' => $status];
                    }
                }
            }
        }

        $basketId = DB::table('tai_ticket_task')->where('id', $request->task_id)->first();
        $baskerOwnerId = DB::table('tai_ticket_basket')->where('is_active', 1)->where('id', $basketId->ticket_basket_id)->first();
        $data[] = ["basket_owner" => $baskerOwnerId->basket_owner];
        return $data;
        // return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $data]);
    }

    public function requestRegularizationTime(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $basketOwner = DB::table('tai_ticket_basket')->where('id', $request->ticket_basket_id)
            ->where('is_active', 1)
            ->where('tenant_id', $tenantId)
            ->first()
            ->basket_owner;

        $ticketOwner = DB::table('tai_ticket_master')->where('id', $request->ticket_id)
            ->where('is_active', 1)
            ->where('tenant_id', $tenantId)
            ->first()
            ->created_by;

        $insertedRecord = 0;
        for ($i = 0; $i < count($request->date); $i++) {

            $from = $request->date[$i] . " " . $request->from_time[$i] . ":00";
            $to = $request->date[$i] . " " . $request->to_time[$i] . ":00";

            $already = DB::table('tai_ticket_task_time_history')
                ->where('tenant_id', $tenantId) //$request->tenant_id)
                ->where('ticket_id', $request->ticket_id)
                ->where('ticket_task_id', $request->created_by)
                ->where('user_id', $request->created_by)
                ->where(function ($query) use ($from, $to) {
                    $query->where(function ($query) use ($from) {
                        $query->where('start_time', '<=', $from);
                        $query->where('stop_time', '>=', $from);
                    })
                        ->orWhere(function ($query) use ($to) {
                            $query->where('start_time', '<=', $to);
                            $query->where('stop_time', '>=', $to);
                        });
                })
                ->get();

            if ($already && count($already) > 0) {
                return response()->json(['status' => 0, 'message' => "Task time already exist !!!", 'data' => null]);
            }

            $data['tenant_id'] = $tenantId; //$request->tenant_id;
            $data['ticket_id'] = $request->ticket_id;
            $data['ticket_basket_id'] = $request->ticket_basket_id;
            $data['ticket_task_id'] = $request->ticket_task_id;
            $data['project_owner_id'] = null;
            $data['ticket_basket_owner_id'] = $basketOwner;
            $data['ticket_owner_id'] = $ticketOwner;
            $data['user_id'] = $request->created_by;
            $data['date'] = $request->date[$i];
            $data['from_time'] = $request->from_time[$i];
            $data['to_time'] = $request->to_time[$i];
            $data['ticket_task_id'] = $request->ticket_task_id;
            $data['created_by'] = $request->created_by;
            $data['updated_by'] = $request->created_by;
            $data['remark'] = $request->remark;

            // if($request->task_owner_id == $basketOwner->basket_owner){
            //     $data['task_owner'] = NULL;
            //     $data['project_owner'] = $ticketOwner->user_id;
            // }else{
            //     $data['task_owner'] = $basketOwner->basket_owner;
            //     $data['project_owner'] = NULL;
            // }

            $id = DB::table('tai_request_task_time')->insertGetId($data);
            if ($id > 0) {
                $insertedRecord++;
            }

            //Add Notification for Ticket Owner
            $TID = DB::table('tai_ticket_master')->where('id', $request->ticket_id)->first()->ticket_id;
            $msg = "New Regularization request raised by ";
            $userInfo = CommonController::userInfo($request->created_by, ["first_name", "last_name",]);
            $msg .= $userInfo->first_name . " " . $userInfo->last_name . " for " . $TID;
            $url = "Ticket/Task/" . $request->ticket_id;
            CommonController::addNotification($request->created_by, $ticketOwner, $msg, $url);

            //Add Notification for Project Owner
            $POId = DB::table('tai_ticket_master as tm')->where('tm.id', $request->ticket_id)
                ->join('tai_project_owner as tpo', 'tm.project_id', '=', 'tpo.project_id')
                ->first();
            if ($POId) {
                $POId = $POId->owner_id;
                $msg = "New Regularization request raised by ";
                $userInfo = CommonController::userInfo($request->created_by, ["first_name", "last_name",]);
                $msg .= $userInfo->first_name . " " . $userInfo->last_name . " for " . $TID;
                $url = "";
                CommonController::addNotification($request->created_by, $POId, $msg, $url);
            }
            // return $request->created_by . " " . $POId . " " . $msg . " " . $url;
        }

        if ($insertedRecord > 0) {
            return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Not Inserted !!!", 'data' => null]);
        }
    }

    public function changeStatusRegularizationTime(Request $request)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        if ($request->type) {
            for ($i = 0; $i < count($request->payload); $i++) {
                if ($request->payload[$i]['is_checked'] == 1) {
                    DB::table('tai_request_task_time')->where('id', $request->payload[$i]['id'])
                        ->update([
                            'status' => $request->type,
                            'updated_by' => $request->updated_by,
                            'updated_at' => $request->updated_at,
                        ]);
                    $msg1 = "";
                    $ticket = DB::table('tai_request_task_time')->where('id', $request->payload[$i]['id'])->first();
                    if ($ticket && $request->type == 'APPROVED') {
                        $total_time_min = round(abs(strtotime($ticket->date . " " . $ticket->from_time) - strtotime($ticket->date . " " . $ticket->to_time)) / 60, 2);
                        DB::table('tai_ticket_task_time_history')->insert([
                            'tenant_id' => $tenantId, //$ticket->tenant_id,
                            'ticket_id' => $ticket->ticket_id,
                            'ticket_task_id' => $ticket->ticket_task_id,
                            'user_id' => $ticket->user_id,
                            'start_time' => $ticket->date . " " . $ticket->from_time,
                            'stop_time' => $ticket->date . " " . $ticket->to_time,
                            'total_time_min' => $total_time_min,
                            'total_time' => floor($total_time_min / 60) . ':' . ($total_time_min -   floor($total_time_min / 60) * 60) . ':00',
                            'created_at' => now()
                        ]);
                        $task = DB::table('tai_ticket_task')->where('id', $ticket->ticket_task_id)->first();
                        $task_min = $task->total_worked_in_min + $total_time_min;
                        $total_time = floor($task_min / 60) . ':' . ($task_min -   floor($task_min / 60) * 60) . ':00';
                        $task = DB::table('tai_ticket_task')->where('id', $ticket->ticket_task_id)
                            ->update(['total_worked_in_min' => $task_min, 'total_worked' => $total_time]);

                        $msg1 = " Regularization request is approved by ";
                    } else {
                        $msg1 = " Regularization request is rejected by ";
                    }

                    //Add Notification for user
                    $TID = DB::table('tai_ticket_master')->where('id', $ticket->ticket_id)->first()->ticket_id;
                    $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name",]);
                    $msg = $TID . $msg1 . " " . $userInfo->first_name . " " . $userInfo->last_name;
                    $url = "Ticket/Task/" . $ticket->ticket_id;
                    CommonController::addNotification($request->updated_by, $ticket->user_id, $msg, $url);

                    //Add Notification for Project Owner
                    $POId = DB::table('tai_ticket_master as tm')->where('tm.id', $ticket->ticket_id)
                        ->join('tai_project_owner as tpo', 'tm.project_id', '=', 'tpo.project_id')
                        ->first();

                    if ($POId) {
                        $POId = $POId->owner_id;
                        $msg = "New Regularization request raised by ";
                        $userInfo = CommonController::userInfo($request->updated_by, ["first_name", "last_name",]);
                        $msg = $TID . $msg1 . " " . $userInfo->first_name . " " . $userInfo->last_name;
                        $url = "Ticket/Task/" . $ticket->ticket_id;
                        CommonController::addNotification($request->updated_by, $POId, $msg, $url);
                        // return $request->updated_by . " " . $POId . " " . $msg . " " . $url;
                    }
                }
            }
            $msg = $request->type == "APPROVED" ? "Approved " : "Rejected ";
            return response()->json(['status' => 1, 'message' => "Request $msg !!!", 'data' => null]);
        } else {
            return response()->json(['status' => 0, 'message' => "Request Error !!!", 'data' => null]);
        }
    }

    public function getRegularizationTime(Request $request, $user_id, $ticket_id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $type = "";
        $ticket = DB::table('tai_ticket_master')->where('tenant_id', $tenantId)->where('id', $ticket_id)->first();
        if ($ticket->project_id) {
            $check = DB::table('tai_project_owner')
                ->where('project_id', $ticket->project_id)
                ->first();
            if ($check) {
                $type = "PROJECT_OWNER";
            }
        }

        if ($type == "") {
            if ($ticket->created_by == $user_id) {
                $type = "TICKET_OWNER";
            }
        }

        if ($type == "") {
            $type = "USER";
        }


        $query = DB::table('tai_request_task_time as tr')
            ->join('tai_employee_master as t', 't.id', '=', 'tr.user_id')
            ->where('ticket_id', $ticket_id)
            ->where('t.tenant_id', $tenantId);

        if ($type == "TICKET_OWNER") {
            $query->where('ticket_owner_id', $user_id);
        }
        // if($type=="USER"){  
        //     $query->where('user_id',$user_id);
        // }
        $data = $query->where('tr.is_active', 1)
            // ->where('tr.status', '!=', 'APPROVED')
            ->select('tr.*', DB::raw("CONCAT(t.first_name,' ',t.last_name) as created_by_name"))
            ->orderByDesc('date')->get();
        if (count($data)) {
            return response()->json(['status' => 1, 'message' => "Record Found!!!", 'data' => $data]);
        } else {
            return response()->json(['status' => 0, 'message' => "Record Found!!!", 'data' => null]);
        }
    }

    public function apporvalRequestTime($id)
    {
        $token_data = JWTAuth::parseToken()->authenticate(); //Date:30-05-2023 PUNAM SHINDE
        $tenantId = $token_data->tenant_id; //Date:30-05-2023 PUNAM SHINDE

        $basketData = DB::table('tai_request_task_time as tr')
            ->join('tai_employee_master as t', 't.id', '=', 'tr.created_by')
            ->where('tr.task_owner', $id)->where('tr.is_active', 1)->select('tr.*', 't.first_name', 't.last_name')->get();
        if (count($basketData) > 0) {
            return response()->json(['status' => 1, 'message' => "Record Found!!!", 'data' => $basketData]);
        } else {
            $projectData = DB::table('tai_request_task_time as tr')->leftjoin('tai_employee_master as t', 't.id', '=', 'tr.created_by')->where('tr.project_owner', $id)->where('tr.is_active', 1)->select('tr.*', 't.first_name', 't.last_name')->get();
            print_r($projectData);
            if (count($projectData) > 0) {
                return response()->json(['status' => 1, 'message' => "Record Found !!!", 'data' => $projectData]);
            } else {
                return response()->json(['status' => 0, 'message' => "Record Not Found !!!", 'data' => null]);
            }
        }
    }

    public function submitRequestTime(Request $request, $id)
    {
        $token_data = JWTAuth::parseToken()->authenticate();
        $tenantId = $token_data->tenant_id;

        $data = $request->toArray();

        $res = DB::table('tai_ticket_task_regularization')->where('id', $id)->first();

        $result = DB::table('tai_ticket_task')->where('tenant_id', $tenantId)->where('id', $res->ticket_task_id)->first();

        $data['tenant_id'] = $result->tenant_id;
        $data['ticket_id'] = $result->ticket_id;
        $data['ticket_task_id'] = $res->ticket_task_id;
        $data['user_id'] = $res->created_by;

        $time = $res->date . ' ' . $res->from_time . ':00';
        $end_time = $res->date . ' ' . $res->to_time . ':00';

        // $checkTime = strtotime($time) - strtotime($end_time);
        // [$hours, $minutes] = explode(':', $checkTime);
        // $min = (int)$hours * 60 + (int)$minutes;

        $data['start_time'] = $time;
        $data['stop_time'] = $end_time;
        $data['total_time'] = "00:00:00";
        $data['total_time_min'] = "00:00:00";
        $data['is_active'] = '1';
        $data['created_at'] = date('Y-m-d h:i:s');
        $data['updated_at'] = date('Y-m-d h:i:s');

        try {
            DB::table('tai_ticket_task_time_history')->insert($data);
            DB::table('tai_request_task_time')->where('id', $id)->update(['is_active' => '0']);

            return response()->json(['status' => 1, 'message' => "Record Inserted !!!", 'data' => null]);
        } catch (exception $e) {
            return response()->json(['status' => 1, 'message' => "Record Not Inserted !!!", 'data' => null]);
        }
    }
}
