<?php

namespace App\Http\Controllers;
use App\Library\CommonController;
use App\Library\TaskSupportiveController as TaskSupportive;
use App\Library\OwnershipController as Ownership;
use App\Models\Employee;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use Carbon\Carbon;
use JWTAuth;

class TicketTaskTimerController extends Controller
{

    public function postTimerData(Request $request)
    {   
        // dd($request->all());
        if(is_array($request->user_id))
        {
            foreach($request->user_id as $value){

                $task = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();

                if($request->status=="START" || $request->status=="Start")
                {
                    if(!$task->start_time)
                    {
                        DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                                    'status'=>'IN_PROGRESS',
                                                                                    'start_time'=>$request->time,
                                                                                    'time_status'=>"START",
                                                                                ]);
                    }else{
                        DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                                'status'=>'IN_PROGRESS',
                                                                                'time_status'=>"START",
                                                                            ]);
                    }

                    DB::table('tai_ticket_task as t')
                        ->leftJoin('tai_ticket_task_owner as ow','t.id','=','ow.ticket_task_id')
                        ->where('ow.task_owner_id', $value)
                        ->where('ow.is_active',1)
                        ->where('t.is_active',1)
                        ->where('t.id','!=', $task->id)
                        ->where('t.status','IN_PROGRESS')
                        ->where('t.time_status','START')
                        ->update([
                            't.time_status'=>'STOP',
                        ]);
                }

                if($request->status=="STOP" || $request->status=="Stop")
                {
                    DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                                    'status'=>'IN_PROGRESS',
                                                                                    'time_status'=>"STOP",
                                                                                ]);                    
                }
               
                if($request->status=="START" || $request->status=="Start")
                {
                    // DB::table('tai_ticket_task_time_history')->where('user_id', $request->user_id)->update([
                    //     'stop_time'=>now()
                    // ]);
                    
                    DB::table('tai_ticket_task_time_history')->insert([
                                                                        'ticket_id'=>$request->ticket_id,
                                                                        'ticket_task_id'=>$request->ticket_task_id,
                                                                        'user_id'=>$value,
                                                                        'start_time'=>$request->time,
                                                                        'time_status'=>"START",
                                                                        'created_at'=>now()
                                                                    ]);
                }else{
                    $time_history = DB::table('tai_ticket_task_time_history')->where([
                                                                            'ticket_id'=>$request->ticket_id,
                                                                            'ticket_task_id'=>$request->ticket_task_id,
                                                                            'user_id'=>$value
                                                                        ])
                                                                        ->orderBy('id','DESC')
                                                                        ->first();
                    $start = new Carbon($time_history->start_time);
                    $finish = new Carbon($request->time);
                    
                    $total_time = $start->diff($finish)->format('%H:%I:%S');  
                                 
                    $total_time_min = Carbon::parse($start)->diffInMinutes($finish);   

                    DB::table('tai_ticket_task_time_history')
                                                                ->where('id',$time_history->id)
                                                                ->update(['stop_time'=>$request->time,
                                                                        'total_time'=>$total_time,
                                                                        'total_time_min'=>$total_time_min
                                                                        ]);                      
                }   

                $time=DB::table('tai_ticket_task_time_history')->where([
                                                                'ticket_id'=>$request->ticket_id,
                                                                'ticket_task_id'=>$request->ticket_task_id,
                                                                // 'user_id'=>$request->user_id
                                                            ])
                                                            ->whereNotNull('start_time')
                                                            ->whereNotNull('stop_time')
                                                            ->pluck('total_time')->toArray();
                if($time)
                {          
                    $sum = strtotime('00:00:00');
                    $totaltime = 0;         
                    foreach( $time as $element ) {
                        $timeinsec = strtotime($element) - $sum;
                        $totaltime = $totaltime + $timeinsec;
                    }
                    $h = intval($totaltime / 3600);
                    $totaltime = $totaltime - ($h * 3600);
                    $m = intval($totaltime / 60);
                    $s = $totaltime - ($m * 60);
                    $f=$h.":".$m.":".$s;

                    $sum=DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history 
                                             WHERE ticket_id=$request->ticket_id 
                                             AND ticket_task_id=$request->ticket_task_id"));

                    DB::table('tai_ticket_task')->where('id', $task->id)    
                                                ->update([
                                                           'total_worked'=>$f,
                                                           'total_worked_in_min'=>$sum[0]->time_in_min
                                                        ]);
                }
            }
            $task = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();
            $status=($request->status=="Start" || $request->status=="START") ? "STOP":"START";

            return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!", 'data' => $status, 'task' => $task]);
        }else{

            $task = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();


            if($request->status=="START" || $request->status=="Start")
            {
                if(!$task->start_time)
                {
                    DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                                'status'=>'IN_PROGRESS',
                                                                                'start_time'=>$request->time,
                                                                                'time_status'=>"START",
                                                                            ]);
                }else{
                    DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                            'status'=>'IN_PROGRESS',
                                                                            'time_status'=>"START",
                                                                        ]);
                }

                DB::table('tai_ticket_task as t')
                        ->leftJoin('tai_ticket_task_owner as ow','t.id','=','ow.ticket_task_id')
                        ->where('ow.task_owner_id', $request->user_id)
                        ->where('ow.is_active',1)
                        ->where('t.is_active',1)
                        ->where('t.id','!=', $task->id)
                        ->where('t.status','IN_PROGRESS')
                        ->where('t.time_status','START')
                        ->update([
                            't.time_status'=>'STOP',
                        ]);
            }

            if(($request->status=="STOP" || $request->status=="Stop") )
            {
                DB::table('tai_ticket_task')->where('id', $task->id)->update([
                                                                                'status'=>'IN_PROGRESS',
                                                                                'time_status'=>"STOP",
                                                                            ]);
            }
    
            if($request->status=="START" || $request->status=="Start")
            {
            
                $this->updateTime($request->ticket_id,$request->ticket_task_id,$request->user_id,$request->time,"START");
                
                DB::table('tai_ticket_task_time_history')->insert([
                                                                    'tenant_id'=>$request->tenant_id,
                                                                    'ticket_id'=>$request->ticket_id,
                                                                    'ticket_task_id'=>$request->ticket_task_id,
                                                                    'user_id'=>$request->user_id,
                                                                    'start_time'=>$request->time,
                                                                    'created_at'=>now()
                                                                    ]);
                

            }else{
                $time_history = DB::table('tai_ticket_task_time_history')->where([
                                                                        'ticket_id'=>$request->ticket_id,
                                                                        'ticket_task_id'=>$request->ticket_task_id,
                                                                        'user_id'=>$request->user_id
                                                                    ])
                                                                    ->orderBy('id','DESC')
                                                                    ->first();
                                                                    
                $start = new Carbon($time_history->start_time);
                $finish = new Carbon($request->time);
                
                $total_time = $start->diff($finish)->format('%H:%I:%S');  
                             
                $total_time_min = Carbon::parse($start)->diffInMinutes($finish);   

                DB::table('tai_ticket_task_time_history')
                            ->where('id',$time_history->id)
                            ->update(['stop_time'=>$request->time,
                                      'total_time'=>$total_time,
                                      'total_time_min'=>$total_time_min
                                    ]);   
                
            }   

            $time=DB::table('tai_ticket_task_time_history')->where([
                                                            'ticket_id'=>$request->ticket_id,
                                                            'ticket_task_id'=>$request->ticket_task_id
                                                        ])
                                                        ->whereNotNull('start_time')
                                                        ->whereNotNull('stop_time')
                                                        ->pluck('total_time')
                                                        ->toArray();
            if($time)
            {          
                $sum = strtotime('00:00:00');
                $totaltime = 0;         
                foreach( $time as $element ) {
                    $timeinsec = strtotime($element) - $sum;
                    $totaltime = $totaltime + $timeinsec;
                }
                $h = intval($totaltime / 3600);
                $totaltime = $totaltime - ($h * 3600);
                $m = intval($totaltime / 60);
                $s = $totaltime - ($m * 60);
                $f=$h.":".$m.":".$s;
             
                $sum=DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history 
                                         WHERE ticket_id=$request->ticket_id 
                                         AND ticket_task_id=$request->ticket_task_id"));

                DB::table('tai_ticket_task')->where('id', $task->id)->update(['total_worked'=>$f,'total_worked_in_min'=>$sum[0]->time_in_min]);
            }
            
            $status=($request->status=="Start" || $request->status=="START") ? "STOP":"START";
            $task = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();
            return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!", 'data' => $status, 'task' => $task]);                                  
        }
    }   

    public function postTimerDataGroupActivity(Request $request){
     
        if($request->user_id)
        {
            $task = DB::table('tai_ticket_task')->where('id', $request->ticket_task_id)->first();

            if(($request->status=="START" || $request->status=="Start") && !$task->start_time)
            {
                DB::table('tai_ticket_task')->where('id', $task->id)
                                            ->update([
                                                    'status'=>'IN_PROGRESS',
                                                    'start_time'=>now(),
                                                    'time_status'=>"START",
                                                ]);
            }
            
            for($i=0;$i<count($request->user_id);$i++)
            {
                if($request->is_present[$i]==1)
                {
                    if($request->status=="START" || $request->status=="Start")
                    {
                            $this->updateTime( $request->ticket_id,
                                            $request->ticket_task_id,
                                            $request->user_id[$i],
                                            now(),
                                            "START");

                            DB::table('tai_ticket_task_time_history')
                                            ->insert([
                                                    'tenant_id'=>$request->tenant_id,
                                                    'ticket_id'=>$request->ticket_id,
                                                    'ticket_task_id'=>$request->ticket_task_id,
                                                    'user_id'=>$request->user_id[$i],
                                                    'start_time'=>now(),
                                                    'created_at'=>now()
                                                ]);                 
                    }else{
                        
                        $time_history = DB::table('tai_ticket_task_time_history')->where([
                            'ticket_id'=>$request->ticket_id,
                            'ticket_task_id'=>$request->ticket_task_id,
                            'user_id'=>$request->user_id[$i]
                        ])
                        ->orderBy('id','DESC')
                        ->first();
                    
                            $start = new Carbon($time_history->start_time);
                            $finish = new Carbon(now());

                            $total_time = $start->diff($finish)->format('%H:%I:%S');  

                            $total_time_min = Carbon::parse($start)->diffInMinutes($finish);   

                            DB::table('tai_ticket_task_time_history')
                                        ->where('id',$time_history->id)
                                        ->update(['stop_time'=>now(),
                                        'total_time'=>$total_time,
                                        'total_time_min'=>$total_time_min
                                        ]);   

                    }//each
                } //is_present
            } //for
        
            $time=DB::table('tai_ticket_task_time_history')->where([
                                    'ticket_id'=>$request->ticket_id,
                                    'ticket_task_id'=>$request->ticket_task_id
                                ])
                                ->whereNotNull('start_time')
                                ->whereNotNull('stop_time')
                                ->pluck('total_time')
                                ->toArray();
                if($time)
                {          
                    $sum = strtotime('00:00:00');
                    $totaltime = 0;         

                    foreach( $time as $element ) {
                        $timeinsec = strtotime($element) - $sum;
                        $totaltime = $totaltime + $timeinsec;
                    }

                    $h = intval($totaltime / 3600);
                    $totaltime = $totaltime - ($h * 3600);
                    $m = intval($totaltime / 60);
                    $s = $totaltime - ($m * 60);
                    $f=$h.":".$m.":".$s;

                    $sum=DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history 
                                                WHERE ticket_id=$request->ticket_id 
                                                AND ticket_task_id=$request->ticket_task_id"));

                    DB::table('tai_ticket_task')->where('id', $task->id)->update(['total_worked'=>$f,'total_worked_in_min'=>$sum[0]->time_in_min]);
                }

                $status=($request->status=="Start" || $request->status=="START") ? "STOP":"START";

                $finalCheck=DB::table('tai_ticket_task_time_history')->where('ticket_task_id', $request->ticket_task_id)
                                                            ->whereNULL('stop_time')
                                                            ->get();
                if(count($finalCheck)==0){
                    DB::table('tai_ticket_task')->where('id', $task->id)
                    ->update([
                            'status'=>'IN_PROGRESS',
                            'time_status'=>"STOP"
                        ]);     
                }                                            

            return response()->json([ 'status'=> 1, 'message'=> "Record Inserted !!!", 'data' => $status]);                                       
        }
    }

  

    public function updateTime($ticket_id,$ticket_task_id,$user_id,$time,$type){

            $userTask=DB::table('tai_ticket_task_time_history')->where([
                                                                        'user_id'=>$user_id
                                                                    ])
                                                                ->whereNull('stop_time')
                                                                ->get();
  
            foreach($userTask as $u)
            { 

                $start = new Carbon($u->start_time);
                $finish = new Carbon($time);
                
                $total_time = $start->diff($finish)->format('%H:%I:%S');  
                                
                $total_time_min = Carbon::parse($start)->diffInMinutes($finish);   


                // dd($start,$finish,$total_time,$total_time_min);

                $update= DB::table('tai_ticket_task_time_history')->where('id',$u->id)
                                                                ->update(['stop_time'=>$time,
                                                                            'total_time'=>$total_time,
                                                                            'total_time_min'=>$total_time_min
                                                                         ]);                      
                                                                        
                if($update)
                {                                    
                    $time=DB::table('tai_ticket_task_time_history')
                                                        ->where([
                                                            'ticket_id'=>$u->ticket_id,
                                                            'ticket_task_id'=>$u->ticket_task_id,
                                                        ])
                                                        ->whereNotNull('start_time')
                                                        ->whereNotNull('stop_time')
                                                        ->pluck('total_time')
                                                        ->toArray();                                            
                                                           
                    if($time)
                    {          
                        $sum = strtotime('00:00:00');
                        $totaltime = 0;         
                        foreach( $time as $element )
                        {
                            $timeinsec = strtotime($element) - $sum;
                            $totaltime = $totaltime + $timeinsec;
                        }
                        $h = intval($totaltime / 3600);
                        $totaltime = $totaltime - ($h * 3600);
                        $m = intval($totaltime / 60);
                        $s = $totaltime - ($m * 60);
                        $f=$h.":".$m.":".$s;

                        $sum=DB::SELECT(DB::RAW("SELECT SUM(total_time_min) as time_in_min from tai_ticket_task_time_history 
                                                WHERE ticket_id=$u->ticket_id 
                                                AND ticket_task_id=$u->ticket_task_id"));
;

                        DB::table('tai_ticket_task')->where('id', $u->ticket_task_id)
                                                                ->update([
                                                                        'total_worked'=>$f,
                                                                        'total_worked_in_min'=>$sum[0]->time_in_min
                                                                        ]);                                              
                    } //time
                } // update
            }   //for 
    }

   
    function sum_time() {
        $i = 0;
        foreach (func_get_args() as $time) {
            sscanf($time, '%d:%d', $hour, $min);
            $i += $hour * 60 + $min;
        }
        if ($h = floor($i / 60)) {
            $i %= 60;
        }
        return sprintf('%02d:%02d', $h, $i);
    }

}
