<?php


namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class TicketOtpMail extends Mailable
{
    use Queueable, SerializesModels;
    public $data;
    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($data)
    {
        $this->data = $data;
     
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {   
        // $from_address = 'info@aiat.com';
        // $from_subject = 'Successful Registration!';
        // $from_name = 'AIAT REGISTRATION';
  
        return $this->view('emails.TicketOtpMail')
                            ->subject("Ticket Confirmation OTP")
                            ->with([
                                'title' => $this->data['title'],
                                'body' => $this->data['body'],
                                'name'=>  $this->data['name'],
                                'ticket_id'=> $this->data['ticket_id'],
                                'email'=> $this->data['email'],
                                'otp' => $this->data['otp'],
                            ]);
    }
}
